SystemOrganization addCategory: 'Deli-announcements'!
SystemOrganization addCategory: 'Deli-configuration'!
SystemOrganization addCategory: 'Deli-frontend'!
SystemOrganization addCategory: 'Deli-models'!
SystemOrganization addCategory: 'Deli-setup'!
SystemOrganization addCategory: 'Deli-tests'!
SystemOrganization addCategory: 'Deli-util'!

MADescribedColumn subclass: #DLMABarChartColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMABarChartColumn methodsFor: 'accessing' stamp: 'PL 8/4/2011 18:23:39.774'!
readSelector

	^ self description accessor readSelector! !

!DLMABarChartColumn methodsFor: 'rendering' stamp: 'CO 08/07/2011 07:29'!
renderCellContent: anObject on: html
	
	| progress level maximum percentage |
	
	progress := anObject perform: self readSelector.
	level := progress first.
	maximum := progress second.
	
	maximum = 0
		ifTrue: [percentage := '0%']
		ifFalse: [percentage := ((level / maximum * 1000) rounded / 10) asFloat rounded asString , '%'].
	
	html div
		class: 'barChart';
		with:
			[html div
				with: [html div
				style: ('width: ' , percentage);
				with: [html div]].
	
			html div
				with: level asString , '/' , maximum asString , ' (' , percentage , ')']! !

MADescribedColumn subclass: #DLMAChangesColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMAChangesColumn methodsFor: 'rendering' stamp: 'TimFelgentreff 01/13/2011 04:58'!
renderCellContent: anObject on: html
	|  changes |
	changes := (self valueFor: anObject).
	html definitionList: [
		changes do: [:aChange | 
			html definitionTerm: aChange attributeName.
			html definitionData: [
				html text: aChange attributeValue.
				html space.
				((aChange klass) includesBehavior: DLModel) ifTrue:[
					html anchor
						callback: [self report call: (DLAdminDetailComp for: ((aChange klass) getFrom: {#oid->aChange objectId}))];
						with: '[Details]'.
				]
			]
		] 
	]! !

MADescribedColumn subclass: #DLMAFileColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMAFileColumn methodsFor: 'rendering' stamp: 'tfel 1/15/2011 16:46'!
renderCellContent: anObject on: html

	| fileModel separatedPath filename delimiter path |
	anObject filePath isEmpty ifTrue: [^ nil].
	delimiter := (FileDirectory default pathNameDelimiter).
	separatedPath := anObject filePath findTokens: delimiter.
	path := separatedPath allButLast.
	filename := separatedPath last.
	fileModel := DLMAExternalFileModel new 
				location: path;
				filename: filename;
				filesize: anObject fileSize;
				yourself.
	html anchor
		url:  (fileModel url);
		with: filename.! !

MADescribedColumn subclass: #DLMAKeyValueColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMAKeyValueColumn methodsFor: 'rendering' stamp: 'sebh 7/1/2009 00:59'!
renderCellContent: anObject on: html
	|  kv |
	kv := (self valueFor: anObject).
	html definitionList: [
		kv do: [:aPair | 
			html definitionTerm: aPair key.
			html definitionData: aPair value.
		] 
	]! !

MADescribedColumn subclass: #DLMALinkColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMALinkColumn methodsFor: 'rendering' stamp: 'sebh 7/14/2009 23:05'!
renderCellContent: anObject on: html
	html anchor url: anObject lectureHomepage; with: '[Beschreibung]'.! !

DLMALinkColumn subclass: #DLMAMailLinkColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMAMailLinkColumn methodsFor: 'rendering' stamp: 'PL 5/25/2011 21:29:55.074'!
renderCellContent: anObject on: html

	anObject mail isNil
		ifFalse: [html anchor
				url: anObject mail;
				class: 'iconpic';
				with: [html image url: DLFileLibrary / #emailPng]]! !

MADescribedColumn subclass: #DLMAToggleColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMAToggleColumn class methodsFor: 'translations' stamp: 'PL 5/29/2011 21:19:23.283'!
undefinedText

	^ '(undefiniert)'! !

!DLMAToggleColumn methodsFor: 'accessing' stamp: 'PL 5/29/2011 21:17:04.901'!
getSymbolAsImage: anObject
	
	| symbolAsImage |
	
	symbolAsImage := anObject class statusImages detect:
		[:each | each key = (anObject perform: self readSelector)].
	
	^ symbolAsImage ifNotNil: [symbolAsImage value]! !

!DLMAToggleColumn methodsFor: 'accessing' stamp: 'PL 5/29/2011 21:19:14.369'!
getSymbolAsString: anObject
	
	| symbolAsString |
	
	symbolAsString := anObject class statusMetaNames detect:
		[:each | each key = (anObject perform: self readSelector)].

	^ symbolAsString
		ifNotNil: [symbolAsString value]
		ifNil: [self class undefinedText]! !

!DLMAToggleColumn methodsFor: 'accessing' stamp: 'PL 5/29/2011 21:17:04.864'!
readSelector

	^ self description accessor readSelector! !

!DLMAToggleColumn methodsFor: 'rendering' stamp: 'PL 5/25/2011 21:26:47.326'!
renderAjaxLinkFor: anObject withUpdater: anUpdater on: html
	
	html anchor
		onClick: anUpdater;
		url: '#';
		class: 'iconpic';
		with: 
			[html image 
				url: (self getSymbolAsImage: anObject);
				title: (self getSymbolAsString: anObject)]! !

!DLMAToggleColumn methodsFor: 'rendering' stamp: 'PL 5/29/2011 21:40:48.662'!
renderCellContent: anObject on: html
	
	| updater |
 
	(updater := html prototype updater)
		id: ('statusToggler' , anObject oid asString);
		callback:
			[:renderer | self toggleStatusOf: anObject.
			self renderAjaxLinkFor: anObject withUpdater: updater on: renderer].
	
	html div
		id: ('statusToggler' , anObject oid asString);
		with: [self renderAjaxLinkFor: anObject withUpdater: updater on: html]! !

!DLMAToggleColumn methodsFor: 'actions' stamp: 'PL 5/29/2011 21:38:27.273'!
toggleStatusOf: anObject

	| oldStatus oldIndex nextIndex nextStatus |

	oldStatus := anObject perform: self readSelector.
	oldIndex := self description options indexOf: oldStatus.
	nextIndex := (oldIndex rem: self description options size) + 1.
	nextStatus := self description options at: nextIndex.
	
	anObject perform: self writeSelector with: nextStatus! !

!DLMAToggleColumn methodsFor: 'accessing' stamp: 'PL 5/29/2011 21:31:44.767'!
writeSelector

	^ self description accessor writeSelector! !

MADescribedColumn subclass: #DLMATruncatedStringColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMATruncatedStringColumn methodsFor: 'rendering' stamp: 'sebh 7/2/2009 23:41'!
renderCellContent: anObject on: html
	html render: ((self description toString: (self valueFor: anObject)) truncateWithElipsisTo: 100).! !

WASession subclass: #DLSession
	instanceVariableNames: 'user announcer activeMenuEntry username firstname lastname email'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-configuration'!

DLSession subclass: #DLDebugSession
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-configuration'!

!DLDebugSession methodsFor: 'as yet unclassified' stamp: 'topa 10/26/2009 17:17'!
login: un
	super login: un.! !

!DLSession methodsFor: 'accessing' stamp: 'cr 7/23/2009 19:09'!
activeMenuEntry

	^ activeMenuEntry! !

!DLSession methodsFor: 'accessing' stamp: 'cr 7/23/2009 19:09'!
activeMenuEntry: anObject

	activeMenuEntry := anObject.! !

!DLSession methodsFor: 'accessing' stamp: 'sebh 6/3/2009 12:04'!
announcer
	^ announcer ifNil: [ announcer := Announcer new. ].! !

!DLSession methodsFor: 'accessing' stamp: 'topa 4/28/2010 13:19'!
announcer1
	^ announcer! !

!DLSession methodsFor: 'accessing' stamp: 'topa 4/28/2010 13:19'!
announcer: anObject
	^ announcer := anObject! !

!DLSession methodsFor: 'accessing' stamp: 'topa 10/26/2009 15:07'!
charSet
	"topa: this does not hold with WAKomAJP 
	^ 'iso-8859-1'"
	^ 'utf-8'! !

!DLSession methodsFor: 'accessing' stamp: 'topa 4/28/2010 13:19'!
email
	^ email! !

!DLSession methodsFor: 'accessing' stamp: 'topa 4/28/2010 13:19'!
email: anObject
	email := anObject! !

!DLSession methodsFor: 'accessing' stamp: 'topa 4/28/2010 13:19'!
firstname
	^ firstname! !

!DLSession methodsFor: 'accessing' stamp: 'topa 4/28/2010 13:19'!
firstname: anObject
	firstname := anObject! !

!DLSession methodsFor: 'accessing' stamp: 'sebh 7/19/2009 22:58'!
fullname
	(self firstname notNil) & (self lastname notNil) ifTrue: [^ (self firstname,' ',self lastname)].
	^ nil.! !

!DLSession methodsFor: 'accessing' stamp: 'topa 4/28/2010 13:31'!
isLoggedIn

	^ self username notNil! !

!DLSession methodsFor: 'accessing' stamp: 'topa 4/28/2010 13:19'!
lastname
	^ lastname! !

!DLSession methodsFor: 'accessing' stamp: 'topa 4/28/2010 13:19'!
lastname: anObject
	lastname := anObject! !

!DLSession methodsFor: 'accessing' stamp: 'topa 4/28/2010 13:19'!
login: aUsername
	self username: aUsername.
	self user: (DLUser getOrCreateFrom: {#userName -> self username asLowercase} withDefaultValues: {#realName->self fullname. #email->self email}).! !

!DLSession methodsFor: 'accessing' stamp: 'tfel 11/2/2011 12:00'!
logout
	self expire.
	self user: nil.
	self username: nil.
	self requestContext response basicAuthenticationRealm: 'HPI Kerberos Login'.! !

!DLSession methodsFor: 'accessing' stamp: 'sebh 7/14/2009 13:25'!
user
	^ user.! !

!DLSession methodsFor: 'accessing' stamp: 'Marik 5/20/2009 17:08'!
user: anObject

	user := anObject.! !

!DLSession methodsFor: 'accessing' stamp: 'topa 4/28/2010 13:19'!
username
	^ username! !

!DLSession methodsFor: 'accessing' stamp: 'topa 4/28/2010 13:19'!
username: anObject
	username := anObject! !

MASingleOptionDescription subclass: #DLMAUpdatableSingleOptionDescription
	instanceVariableNames: 'jsScript'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMAUpdatableSingleOptionDescription class methodsFor: 'magritte-seaside-defaults' stamp: 'PL 5/16/2011 18:41:26.645'!
defaultComponentClasses

	^ Array with: DLMAUpdatableSelectListComponent! !

!DLMAUpdatableSingleOptionDescription methodsFor: 'accessing' stamp: 'PL 5/25/2011 13:44:23.494'!
jsScript
	^ jsScript! !

!DLMAUpdatableSingleOptionDescription methodsFor: 'accessing' stamp: 'PL 5/25/2011 13:44:23.521'!
jsScript: anObject
	jsScript := anObject! !

MACommandColumn subclass: #DLMACommandColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMACommandColumn methodsFor: 'accessing' stamp: 'MG 7/23/2009 19:11'!
additionalText
	^ self propertyAt: #additionalText ifAbsent: [ self defaultAdditionalText ]! !

!DLMACommandColumn methodsFor: 'accessing' stamp: 'MG 7/23/2009 19:00'!
additionalText: aBoolean

	self propertyAt: #additionalText put: aBoolean.
	self useLinks: false.! !

!DLMACommandColumn methodsFor: 'default' stamp: 'MG 7/23/2009 18:59'!
defaultAdditionalText
	^ false! !

!DLMACommandColumn methodsFor: 'default' stamp: 'caro 7/20/2009 14:17'!
defaultUseImages
	^ true! !

!DLMACommandColumn methodsFor: 'rendering' stamp: 'MG 7/23/2009 19:06'!
renderCellContent: anObject on: html
	self useLinks
		ifTrue: [ self renderCellLinkContent: anObject on: html ]
		ifFalse: [ 
			self useImages 
				ifTrue: [
					self additionalText
						ifTrue: [self renderCellImageAndTextContent: anObject on: html]
						ifFalse: [self renderCellImageContent: anObject on: html]]
				ifFalse: [self renderCellFormContent: anObject on: html ]]! !

!DLMACommandColumn methodsFor: 'rendering' stamp: 'topa 5/10/2010 08:55'!
renderCellImageAndTextContent: anObject on: html
	self commands
		do: [ :each |
			| actionName |
			actionName := each value asString.
			html anchor
				title: each value;
				callback: [ each key value: anObject ];
				with: [html div class: 'iconpic'; with: [html image url: (DLFileLibrary / (actionName,'Png' asSymbol))].
					html div class: 'iconstring'; with: [html text: (self labelForSelector: actionName)].]]
		separatedBy: [ html space ]! !

!DLMACommandColumn methodsFor: 'rendering' stamp: 'topa 5/10/2010 08:55'!
renderCellImageContent: anObject on: html
	self commands
		do: [ :each |
			html anchor
				title: each value;
				callback: [ each key value: anObject ];
				with: [html div class: 'iconpic'; with: [html image url: (DLFileLibrary / (each value,'Png' asSymbol))].] ]
		separatedBy: [ html space ]! !

!DLMACommandColumn methodsFor: 'accessing' stamp: 'caro 7/20/2009 14:17'!
useImages
	^ self propertyAt: #useImages ifAbsent: [ self defaultUseImages ]! !

!DLMACommandColumn methodsFor: 'accessing' stamp: 'MG 7/23/2009 19:00'!
useImages: aBoolean

	self propertyAt: #useImages put: aBoolean.
	self useLinks: false.! !

DLMACommandColumn subclass: #DLMAConditionalCommandColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMAConditionalCommandColumn methodsFor: 'saving' stamp: 'MG 7/1/2009 15:48'!
addCommand: aCommand condition: aCondition text: aText
	self commands add: aCondition -> (aCommand -> (aText -> nil)).! !

!DLMAConditionalCommandColumn methodsFor: 'saving' stamp: 'sebh 7/1/2009 16:18'!
addCommand: aCommand condition: aCondition text: aText classed: aClass
	self commands add: aCondition -> (aCommand -> (aText -> aClass)).! !

!DLMAConditionalCommandColumn methodsFor: 'saving' stamp: 'MG 7/1/2009 15:51'!
addCondition: aCondition text: aText
	self commands add: aCondition -> (nil -> (aText -> nil)).! !

!DLMAConditionalCommandColumn methodsFor: 'rendering' stamp: 'martin 7/24/2009 16:20'!
renderCellImageAndTextContent: anObject on: html
	self commands
		do: [ :each |
			| condition block actionName |
			condition := each key. block := each value key. actionName := each value value key.
			(condition value: anObject)
				ifTrue: [
					html anchor
						callback: [ block value: anObject ];
						with: [html div class: 'iconpic'; with: [html image url: (DLFileLibrary / (actionName,'Png' asSymbol))].
							html div class: 'iconstring'; with: [html text: (self labelForSelector: actionName)].]]]
		separatedBy: [ html space ].! !

!DLMAConditionalCommandColumn methodsFor: 'rendering' stamp: 'martin 7/24/2009 16:21'!
renderCellImageContent: anObject on: html

		self commands
		do: [ :each |
			| condition block fileName |
			condition := each key. block := each value key. fileName := each value value key.
			(condition value: anObject)
			ifTrue:[ html anchor
							callback: [ block value: anObject ];
							with: [html div class: 'iconpic'; with: [html image url: (DLFileLibrary / (fileName,'Png' asSymbol))]]
					]]! !

!DLMAConditionalCommandColumn methodsFor: 'rendering' stamp: 'sebh 7/2/2009 17:43'!
renderCellLinkContent: anObject on: html
	self commands
		do: [ :each |
			| condition block text cssClass |
			condition := each key. block := each value key. text := each value value key. cssClass := each value value value.
			(condition value: anObject)
			ifTrue:[
				(block isNil)
				ifTrue:  [ html text: text. ]
				ifFalse: [ 
					html div class: cssClass; with: [
								html anchor
								callback: [ block value: anObject ];
								with: text]
					].
			]]! !

TestCase subclass: #DLGenericModelTests
	instanceVariableNames: 'session'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-tests'!

!DLGenericModelTests methodsFor: 'accessing' stamp: 'sebh 6/30/2009 11:53'!
session

	^ session! !

!DLGenericModelTests methodsFor: 'accessing' stamp: 'sebh 6/30/2009 11:53'!
session: anObject

	session := anObject.! !

!DLGenericModelTests methodsFor: 'deprecated' stamp: 'topa 2/6/2012 17:24'!
setUp
	| |
	super setUp.
	"SqsConnectionManager reset.
	self session: (SqsConnectionManager getInstance sessionForClass: DLTestModel).
	self session resetDatabase."! !

!DLGenericModelTests methodsFor: 'deprecated' stamp: 'sebh 6/30/2009 18:06'!
tearDown
	| |
	super tearDown.! !

!DLGenericModelTests methodsFor: 'accessing' stamp: 'sebh 7/12/2009 18:44'!
testCollectionLogging
	| model item |
	model := DLTestModel createFrom: {
		#title->'A nice title'. 
		#items->{
			DLTestItemModel createFrom:{#title->'Nummer 1'}.
			DLTestItemModel createFrom:{#title->'Nummer 2'}.
			} asOrderedCollection.
		}.
		
	self assert: [(SqsSearch for: DLLogEntry) findAll size = 1] 
		  description: 'Saving a new item should result in a log entry'.
	self assert: [((SqsSearch for: DLLogEntry) select: [:anEntry | anEntry changes anySatisfy: [:aChange | aChange attributeName = 'title']]) size = 1]
		  description: 'Make sure the created changes include #title'.
		self assert: [((SqsSearch for: DLLogEntry) select: [:anEntry | anEntry changes anySatisfy: [:aChange | aChange attributeName = 'items']]) size = 1]
		  description: 'Make sure the created changes include #items'.
	self assert: [((SqsSearch for: DLLogEntry) select: [:aChange | aChange changes size = 3]) size = 1]
			description: '3 changes should have been recorded: Changed title + 2 added elements'.
	model := DLTestModel getOrCreateFrom: {#title->'A nice title'}.
	model save.
	self assert: [(SqsSearch for: DLLogEntry) findAll size = 1]
		  description: 'Since nothing changed, no new log should be created'.
	item := DLTestItemModel createFrom:{#title->'Nummer 3'}.
	model items add: (item).
	model save.
	self assert: [(SqsSearch for: DLLogEntry) findAll size = 2]
		  description: 'Collection changed, a new log entry should be created'.
	model items remove: item.
	model save.
	self assert: [(SqsSearch for: DLLogEntry) findAll size = 3]
		  description: 'Collection changed, a new log entry should be created'.! !

!DLGenericModelTests methodsFor: 'accessing' stamp: 'sebh 7/9/2009 10:37'!
testCollectionProxying
	| model item |
	item := DLTestItemModel createFrom: {#title->'Test'}.
	model := DLTestModel newFrom: {
		#title->'A nice title'.
		#items->(OrderedCollection with: item)
	}.
	model save.
	self assert: (model items class includesBehavior: SqsProxy)! !

!DLGenericModelTests methodsFor: 'accessing' stamp: 'sebh 7/10/2009 16:10'!
testCollectionProxyProtection
	| model item item2 |
	item := DLTestItemModel createFrom: {#title->'Test'}.
	model := DLTestModel newFrom: {
		#title->'A nice title'.
		#items->(OrderedCollection with: item)
	}.
	model save.
	self assert: [model items class includesBehavior: SqsProxy] 
	     description: 'After #save, collections should be proxied'.
	item2 := DLTestItemModel createFrom: {#title->'Test2'}.
	model items: (OrderedCollection with: item2).
	self assert: [model items class includesBehavior: SqsProxy] 
		  description: 'Trying to replace a proxied collection just adds and removes differences but does not replace the original list'.! !

!DLGenericModelTests methodsFor: 'deprecated' stamp: 'sebh 6/27/2009 18:59'!
testCreateFrom
	| model model2 |
	model := DLTestModel createFrom: {#title->'A nice title'}.
	self assert: [ model oid notNil ] description: 'CreateFrom saves an object to a database'.
	model2 := DLTestModel createFrom: {#title->'A nice title'}.
	self assert: [ model oid notNil ] description: 'CreateFrom saves another object to a database, doesnt care about identity'.
	self assert: [ model ~= model2 ] description: 'Objects should not be equal'.! !

!DLGenericModelTests methodsFor: 'deprecated' stamp: 'sebh 6/27/2009 19:13'!
testGetOrCreateFrom
	| model model2 model3 |
	model := DLTestModel getOrCreateFrom: {#title->'A nice title'}.
	self assert: [ model oid notNil ] description: 'GetOrCreateFrom saves an object to a database, if it didnt exist before'.
	model2:= DLTestModel getOrCreateFrom: {#title->'A nice title'}.
	self assert: [model = model2] description: 'Same parameters lead to the same object.'.
	model3:= DLTestModel getOrCreateFrom: {#title->'A nice title'. #body->'Same title, but given text'}.
	self assert: [model2 ~= model3] description: 'Different parameters will create a new object'.! !

!DLGenericModelTests methodsFor: 'deprecated' stamp: 'sebh 6/30/2009 18:24'!
testGetOrCreateFromColisions
	| model1 model2 |
	model1 := DLTestModel getOrCreateFrom: {#title -> 'A nice title'. #body -> 'A body'}.
	model2 := DLTestModel getOrCreateFrom: {#title -> 'A nice title'. #body -> 'Another body'}.
	self assert: [ model1 ~= model2 ] description: 'Different parameters should create different objects'.
	self should: [ DLTestModel getOrCreateFrom: {  (#title -> 'A nice title')  } ]
		  raise: DLMultipleResultsException
		  description: '"A nice title" is set for two objects, thus it is not possible to return a single object that fits the array'! !

!DLGenericModelTests methodsFor: 'deprecated' stamp: 'sebh 6/30/2009 18:21'!
testGetOrCreateNil
	self should: [ DLTestModel getOrCreateFrom: {#title -> 'A nice title'. #body -> nil} ]
		  raise: DLNilValueException
		  description: 'We do not retrieve objects for nil which is to be treated as uncertain value'! !

!DLGenericModelTests methodsFor: 'accessing' stamp: 'sebh 6/30/2009 18:25'!
testLogging
	| model logEntry |
	model := DLTestModel createFrom: {#title->'A nice title'}.
	self assert: [(SqsSearch for: DLLogEntry) findAll size = 1] 
		  description: 'A newly created model with tracked fields creates a log entry'.
	logEntry := (SqsSearch for: DLLogEntry) findAll first.
	self assert: [ (logEntry klassName = 'DLTestModel') & (logEntry oid = model oid) ] 
		  description: 'A new logentry with corresponding info was created'.
	model save.
	self assert: [(SqsSearch for: DLLogEntry) findAll size = 1] 
	     description: 'Having changed nothing, we dont create a new log entry'.
	model title: 'Another title'; save.
	self assert: [(SqsSearch for: DLLogEntry) findAll size = 2] 
	     description: 'Having changed a tracked instvar, we create a new log entry'.
	model body: 'Somebody!!'; save.
	self assert: [(SqsSearch for: DLLogEntry) findAll size = 2] 
	     description: 'Having changed a nontracked instvar, we dont create a new log entry'.! !

!DLGenericModelTests methodsFor: 'deprecated' stamp: 'sebh 7/10/2009 16:18'!
testNewFrom
	| model |
	model := DLTestModel newFrom: {#title->'A nice title'. #items->{'item 1'. 'item 2'}}.
	self assert: [ model title = 'A nice title'] description: 'Correct model title'.
	self assert: [ model items =(OrderedCollection newFrom:{'item 1'. 'item 2'})] description: 'Correct model item collection'.
	self assert: [ model oid isNil ] description: 'newFrom does not invoke a database save'.! !

TestCase subclass: #DLPolicyTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-tests'!

!DLPolicyTests methodsFor: 'as yet unclassified' stamp: 'sebh 7/9/2009 15:31'!
testMetaName
	DLModel allSubclassesDo: [:subclass| 
		self assert: [(subclass perform: #metaName) notEmpty]
			  description: subclass name, ' does not properly implement #metaName (is empty)'
		]! !

!DLPolicyTests methodsFor: 'as yet unclassified' stamp: 'sebh 7/9/2009 15:31'!
testMetaNamePlural
	DLModel allSubclassesDo: [:subclass| 
		self assert: [(subclass perform: #metaNamePlural) notEmpty]
			  description: subclass name, ' does not properly implement #metaNamePlural (is empty)'
		]! !

TestCase subclass: #DLSurveyComponentTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-tests'!

!DLSurveyComponentTests methodsFor: 'testing' stamp: 'PL 8/6/2011 00:59:52.333'!
testDLMAQuestionnaireDescription

	| questionnaireDescription |
	
	questionnaireDescription := DLMAQuestionnaireDescription new.

	self
		assert: [DLMAQuestionnaireDescription defaultKind = Dictionary]
		description: 'Questionnaire editors work only with dictionaries containing ordered collections for headings and surveys.';
		assert: [DLMAQuestionnaireDescription label = 'Questionnaire Editor']
		description: 'The label of the questionnaire editor is incorrect';
		assert: [DLMAQuestionnaireDescription defaultComponentClasses first = DLMAQuestionnaireComponent]
		description: 'This description is primarily designed for use with the questionnaire editor component.';
		should: [questionnaireDescription validateKind: nil] raise: MAKindError
		description: 'Only dictionaries have to be accepted by the questionnaire editor.';
		shouldnt: [questionnaireDescription validateRequired: nil] raise: MARequiredError
		description: 'The questionnaire editor should not have required fields.'! !

TestCase subclass: #DLSurveyTests
	instanceVariableNames: 'models semester user1 user2 user3 lecture survey1 survey2 answer11 answer12 answer21 answer22 questionnaire'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-tests'!

!DLSurveyTests methodsFor: 'accessing' stamp: 'PL 5/11/2011 14:03:19.181'!
models

	^ models! !

!DLSurveyTests methodsFor: 'accessing' stamp: 'PL 5/11/2011 14:04:46.965'!
models: anOrderedCollection

	^ models := anOrderedCollection! !

!DLSurveyTests methodsFor: 'testing-surveys' stamp: 'PL 8/6/2011 00:33:58.811'!
setUp

	super setUp.
	
	"Tell DLModel that it must not make snapshots for every created model"
	DLModel isTestRunning: true.
	
	Transcript show: 'setUp'; cr.
	
	(self models: OrderedCollection new)
		add: (semester := DLSemester createFrom:
			{#semesterName -> 'Test Semester'.
			#year -> Date today year});		
		add: (user1 := DLUser createFrom:
			{#userName -> 'user1'. 
			#realName -> 'User One'. 
			#email -> 'student@deli'. #isAdmin -> false});
		add: (user2 := DLUser createFrom:
			{#userName -> 'user2'. 
			#realName -> 'User Two'. 
			#email -> 'student@deli'. #isAdmin -> false});
		add: (user3 := DLUser createFrom:
			{#userName -> 'user3'. 
			#realName -> 'User Three'. 
			#email -> 'student@deli'. #isAdmin -> true});
		add: (lecture := DLLecture createFrom:
			{#lectureName -> 'Test Lecture'.
			#semester -> semester.
			#students -> (OrderedCollection with: user1 with: user2 with: user3)});
		add: (survey1 := DLSurvey createFrom:
			{#question -> 'Test question?'.
			#lecture ->  lecture.
			#surveyType -> #text});
		add: (answer11 := DLAnswer createFrom:
			{#survey -> survey1.
			#author -> user1.
			#answer -> 'Test answer 1.'});
		add: (answer12 := DLAnswer createFrom:
			{#survey -> survey1.
			#author -> user2.
			#answer -> 'Test answer 2.'});
		add: (survey2 := DLSurvey createFrom:
			{#question -> 'Multiple Choice test question'.
			#lecture -> lecture.
			#surveyType -> #multipleChoice.
			#choices -> (OrderedCollection with: 'A' with: 'B' with: 'C' with: 'D').
			#maxAnswers -> 5.
			#maxAnswersPerChoice -> 3.});
		add: (answer21 := DLAnswer createFrom:
			{#survey -> survey2.
			#author -> user1.
			#answer -> (Dictionary with: 'A' -> 2 with: 'B' -> 1)});
		add: (questionnaire := DLQuestionnaire createFrom:
			{#title -> 'Example questionnaire'.
			#surveys -> (OrderedCollection with: survey1 with: survey2).
			#headings -> (OrderedCollection with: 0 -> 'Misc.')})! !

!DLSurveyTests methodsFor: 'testing-surveys' stamp: 'CM 5/12/2011 22:18:44.794'!
tearDown

	super tearDown.

	self models
		do: [:each | each delete];
		removeAll.
		
	"Switch back to creating snapshots everytime a DLModel instance is created."
	DLModel isTestRunning: false.! !

!DLSurveyTests methodsFor: 'testing-surveys' stamp: 'PL 8/5/2011 23:48:36.061'!
testAnswerDescriptions

	survey1 answers do:
		[:each | self
			assert: [each description notEmpty]
			description: 'The set of descriptions is empty.';
			assert: [each descriptionList notEmpty]
			description: 'The set of descriptions for the list view is empty.';
			assert: [each descriptionCreate notEmpty]
			description: 'The set of descriptions for the create view is empty.';
			assert: [each descriptionUpdate notEmpty]
			description: 'The set of descriptions for the update view is empty.';
			assert: [each descriptionDetail notEmpty]
			description: 'The set of descriptions for the detail view is empty.'].
	
	self
		assert: [DLAnswer descriptionAnswerAsString isKindOf: MADescription]
		description: 'The description has the wrong type';
		assert: [DLAnswer descriptionAuthor isKindOf: MADescription]
		description: 'The description has the wrong type'! !

!DLSurveyTests methodsFor: 'testing-surveys' stamp: 'PL 8/6/2011 00:05:46.514'!
testAnswers

	survey1 answers do:
		[:each | self
			assert: [each author notNil]
			description: 'Author of answer has not been set.';
			assert: [each answer notNil]
			description: 'Content of answer has not been set.';
			assert: [each answerAsString = each canonicalName]
			description: 'For text surveys, the canonical name has to be identical to answerAsString.'].
		
	survey1 answers first answerAsString: 'Manipulated Answer'.

	self
		assert: [survey1 answers first answerAsString = 'Manipulated Answer']
		description: 'Answers are not stored correctly.';
		assert: [answer11 isKindOf: DLAnswer]
		description: 'The answer has a wrong type.';
		should: [answer22 answer] raise: Exception
		description: 'has to fail because object has never been created'.
		
	survey1 answers: survey1 answers.
	
	self
		assert: [survey1 answers notEmpty]
		description: 'Setting a survey''s answer does not work properly.'! !

!DLSurveyTests methodsFor: 'testing-surveys' stamp: 'PL 8/4/2011 19:43:38.72'!
testCanonicalName

	self
		assert: [survey1 canonicalName = survey1 question]
		description: 'The survey''s display name has to be its question.'! !

!DLSurveyTests methodsFor: 'testing-surveys' stamp: 'PL 8/6/2011 00:00:06.288'!
testDescriptions

	| description |
	
	description := 'One of the class-side descriptions is missing or incorrect.'.
	
	self
		assert: [DLSurvey descriptionAdminAnswersVisibility isKindOf: MADescription]
		description: description;
		assert: [DLSurvey descriptionAdminQuestion isKindOf: MADescription]
		description: description;
		assert: [DLSurvey descriptionAdminStatisticsVisibility isKindOf: MADescription]
		description: description;
		assert: [DLSurvey descriptionAdminStatus isKindOf: MADescription]
		description: description;
		assert: [DLSurvey descriptionAdminType isKindOf: MADescription]
		description: description;
		assert: [DLSurvey descriptionAnswers isKindOf: MADescription]
		description: description;
		assert: [DLSurvey descriptionLecture isKindOf: MADescription]
		description: description;
		assert: [DLSurvey descriptionLectureReadonly isKindOf: MADescription]
		description: description;
		assert: [DLSurvey descriptionMyAnswerWrittenOut isKindOf: MADescription]
		description: description;
		assert: [DLSurvey descriptionParticipation isKindOf: MADescription]
		description: description;
		assert: [DLSurvey descriptionLecture isKindOf: MADescription]
		description: description;
		assert: [DLSurvey descriptionUserAnswers isKindOf: MADescription]
		description: description;
		assert: [DLSurvey descriptionUserQuestion isKindOf: MADescription]
		description: description;
		assert: [DLSurvey descriptionUserStatus isKindOf: MADescription]
		description: description;
		assert: [DLSurvey descriptionUserType isKindOf: MADescription]
		description: description! !

!DLSurveyTests methodsFor: 'testing-surveys' stamp: 'PL 8/4/2011 19:48:11.661'!
testInitialChoices

	self
		assert: [survey2 choices class = OrderedCollection]
		description: 'If not set, choices have to be an ordered collection.'! !

!DLSurveyTests methodsFor: 'testing-surveys' stamp: 'PL 8/5/2011 23:02:00.79'!
testMaxAnswers

	self
		assert: [survey2 maxAnswers = 5]
		description: 'The overall maximal amount of answers is stored incorrectly.';
		assert: [survey2 maxAnswersPerChoice = 3]
		description: 'The maximal amount of answers per choice is stored incorrectly.'.! !

!DLSurveyTests methodsFor: 'testing-surveys' stamp: 'PL 8/6/2011 00:02:51.003'!
testMetaNames

	self
		assert: [DLSurvey metaName = 'Umfrage']
		description: 'The meta name for surveys is wrong.';
		assert: [DLSurvey metaNamePlural = 'Umfragen']
		description: 'The meta name plural for surveys is wrong.';
		assert: [DLAnswer metaName = 'Antwort']
		description: 'The meta name for answers is wrong.';
		assert: [DLAnswer metaNamePlural = 'Antworten']
		description: 'The meta name plural for answers is wrong.';
		assert: [DLSurvey invisibleText notNil]
		description: 'A text for invisible answers has to be set.'.

	DLSurvey statusMetaNames detect: [:each | each key = #open] ifNone: [self fail].
	DLSurvey statusImages detect: [:each | each key = #open] ifNone: [self fail].
	DLSurvey typeMetaNames detect: [:each | each key = #text] ifNone: [self fail].
	DLSurvey statisticsVisibilityMetaNames detect: [:each | each key = #nothing] ifNone: [self fail].
	DLSurvey answersVisibilityMetaNames detect: [:each | each key = #group] ifNone: [self fail]! !

!DLSurveyTests methodsFor: 'testing-surveys' stamp: 'PL 8/5/2011 23:40:46.834'!
testMultipleChoiceAnswers

	self
		assert: [answer21 sortedListOfAnswers isKindOf: OrderedCollection]
		description: 'Each answer has to provide an ordered collection of its proper answers.';
		assert: [(answer21 at: 'A') = 2]
		description: 'Multiple choice answers are not stored correctly.'! !

!DLSurveyTests methodsFor: 'testing-surveys' stamp: 'PL 8/5/2011 23:02:07.677'!
testMultipleChoiceFields

	self
		assert: [survey1 areMultipleChoiceFieldsInvisible]
		description: 'Multiple Choice options are displayed for text surveys, but they should not.';
		assert: [survey2 areMultipleChoiceFieldsInvisible = false]
		description: 'Multiple Choice options are not displayed for multiple choice surveys, but they should.'! !

!DLSurveyTests methodsFor: 'testing-surveys' stamp: 'PL 8/5/2011 21:47:21.409'!
testMultipleChoices

	| testChoices |

	self
		assert: [survey1 choices isEmpty]
		description: 'Text surveys should not offer any choices.';
		assert: [survey2 choices notEmpty]
		description: 'Multiple Choice survey should offer at least one choice.'.
		
	testChoices := 'Manipulated Choice A' , String crlf , 'Manipulated Choice B'.

	survey2 choicesAsString: testChoices.
	
	self
		assert: [survey2 choicesAsString = testChoices]
		description: 'The choices are saved or loaded incorrectly.';
		assert: [survey2 choices size = 2]
		description: 'The amount of choices is not correct.'! !

!DLSurveyTests methodsFor: 'testing-surveys' stamp: 'PL 8/5/2011 21:49:00.422'!
testNoAnswerText

	self
		assert: [DLSurvey noAnswerText notNil]
		description: 'A text has to be defined which is displayed when no answer was given.'! !

!DLSurveyTests methodsFor: 'testing-surveys' stamp: 'PL 8/5/2011 21:49:12.005'!
testNumberOfAnswers

	self
		assert: [survey1 numberOfAnswers = survey1 answers size]
		description: 'The number of given answers is incorrect.'! !

!DLSurveyTests methodsFor: 'testing-surveys' stamp: 'PL 8/5/2011 21:49:16.94'!
testNumberOfParticipants

	self
		assert: [survey1 numberOfParticipants = 3]
		description: 'The number of participants is incorrect.'! !

!DLSurveyTests methodsFor: 'testing-surveys' stamp: 'PL 8/5/2011 21:49:23.643'!
testParticipation

	self
		assert: [survey1 participation = #(2 3)]
		description: 'Participation is not computed correctly.'! !

!DLSurveyTests methodsFor: 'testing-surveys' stamp: 'PL 8/5/2011 21:49:28.381'!
testQuestion

	self
		assert: [survey1 question notNil]
		description: 'The survey does not have a question.'! !

!DLSurveyTests methodsFor: 'testing-surveys' stamp: 'PL 8/6/2011 00:46:53.03'!
testQuestionnaireDescriptions

	| description |
	
	description := 'One of the questionnaire''s class-side descriptions is missing or incorrect.'.

	self
		assert: [questionnaire descriptionList notEmpty]
		description: 'The questionnaire description for the list view has to contain some field.';
		assert: [questionnaire descriptionUpdate notEmpty]
		description: 'The questionnaire description for the edit view has to contain some field.';
		assert: [questionnaire descriptionCreate notEmpty]
		description: 'The questionnaire description for the creation view has to contain some field.';
		assert: [questionnaire descriptionDetail notEmpty]
		description: 'The questionnaire description for the detail view has to contain some field.';
		assert: [DLQuestionnaire descriptionAdminTitle isKindOf: MADescription]
		description: description;
		assert: [DLQuestionnaire descriptionEditor isKindOf: MADescription]
		description: description;
		assert: [DLQuestionnaire descriptionLecture isKindOf: MADescription]
		description: description;
		assert: [DLQuestionnaire descriptionNumberOfSurveys isKindOf: MADescription]
		description: description! !

!DLSurveyTests methodsFor: 'testing-surveys' stamp: 'PL 8/6/2011 00:40:46.117'!
testQuestionnaireMetaNames

	self
		assert: [questionnaire canonicalName = questionnaire title]
		description: 'The questionnaire''s canonical name has to match its title.';
		assert: [DLQuestionnaire metaName isString and: (DLQuestionnaire metaName ~= '')]
		description: 'A meta name for questionnaires has to be set.';
		assert: [DLQuestionnaire metaNamePlural isString and: (DLQuestionnaire metaNamePlural ~= '')]
		description: 'A plural of the meta name for questionnaires has to be set.';
		assert: [DLQuestionnaire labelTranslations isDictionary and: (DLQuestionnaire labelTranslations notEmpty)]
		description: 'The questionnaire''s descriptions have to be labeled correctly.'! !

!DLSurveyTests methodsFor: 'testing-surveys' stamp: 'PL 8/6/2011 00:41:54.333'!
testQuestionnaires

	self
		assert: [questionnaire lecture isKindOf: DLLecture]
		description: 'The questionnaire has no corresponding lecture.';
		assert: [((questionnaire editorInfo at: #headings) isKindOf: OrderedCollection)
			and: ((questionnaire editorInfo at: #surveys) isKindOf: OrderedCollection)]
		description: 'The input for the questionnaire editor has the wrong format.';
		assert: [questionnaire numberOfSurveys = 2]
		description: 'The questionnaire''s number of surveys is incorrect.';
		assert: [questionnaire title = 'Example questionnaire']
		description: 'The questionnaire''s title is not saved correctly.';
		assert: [DLQuestionnaire priorities isDictionary and: (DLQuestionnaire priorities notEmpty)]
		description: 'Priorities for the questionnaire''s descriptions have to be set.'.
		
	questionnaire editorInfo: questionnaire editorInfo.
	
	self
		assert: [((questionnaire editorInfo at: #headings) isKindOf: OrderedCollection)
			and: ((questionnaire editorInfo at: #surveys) isKindOf: OrderedCollection)]
		description: 'The data returned from the questionnaire editor cannot be saved correctly.'.! !

!DLSurveyTests methodsFor: 'testing-surveys' stamp: 'PL 8/5/2011 22:10:47.337'!
testReadonlyFields

	self
		assert: [((survey2 statusUser = survey2 status)
			and: (survey2 surveyTypeUser = survey2 surveyType)
			and: (survey2 statisticsUser = survey2 statistics)
			and: (survey2 questionReadonly = survey2 question))
			and: (survey2 maxAnswersPerChoiceReadonly = survey2 maxAnswersPerChoice)
			and: (survey2 maxAnswersReadonly = survey2 maxAnswers)
			and: (survey2 lectureReadonly = survey2 lecture)
			and: (survey2 choicesAsString = survey2 choicesAsStringReadonly)]
		description: 'ReadOnly accessors have to return the same value as the corresponding read/write accessors.'! !

!DLSurveyTests methodsFor: 'testing-surveys' stamp: 'PL 8/6/2011 00:11:53.071'!
testSession

	self
		should: [survey1 myAnswer] raise: Exception
		description: 'Without a session, it should not be possible to obtain an answer.';
		should: [survey1 myAnswer: 'new answer'] raise: Exception
		description: 'Without a session, it should not be possible to set an answer.';
		should: [survey1 myAnswerWrittenOut] raise: Exception
		description: 'Without a session, it should not be possible to obtain an answer.';
		should: [survey1 answersUser] raise: Exception
		description: 'Without a session, it should not be possible to obtain a list of answers.'! !

!DLSurveyTests methodsFor: 'testing-surveys' stamp: 'PL 8/5/2011 21:51:26.778'!
testStatus

	self
		assert: [survey1 status = #hidden]
		description: 'The survey''s initial status has to be #hidden.';
		assert: [(survey1 rightUpdate: user1) = false]
		description: 'Users should only be able to edit surveys being open.';
		assert: [survey1 rightUpdate: user3]
		description: 'Admins should always be able to edit the surveys.'.

	survey1 status: #open.

	self
		assert: [survey1 rightUpdate: user1]
		description: 'Users should have the right to edit their answer if the survey is open.';
		assert: [survey1 rightUpdate: user3]
		description: 'Users should have the right to edit their answer if the survey is open.'! !

!DLSurveyTests methodsFor: 'testing-surveys' stamp: 'PL 8/5/2011 21:51:45.204'!
testTypes

	self
		assert: [survey1 surveyType = #text]
		description: 'The survey type is wrong.';
		assert: [survey2 surveyType = #multipleChoice]
		description: 'The survey type is wrong.'! !

!DLSurveyTests methodsFor: 'testing-surveys' stamp: 'PL 8/5/2011 21:52:42.037'!
testUpdateRights

	self
		assert: [survey1 descriptionUserUpdate size < survey2 descriptionAdminUpdate size]
		description: 'Admins should have more options to edit surveys than users.'! !

!DLSurveyTests methodsFor: 'testing-surveys' stamp: 'PL 8/5/2011 23:55:04.282'!
testViews

	self
		assert: [survey1 descriptionUserDetail size >= survey1 descriptionUserList size]
		description: 'The detail view should not yield less information than the list view.';
		assert: [survey1 descriptionAdminDetail size >= survey1 descriptionAdminList size]
		description: 'The detail view should not yield less information than the list view.';
		assert: [survey1 descriptionCreate isKindOf: MADescription]
		description: 'The creation view description does not exist or has the wrong type.'.
		
	survey1 description do:
		[:each | self
			assert: [each isNil or: (each isKindOf: MADescription)]
			description: 'One of the descriptions is not of type MADescription.']! !

!DLSurveyTests methodsFor: 'testing-surveys' stamp: 'PL 8/5/2011 21:53:23.591'!
testVisibility

	self
		assert: [survey1 statisticsVisibility notNil]
		description: 'The field statisticsVisibility has to be set.';
		assert: [survey1 answersVisibility notNil]
		description: 'The field answersVisibility has to be set.'.! !

TestCase subclass: #WtSeleniumCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-tests'!

WtSeleniumCase subclass: #DLSeleniumTestCase
	instanceVariableNames: 'adminLogInName userLogInName adminPassword userPassword host port'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-tests'!

!DLSeleniumTestCase commentStamp: 'CM 8/5/2011 20:22:04.095' prior: 0!
DLSeleniumTestCase and its subclasses are testcases for the Deli system. They are to be used with the standalone selenium server and a compatible browser.
The tests were developed using selenium-server-standalone-2.0b3 and firefox 3.6.18. There seem to be occasional problems with higher versions of firefox.

Instance Variables
	adminLogInName:		A name of a user with admin rights
	adminPassword:		The password of said admin user
	host:					Where Deli is hosted
	port:					The port that Deli uses
	userLogInName:		A name of a user with user rights
	userPassword:			The password of the user!

DLSeleniumTestCase subclass: #DLSeleniumAnswerSurveysTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-tests'!

!DLSeleniumAnswerSurveysTest methodsFor: 'as yet unclassified' stamp: 'CM 8/8/2011 22:03:18.605'!
answerButton

	^ self linkByXPath: '//tr[5]/td[6]/a/div/img'.! !

!DLSeleniumAnswerSurveysTest methodsFor: 'as yet unclassified' stamp: 'CM 8/8/2011 22:04:08.056'!
answerInputField

	^ self textFieldByXPath: '//div[@id="lightbox"]/form/dl/dd[3]/input'.! !

!DLSeleniumAnswerSurveysTest methodsFor: 'as yet unclassified' stamp: 'CM 8/8/2011 22:04:44.081'!
submitButton
	
	^ self buttonByXPath: '//div[@id="lightbox"]/form/div[2]/input'.! !

!DLSeleniumAnswerSurveysTest methodsFor: 'as yet unclassified' stamp: 'CM 8/8/2011 22:21:04.054'!
testAnswerSurvey

	| answer |
	answer := 'Scrum und XP'.
	self openDeliAsUser.
	self openSurveyUserView.
	self should: (self isTextPresent: 'Welches Thema in SWT fandet ihr am interessantesten?') description: 'The question that supposed to be answered could not be found'.
	self answerButton click waitForPageToLoad.
	self answerInputField text: answer.
	self submitButton click waitForPageToLoad.
	self should: (self isTextPresent: answer) description: 'The answer was not found on the overview page.'.! !

DLSeleniumTestCase subclass: #DLSeleniumFrontpageTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-tests'!

!DLSeleniumFrontpageTest methodsFor: 'testing' stamp: 'CM 8/8/2011 20:40:58.221'!
testDivsArePresent

	| divsToTest |
	divsToTest := #('header' 'menu' 'content' 'component' 'actions' 'footer').
	self openDeliAsAdmin. "divs are the same for User and Admin on the frontpage, so we only need to est this for one."
	divsToTest do: [:each | 
		self should: (self divByXPath: ('//div[@class="' , each , '"]')) isPresent description: ('The div ', each, ' was not found on the front page.'). ].
	"There should be no divs with empty classes"
	self shouldnt: (self divByXPath: '//div[@class=""]') isPresent description: ('divs with empty calsses were found.')! !

!DLSeleniumFrontpageTest methodsFor: 'testing' stamp: 'CM 8/8/2011 20:41:03.926'!
testOpenUrlAndTitle

	self openDeliAsAdmin.
	self should: ['deli submitting system' = self title] description: ('The title of the page is incorrect').! !

DLSeleniumTestCase subclass: #DLSeleniumMenuEntriesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-tests'!

!DLSeleniumMenuEntriesTest methodsFor: 'testing' stamp: 'CM 8/8/2011 20:43:02.377'!
testDLMenuEntriesForAdminByLinkID
	
	| idsToTest |
	idsToTest := #('Lehrveranstaltungen_ID' 'Gruppen_ID' 'Abgaben_ID' 'Themen_ID' 'Benutzer_ID' 'Dateitypen_ID' 'Umfragen_ID' 'Aktuelle Lehrveranstaltungen_ID' 'Aktuelle Themen_ID' 'Meine Lehrveranstaltungen_ID' 'Meine Gruppen_ID' 'Meine Abgaben_ID' 'Mein Profil_ID' 'Meine Umfragen_ID' 'Startseite_ID' 'ausloggen_ID').
	
	self openDeliAsAdmin.
	idsToTest do: [:each | self should: (self linkById: each) isPresent description: ('The String: ', each, ' was not found in Admin view.'). ].! !

!DLSeleniumMenuEntriesTest methodsFor: 'testing' stamp: 'CM 8/8/2011 20:43:09.316'!
testDLMenuEntriesForAdminByLinkText
	
	| stringsToTest |
	stringsToTest := #('Lehrveranstaltungen' 'Gruppen' 'Abgaben' 'Themen' 'Benutzer' 'Dateitypen' 'Umfragen' 'Aktuelle Lehrveranstaltungen' 'Aktuelle Themen' 'Meine Lehrveranstaltungen' 'Meine Gruppen' 'Meine Abgaben' 'Mein Profil' 'Meine Umfragen' 'Startseite').
	stringsToTest := stringsToTest asSortedCollection addLast: (adminLogInName , ' ausloggen'); yourself .
	
	self openDeliAsAdmin.
	stringsToTest do: [:each | self should: (self link: each) isPresent description: ('The String: ', each, ' was not found in Admin view.'). ].! !

!DLSeleniumMenuEntriesTest methodsFor: 'testing' stamp: 'CM 8/8/2011 20:43:15.346'!
testDLMenuEntriesForUserByLinkID
	
	| idsToTest |
	idsToTest := #('Aktuelle Lehrveranstaltungen_ID' 'Aktuelle Themen_ID' 'Meine Lehrveranstaltungen_ID' 'Meine Gruppen_ID' 'Meine Abgaben_ID' 'Mein Profil_ID' 'Meine Umfragen_ID' 'Startseite_ID' 'ausloggen_ID').
	
	self openDeliAsUser.
	idsToTest do: [:each | self should: (self linkById: each) isPresent description: ('The String: ', each, ' was not found in User view.').].! !

!DLSeleniumMenuEntriesTest methodsFor: 'testing' stamp: 'CM 8/8/2011 23:52:04.985'!
testDLMenuEntriesForUserByLinkText
	
	| stringsToTest |
	stringsToTest := #('Aktuelle Lehrveranstaltungen' 'Aktuelle Themen' 'Meine Lehrveranstaltungen' 'Meine Gruppen' 'Meine Abgaben' 'Mein Profil' 'Meine Umfragen' 'Startseite').
	stringsToTest := stringsToTest asSortedCollection addLast: (userLogInName , ' ausloggen'); yourself .
	
	self openDeliAsUser.
	stringsToTest do: [:each | self should: (self link: each) isPresent description: ('The String: ', each, ' was not found in User view.').].! !

DLSeleniumTestCase subclass: #DLSeleniumSurveysTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-tests'!

!DLSeleniumSurveysTest methodsFor: 'testing' stamp: 'CM 8/8/2011 22:14:52.281'!
actionsDivPresent

	| actionsDiv |
	actionsDiv := self divByXPath: '//div[@class="actions"]'.
	self should: actionsDiv isPresent description: 'No "actions" divs were found on the user survey overview page.'.! !

!DLSeleniumSurveysTest methodsFor: 'testing' stamp: 'CM 8/8/2011 22:16:02.524'!
noEmptyClassesPresent

	| emptyClass |
	emptyClass := self divByXPath: '//div[@class=""]'.
	self shouldnt: emptyClass isPresent description: 'Empty classes were found'.! !

!DLSeleniumSurveysTest methodsFor: 'testing' stamp: 'CM 8/8/2011 22:16:32.933'!
testSurveysAdminLinkClick

	| textToTestFor iconpicDiv |
	self openDeliAsAdmin.
	self openSurveyAdminView.
	
	textToTestFor := #('Umfragen' 'Hinzufgen' 'Status' 'Vorlesung' 'Frage' 'Typ' 'Beteiligung' 'SWT 2011 SS' 'Was bedeutet TDD?' '2/4 (50%)').
	textToTestFor do: [:each | self should: (self isTextPresent: each) description: (each , ' was not found')].

	self actionsDivPresent.
	self noEmptyClassesPresent.
	iconpicDiv := self divByXPath: '//div[@class="iconpic"]'.
	self should: iconpicDiv isPresent description: 'No "iconpic" divs were found on the Admin Umfragen page. Icons are missing.'.! !

!DLSeleniumSurveysTest methodsFor: 'testing' stamp: 'CM 8/8/2011 22:12:01.648'!
testSurveysUserLinkClick

	| textToTestFor |
	self openDeliAsUser.
	self openSurveyUserView.
	
	textToTestFor := #('Umfragen' 'Status' 'Vorlesung' 'Frage' 'Meine Antwort').
	textToTestFor do: [:each | self should: (self isTextPresent: each) description: (each , ' was not found')].

	self should: (self divByXPath: ('//div[@class="actions"]')) isPresent description: ('No "actions" divs were found on the User Meine Umfragen page...').
	self shouldnt: (self divByXPath: '//div[@class=""]') isPresent description: 'divs with empty classes were found.'.! !

!DLSeleniumTestCase class methodsFor: 'configuring' stamp: 'CM 8/8/2011 20:41:44.769'!
defaultAppRoot

	^'http://localhost:8080/deli'! !

!DLSeleniumTestCase methodsFor: 'actions' stamp: 'CM 8/8/2011 20:39:01.38'!
openDeliAsAdmin

	self openUrl: 'http://' , adminLogInName , ':' , adminPassword , '@', host , ':' , port , '/deli'.! !

!DLSeleniumTestCase methodsFor: 'actions' stamp: 'CM 8/8/2011 20:39:09.253'!
openDeliAsUser

	self openUrl: 'http://' , userLogInName , ':' , userPassword , '@', host , ':' , port , '/deli'.! !

!DLSeleniumTestCase methodsFor: 'actions' stamp: 'CM 8/8/2011 21:46:04.261'!
openSurveyAdminView

	((self linkById: 'Umfragen_ID') click) waitForPageToLoad.! !

!DLSeleniumTestCase methodsFor: 'actions' stamp: 'CM 8/8/2011 21:46:16.006'!
openSurveyUserView

	((self linkById: 'Meine Umfragen_ID') click) waitForPageToLoad.! !

!DLSeleniumTestCase methodsFor: 'running' stamp: 'CM 8/8/2011 20:39:26.559'!
setUp
	
	super setUp.
	
	DeliSetup new InstallDatabase.
	
	"Allow authentification with username + arbitrary password"
	DLPreAuthentication allowExistingUsersViaBasicAuth: true.
	
	adminLogInName := 'admin'.
	userLogInName := 'martin'.
	adminPassword := 'a'.
	userPassword := 'a'.	
	host := 'localhost'.
	port := '8080'.! !

!DLSeleniumTestCase methodsFor: 'running' stamp: 'CM 8/8/2011 20:39:33.049'!
tearDown
	
	"Reset the database (including test users)"
	DeliSetup new InstallDatabase.! !

!DLSeleniumTestCase methodsFor: 'testing' stamp: 'CM 8/8/2011 20:40:06.555'!
testopenDeliAsAdmin

	self openDeliAsAdmin.! !

!DLSeleniumTestCase methodsFor: 'testing' stamp: 'CM 8/8/2011 20:40:13.535'!
testopenDeliAsUser

	self openDeliAsUser.! !

MAExternalFileModel subclass: #DLMAExternalFileModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMAExternalFileModel methodsFor: 'accessing' stamp: 'sebh 6/14/2009 01:33'!
calcFilesize
	filesize := self contents size.! !

!DLMAExternalFileModel methodsFor: 'accessing' stamp: 'sebh 6/14/2009 01:35'!
filesize: aFilesize
	"Allow to manually set filesize so we can save it somewhere else."
	filesize := aFilesize.! !

!DLMAExternalFileModel methodsFor: 'accessing' stamp: 'tfel 1/13/2010 22:04'!
finalize

	super initialize! !

!DLMAExternalFileModel methodsFor: 'accessing' stamp: 'sebh 6/14/2009 01:30'!
isEmpty
	^ location isEmpty! !

!DLMAExternalFileModel methodsFor: 'accessing' stamp: 'Marik 7/20/2009 15:53'!
location: aLocation
	| directory |
	location := aLocation.
	directory := self baseDirectory.
	directory assureExistence.
	aLocation do: [:each |
		directory := directory directoryNamed: each.
		directory assureExistence.
	]! !

WAComponent subclass: #DLComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

DLComponent subclass: #DLAdminConfirmDeleteComp
	instanceVariableNames: 'deleteElement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLAdminConfirmDeleteComp class methodsFor: 'initialize' stamp: 'sebh 6/15/2009 11:04'!
for: anElement
	^ self new
		deleteElement: anElement;
		yourself.! !

!DLAdminConfirmDeleteComp methodsFor: 'accessing' stamp: 'sebh 6/15/2009 11:12'!
deleteElement

	^ deleteElement! !

!DLAdminConfirmDeleteComp methodsFor: 'accessing' stamp: 'sebh 6/15/2009 11:12'!
deleteElement: anObject

	deleteElement := anObject.! !

!DLAdminConfirmDeleteComp methodsFor: 'permission' stamp: 'sebh 6/15/2009 11:14'!
permissionCheck
	^ self session user isAdmin! !

!DLAdminConfirmDeleteComp methodsFor: 'rendering' stamp: 'martin 7/24/2009 17:23'!
renderContent: html
	
	self renderDeletionConfirmation: html.
	self renderDependencies: html.
	html break.
	self renderDeletionConfirmation: html.! !

!DLAdminConfirmDeleteComp methodsFor: 'rendering' stamp: 'TimFelgentreff 01/13/2011 04:57'!
renderDeletionConfirmation: html

	html text: 'Mchten sie "', self deleteElement asString, '" wirklich lschen?'; break.
	
	html anchor 
				callback: [self answer: true];
				with: 'Ja'.
	html text: ' | '.
	html anchor
				callback: [self answer: false];
				with: 'Nein'.
	html break.
	html break.! !

!DLAdminConfirmDeleteComp methodsFor: 'rendering' stamp: 'martin 7/24/2009 17:09'!
renderDependencies: html
	|dependencies lastDependency|
	lastDependency := ''.
	dependencies := self deleteElement collectDependencies.
	html paragraph: 'Folgende Element werden durch bestehende Abhngigkeiten ebenfalls gelscht'.
	html unorderedList:
		[
			dependencies do: [:aDependency | 
				html listItem: [
					lastDependency = (aDependency class metaName) ifFalse: [
						html div class: 'deletionDescription'; with: 
							aDependency class metaName, ':'.].
						
					lastDependency = (aDependency class metaName) ifTrue: [
						html div class: 'deletionDescription'; with: [
							html text: '-'].].
						
					html anchor
						callback: [self call: (DLAdminDetailComp for: aDependency)];
						with: [
							html div class: 'deletionItem'; with: [
								html text: aDependency canonicalName
							]
						].
					html div class: 'clearFloat'.
					lastDependency := aDependency class metaName.
				]	
			]
		]! !

DLComponent subclass: #DLAdminDeadlineZipComp
	instanceVariableNames: 'deadline lecture zipFile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLAdminDeadlineZipComp class methodsFor: 'as yet unclassified' stamp: 'topa 3/17/2010 19:49'!
for: aDlModel
	
	| zipComponent |
	zipComponent := self new.
	(aDlModel isA: DLDeadline) ifTrue: [zipComponent deadline: aDlModel].
	(aDlModel isA: DLLecture) ifTrue: [zipComponent lecture: aDlModel].
	^ zipComponent! !

!DLAdminDeadlineZipComp methodsFor: 'zipping' stamp: 'tfel 11/02/2011 10:01'!
baseDirectory

	^ DLMAExternalFileModel baseDirectory pathName, FileDirectory slash! !

!DLAdminDeadlineZipComp methodsFor: 'accessing' stamp: 'tfel 2/13/2010 23:51'!
deadline
	^ deadline! !

!DLAdminDeadlineZipComp methodsFor: 'accessing' stamp: 'tfel 1/12/2011 14:18'!
deadline: anObject
	deadline := anObject.
	self lecture: deadline lecture.! !

!DLAdminDeadlineZipComp methodsFor: 'accessing' stamp: 'topa 3/17/2010 20:03'!
lecture
	^ lecture! !

!DLAdminDeadlineZipComp methodsFor: 'accessing' stamp: 'topa 3/17/2010 20:03'!
lecture: anObject
	lecture := anObject! !

!DLAdminDeadlineZipComp methodsFor: 'as yet unclassified' stamp: 'topa 01/02/2012 12:38'!
respond

	self requestContext respond: [:response |
		response
			binary;
			contentType: (WAMimeType main: 'application' sub: 'zip');
			nextPutAll: self createZipFile]! !

!DLAdminDeadlineZipComp methodsFor: 'zipping' stamp: 'tfel 1/12/2011 14:25'!
zipDirectoryPath

	| directory |
	directory := (self lecture semester asString, FileDirectory slash, self lecture lectureName).
	self deadline ifNotNil: [
		directory := directory, FileDirectory slash, self deadline canonicalName.
		self deadline group ifNotNil: [
			directory := directory, FileDirectory slash, self deadline group canonicalName]].
	^ directory! !

DLComponent subclass: #DLChartComp
	instanceVariableNames: 'count max'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLChartComp class methodsFor: 'accessing' stamp: 'Marik 7/1/2009 12:10'!
count: aCount of: aMaxValue

	^self new
		count: aCount;
		max: aMaxValue;
		yourself.! !

!DLChartComp methodsFor: 'accessing' stamp: 'Marik 7/1/2009 12:06'!
count

	^ count! !

!DLChartComp methodsFor: 'accessing' stamp: 'Marik 7/1/2009 12:06'!
count: anObject

	count := anObject.! !

!DLChartComp methodsFor: 'accessing' stamp: 'Marik 7/1/2009 12:06'!
max

	^ max! !

!DLChartComp methodsFor: 'accessing' stamp: 'Marik 7/1/2009 12:06'!
max: anObject

	max := anObject.! !

!DLChartComp methodsFor: 'permission' stamp: 'Marik 7/1/2009 12:14'!
permissionCheck
	^ self session isLoggedIn.! !

!DLChartComp methodsFor: 'rendering' stamp: 'Marik 7/24/2009 16:47'!
renderContent: html
	| perCent perCentString |
	(self max isZero)
		ifTrue:[
			perCent := 0]
		ifFalse:[
			perCent := ((self count / self max) asFloat * 100) rounded].
	perCentString := perCent asString, '%'.
	html text: 'Fortschritt: ';
		  text: self count asString, '/', self max asString, ' Abgaben sind komplett.'.
	html div class:'graph';	  with: [html strong class:'bar'; style:'width: ', perCent asString,'%;'; 
												with: [html text: perCentString]].! !

!DLComponent methodsFor: 'accessing' stamp: 'cr 7/23/2009 19:39'!
initialize
	super initialize.! !

!DLComponent methodsFor: 'accessing' stamp: 'cr 7/23/2009 19:29'!
menuItem
	^nil.! !

!DLComponent methodsFor: 'permission' stamp: 'MG 6/5/2009 15:29'!
permissionCheck

	^ false.! !

!DLComponent methodsFor: 'rendering' stamp: 'MG 6/5/2009 15:29'!
renderContent: html

	self subclassResponsibility! !

!DLComponent methodsFor: 'rendering' stamp: 'topa 04/28/2010 16:53'!
renderContentOn: html

	html div class: 'component'; with:[
	self permissionCheck 
		ifTrue: [self renderContent: html.]
		ifFalse:[html heading level3; with: 'Permission denied']].
	self menuItem ifNotNil: [
		self session activeMenuEntry: self menuItem.
	].! !

DLComponent subclass: #DLDetailComp
	instanceVariableNames: 'detailElement additionalComps'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

DLDetailComp subclass: #DLAdminDetailComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

DLAdminDetailComp subclass: #DLAdminDeliveryDetailComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLAdminDeliveryDetailComp class methodsFor: 'as yet unclassified' stamp: 'tfel 2/9/2010 11:33'!
for: aDeadline user: aUser
	| group delivery deliverables |
	
	group := aDeadline group.
	group ifNotNil:[
		delivery := DLDelivery getOrCreateFrom: {#group -> group. #deadline -> aDeadline.}.
		deliverables := OrderedCollection new.
		delivery deliverables do: [:aDeliverable | deliverables add: (aDeliverable descriptionUpdate asComponentOn: 		aDeliverable) addForm].
		^ self for: delivery additionalComps: deliverables]
	ifNil: [^ DLAdminGroupSelectListComp subject: aDeadline user: aUser].! !

!DLAdminDeliveryDetailComp class methodsFor: 'as yet unclassified' stamp: 'tfel 2/9/2010 11:25'!
for: aDeadline user: aUser group: aGroup
	
	| delivery deliverables |
	delivery := DLDelivery getOrCreateFrom: {#group -> aGroup. #deadline -> aDeadline.}.
	deliverables := OrderedCollection new.
	delivery deliverables do: [:aDeliverable | deliverables add: (aDeliverable descriptionUpdate asComponentOn: 		aDeliverable) addForm].
	^ self for: delivery additionalComps: deliverables! !

!DLAdminDeliveryDetailComp methodsFor: 'as yet unclassified' stamp: 'tfel 2/13/2010 15:43'!
renderContent: html
	self renderActions: html.
	html definitionList with: [
		self detailElement descriptionDetail do: [:desc |
			html definitionTerm: desc label.
			html definitionData: (desc accessor read: (self detailElement))
		]
	].
	additionalComps do: [:each | 
			html div with: each.
			html break; break].! !

!DLAdminDetailComp methodsFor: 'as yet unclassified' stamp: 'CO 5/12/2011 18:23:51.815'!
detailDescription

	 ^ self detailElement descriptionAdminDetail! !

!DLAdminDetailComp methodsFor: 'permission' stamp: 'Marik 6/4/2009 21:21'!
permissionCheck

	^ self session user isAdmin! !

!DLAdminDetailComp methodsFor: 'as yet unclassified' stamp: 'CO 5/12/2011 18:24:57.424'!
updateDescription

	 ^ self detailElement descriptionAdminUpdate! !

!DLDetailComp class methodsFor: 'accessing' stamp: 'MG 6/5/2009 15:28'!
for: anDetailElement

	^self new
		detailElement: anDetailElement;
		yourself.! !

!DLDetailComp class methodsFor: 'accessing' stamp: 'cr 6/6/2009 17:16'!
for: anDetailElement additionalComp: aComponent
	^self for: anDetailElement additionalComps: {aComponent}! !

!DLDetailComp class methodsFor: 'accessing' stamp: 'cr 6/6/2009 17:15'!
for: anDetailElement additionalComps: aComponentList

	|new|
	new := self new
		detailElement: anDetailElement.
	new additionalComps addAll: aComponentList.
	^ new.! !

!DLDetailComp methodsFor: 'accessing' stamp: 'sebh 6/6/2009 16:39'!
additionalComps
	^ additionalComps! !

!DLDetailComp methodsFor: 'accessing' stamp: 'sebh 6/6/2009 16:39'!
additionalComps: anObject 
	additionalComps := anObject! !

!DLDetailComp methodsFor: 'initialize' stamp: 'sebh 6/6/2009 16:44'!
children
	^ self additionalComps asArray.! !

!DLDetailComp methodsFor: 'as yet unclassified' stamp: 'CO 5/12/2011 18:23:33.275'!
detailDescription

	 ^ self detailElement descriptionDetail! !

!DLDetailComp methodsFor: 'accessing' stamp: 'Marik 6/4/2009 21:09'!
detailElement

	^ detailElement! !

!DLDetailComp methodsFor: 'accessing' stamp: 'Marik 6/4/2009 21:09'!
detailElement: anObject

	detailElement := anObject.! !

!DLDetailComp methodsFor: 'initialize' stamp: 'sebh 6/6/2009 16:44'!
initialize

	super initialize.
	self additionalComps: OrderedCollection new.! !

!DLDetailComp methodsFor: 'permission' stamp: 'Marik 6/4/2009 21:14'!
permissionCheck
	
	^ self session isLoggedIn! !

!DLDetailComp methodsFor: 'rendering' stamp: 'PL 5/13/2011 01:07:07.931'!
renderActions: html
	html div class: 'actions'; with: [
		(self detailElement rightUpdate: self session user) ifTrue: [
			html anchor
				callback: [| answer |
					answer := self call: (self updateDescription asComponentOn: self detailElement) addForm.
					answer ifNotNil: [self detailElement save]];
				with: [html image url: DLFileLibrary / #editPng].
			html text: ' '.
			].
		self detailElement trackChangeVariables ifNotEmpty: [
			html anchor
				callback: [ self call: (DLListComp for: DLLogEntry 
					 										  with: {#klassName->self detailElement className. #objectId->self detailElement oid}
			 	  )];
				with: [html image url: DLFileLibrary / #logPng].
			html text: ' '.
			].
		html anchor
			callback: [self answer: true];
			with: [html image url: DLFileLibrary / #backPng]
		].! !

!DLDetailComp methodsFor: 'rendering' stamp: 'CO 5/25/2011 14:04:29.211'!
renderContent: html
	| descriptionCopy |
	
	html heading level: 2; with: (self detailElement class metaName,': ',self detailElement canonicalName).
	self renderActions: html.
	descriptionCopy := self detailDescription collect:[:desc|desc copy beReadonly; yourself.].
	html render: (descriptionCopy asComponentOn: self detailElement).
	self additionalComps do: [:each | 
		html render: each.
	].! !

!DLDetailComp methodsFor: 'as yet unclassified' stamp: 'CO 5/12/2011 18:24:46.248'!
updateDescription

	 ^ self detailElement descriptionUpdate! !

DLDetailComp subclass: #DLUserDetailComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

DLUserDetailComp subclass: #DLUserDeliveryDetailComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLUserDeliveryDetailComp class methodsFor: 'accessing' stamp: 'tfel 2/13/2010 16:48'!
for: aDeadline user: aUser
	| group delivery deliverables |
	
	group := aUser groupForLecture: aDeadline lecture.
	group ifNotNil:[
		delivery := DLDelivery getOrCreateFrom: {#group -> group. #deadline -> aDeadline.}.
		deliverables := OrderedCollection new.
		delivery deliverables do: [:aDeliverable | deliverables add: (aDeliverable descriptionUpdate asComponentOn: 		aDeliverable) addForm].
		^ self for: delivery additionalComps: deliverables]
	ifNil: [^ self for: (DLDelivery getOrCreateFrom: {#deadline -> aDeadline.}) additionalComps: OrderedCollection new].! !

!DLUserDeliveryDetailComp methodsFor: 'permission' stamp: 'MG 7/23/2009 17:32'!
permissionCheck
	
	^ self session isLoggedIn! !

!DLUserDeliveryDetailComp methodsFor: 'rendering' stamp: 'tfel 2/13/2010 16:42'!
renderAdditionalComps: html

	additionalComps do: [:each | 
		html div with: each.
		html break; break].! !

!DLUserDeliveryDetailComp methodsFor: 'rendering' stamp: 'tfel 2/13/2010 17:02'!
renderContent: html
	self renderActions: html.
	html definitionList with: [
		self detailElement descriptionDetail do: [:desc |
			html definitionTerm: desc label.
			html definitionData: (desc accessor read: (self detailElement))
		]
	].
	self additionalComps 
		ifEmpty: [html text: 'Bitte trete erst einer Gruppe bei.']
		ifNotEmpty: [
			(self detailElement deadline isExpired) ifTrue: [
				html div with: 'Abgabetermin ist ausgelaufen.'. html break; break.
				additionalComps := {(DLUserListComp for: DLDeliverable with: {#delivery->self detailElement})}].
			self renderAdditionalComps: html]! !

!DLUserDetailComp methodsFor: 'as yet unclassified' stamp: 'CO 5/12/2011 18:24:08.707'!
detailDescription

	 ^ self detailElement descriptionUserDetail! !

!DLUserDetailComp methodsFor: 'rendering' stamp: 'PL 5/16/2011 16:31:17.282'!
renderActions: html
	
	html div class: 'actions'; with: [
		(self detailElement rightUpdate: self session user) ifTrue: [
			html anchor
				callback: [| answer |
					answer := self call: (self updateDescription asComponentOn: self detailElement) addForm.
					answer ifNotNil: [self detailElement save]];
				with: [html image url: DLFileLibrary / #editPng].
			html text: ' '.
			].
		html anchor
			callback: [self answer: true];
			with: [html image url: DLFileLibrary / #backPng]
		].! !

!DLUserDetailComp methodsFor: 'as yet unclassified' stamp: 'CO 5/12/2011 18:25:06.473'!
updateDescription

	 ^ self detailElement descriptionUserUpdate! !

DLUserDetailComp subclass: #DLUserLectureDetailComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLUserLectureDetailComp methodsFor: 'rendering' stamp: 'TimFelgentreff 01/13/2011 05:00'!
renderActions: html
	html div class: 'actions'; with: [
		html anchor
			callback: [|answer group|
					group := DLGroup newFrom: {#lecture->self detailElement}.
					answer := self call: (group descriptionUpdate asComponentOn: group) addForm.
					answer ifNotNil: [group save]];
			with: 'Gruppe anlegen'.
		].! !

DLUserDetailComp subclass: #DLUserProfileDetailComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLUserProfileDetailComp methodsFor: 'rendering' stamp: 'TimFelgentreff 01/13/2011 05:00'!
renderActions: html
	"Duplicate from DLDetailComp"
	html div class: 'actions'; with: [
		(self detailElement rightUpdate: self session user) ifTrue: [
			html anchor
				callback: [|answer|
					answer := self call: (self detailElement descriptionUserUpdate asComponentOn: self detailElement) addForm.
					answer ifNotNil: [self detailElement save]];
				with: 'Bearbeiten'.
			].
		].! !

DLComponent subclass: #DLFrontPageComp
	instanceVariableNames: 'reportComps'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLFrontPageComp methodsFor: 'initialize' stamp: 'cr 7/20/2009 17:29'!
children
	^ self reportComps asArray! !

!DLFrontPageComp methodsFor: 'initialize' stamp: 'cr 7/23/2009 19:23'!
initialize
	
	super initialize.
	self session activeMenuEntry: 'Startseite'.
	self reportComps: OrderedCollection new.
	
	self session user isAdmin ifTrue: [
		self initializeAdminView.
		]
	ifFalse: [
		self initializeUserView.
	].! !

!DLFrontPageComp methodsFor: 'initialize' stamp: 'cr 7/21/2009 15:04'!
initializeAdminView
	self reportComps add: DLAdminRelatedDeadLineListComp new;
		add: DLAdminCurrentLectureListComp new;
		add: DLAdminUpcomingLectureListComp new.! !

!DLFrontPageComp methodsFor: 'initialize' stamp: 'cr 7/21/2009 15:09'!
initializeUserView
	self reportComps add: (DLUserDeadlineListComp for: self session user);
		add: DLUserChosenLectureListComp new.! !

!DLFrontPageComp methodsFor: 'permission' stamp: 'cr 7/18/2009 22:11'!
permissionCheck
	^ self session isLoggedIn.! !

!DLFrontPageComp methodsFor: 'rendering' stamp: 'topa 04/28/2010 16:54'!
renderContent: html

	html heading
		level: 1;
		with: 'Willkommen bei Deli'.
	
	self reportComps do: [ :aReport |
		html div with: aReport.
	].! !

!DLFrontPageComp methodsFor: 'accessing' stamp: 'cr 7/20/2009 17:30'!
reportComps

	^ reportComps! !

!DLFrontPageComp methodsFor: 'accessing' stamp: 'cr 7/20/2009 17:30'!
reportComps: anObject

	reportComps := anObject.! !

DLComponent subclass: #DLGroupToTopicListComp
	instanceVariableNames: 'lecture'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLGroupToTopicListComp class methodsFor: 'as yet unclassified' stamp: 'topa 4/26/2010 20:44'!
for: aDlLecture

	^ self new 
		lecture: aDlLecture;
		yourself! !

!DLGroupToTopicListComp methodsFor: 'accessing' stamp: 'topa 4/26/2010 20:44'!
lecture
	^ lecture! !

!DLGroupToTopicListComp methodsFor: 'accessing' stamp: 'topa 4/26/2010 20:44'!
lecture: anObject
	lecture := anObject! !

!DLGroupToTopicListComp methodsFor: 'as yet unclassified' stamp: 'topa 4/28/2010 18:32'!
permissionCheck
	
	^ true! !

!DLGroupToTopicListComp methodsFor: 'as yet unclassified' stamp: 'tfel 11/02/2011 11:08'!
renderContent: html

	| groupsUsersTopics |
	groupsUsersTopics := (self lecture groups sort collect: [:group || students topics topicColl |
		students := ''.
		group students 
			do: [:s | students := students, s canonicalName]
			separatedBy: [students := students, ', '].
		topics := ''.
		topicColl := Set new.
		(group students do: [:student |
			topicColl addAll: (self lecture topics select: [:topic |
				topic students includes: student.
			]).
		]).
		(topicColl asSortedCollection sortBy: [:a :b | 
			(a students select: [:s | group students includes: s]) size > 
				(b students select: [:s | group students includes: s]) size])
			do: [:topic | topics := topics, topic canonicalName]
			separatedBy: [topics := topics, ', '].
		{group canonicalName . students . topics}.
	]).

	self renderTitle: html.
	html table
		style: 'display:none';
		with: [
			html tableHead
				style: 'font-weight: bold'; 
				with: [{'Gruppe'. 'Gruppenmitglieder'. 'Themen, sortiert nach Zustimmung'} do: [:head |
						html tableData: [html text: head]	]].
			groupsUsersTopics withIndexDo: [:arr :idx | 
			html tableRow
				class: ((idx \\ 2) odd ifTrue: ['odd'] ifFalse: ['even']);
				with: [
					arr do: [:each |
						html tableData: [html text: each]]]]].! !

!DLGroupToTopicListComp methodsFor: 'as yet unclassified' stamp: 'topa 4/28/2010 18:47'!
renderTitle: html

	html heading
		level: 3;
		with: [
			html text: 'Gruppen, Nutzer, Themen'.
			html anchor onClick: '$(this).up().next(''table'').toggle()';
			with: [html image url: DLFileLibrary / #togglePng]].! !

DLComponent subclass: #DLListComp
	instanceVariableNames: 'listClass magritteReport hiddenStart collectionFields valueFields'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

DLListComp subclass: #DLAdminListComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

DLAdminListComp subclass: #DLAdminDeadLineListComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLAdminDeadLineListComp methodsFor: 'rendering' stamp: 'Marik 7/24/2009 10:43'!
actions
	^ { 
		((self listClass rightCreate: self session user) -> (#add -> 
				[ | answer listElement |
				listElement := self listClass newFrom: self valueFields.
				answer := self lightbox: ((listElement descriptionCreateForLecture asComponentOn: listElement) addForm; yourself).
				answer ifNotNil: [ listElement save ].
				self refreshReport ]))
	 }! !

!DLAdminDeadLineListComp methodsFor: 'rendering' stamp: 'topa 01/02/2012 12:33'!
columnDetail
	^ DLMACommandColumn new
		useImages: true;
		addCommand: [:listElement | 
			self call: (DLAdminDetailComp for: listElement additionalComps: {
										(DLChartComp count: listElement countDeliveriesComplete of: listElement deliveries size).
										(DLAdminDeliveryListComp with: {(#deadline -> listElement) })})]
		text: #details;
		addCommand: [:listElement | self call: (DLAdminDeliveryDetailComp for: listElement user: self session user)]
		text: #disk;
		addCommand: [:listElement | (DLAdminDeadlineZipComp for: listElement) respond]
		text: #zip;
		addCommand: [:listElement || answer newListElement |
				newListElement := listElement copy oid: nil; group: nil; yourself.
				answer := self lightbox: ((newListElement descriptionUpdate asComponentOn: newListElement) addForm; yourself).
				answer ifNotNil: [ newListElement save ].
				self refreshReport]
		text: #copy;
		yourself! !

!DLAdminDeadLineListComp methodsFor: 'rendering' stamp: 'sebh 6/13/2009 22:29'!
listClass
	^ DLDeadline! !

!DLAdminDeadLineListComp methodsFor: 'rendering' stamp: 'cr 7/23/2009 19:31'!
menuItem

	^'Abgaben'! !

DLAdminDeadLineListComp subclass: #DLAdminRelatedDeadLineListComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLAdminRelatedDeadLineListComp methodsFor: 'rendering' stamp: 'cr 7/20/2009 19:39'!
actions

	^{}! !

!DLAdminRelatedDeadLineListComp methodsFor: 'rendering' stamp: 'Marik 7/24/2009 16:50'!
columnDetail
^ (DLMACommandColumn new
	useImages: true;
			addCommand: [:listElement |
					self session announcer announce: ((DLViewCompReplacement) forComponent:  (
						DLAdminDetailComp for: listElement 
							additionalComps: {(DLChartComp count: listElement countDeliveriesComplete of: listElement deliveries size).(DLAdminDeliveryListComp with: {#deadline->listElement}).}
					))
			]
			text: #details;
			yourself).! !

!DLAdminRelatedDeadLineListComp methodsFor: 'convenience' stamp: 'tfel 2/13/2010 15:58'!
endDate

	^ Date today addDays: 14! !

!DLAdminRelatedDeadLineListComp methodsFor: 'rendering' stamp: 'tfel 2/13/2010 15:57'!
listObjects
	^ DLDeadline instances
		select: [:t1 | t1 lecture teacher = self session user
				| (t1 lecture assistants includes: self session user)
				| (t1 lecture studentAssistants includes: self session user) 
				and: [(t1 date < self endDate) and: [t1 date > (Date today addDays: -7)]]]! !

!DLAdminRelatedDeadLineListComp methodsFor: 'rendering' stamp: 'tfel 2/13/2010 16:02'!
reportTitle
	
	^'Abgabetermine von ', (self startDate printFormat: #(1 2 3 $. 1 1)), ' bis ', (self endDate printFormat: #(1 2 3 $. 1 1))! !

!DLAdminRelatedDeadLineListComp methodsFor: 'convenience' stamp: 'tfel 2/13/2010 15:58'!
startDate

	^ Date today addDays: -7! !

DLAdminListComp subclass: #DLAdminDeliveryListComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLAdminDeliveryListComp methodsFor: 'rendering' stamp: 'tfel 2/13/2010 18:08'!
columnDetail
	| detailBlock |
	detailBlock := [:listElement | 
		self call: (DLAdminDetailComp for: listElement 
						additionalComps: {(DLAdminListComp for: DLDeliverable with: {#delivery->listElement})})].
^ (DLMAConditionalCommandColumn new
			addCommand: detailBlock
			condition: [:listElement| listElement isComplete]
			text: 'Komplett';
			addCommand: detailBlock
			condition: [:listElement| listElement isComplete not]
			text: 'Nicht komplett';
			yourself).! !

!DLAdminDeliveryListComp methodsFor: 'rendering' stamp: 'sebh 6/13/2009 22:36'!
listClass
	^ DLDelivery! !

!DLAdminDeliveryListComp methodsFor: 'rendering' stamp: 'tfel 6/22/2010 12:33'!
listObjects
	| deadline |
	deadline := self valueFieldsAt: #deadline.
	deadline ifNotNil: [
		deadline group 
			ifNil: [(DLGroup instances select: [:group | group lecture = deadline lecture])
					do: [:group | DLDelivery getOrCreateFrom: {#deadline -> deadline. #group -> group}]]
			ifNotNil: [DLDelivery getOrCreateFrom: {#deadline -> deadline. #group -> deadline group}]].
	^ super listObjects! !

DLAdminListComp subclass: #DLAdminGroupListComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLAdminGroupListComp methodsFor: 'rendering' stamp: 'MH 5/24/2011 15:58:37.848'!
columnDetail
	^ DLMACommandColumn new
		useImages: true;
		addCommand: 
				[ :listElement | 
				self call: (DLAdminDetailComp 
						for: listElement
						additionalComps: { 
								(DLAdminListComp 
									for: DLDeadline
									with: {  (#group -> listElement). (#lecture -> listElement lecture)  }).
							 }) ]
			text: #details;
		yourself! !

!DLAdminGroupListComp methodsFor: 'rendering' stamp: 'caro 7/15/2009 17:27'!
listClass
	^ DLGroup.! !

!DLAdminGroupListComp methodsFor: 'rendering' stamp: 'cr 7/23/2009 19:32'!
menuComp

	^'Gruppen'! !

!DLAdminGroupListComp methodsFor: 'rendering' stamp: 'cr 7/23/2009 19:40'!
menuItem

	^'Gruppen'! !

DLAdminListComp subclass: #DLAdminGroupSelectListComp
	instanceVariableNames: 'subject subjectUser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLAdminGroupSelectListComp class methodsFor: 'as yet unclassified' stamp: 'tfel 2/9/2010 11:38'!
subject: aModel user: aUser
	
	^ self new
		subject: aModel;
		subjectUser: aUser;
		yourself! !

!DLAdminGroupSelectListComp methodsFor: 'rendering' stamp: 'tfel 2/9/2010 11:43'!
columnDetail

	^ DLMACommandColumn new
		useImages: true;
		addCommand: 
				[ :listElement |
				self call: (DLAdminDeliveryDetailComp for: self subject user: self subjectUser group: listElement)]
			text: #disk;
		yourself! !

!DLAdminGroupSelectListComp methodsFor: 'as yet unclassified' stamp: 'tfel 2/9/2010 11:41'!
listClass
	^ DLGroup.! !

!DLAdminGroupSelectListComp methodsFor: 'as yet unclassified' stamp: 'tfel 7/26/2010 11:26'!
listSelectBlock

	^ [:aGroup | aGroup notNil and: [self subject lecture = aGroup lecture]]! !

!DLAdminGroupSelectListComp methodsFor: 'as yet unclassified' stamp: 'tfel 2/9/2010 11:49'!
reportTitle

	^ 'Diese Abgabe gilt fuer mehrere Gruppen. Bitte eine selektieren, fuer die die Abgabe bearbeitet werden soll (Disk Icon)'! !

!DLAdminGroupSelectListComp methodsFor: 'accessing' stamp: 'tfel 2/9/2010 11:39'!
subject
	^ subject! !

!DLAdminGroupSelectListComp methodsFor: 'accessing' stamp: 'tfel 2/9/2010 11:39'!
subject: anObject
	subject := anObject! !

!DLAdminGroupSelectListComp methodsFor: 'accessing' stamp: 'tfel 2/9/2010 11:39'!
subjectUser
	^ subjectUser! !

!DLAdminGroupSelectListComp methodsFor: 'accessing' stamp: 'tfel 2/9/2010 11:39'!
subjectUser: anObject
	subjectUser := anObject! !

DLAdminListComp subclass: #DLAdminLectureListComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

DLAdminLectureListComp subclass: #DLAdminCurrentLectureListComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLAdminCurrentLectureListComp methodsFor: 'rendering' stamp: 'cr 7/20/2009 19:31'!
actions
	^{}! !

!DLAdminCurrentLectureListComp methodsFor: 'rendering' stamp: 'cr 7/20/2009 19:31'!
additionalActions
	^{}! !

!DLAdminCurrentLectureListComp methodsFor: 'as yet unclassified' stamp: 'Marik 7/24/2009 13:02'!
columnDetail
	^ DLMACommandColumn new
		useImages: true;
		addCommand: 
				[ :listElement | 
				self session announcer announce: ((DLViewCompReplacement) forComponent: (DLAdminDetailComp 
						for: listElement
						additionalComps: { 
								(DLAdminListComp 
									for: DLDeadline
									with: {  (#lecture -> listElement)  }) startsHidden.
								(DLAdminListComp 
									for: DLTopic
									with: {  (#lecture -> listElement)  }) startsHidden.
								(DLAdminListComp 
									for: DLGroup
									with: {  (#lecture -> listElement)  }) startsHidden.
								(DLAdminGrouplessUserListComp for: listElement)
							 })) ]
			text: #details;
		yourself! !

!DLAdminCurrentLectureListComp methodsFor: 'rendering' stamp: ''!
listObjects
	| t1 |
	t1 := DLSemester getForDate: Date today.
	^ DLLecture instances
		select: [:t2 | t2 semester = t1]! !

!DLAdminCurrentLectureListComp methodsFor: 'rendering' stamp: 'cr 7/20/2009 17:29'!
reportTitle

	^ 'Lehrveranstaltungen dieses Semesters'! !

DLAdminCurrentLectureListComp subclass: #DLAdminUpcomingLectureListComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLAdminUpcomingLectureListComp methodsFor: 'rendering' stamp: 'cr 7/20/2009 19:31'!
actions
	^{}! !

!DLAdminUpcomingLectureListComp methodsFor: 'rendering' stamp: 'cr 7/20/2009 19:30'!
additionalActions
	^{}! !

!DLAdminUpcomingLectureListComp methodsFor: 'rendering' stamp: ''!
listObjects
	| t1 |
	t1 := (DLSemester getForDate: Date today) nextSemester.
	^ DLLecture instances
		select: [:t2 | t2 semester = t1]! !

!DLAdminUpcomingLectureListComp methodsFor: 'rendering' stamp: 'cr 7/20/2009 17:34'!
reportTitle

	^ 'Lehrveranstaltungen des nchsten Semesters'! !

!DLAdminLectureListComp methodsFor: 'rendering' stamp: 'topa 01/02/2012 12:32'!
columnDetail
	^ DLMACommandColumn new
		useImages: true;
		addCommand: 
				[ :listElement | 
				self call: (DLAdminDetailComp 
						for: listElement
						additionalComps: { 
								((DLAdminListComp 
									for: DLDeadline
									with: {  (#lecture -> listElement)  }) startsHidden).
								((DLAdminListComp 
									for: DLTopic
									with: {  (#lecture -> listElement)  }) startsHidden).
								((DLAdminGroupListComp 
									for: DLGroup
									with: {  (#lecture -> listElement)  }) startsHidden).
								(DLGroupToTopicListComp for: listElement).
								(DLAdminGrouplessUserListComp for: listElement)
							 }) ]
			text: #details;
		addCommand: [ :listElement | (DLAdminDeadlineZipComp for: listElement) respond ]
			text: #zip;
		yourself! !

!DLAdminLectureListComp methodsFor: 'rendering' stamp: 'sebh 6/13/2009 17:34'!
listClass
	^ DLLecture.! !

!DLAdminLectureListComp methodsFor: 'rendering' stamp: 'cr 7/23/2009 19:32'!
menuItem
	^'Lehrveranstaltungen'! !

!DLAdminListComp methodsFor: 'accessing' stamp: 'sebh 7/14/2009 00:18'!
deleteComponent
	^DLAdminConfirmDeleteComp! !

!DLAdminListComp methodsFor: 'accessing' stamp: 'sebh 6/13/2009 19:25'!
detailComponent
	^DLAdminDetailComp! !

!DLAdminListComp methodsFor: 'description' stamp: 'sebh 6/13/2009 19:39'!
listDescription
	^ (self listClass) new descriptionAdminList! !

!DLAdminListComp methodsFor: 'permission' stamp: 'sebh 6/6/2009 17:01'!
permissionCheck
	^ self session user isAdmin! !

!DLAdminListComp methodsFor: 'rendering' stamp: 'sebh 7/19/2009 19:31'!
reportEmptyMessage
	^ 'Es wurden noch keine ',self listClass metaNamePlural,' erstellt.'! !

!DLAdminListComp methodsFor: 'as yet unclassified' stamp: 'PL 5/28/2011 03:54:18.649'!
updateDescriptionFor: aDLModel

	^ aDLModel descriptionAdminUpdate! !

DLAdminListComp subclass: #DLAdminQuestionnaireListComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLAdminQuestionnaireListComp methodsFor: 'accessing' stamp: 'PL 6/22/2011 14:16:05.072'!
listClass

	^ DLQuestionnaire! !

!DLAdminQuestionnaireListComp methodsFor: 'accessing' stamp: 'PL 6/22/2011 14:16:23.282'!
menuItem

	^ 'Fragebgen'! !

DLAdminListComp subclass: #DLAdminSurveyListComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLAdminSurveyListComp methodsFor: 'rendering' stamp: 'PL 6/22/2011 14:16:11.145'!
listClass

	^ DLSurvey! !

!DLAdminSurveyListComp methodsFor: 'rendering' stamp: 'CM 5/10/2011 16:37:38.893'!
menuItem

	^ 'Umfragen'! !

DLAdminListComp subclass: #DLAdminTopicListComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLAdminTopicListComp methodsFor: 'rendering' stamp: 'MG 7/23/2009 19:51'!
columnDetail
	^ (DLMACommandColumn new
			useImages: true;
			addCommand: [:listElement |
					self call: (DLAdminDetailComp for: listElement )]
			text: #details;
			yourself).! !

!DLAdminTopicListComp methodsFor: 'rendering' stamp: 'caro 6/26/2009 01:08'!
listClass
	^ DLTopic.! !

!DLAdminTopicListComp methodsFor: 'rendering' stamp: 'cr 7/23/2009 19:35'!
menuItem

	^'Themen'! !

DLAdminListComp subclass: #DLAdminUserListComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

DLAdminUserListComp subclass: #DLAdminGrouplessUserListComp
	instanceVariableNames: 'lecture'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLAdminGrouplessUserListComp class methodsFor: 'accessing' stamp: 'caro 7/12/2009 17:40'!
for: aLecture
	^ self new
		lecture: aLecture;
		yourself.! !

!DLAdminGrouplessUserListComp methodsFor: 'rendering' stamp: 'caro 7/24/2009 17:20'!
additionalColumns
	^ {(DLMACommandColumn new
			useImages: true;
			addCommand: [:listElement | 
				|answer|
				answer := self lightbox: (DLUserJoinGroupComp for: listElement lectures: {self lecture}).
				self refreshReport.
				]
			text: #group;
			yourself)}! !

!DLAdminGrouplessUserListComp methodsFor: 'rendering' stamp: 'caro 7/16/2009 15:14'!
initializeReport
	super initializeReport.
	self magritteReport tableEmpty:  'Es gibt keine gruppenlosen Benutzer bei dieser Lehrveranstaltung.'! !

!DLAdminGrouplessUserListComp methodsFor: 'accessing' stamp: 'caro 7/12/2009 17:33'!
lecture

	^ lecture! !

!DLAdminGrouplessUserListComp methodsFor: 'accessing' stamp: 'caro 7/12/2009 17:33'!
lecture: anObject

	lecture := anObject.! !

!DLAdminGrouplessUserListComp methodsFor: 'rendering' stamp: 'topa 4/27/2010 13:41'!
listObjects
	|answer students|
	students := OrderedCollection new.
	answer := OrderedCollection new.
	students := (self lecture students).
	students do:[:anElement |
		(anElement groupForLecture: lecture) ifNil: [
			answer add: anElement]].
	^ answer! !

!DLAdminGrouplessUserListComp methodsFor: 'rendering' stamp: 'sebh 7/19/2009 19:15'!
reportTitle
	^ 'Gruppenlose Nutzer'! !

!DLAdminUserListComp methodsFor: 'rendering' stamp: 'martin 7/18/2009 13:34'!
listClass
	^ DLUser.! !

!DLAdminUserListComp methodsFor: 'rendering' stamp: 'cr 7/23/2009 19:40'!
menuItem
	^'Benutzer'! !

!DLListComp class methodsFor: 'accessing' stamp: 'sebh 6/6/2009 00:26'!
for: aListElement
	^ self new
		listClass: aListElement;
		yourself.! !

!DLListComp class methodsFor: 'accessing' stamp: 'Marik 7/24/2009 11:02'!
for: aClass with: anObjectDict
	"Given a dictionary of #fieldname to object, this method constructs a query."
	| newlist inspect |
	newlist := self new.
	newlist listClass: aClass.
	inspect := aClass new.
	anObjectDict do: [:pair | 
			(inspect perform: pair key) isCollection
			ifTrue: [ newlist collectionFields add: pair ]
			ifFalse:[ newlist valueFields add: pair ].
		].
	^ newlist.! !

!DLListComp class methodsFor: 'accessing' stamp: 'sebh 6/13/2009 22:50'!
with: anObjectDict
	| newlist inspect |
	newlist := self new.
	inspect := newlist listClass new.
	anObjectDict do: [:pair | 
			(inspect perform: pair key) isCollection
			ifTrue: [ newlist collectionFields add: pair ]
			ifFalse:[ newlist valueFields add: pair ].
		].
	^ newlist.! !

!DLListComp methodsFor: 'rendering' stamp: 'sebh 7/23/2009 17:18'!
actions
	^ { 
		((self listClass rightCreate: self session user) -> (#add -> 
				[ | answer listElement |
				listElement := self listClass newFrom: self valueFields.
				answer := self lightbox: ((listElement descriptionCreate asComponentOn: listElement) addForm; yourself).
				answer ifNotNil: [ listElement save ].
				self refreshReport ]))
	 }! !

!DLListComp methodsFor: 'rendering' stamp: 'sebh 6/18/2009 14:42'!
additionalActions
	^ {}! !

!DLListComp methodsFor: 'rendering' stamp: 'sebh 6/13/2009 14:47'!
additionalColumns
	^ {}! !

!DLListComp methodsFor: 'rendering' stamp: 'sebh 6/18/2009 21:57'!
call: someComponent
	"Refresh list after a call to another component, values might have changed."
	| result |
	result := super call: someComponent.
	self refreshReport.
	^ result! !

!DLListComp methodsFor: 'accessing' stamp: 'MG 6/5/2009 15:26'!
children

	^ Array with: self magritteReport.! !

!DLListComp methodsFor: 'accessing' stamp: 'sebh 6/13/2009 17:41'!
collectionFields

	^ collectionFields! !

!DLListComp methodsFor: 'accessing' stamp: 'sebh 6/13/2009 17:41'!
collectionFields: anObject

	collectionFields := anObject.! !

!DLListComp methodsFor: 'rendering' stamp: 'sebh 7/24/2009 15:10'!
columnDelete
	^ (DLMACommandColumn new
		useImages: true;
			addCommand: [:listElement | |answer| 
				answer := self call: (self deleteComponent for: listElement).
				answer ifTrue: [listElement collectDependencies do: [:element| element destroy]].
				self refreshReport.
				]  
			text: #delete; 
			yourself).! !

!DLListComp methodsFor: 'rendering' stamp: 'CO 5/12/2011 16:47:07.932'!
columnDetail
	^ (DLMACommandColumn new
			useImages: true;
			addCommand: [:listElement | self call: (self detailComponent for: listElement)]
			text:#details;
			yourself).! !

!DLListComp methodsFor: 'rendering' stamp: 'caro 7/14/2009 12:17'!
columns
	| cols |
	cols := OrderedCollection new.
	(self listClass rightDetail: self session user) ifTrue: [ cols add: self columnDetail. ].
	(self listClass rightUpdate: self session user) ifTrue: [ cols add: self columnUpdate. ].
	(self listClass rightDelete: self session user) ifTrue: [ cols add: self columnDelete. ].
	cols addAll: self additionalColumns.
	^ cols select: [:aColumn | aColumn ~= nil ]! !

!DLListComp methodsFor: 'rendering' stamp: 'PL 5/28/2011 03:53:34.271'!
columnUpdate
	^ (DLMACommandColumn new
			useImages: true;
			addCommand: [:listElement | 
				|answer| 
				answer := self lightbox: (((self updateDescriptionFor: listElement) asComponentOn: listElement) addForm; yourself).
				answer ifNotNil: [listElement save].
				self refreshReport.
				]
			text: #edit;
			yourself)! !

!DLListComp methodsFor: 'accessing' stamp: 'sebh 7/13/2009 23:30'!
deleteComponent
	^DLAdminConfirmDeleteComp! !

!DLListComp methodsFor: 'accessing' stamp: 'sebh 6/13/2009 19:21'!
detailComponent
	^DLDetailComp! !

!DLListComp methodsFor: 'accessing' stamp: 'sebh 7/23/2009 19:49'!
hiddenStart

	^ hiddenStart! !

!DLListComp methodsFor: 'accessing' stamp: 'sebh 7/23/2009 19:49'!
hiddenStart: anObject

	hiddenStart := anObject.! !

!DLListComp methodsFor: 'initialize' stamp: 'sebh 6/13/2009 21:18'!
initialize
	super initialize.
	self valueFields: OrderedCollection new.
	self collectionFields: OrderedCollection new.! !

!DLListComp methodsFor: 'initialize' stamp: 'sebh 7/23/2009 20:09'!
initializeReport

	self magritteReport: (self reportClass rows: self listObjects
							 	  description: self listDescription).
	self magritteReport 
	   batchSize: 50;
 		tableEmpty: self reportEmptyMessage.
	
	self hiddenStart ifNotNil: [
		self magritteReport cssStyle: 'display:none'.
	].
		
	self columns do: [:each | self magritteReport addColumn: each].! !

!DLListComp methodsFor: 'accessing' stamp: 'MG 6/5/2009 15:33'!
listClass

	^ listClass! !

!DLListComp methodsFor: 'accessing' stamp: 'MG 6/5/2009 15:33'!
listClass: anObject

	listClass := anObject.! !

!DLListComp methodsFor: 'description' stamp: 'cr 6/6/2009 17:26'!
listDescription

	^ (self listClass) new descriptionList! !

!DLListComp methodsFor: 'rendering' stamp: ''!
listObjects
	| t1 t3 |
	t1 := self listClass instances select: self listSelectBlock.
	t1 := t1
				select: [:t2 | 
					t3 := true.
					self collectionFields
						do: [:t4 | ((t2 perform: t4 key)
									includes: t4 value)
								ifFalse: [t3 := false]].
					self valueFields
						do: [:t4 | (t2 perform: t4 key)
									= t4 value
								ifFalse: [t3 := false]].
					t3].
	^ t1 asSortedCollection! !

!DLListComp methodsFor: 'rendering' stamp: 'tfel 12/5/2009 15:23'!
listSelectBlock
	^[:anObject | anObject notNil]! !

!DLListComp methodsFor: 'accessing' stamp: 'Marik 6/18/2009 17:48'!
magritteReport
	"Lazily initialize report"
	magritteReport ifNil: [self initializeReport].
	^ magritteReport! !

!DLListComp methodsFor: 'accessing' stamp: 'MG 6/5/2009 15:23'!
magritteReport: anObject

	magritteReport := anObject.! !

!DLListComp methodsFor: 'permission' stamp: 'sebh 6/6/2009 17:00'!
permissionCheck
	^ self session isLoggedIn.! !

!DLListComp methodsFor: 'rendering' stamp: 'sebh 7/19/2009 23:29'!
refreshReport
	self magritteReport rows: self listObjects.! !

!DLListComp methodsFor: 'rendering' stamp: 'sebh 7/23/2009 17:48'!
renderActions: html
	html div class: 'actions'; with: [
		(self actions, self additionalActions) do: [:each |
			| permission actionName callback |
			permission := each key. actionName := each value key. callback := each value value.
			permission ifTrue: [
				html anchor
					callback: callback;
					with: [
						html image url: (DLFileLibrary / (actionName, 'Png' asSymbol)). html text: (self labelForSelector: actionName).]
				]
			] separatedBy: [html space.]
		].! !

!DLListComp methodsFor: 'rendering' stamp: 'tfel 2/13/2010 16:34'!
renderContent: html
	self renderTitle: html.
	self renderActions: html.
	html render: self magritteReport.! !

!DLListComp methodsFor: 'rendering' stamp: 'topa 04/28/2010 16:55'!
renderTitle: html
	
	html heading
		level: 3;
		with: [
			html text: self reportTitle.
			self hiddenStart ifNotNil: [
				html anchor onClick: '$(this).up().next(''table'').toggle()';
					with: [html image url: DLFileLibrary / #togglePng]]].! !

!DLListComp methodsFor: 'rendering' stamp: 'sebh 7/23/2009 19:32'!
reportClass
	^ DLMAReport! !

!DLListComp methodsFor: 'rendering' stamp: 'sebh 7/19/2009 19:28'!
reportEmptyMessage
	^ 'Es sind keine ',self listClass metaNamePlural,' vorhanden, die angezeigt werden knnen'.! !

!DLListComp methodsFor: 'rendering' stamp: 'sebh 7/19/2009 19:27'!
reportTitle
	^ self listClass metaNamePlural.! !

!DLListComp methodsFor: 'initialize' stamp: 'sebh 7/23/2009 19:50'!
startsHidden
	self hiddenStart: true.! !

!DLListComp methodsFor: 'description' stamp: 'PL 5/28/2011 03:52:54.104'!
updateDescriptionFor: aDLModel

	^ aDLModel descriptionUpdate! !

!DLListComp methodsFor: 'accessing' stamp: 'sebh 6/13/2009 17:41'!
valueFields

	^ valueFields! !

!DLListComp methodsFor: 'accessing' stamp: 'sebh 6/13/2009 17:41'!
valueFields: anObject

	valueFields := anObject.! !

!DLListComp methodsFor: 'accessing' stamp: 'sebh 6/13/2009 22:57'!
valueFieldsAt: aKey
	| temp |
	temp := valueFields select: [:each | each key = aKey ].
	^ temp first value.! !

DLListComp subclass: #DLUserListComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

DLUserListComp subclass: #DLUserDeadlineListComp
	instanceVariableNames: 'user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLUserDeadlineListComp class methodsFor: 'accessing' stamp: 'sebh 6/13/2009 23:24'!
for: aUser
	^ self new
		user: aUser;
		yourself.! !

!DLUserDeadlineListComp class methodsFor: 'accessing' stamp: 'Marik 6/9/2009 13:59'!
for: aListElement user: aUser
	^ self new
		listClass: aListElement;
		user: aUser;
		yourself.! !

!DLUserDeadlineListComp methodsFor: 'rendering' stamp: 'tfel 2/13/2010 15:51'!
additionalColumns
	"Checks whether a Deadline already is run out"
	| detailBlock |
	detailBlock := [:listElement | self call: (DLUserDeliveryDetailComp 
							for: listElement
							user: self session user) ].
	^ {(DLMAConditionalCommandColumn new
			useImages: true;
			addCommand: detailBlock
			condition:  [:listElement | listElement isNotCritical]
			text: #disk;
			
			addCommand: detailBlock
			condition:  [:listElement | listElement isCritical]
			text: #diskCritical;
			
			addCommand: detailBlock
			condition:  [:listElement | listElement isExpired]
			text: #diskOver
			yourself).}! !

!DLUserDeadlineListComp methodsFor: 'rendering' stamp: 'sebh 6/13/2009 23:22'!
listClass
	^ DLDeadline! !

!DLUserDeadlineListComp methodsFor: 'rendering' stamp: 'tfel 2/13/2010 17:18'!
listObjects
	| t1 t2 t3 t7 |
	t1 := OrderedCollection new.
	t2 := DLLecture instances
				select: [:t4 | t4 students includes: self user].
	t3 := DLGroup instances
				select: [:t5 | t5 students includes: self user].
	t1 := DLDeadline instances
				select: [:t6 | 
					t7 := false.
					t6 group = nil
						ifTrue: [t3
								do: [:t5 | t5 lecture = t6 lecture
										ifTrue: [t7 := true]]].
					t6 group = nil
						ifFalse: [t3
								do: [:t5 | t5 = t6 group
										ifTrue: [t7 := true]]].
					t7].
	^ t1 asSortedCollection! !

!DLUserDeadlineListComp methodsFor: 'rendering' stamp: 'sebh 7/19/2009 19:16'!
reportTitle
	^ 'Meine Abgaben'! !

!DLUserDeadlineListComp methodsFor: 'accessing' stamp: 'Marik 6/9/2009 13:59'!
user

	^ user! !

!DLUserDeadlineListComp methodsFor: 'accessing' stamp: 'Marik 6/9/2009 13:59'!
user: anObject

	user := anObject.! !

DLUserListComp subclass: #DLUserGroupListComp
	instanceVariableNames: 'user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLUserGroupListComp class methodsFor: 'accessing' stamp: 'sebh 6/13/2009 15:31'!
for: aUser
	^ self new
		user: aUser;
		yourself.! !

!DLUserGroupListComp methodsFor: 'rendering' stamp: 'caro 7/24/2009 15:58'!
additionalActions
	^ {
		true -> (#group ->[
			self call: (DLUserJoinGroupComp for: self user lectures: self user lectures).
			self refreshReport.
			])
	}! !

!DLUserGroupListComp methodsFor: 'rendering' stamp: 'MG 7/23/2009 19:49'!
additionalColumns
	^ {(DLMAConditionalCommandColumn new
			useImages: true;
			addCommand:
					[ :listElement | |answer|
					answer := self call: (DLUserConfirmLeaveComp for: listElement).
					answer ifTrue: [listElement removeStudent: self user].
					self refreshReport.
					]
			condition: 
					[ :listElement | listElement lecture groupingPhaseActive ]
			text: #leave;
			yourself)
		}! !

!DLUserGroupListComp methodsFor: 'rendering' stamp: 'sebh 6/13/2009 18:12'!
listClass
	^ DLGroup! !

!DLUserGroupListComp methodsFor: 'rendering' stamp: 'topa 10/26/2009 18:22'!
listSelectBlock
	^ [:aGroup | (aGroup students) includes: (self session user)]! !

!DLUserGroupListComp methodsFor: 'rendering' stamp: 'sebh 7/19/2009 19:34'!
reportEmptyMessage
	^ 'Noch keiner Gruppe beigetreten.'! !

!DLUserGroupListComp methodsFor: 'rendering' stamp: 'sebh 7/19/2009 19:16'!
reportTitle
	^ 'Meine Gruppen'! !

!DLUserGroupListComp methodsFor: 'accessing' stamp: 'sebh 6/13/2009 15:27'!
user

	^ user! !

!DLUserGroupListComp methodsFor: 'accessing' stamp: 'sebh 6/13/2009 15:27'!
user: anObject

	user := anObject.! !

DLUserListComp subclass: #DLUserJoinGroupComp
	instanceVariableNames: 'user lectures'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLUserJoinGroupComp class methodsFor: 'accessing' stamp: 'caro 7/14/2009 13:02'!
for: aUser
	^ self new
		user: aUser;
		yourself.! !

!DLUserJoinGroupComp class methodsFor: 'accessing' stamp: 'caro 7/24/2009 16:23'!
for: aUser lectures: aLecture
	^ self new
		user: aUser;
		lectures: aLecture;
		yourself.! !

!DLUserJoinGroupComp methodsFor: 'as yet unclassified' stamp: 'Marik 7/24/2009 12:20'!
additionalActions
	^ {
		true -> (#add -> 
			[ | answer newGroup |
			newGroup := DLGroup new.
			answer := self lightbox: ((newGroup descriptionCreate asComponentOn: newGroup) addForm; yourself).
			answer ifNotNil: [ newGroup save ].
			self refreshReport])
	}! !

!DLUserJoinGroupComp methodsFor: 'rendering' stamp: 'topa 10/26/2009 18:41'!
additionalColumns
	^ { 
		(DLMAConditionalCommandColumn new
			useImages: true;
			addCommand: 
				[:listElement | |answer|
					answer := self call: (DLUserConfirmJoinComp for: self user group: listElement).
					answer ifTrue: [listElement addStudent: self user].
					self answer: true.
				]
			condition: 
					[ :listElement | listElement lecture groupingPhaseActive | (self session user isAdmin)]
			text: #choose;
			yourself)
	 }.! !

!DLUserJoinGroupComp methodsFor: 'rendering' stamp: 'sebh 7/19/2009 19:36'!
initializeReport
	super initializeReport.
	self magritteReport groupField: #lecture.! !

!DLUserJoinGroupComp methodsFor: 'accessing' stamp: 'caro 7/24/2009 11:57'!
lectures

	^ lectures! !

!DLUserJoinGroupComp methodsFor: 'accessing' stamp: 'caro 7/24/2009 11:57'!
lectures: anObject

	lectures := anObject.! !

!DLUserJoinGroupComp methodsFor: 'rendering' stamp: 'caro 6/18/2009 21:50'!
listClass
	^ DLGroup! !

!DLUserJoinGroupComp methodsFor: 'rendering' stamp: 'tfel 2/13/2010 17:18'!
listObjects
	| t1 t2 |
	t1 := self lectures.
	t1
		do: [:t3 | (self user groupForLecture: t3)
				ifNotNil: [t1 remove: t3]].
	t2 := DLGroup instances
				select: [:t4 | t1
						anySatisfy: [:t5 | t4 lecture oid = t5 oid]].
	^ t2 asSortedCollection! !

!DLUserJoinGroupComp methodsFor: 'rendering' stamp: 'sebh 6/21/2009 00:29'!
reportClass
	^ DLMAGroupedReport! !

!DLUserJoinGroupComp methodsFor: 'rendering' stamp: 'caro 7/24/2009 16:04'!
reportEmptyMessage
	^ 'Es wurde noch keine Lehrveranstaltung belegt, fr die man sich momentan in Gruppen eintragen kann.'! !

!DLUserJoinGroupComp methodsFor: 'accessing' stamp: 'caro 6/18/2009 19:04'!
user

	^ user! !

!DLUserJoinGroupComp methodsFor: 'accessing' stamp: 'caro 6/18/2009 19:04'!
user: anObject

	user := anObject.! !

DLUserListComp subclass: #DLUserLectureListComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

DLUserLectureListComp subclass: #DLUserChosenLectureListComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLUserChosenLectureListComp methodsFor: 'rendering' stamp: 'tfel 2/13/2010 17:19'!
listObjects
	^ (DLLecture instances
		select: [:t1 | t1 students includes: self session user]) asSortedCollection! !

!DLUserChosenLectureListComp methodsFor: 'rendering' stamp: 'sebh 7/19/2009 19:24'!
listSelectBlock
	^ [:aLecture | aLecture students includes: self session user]! !

!DLUserChosenLectureListComp methodsFor: 'rendering' stamp: 'sebh 7/19/2009 19:38'!
reportEmptyMessage
	^ 'Du hast noch keine Lehrveranstaltung gewhlt!!'! !

!DLUserChosenLectureListComp methodsFor: 'rendering' stamp: 'sebh 7/19/2009 19:19'!
reportTitle
	^ 'Meine Lehrveranstaltungen'! !

!DLUserLectureListComp methodsFor: 'rendering' stamp: 'tfel 1/11/2011 11:11'!
additionalColumns
	^ {(DLMAConditionalCommandColumn new
			useImages: true;
			additionalText: true;
			addCommand: [:listElement | listElement addStudent: self session user. self call: (DLUserChosenLectureListComp with: {#students->self session user})]
			condition:  [:listElement | 
				(listElement students includes: self session user) not
				and: [Date today year <= listElement semester year]]
			text: #choose;
			addCommand: [:listElement | listElement removeStudent: self session user. self refreshReport.]
			condition:  [:listElement | (listElement students includes: self session user)]
			text: #leave;
			yourself).}! !

!DLUserLectureListComp methodsFor: 'rendering' stamp: 'topa 4/30/2010 11:31'!
columnDetail
	^ (DLMACommandColumn new
			useImages: true;
			addCommand: [:listElement |
					self call: (
						DLUserDetailComp for: listElement 
							additionalComps: {
								(DLUserListComp for: DLDeadline with: {#lecture->listElement. #group->nil}) startsHidden. 
								(DLUserListComp for: DLGroup 	with:   {#lecture->listElement}) startsHidden.
								(DLUserListComp for: DLTopic 	with:   {#lecture->listElement}) startsHidden.
								(DLGroupToTopicListComp for: listElement).}
					)
			]
			text: #details;
			yourself).! !

!DLUserLectureListComp methodsFor: 'accessing' stamp: 'sebh 6/18/2009 14:54'!
detailComponent
	^ DLUserLectureDetailComp! !

!DLUserLectureListComp methodsFor: 'rendering' stamp: 'sebh 6/13/2009 18:11'!
listClass
	^ DLLecture! !

!DLUserLectureListComp methodsFor: 'rendering' stamp: 'sebh 7/19/2009 19:39'!
listSelectBlock
	^ [:aLecture  | aLecture visible = true]! !

!DLUserLectureListComp methodsFor: 'rendering' stamp: 'sebh 7/19/2009 19:22'!
reportTitle
	^ 'Aktuelle Lehrveranstaltungen'! !

!DLUserListComp methodsFor: 'rendering' stamp: 'sebh 6/23/2009 18:01'!
actions 
	^ {}! !

!DLUserListComp methodsFor: 'rendering' stamp: 'sebh 6/13/2009 19:12'!
columnDelete
	^ nil! !

!DLUserListComp methodsFor: 'rendering' stamp: 'CO 5/12/2011 18:34:44.693'!
columnUpdate
	^ nil! !

!DLUserListComp methodsFor: 'accessing' stamp: 'sebh 7/2/2009 23:13'!
detailComponent
	^ DLUserDetailComp! !

!DLUserListComp methodsFor: 'description' stamp: 'PL 5/28/2011 03:56:07.64'!
listDescription

	^ (self listClass) new descriptionUserList! !

!DLUserListComp methodsFor: 'rendering' stamp: 'cr 7/23/2009 19:41'!
menuItem
	^self reportTitle! !

!DLUserListComp methodsFor: 'rendering' stamp: 'sebh 7/19/2009 19:33'!
reportEmptyMessage
	^ 'Noch keine ', self listClass metaNamePlural, ' vorhanden.'! !

!DLUserListComp methodsFor: 'rendering' stamp: 'PL 5/28/2011 03:56:55.764'!
updateDescriptionFor: aDLModel

	^ aDLModel descriptionUserUpdate! !

DLUserListComp subclass: #DLUserQuestionnaireListComp
	instanceVariableNames: 'user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLUserQuestionnaireListComp methodsFor: 'rendering' stamp: 'PL 6/22/2011 14:19:13.948'!
columnDetail

	^ DLMACommandColumn new
			useImages: true;
			addCommand: [:listElement | self call: (self detailComponent for: listElement)]
				text: #details;
			yourself! !

!DLUserQuestionnaireListComp methodsFor: 'accessing' stamp: 'PL 6/22/2011 14:17:24.451'!
listClass

	^ DLQuestionnaire! !

!DLUserQuestionnaireListComp methodsFor: 'accessing' stamp: 'PL 6/22/2011 14:17:46.705'!
user
	^ user! !

!DLUserQuestionnaireListComp methodsFor: 'accessing' stamp: 'PL 6/22/2011 14:17:46.743'!
user: anObject
	user := anObject! !

DLUserListComp subclass: #DLUserSurveyListComp
	instanceVariableNames: 'user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLUserSurveyListComp class methodsFor: 'as yet unclassified' stamp: 'PL 5/11/2011 15:30:48.773'!
for: aUser

	^ self new
		user: aUser;
		yourself! !

!DLUserSurveyListComp methodsFor: 'rendering' stamp: 'PL 5/28/2011 03:54:03.739'!
additionalColumns

	^ {(DLMAConditionalCommandColumn new
			useImages: true;
			addCommand: [:listElement | 
				|answer| 
				answer := self lightbox: (((self updateDescriptionFor: listElement) asComponentOn: listElement) addForm; yourself).
				answer ifNotNil: [listElement save].
				self refreshReport]
				condition: [:listElement | listElement status = #open]
				text: #edit;
			yourself)}! !

!DLUserSurveyListComp methodsFor: 'rendering' stamp: 'PL 6/22/2011 14:18:55.666'!
columnDetail

	^ DLMACommandColumn new
			useImages: true;
			addCommand: [:listElement | self call: (self detailComponent for: listElement)]
				text: #details;
			yourself! !

!DLUserSurveyListComp methodsFor: 'accessing' stamp: 'CM 5/10/2011 16:31:48.436'!
listClass

	^ DLSurvey! !

!DLUserSurveyListComp methodsFor: 'rendering' stamp: 'PL 5/12/2011 16:29:38.747'!
listSelectBlock

	^ [:survey | (survey status ~= #hidden) and: (survey lecture students includes: self user)]! !

!DLUserSurveyListComp methodsFor: 'accessing' stamp: 'PL 5/11/2011 15:36:16.828'!
user
	^ user! !

!DLUserSurveyListComp methodsFor: 'accessing' stamp: 'PL 5/11/2011 15:36:16.863'!
user: anObject
	user := anObject! !

DLUserListComp subclass: #DLUserTopicListComp
	instanceVariableNames: 'user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLUserTopicListComp class methodsFor: 'accessing' stamp: 'caro 7/3/2009 22:04'!
for: aUser
	^ self new
		user: aUser;
		yourself.! !

!DLUserTopicListComp methodsFor: 'as yet unclassified' stamp: 'Marik 7/24/2009 12:59'!
additionalActions
	^ {
		true -> (#add -> 
			[ | answer newTopic |
			newTopic := DLTopic new.
			answer := self lightbox: ((newTopic descriptionCreate asComponentOn: newTopic) addForm; yourself).
			answer ifNotNil: [ newTopic save ].
			self refreshReport])
	}! !

!DLUserTopicListComp methodsFor: 'rendering' stamp: 'MG 7/23/2009 19:48'!
additionalColumns
	^ {(DLMAConditionalCommandColumn new
			useImages: true;
			addCommand: [:listElement | listElement addStudent: self session user. self call: (DLUserTopicListComp with: {#students->self session user})]
			condition:  [:listElement | (listElement students includes: self session user) ~= true]
			text: #choose;
			addCommand: [:listElement | listElement removeStudent: self session user]
			condition:  [:listElement | (listElement students includes: self session user)]
			text: #edit;
			yourself).}! !

!DLUserTopicListComp methodsFor: 'rendering' stamp: 'caro 6/25/2009 17:24'!
listClass
	^ DLTopic! !

!DLUserTopicListComp methodsFor: 'rendering' stamp: 'CM 5/10/2011 16:47:45.895'!
listObjects
	| t1 t2 t4 |
	t1 := DLLecture instances select: [ :t3 | t3 topicPhaseActive = true & (t3 students includes: self session user) ].
	t1 := t1
		select: [ :t3 | 
			t4 := false.
			(self session user topicForLecture: t3) ifNil: [ t4 := true ].
			t4 ].
	t2 := DLTopic instances select: [ :t5 | t1 includes: t5 lecture ].
	^ t2 asSortedCollection! !

!DLUserTopicListComp methodsFor: 'accessing' stamp: 'caro 7/3/2009 22:04'!
user

	^ user! !

!DLUserTopicListComp methodsFor: 'accessing' stamp: 'caro 7/3/2009 22:04'!
user: anObject

	user := anObject.! !

DLComponent subclass: #DLPermissionDeniedComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLPermissionDeniedComp methodsFor: 'rendering' stamp: 'caro 7/16/2009 15:39'!
initializeReport
	super initializeReport.
	self magritteReport tableEmpty:  'Noch keiner ', self listClass metaName, ' beigetreten.'! !

!DLPermissionDeniedComp methodsFor: 'permission' stamp: 'sebh 6/3/2009 17:02'!
permissionCheck
	"Always allow anyone to see permission denied"
	^ true! !

!DLPermissionDeniedComp methodsFor: 'rendering' stamp: 'sebh 6/3/2009 17:24'!
renderContent: html
	html heading: 'Permission denied';
		  paragraph: 'You have insufficient rights to open this page.'! !

DLComponent subclass: #DLUserConfirmJoinComp
	instanceVariableNames: 'group user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLUserConfirmJoinComp class methodsFor: 'initialize' stamp: 'caro 7/24/2009 16:04'!
for: aUser group: aGroup
	^ self new
		user: aUser;
		group: aGroup;
		yourself.! !

!DLUserConfirmJoinComp methodsFor: 'accessing' stamp: 'caro 6/19/2009 14:32'!
group

	^ group! !

!DLUserConfirmJoinComp methodsFor: 'accessing' stamp: 'caro 6/19/2009 14:32'!
group: anObject

	group := anObject.! !

!DLUserConfirmJoinComp methodsFor: 'accessing' stamp: ''!
isNotInGroup
	| t1 |
	t1 := DLGroup instances
				select: [:t2 | t2 students includes: self session user].
	t1
		ifEmpty: [^ true].
	^ false! !

!DLUserConfirmJoinComp methodsFor: 'permission' stamp: 'caro 7/16/2009 00:59'!
permissionCheck
	|answer groupSize|
	groupSize := self group lecture groupSize.
	groupSize 	ifNil: [answer := (self session isLoggedIn)]
					ifNotNil: [answer := ((self session isLoggedIn)
												&(self group students size < groupSize))].
	^ answer! !

!DLUserConfirmJoinComp methodsFor: 'rendering' stamp: 'TimFelgentreff 01/13/2011 04:59'!
renderContent: html
	(self user groupForLecture: self group lecture)
	ifNil:[
			html text: 'Die Gruppe "', (self group groupName) asString, '" wirklich whlen?'; break.
			html anchor 
				callback: [self answer: true];
				with: 'Ja'.
			html text: ' | '.
			html anchor
				callback: [self answer: false];
				with: 'Nein'.
		]
	ifNotNil: [
			html text:'Sie sind fr die Lehrveranstaltung ',self group lecture canonicalName,
				' schon in einer Gruppe eingetragen!!'.
		]! !

!DLUserConfirmJoinComp methodsFor: 'rendering' stamp: 'caro 7/16/2009 01:02'!
renderContentOn: html
	self permissionCheck 
		ifTrue: [self renderContent: html.]
		ifFalse:[html div with: 'Mglicherweise hat diese Gruppe schon die maximale Gruppengre erreicht.']! !

!DLUserConfirmJoinComp methodsFor: 'accessing' stamp: 'caro 7/12/2009 19:17'!
user

	^ user! !

!DLUserConfirmJoinComp methodsFor: 'accessing' stamp: 'caro 7/12/2009 19:17'!
user: anObject

	user := anObject.! !

DLComponent subclass: #DLUserConfirmLeaveComp
	instanceVariableNames: 'group'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLUserConfirmLeaveComp class methodsFor: 'initialize' stamp: 'caro 6/19/2009 20:08'!
for: aGroup
	^ self new
		group: aGroup;
		yourself.! !

!DLUserConfirmLeaveComp methodsFor: 'accessing' stamp: 'caro 6/19/2009 20:07'!
group

	^ group! !

!DLUserConfirmLeaveComp methodsFor: 'accessing' stamp: 'caro 6/19/2009 20:07'!
group: anObject

	group := anObject.! !

!DLUserConfirmLeaveComp methodsFor: 'permission' stamp: 'caro 6/19/2009 20:17'!
permissionCheck
	^ true.! !

!DLUserConfirmLeaveComp methodsFor: 'rendering' stamp: 'TimFelgentreff 01/13/2011 04:59'!
renderContent: html
	html text: 'Mchten sie die Gruppe "', self group groupName, '" wirklich verlassen?'; break.
	html anchor 
		callback: [self answer: true];
		with: 'Ja'.
	html text: ' | '.
	html anchor
		callback: [self answer: false];
		with: 'Nein'.! !

WAComponent subclass: #DLMenuComp
	instanceVariableNames: 'entries content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLMenuComp methodsFor: 'rendering' stamp: 'cr 7/21/2009 15:02'!
addEntries
	"If an inheriting method has defined this method, we use it to automagically insert entries"
	self entries
		add: ('Andere Aktionen' -> [:aUser | true ]) -> { 
			DLMenuEntry forTitle: 'Startseite' block: [self showComponent: (DLFrontPageComp new)].
			DLLogOutEntry new}.! !

!DLMenuComp methodsFor: 'seaside' stamp: 'sebh 7/14/2009 13:37'!
children
	| catElements |
	catElements := OrderedCollection new.
	self entries do: [:category | catElements addAll: category value ].
	^ catElements asArray.! !

!DLMenuComp methodsFor: 'accessing' stamp: 'sebh 6/13/2009 19:00'!
entries

	^ entries ifNil: [self entries: OrderedCollection new. self addEntries. ^ entries]! !

!DLMenuComp methodsFor: 'accessing' stamp: 'sebh 5/26/2009 17:08'!
entries: anObject

	entries := anObject.! !

!DLMenuComp methodsFor: 'rendering' stamp: 'cr 7/23/2009 19:19'!
renderContentOn: html
	self entries
		do: [:entry | self renderEntry: entry on: html. ].
	"self session activeMenuEntry: nil."! !

!DLMenuComp methodsFor: 'rendering' stamp: 'sebh 7/14/2009 13:48'!
renderEntry: anEntry on: html
	(anEntry key value value: self session user) ifTrue:[
		anEntry value isCollection
		ifTrue: [ 
			html unorderedList class: anEntry key key; with: [
				anEntry value do: [:entry | html render: entry.].
			]
		]
	]! !

!DLMenuComp methodsFor: 'rendering' stamp: 'sebh 6/13/2009 13:42'!
showComponent: aComponent
	self session announcer announce: ((self signal) forComponent: aComponent)! !

!DLMenuComp methodsFor: 'rendering' stamp: 'sebh 6/3/2009 17:55'!
signal
	^ DLViewCompReplacement! !

DLMenuComp subclass: #DLUserMenuComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

DLUserMenuComp subclass: #DLAdminMenuComp
	instanceVariableNames: 'lectureListComp formComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLAdminMenuComp methodsFor: 'rendering' stamp: 'PL 6/22/2011 14:20:47.205'!
addEntries
	self entries
		add: ('Admin' -> [:aUser | aUser isAdmin ]) -> {
			DLMenuEntry forTitle: 'Lehrveranstaltungen' block: [self showComponent: (DLAdminLectureListComp new)].
			DLMenuEntry forTitle: 'Gruppen' block: 	[self showComponent: (DLAdminGroupListComp new)].
			DLMenuEntry forTitle: 'Abgaben' block: 	[self showComponent: (DLAdminDeadLineListComp new)].
			DLMenuEntry forTitle: 'Themen' block: 	[self showComponent: (DLAdminTopicListComp new)].
			DLMenuEntry forTitle: 'Benutzer' block: 	[self showComponent: (DLAdminUserListComp new)].
			DLMenuEntry forTitle: 'Dateitypen' block: [self showComponent: (DLAdminListComp for: DLFileType)].
			DLMenuEntry forTitle: 'Umfragen' block: [self showComponent: (DLAdminSurveyListComp new)].
			DLMenuEntry forTitle: 'Fragebgen' block: [self showComponent: (DLAdminQuestionnaireListComp new)].
		}.
	super addEntries.! !

!DLUserMenuComp methodsFor: 'rendering' stamp: 'PL 6/22/2011 14:20:40.465'!
addEntries
	self entries
		add: ('Benutzer'->[:aUser | true ]) -> {
			DLMenuEntry forTitle: 'Aktuelle Lehrveranstaltungen' block: [self showComponent: (DLUserLectureListComp new)].
			DLMenuEntry forTitle: 'Aktuelle Themen' block: 	[self showComponent: (DLUserTopicListComp new)].
			DLMenuEntry forTitle: 'Meine Lehrveranstaltungen' block: [self showComponent: (DLUserChosenLectureListComp new)].
			DLMenuEntry forTitle: 'Meine Gruppen' block: 	[self showComponent: (DLUserGroupListComp for: self session user)].
			DLMenuEntry forTitle: 'Meine Abgaben' block: 	[self showComponent: (DLUserDeadlineListComp for: self session user)].
			DLMenuEntry forTitle: 'Mein Profil' block: [self showComponent: (DLUserProfileDetailComp for: self session user)].
			DLMenuEntry forTitle: 'Meine Umfragen' block: [self showComponent: (DLUserSurveyListComp for: self session user)].
			DLMenuEntry forTitle: 'Meine Fragebgen' block: [self showComponent: (DLUserQuestionnaireListComp for: self session user)].
		}.
	super addEntries! !

WAComponent subclass: #DLMenuEntry
	instanceVariableNames: 'title active block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

DLMenuEntry subclass: #DLLogOutEntry
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLLogOutEntry methodsFor: 'rendering' stamp: 'CM 5/12/2011 20:36:57.724'!
renderContentOn: html

	html listItem with:[
		html anchor
			id: 'ausloggen_ID';
			callback: [self session logout];
			with: self session user userName, ' ausloggen'.
		]! !

!DLMenuEntry class methodsFor: 'initialize' stamp: 'sebh 7/14/2009 11:42'!
forTitle: aTitle block: aBlock
	^ self new
		block: aBlock;
		title: aTitle;
		yourself.! !

!DLMenuEntry methodsFor: 'accessing' stamp: 'sebh 6/13/2009 13:41'!
block

	^ block! !

!DLMenuEntry methodsFor: 'accessing' stamp: 'sebh 6/13/2009 13:41'!
block: anObject

	block := anObject.! !

!DLMenuEntry methodsFor: 'rendering' stamp: 'CM 5/12/2011 20:22:59.095'!
renderContentOn: html
	| cssClass |
	cssClass:= ''.
	self session activeMenuEntry = self title
	ifTrue: [cssClass := 'active'].
	
	html listItem class: cssClass; with:[
		html anchor
			id: (self title asString , '_ID');
			callback: [self session activeMenuEntry: self title. self block value];
			with: self title.
		]! !

!DLMenuEntry methodsFor: 'accessing' stamp: 'sebh 7/14/2009 11:43'!
title

	^ title! !

!DLMenuEntry methodsFor: 'accessing' stamp: 'sebh 7/14/2009 11:43'!
title: anObject

	title := anObject.! !

WAComponent subclass: #DLRootComponent
	instanceVariableNames: 'menuComp viewComp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLRootComponent class methodsFor: 'seaside' stamp: 'tfel 11/30/2010 17:56'!
applicationNamed: aString
	| application |
	application := DLApplication named: aString.
	application configuration addAncestor: WARenderLoopConfiguration new.
	^ application! !

!DLRootComponent class methodsFor: 'seaside' stamp: 'cr 7/23/2009 20:36'!
canBeRoot
	^true! !

!DLRootComponent class methodsFor: 'seaside' stamp: 'tfel 1/11/2011 20:23'!
initialize

	| application |
	super initialize.
	application := WAAdmin register: DLApplication at: 'deli'.
	WAAdmin configureNewApplication: application.
	application initializeWith: self.
	^ application! !

!DLRootComponent methodsFor: 'seaside' stamp: 'sebh 6/3/2009 12:00'!
children
	^ Array with: self viewComp with: self menuComp! !

!DLRootComponent methodsFor: 'accessing' stamp: 'sebh 7/20/2009 18:53'!
menuComp
	^ menuComp ifNil: [ 
			self session user ifNotNil: [^ menuComp := DLAdminMenuComp new.].
			^ nil.
		]! !

!DLRootComponent methodsFor: 'accessing' stamp: 'sebh 6/3/2009 12:10'!
menuComp: anObject

	menuComp := anObject.! !

!DLRootComponent methodsFor: 'rendering' stamp: 'PL 6/27/2011 18:58:55.534'!
renderContentOn: html

	html div class:'header';  with: [
		html anchor callback: [self viewComp: DLFrontPageComp new];
			with: [html image url: DLFileLibrary / #deliPng].
		html div class:'menu';	  with: self menuComp.
		].
	html div class:'content'; with: self viewComp.
	html div class:'footer';  with: [html text: 'Deli. A product.']! !

!DLRootComponent methodsFor: 'accessing' stamp: 'topa 10/26/2009 18:05'!
updateRoot: anHtmlRoot

	super updateRoot: anHtmlRoot.
	anHtmlRoot title: 'deli submitting system'.! !

!DLRootComponent methodsFor: 'accessing' stamp: 'sebh 7/20/2009 18:53'!
viewComp

	^ viewComp ifNil: [ 
			"Only include this component if the user is in the session."
			self session user ifNotNil: [^ viewComp:= DLFrontPageComp new.].
			^ nil.
		]! !

!DLRootComponent methodsFor: 'accessing' stamp: 'sebh 6/3/2009 12:10'!
viewComp: anObject

	viewComp := anObject.! !

JSScript subclass: #DLPureJSScript
	instanceVariableNames: 'jsScript'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLPureJSScript methodsFor: 'printing' stamp: 'PL 5/25/2011 13:34:41.263'!
javascriptContentOn: aStream

	aStream nextPutAll: self jsScript! !

!DLPureJSScript methodsFor: 'accessing' stamp: 'PL 5/25/2011 13:33:44.661'!
jsScript
	^ jsScript! !

!DLPureJSScript methodsFor: 'accessing' stamp: 'PL 5/25/2011 13:33:44.693'!
jsScript: anObject
	jsScript := anObject! !

MAOptionComponent subclass: #DLMAMultiCheckboxGroupComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMAMultiCheckboxGroupComponent class methodsFor: 'testing' stamp: 'PL 5/27/2011 00:41:14.131'!
isAbstract

	^ false! !

!DLMAMultiCheckboxGroupComponent methodsFor: 'actions' stamp: 'PL 5/28/2011 02:20:33.83'!
clear

	self value: Dictionary new! !

!DLMAMultiCheckboxGroupComponent methodsFor: 'testing' stamp: 'PL 5/27/2011 00:35:53.771'!
hasLabelId

	^ self isReadonly not! !

!DLMAMultiCheckboxGroupComponent methodsFor: 'rendering' stamp: 'PL 6/23/2011 17:39:55.488'!
renderButtonMinusFor: anObject On: html

	| script |
	
	script := DLPureJSScript new
		jsScript: ('removeVote("checkMarks' , anObject , '", "multiCheckBoxValue' , anObject , '");').

	html anchor
		url: '#';
		onClick: script;
		class: 'voteButton';
		with: 
			[html image 
				url: (DLFileLibrary / #minusPng);
				title: 'Stimme zurcknehmen']! !

!DLMAMultiCheckboxGroupComponent methodsFor: 'rendering' stamp: 'tfel 7/12/2011 15:33:03.715'!
renderButtonPlusFor: anObject On: html

	| script |
	
	script := DLPureJSScript new
		jsScript: ('addVote("checkMarks' , anObject , '", "multiCheckBoxValue' , anObject
			, '", ' , self description maxAnswers asString , ', ' , self description maxAnswersPerChoice asString , ');').
		
	html anchor
		url: '#';
		onClick: script;  
		class: 'voteButton';
		with: 
			[html image 
				url: (DLFileLibrary / #plusPng);
				title: 'Stimme hinzufgen']! !

!DLMAMultiCheckboxGroupComponent methodsFor: 'rendering' stamp: 'PL 5/28/2011 00:52:37.626'!
renderCheckMarksFor: anObject On: html

	html div
		class: 'checkMarks';
		id: ('checkMarks' , anObject);
		with:
			[html div]! !

!DLMAMultiCheckboxGroupComponent methodsFor: 'rendering' stamp: 'PL 5/28/2011 03:39:34.195'!
renderEditorOn: html

	| updateArray |
	
	updateArray := ''.
	self description labels do: [:each |
		updateArray = '' ifFalse: [updateArray := updateArray , ', '].  
		updateArray := updateArray , '["checkMarks', each , '", "multiCheckBoxValue', each, '"]'].

	html script
		with: ('window.addEventListener(''load'', function() {updateMultiCheckBoxes([' , updateArray , '])}, true)').
	
	html hiddenInput
		callback: [:value | self clear].
	
	html definitionList
		with: [self description labels do: [:each | self renderMultiCheckBoxFor: each on: html]]! !

!DLMAMultiCheckboxGroupComponent methodsFor: 'rendering' stamp: 'tfel 7/12/2011 15:32:43.591'!
renderHiddenInputFor: anObject On: html

	| oldValue |
	
	oldValue := (self value = '' ifTrue: [nil] ifFalse: self value) ifNotNil: [self value at: anObject].
	
	oldValue ifNil: [oldValue := 0].
	
	html hiddenInput
		id: ('multiCheckBoxValue' , anObject);
		value: oldValue;
		callback: [:value | | newValue |
			newValue := (value ifNil: [0]) asInteger.
			self value at: anObject put: newValue]! !

!DLMAMultiCheckboxGroupComponent methodsFor: 'rendering' stamp: 'PL 5/28/2011 01:07:35.656'!
renderMultiCheckBoxFor: anObject on: html

	html definitionTerm
		with: anObject.
	
	html definitionData
		class: 'multiCheckBox';
		with: [self
			renderButtonMinusFor: anObject On: html;
			renderCheckMarksFor: anObject On: html;
			renderButtonPlusFor: anObject On: html;
			renderHiddenInputFor: anObject On: html].
	
	html div style: 'clear: both;'! !

!DLMAMultiCheckboxGroupComponent methodsFor: 'rendering' stamp: 'PL 5/27/2011 00:23:19.167'!
renderViewerOn: html

	html render: (self labelForOption: self value)! !

!DLMAMultiCheckboxGroupComponent methodsFor: 'accessing-model' stamp: 'PL 6/23/2011 16:34:40.753'!
value

	^ super value ifNil: [	self value: Dictionary new. super value]! !

MAOptionComponent subclass: #DLMAQuestionnaireComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMAQuestionnaireComponent class methodsFor: 'testing' stamp: 'PL 6/23/2011 16:09:54.746'!
isAbstract

	^ false! !

!DLMAQuestionnaireComponent methodsFor: 'accessing-model' stamp: 'MH 6/27/2011 23:08:44.96'!
excludedSurveys

	| allSurveysInQuestionnaires |
	
	allSurveysInQuestionnaires := OrderedCollection new.
	DLQuestionnaire instances do: [:questionnaire | allSurveysInQuestionnaires addAll: questionnaire surveys].
	
	^ DLSurvey instances select: [:survey | (allSurveysInQuestionnaires includes: survey) not]! !

!DLMAQuestionnaireComponent methodsFor: 'testing' stamp: 'PL 6/23/2011 16:10:12.294'!
hasLabelId

	^ self isReadonly not! !

!DLMAQuestionnaireComponent methodsFor: 'rendering' stamp: 'PL 6/23/2011 17:54:55.665'!
renderDividerOn: html

	html div class: 'divider'! !

!DLMAQuestionnaireComponent methodsFor: 'rendering' stamp: 'PL 6/28/2011 02:39:48.603'!
renderEditorOn: html

	html script
		with: ('window.addEventListener(''load'', function() {renderQuestionnaireEditor("' , self id , '");}, true)').

	html div
		class: 'questionnaire';
		with:
			[self
				renderHiddenInputForIncludedOn: html;
				renderHiddenInputForExcludedOn: html;
				renderHiddenInputForHeadingsOn: html;
				renderIncludedSurveysOn: html;
				"renderDividerOn: html;"
				renderExcludedSurveysOn: html]! !

!DLMAQuestionnaireComponent methodsFor: 'rendering' stamp: 'PL 6/28/2011 01:05:48.656'!
renderExcludedSurveysOn: html

	"html div
		class: 'label';
		with: [html render: 'verfgbar']."
	
	html div
		class: 'table';
		id: ('excludedTable_' , self id)! !

!DLMAQuestionnaireComponent methodsFor: 'rendering' stamp: 'tfel 07/12/2011 06:47'!
renderHiddenInputForExcludedOn: html

	| editorInfo |
	
	editorInfo := ''.
	
	self excludedSurveys do:
		[:survey | editorInfo := editorInfo, survey oid asString, Character lf asString, survey question, Character lf asString].

	html hiddenInput
		id: 'excludedInfo_' , self id asString;
		value: editorInfo! !

!DLMAQuestionnaireComponent methodsFor: 'rendering' stamp: 'tfel 07/12/2011 06:49'!
renderHiddenInputForHeadingsOn: html

	| headingsInfo |
	
	headingsInfo := ''.
	
	(self value at: #headings) do:
		[:page | headingsInfo := headingsInfo , page key asString, Character lf asString, page value, Character lf asString].

	html hiddenInput
		id: 'headingsInfo_' , self id asString;
		value: headingsInfo;
		callback: [:value | self saveHeadings: value]! !

!DLMAQuestionnaireComponent methodsFor: 'rendering' stamp: 'tfel 07/12/2011 06:51'!
renderHiddenInputForIncludedOn: html

	| editorInfo |
	
	editorInfo := ''.
	
	(self value at: #surveys) do:
		[:survey | editorInfo := editorInfo, survey oid asString, Character lf asString, survey question, Character lf asString].

	html hiddenInput
		id: 'includedInfo_' , self id asString;
		value: editorInfo;
		callback: [:value | self saveIncluded: value]! !

!DLMAQuestionnaireComponent methodsFor: 'rendering' stamp: 'PL 6/28/2011 01:05:43.452'!
renderIncludedSurveysOn: html

	"html div
		class: 'label';
		with: [html render: 'enthalten']."
	
	html div
		class: 'table';
		id: ('includedTable_' , self id)! !

!DLMAQuestionnaireComponent methodsFor: 'rendering' stamp: 'PL 6/23/2011 16:14:15.806'!
renderViewerOn: html

	html render: (self labelForOption: self value)! !

!DLMAQuestionnaireComponent methodsFor: 'actions' stamp: 'PL 6/27/2011 23:36:36.126'!
saveHeadings: aString

	| headings currentIndex |
	
	headings := OrderedCollection new.
	
	(aString subStrings: (Character lf asString)) withIndexDo:
		[:each :index | 
			(index rem: 2) = 1
				ifTrue: [currentIndex := each trimRight]
				ifFalse: [headings add: (currentIndex -> each trimRight)]].
	
	self value at: #headings put: headings! !

!DLMAQuestionnaireComponent methodsFor: 'actions' stamp: 'MH 6/27/2011 23:11:25.998'!
saveIncluded: aString

	 | surveys |
	
	surveys := OrderedCollection new.
	
	(aString subStrings: (Character lf asString)) withIndexDo:
		[:each :index | 
			(index rem: 2) = 1 ifTrue:
				[| matchingSurveys |
				matchingSurveys := DLSurvey instances select: [:survey | survey oid = (each trimRight asInteger)].
				matchingSurveys ifNotEmpty: [surveys add: matchingSurveys first]]].
	
	self value at: #surveys put: surveys! !

!DLMAQuestionnaireComponent methodsFor: 'accessing-model' stamp: 'PL 6/23/2011 16:32:01.664'!
value

	^ super value ifNil: [	self value: Dictionary new. super value]! !

MAFileUploadComponent subclass: #DLMADeliverableFileUploadComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMADeliverableFileUploadComponent methodsFor: 'accessing' stamp: 'tfel 1/7/2010 19:07'!
asciiFileNameFrom: aFileName
	"To avoid any problems, replace spaces with underscores and select only 'save for HTTP' characters"

	^ aFileName 
		collect: [:char | char = Character space ifTrue: [$_] ifFalse: [char]]
		thenSelect: [:char | char isSafeForHTTP]! !

!DLMADeliverableFileUploadComponent methodsFor: 'rendering' stamp: 'sebh 6/17/2009 02:36'!
renderEditorOn: html
	self value isNil
		ifTrue:  [ self renderUploadOn: html ]
		ifFalse: [ self renderReplaceOn: html ]! !

!DLMADeliverableFileUploadComponent methodsFor: 'rendering' stamp: 'tfel 01/02/2012 16:55'!
renderReplaceOn: html
	html anchor
		url: (self value url);
		with: self value filename.
	html text: ' ('; render: self value filesize asFileSize; text: ') '.
	html break.
	self renderUploadOn: html.! !

!DLMADeliverableFileUploadComponent methodsFor: 'rendering' stamp: 'Marik 7/23/2009 20:59'!
renderUploadOn: html
	html fileUpload
		id: self labelId;
		on: #upload of: self.! !

!DLMADeliverableFileUploadComponent methodsFor: 'rendering' stamp: 'tfel 12/22/2009 18:31'!
renderViewerOn: html

	self value 
		ifNil: [
			html render: 'Noch keine Abgaben.', self memento model
					deliverableRequirement filetype canonicalName]
		ifNotNil: [
			html anchor
				url: (self value urlFor: html context);
				with: self value filename]! !

!DLMADeliverableFileUploadComponent methodsFor: 'accessing' stamp: 'esec 1/9/2012 14:37'!
replace: aFile
	self flag: #es. "TODO: does not seem to be necessary anymore?"
	
	aFile notNil ifTrue: [
		self value ifNotNil: [
			self value finalize.
			self value: nil ].
		self upload: aFile.
		[aFile delete] on: Error do: ["This deletes the temp file if 
									we use streamUploads with WAKom"]
	].! !

!DLMADeliverableFileUploadComponent methodsFor: 'accessing' stamp: 'esec 1/9/2012 14:35'!
requiresMultipartForm
	^ true! !

!DLMADeliverableFileUploadComponent methodsFor: 'accessing' stamp: 'tfel 01/02/2012 17:01'!
timePrefix
	"Custom time prefix, not quite like ISO, just for Deli"
	| d |
	d := DateAndTime now.
	^ (d year asString padded: #left to: 2 with: $0), '-',
		(d month asString padded: #left to: 2 with: $0), '-',
		(d dayOfMonth asString padded: #left to: 2 with: $0), 'T',
		(d hour asString padded: #left to: 2 with: $0), ':',
		(d minute asString padded: #left to: 2 with: $0), ':',
		(d second asInteger asString padded: #left to: 2 with: $0), ':'! !

!DLMADeliverableFileUploadComponent methodsFor: 'accessing' stamp: 'tfel 01/02/2012 16:54'!
upload: aFile
	self value: (aFile isNil ifFalse: [
		self description kind new
			mimetype: aFile contentType;
			filename: self timePrefix, '-', (self asciiFileNameFrom: aFile fileName);
			location: {
				memento model delivery deadline lecture semester canonicalName. 
				memento model delivery deadline lecture lectureName. 
				memento model delivery deadline canonicalName. 
				memento model delivery group canonicalName
				};
			contents: (aFile rawContents);
			yourself.])! !

MAElementComponent subclass: #DLMAChartComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMAChartComponent class methodsFor: 'testing' stamp: 'MH 6/8/2011 12:29:57.279'!
isAbstract

	^ false! !

!DLMAChartComponent methodsFor: 'rendering' stamp: 'PL 8/5/2011 22:06:54.195'!
colors

	| colors |

	colors := Array new: 5.
	colors at: 1 put: (Color r: 173/255 g: 64/255 b: 0/255).
	colors at: 2 put: (Color r: 197/255 g: 84/255 b: 20/255).
	colors at: 3 put: (Color r: 223/255 g: 104/255 b: 36/255).
	colors at: 4 put: (Color r: 223/255 g: 135/255 b: 84/255).
	colors at: 5 put: (Color r: 223/255 g: 162/255 b: 127/255).

	^ colors! !

!DLMAChartComponent methodsFor: 'rendering' stamp: 'CO 6/22/2011 13:16:03.582'!
renderContentOn: html

	| dataset layout pieChart votes choices amounts |
	
	votes := OrderedCollection new.
	choices := Dictionary new.
	amounts := OrderedCollection new.
	
	self value keysAndValuesDo: [:key :value | votes add: (key -> value)].
	
	votes
		sort: [:a :b | a value > b value];
		do: [:each | choices at: (choices size) put: each key.
			amounts add: each value].
	
	dataset := PKDataset new
		name: 'votes';
		addAll: amounts asArray;
		yourself.

	layout := PKPieLayout new.
	layout options xTicks: choices.
	layout addDataset: dataset.
	layout options pieRadius: 0.4.

	pieChart := PKChart new
		renderer: self renderer;
		layout: layout;
		width: 400; height: 250;
		yourself.
	
	pieChart renderContentOn: html.! !

!DLMAChartComponent methodsFor: 'rendering' stamp: 'CO 6/22/2011 13:43:20.726'!
renderer

	| renderer |
	
	renderer := PKSweetCanvasRenderer new.
	renderer options colorScheme: self colors.
	renderer options backgroundColor: Color white.

	^ renderer! !

Error subclass: #DLMultipleResultsException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

Error subclass: #DLNilValueException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

Error subclass: #DLNoResultException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

Error subclass: #MultipleResultsException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

Announcement subclass: #DLLogoutAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-announcements'!

Announcement subclass: #DLViewCompReplacement
	instanceVariableNames: 'component'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-announcements'!

!DLViewCompReplacement class methodsFor: 'accessing' stamp: 'sebh 6/3/2009 17:57'!
forComponent: aComponent
	^ self new
		component: aComponent;
		yourself.! !

!DLViewCompReplacement methodsFor: 'accessing' stamp: 'sebh 6/3/2009 17:55'!
component

	^ component! !

!DLViewCompReplacement methodsFor: 'accessing' stamp: 'sebh 6/3/2009 17:55'!
component: anObject

	component := anObject.! !

WAFileLibrary subclass: #DLFileLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-configuration'!

!DLFileLibrary methodsFor: 'uploaded' stamp: 'tfel 1/11/2011 18:17'!
addPng
	| cache |
	cache := #(nil) asOrderedCollection.
	(cache first) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 4 103 65 77 65 0 0 175 200 55 5 138 233 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 2 111 73 68 65 84 56 203 165 147 235 75 147 97 24 135 253 91 182 47 5 131 164 134 89 40 168 41 37 88 40 111 217 108 138 138 78 219 150 115 107 138 206 246 110 46 157 186 205 3 45 157 19 15 21 181 161 219 104 164 59 56 15 195 3 102 226 212 210 69 234 235 80 162 141 34 8 106 195 175 191 222 21 77 71 203 136 30 248 125 121 224 186 158 231 190 185 239 36 0 73 255 147 223 46 116 211 117 204 14 143 132 108 117 137 168 230 9 65 88 254 162 58 220 240 188 130 146 90 203 72 209 104 49 243 68 129 110 90 74 180 79 74 66 207 214 123 177 26 90 132 255 243 6 214 63 173 96 50 96 135 210 83 3 190 137 19 226 61 185 78 36 20 252 132 197 145 233 61 59 14 190 237 97 246 131 11 38 106 16 143 119 12 176 239 155 176 244 113 14 218 5 25 74 71 242 35 220 193 60 34 78 160 157 146 50 104 56 232 222 181 96 239 235 54 134 183 245 120 184 214 129 110 95 43 12 126 29 250 252 90 116 111 182 192 125 96 7 233 17 162 208 120 37 88 208 155 205 136 9 104 88 209 191 172 198 187 47 155 244 139 125 232 221 210 66 243 74 137 95 71 189 38 131 124 81 8 197 114 45 156 251 54 220 28 201 65 222 131 12 69 76 208 226 172 161 92 1 27 253 85 51 58 87 85 104 91 145 67 54 43 138 9 4 54 46 26 102 202 32 157 42 198 192 27 29 244 75 205 184 220 157 70 197 4 138 113 254 161 247 189 11 253 111 117 52 220 132 63 29 241 100 17 20 243 124 88 252 195 200 210 165 30 198 4 77 118 222 225 68 96 12 218 13 18 42 95 253 137 2 210 91 13 171 127 8 233 29 236 35 65 189 173 156 50 250 180 48 108 105 208 244 82 8 241 124 5 120 214 27 113 96 52 119 61 92 244 251 212 232 242 222 195 5 117 242 81 9 226 177 18 197 109 43 1 71 192 2 217 124 37 36 222 210 31 53 31 23 136 156 28 212 185 139 225 216 53 227 82 79 42 216 247 89 71 77 20 154 139 24 85 79 11 131 164 71 128 113 106 52 214 176 40 88 235 140 38 10 115 49 177 99 194 29 203 173 40 28 76 86 158 102 196 13 82 249 163 2 162 100 232 106 164 209 81 9 39 45 49 250 218 65 206 84 65 62 85 9 227 106 27 28 52 44 180 112 192 86 177 34 52 76 36 28 101 206 64 46 65 24 114 66 249 3 153 232 89 32 97 126 109 128 121 195 0 141 183 17 89 93 41 81 56 116 28 78 184 76 215 244 153 204 220 158 116 50 187 243 34 149 161 73 9 167 181 159 13 159 111 61 67 157 83 177 200 100 229 41 230 95 183 241 95 243 29 65 70 203 31 0 40 211 193 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache first! !

!DLFileLibrary methodsFor: 'uploaded' stamp: 'tfel 1/11/2011 18:17'!
backPng
	| cache |
	cache := #(nil) asOrderedCollection.
	(cache first) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 4 103 65 77 65 0 0 175 200 55 5 138 233 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 0 235 73 68 65 84 56 203 99 252 255 255 63 3 37 128 137 129 66 48 200 12 40 61 145 201 6 196 187 73 49 128 5 141 127 245 239 159 191 50 164 24 192 8 139 5 160 205 23 197 217 36 244 254 252 249 195 240 240 253 67 134 95 63 127 51 252 250 1 194 191 24 126 2 49 152 254 142 96 131 228 46 244 95 101 100 129 106 62 41 198 42 174 167 192 173 196 240 231 223 31 6 25 110 57 48 253 251 239 95 32 254 205 240 251 31 16 255 253 3 21 3 209 191 25 86 175 92 139 240 2 208 217 191 255 48 254 97 248 245 247 23 88 209 31 160 162 223 96 197 191 17 52 212 0 144 220 159 255 64 177 95 127 80 189 144 185 51 238 188 48 155 136 1 7 51 39 195 195 151 15 25 94 191 127 131 213 217 32 175 129 52 255 249 253 135 225 254 194 71 140 140 200 41 49 118 85 200 77 160 66 57 160 6 199 13 105 59 78 144 28 141 64 205 186 64 205 7 137 213 140 226 133 17 156 23 0 227 161 187 188 122 90 211 201 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache first! !

!DLFileLibrary methodsFor: 'uploaded' stamp: 'PL 8/4/2011 18:14:37.726'!
barchartPng
	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 128 0 0 0 16 8 6 0 0 0 222 88 119 136 0 0 0 4 115 66 73 84 8 8 8 8 124 8 100 136 0 0 0 9 112 72 89 115 0 0 13 215 0 0 13 215 1 66 40 155 120 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 119 119 119 46 105 110 107 115 99 97 112 101 46 111 114 103 155 238 60 26 0 0 0 247 73 68 65 84 104 129 237 153 177 81 196 64 12 69 159 176 59 96 92 130 43 185 156 30 200 152 113 192 92 1 16 208 192 153 0 82 24 247 65 64 5 68 36 56 189 128 38 86 255 2 251 106 80 32 189 100 211 175 153 55 43 105 215 238 158 121 180 27 78 8 35 19 134 228 28 15 183 175 72 58 65 178 250 65 102 118 236 229 204 47 15 31 209 97 34 176 167 247 251 89 18 227 56 70 103 137 192 214 117 157 123 53 248 57 127 70 135 9 65 109 59 187 174 139 13 18 72 239 13 154 71 199 136 193 75 128 77 0 47 1 98 131 4 210 187 131 178 10 176 215 157 90 0 37 110 1 53 3 236 45 32 237 13 80 2 108 2 252 253 127 71 231 8 161 4 184 14 129 45 58 70 12 37 192 117 6 72 42 64 205 0 251 22 144 118 13 172 45 96 127 8 74 122 3 84 11 40 1 128 228 2 168 33 111 233 126 194 0 80 67 0 195 48 164 172 31 80 239 206 244 251 197 27 9 191 67 49 38 73 44 203 146 178 126 73 211 5 13 140 122 185 134 146 171 29 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

!DLFileLibrary methodsFor: 'uploaded' stamp: 'PL 8/4/2011 18:19:58.489'!
barchartseparatorPng
	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 1 0 0 0 16 8 6 0 0 0 215 159 21 183 0 0 0 4 115 66 73 84 8 8 8 8 124 8 100 136 0 0 0 9 112 72 89 115 0 0 13 215 0 0 13 215 1 66 40 155 120 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 119 119 119 46 105 110 107 115 99 97 112 101 46 111 114 103 155 238 60 26 0 0 0 56 73 68 65 84 8 153 99 240 111 96 136 99 226 100 227 153 203 244 235 231 15 22 166 127 127 25 24 160 196 63 6 6 166 255 112 238 239 223 127 160 172 255 112 89 36 197 127 25 254 48 75 169 51 60 4 0 222 188 31 209 47 89 134 9 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

!DLFileLibrary methodsFor: 'uploaded' stamp: 'PL 5/24/2011 18:25:08.164'!
bubbleGreenPng
	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 4 115 66 73 84 8 8 8 8 124 8 100 136 0 0 0 9 112 72 89 115 0 0 13 215 0 0 13 215 1 66 40 155 120 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 119 119 119 46 105 110 107 115 99 97 112 101 46 111 114 103 155 238 60 26 0 0 2 65 73 68 65 84 56 141 149 147 63 76 83 81 20 198 127 183 148 246 189 82 164 96 49 109 144 63 13 129 106 98 128 164 202 0 14 186 48 160 137 22 39 153 28 89 140 186 18 147 74 98 88 213 141 209 9 39 43 36 74 220 52 193 48 128 21 3 38 10 129 16 10 132 98 107 109 161 244 189 215 215 199 117 64 20 34 34 254 146 111 187 223 57 247 228 156 79 72 41 217 79 207 128 104 150 208 11 132 126 10 32 6 196 4 12 71 35 114 126 255 123 177 87 64 32 196 245 1 238 40 78 101 240 82 123 183 122 186 186 145 234 138 58 0 146 217 56 171 201 69 222 78 142 105 186 161 247 143 68 120 34 217 53 10 41 229 158 249 229 217 198 150 238 43 29 183 48 100 138 77 61 78 190 144 6 192 229 168 226 132 82 135 83 120 121 53 241 148 207 139 51 99 35 17 174 74 164 20 82 74 194 3 226 110 48 112 238 81 207 229 62 150 191 191 35 103 36 56 12 183 211 71 125 229 69 162 111 134 152 91 250 116 239 69 68 62 22 225 7 52 43 138 235 99 223 141 135 106 98 107 146 173 194 225 230 61 202 29 62 124 229 237 12 61 191 175 233 122 190 205 38 161 183 179 173 75 213 139 41 178 90 130 29 139 35 149 213 18 232 197 20 157 109 93 170 20 220 180 3 161 26 111 19 233 92 156 109 61 195 118 33 133 105 105 20 119 12 138 150 14 128 189 68 193 110 115 82 90 162 82 230 240 146 206 197 169 241 54 129 228 188 29 8 169 138 155 15 139 175 217 46 164 14 253 182 89 204 1 57 0 210 172 146 206 173 210 217 120 27 32 100 7 200 27 155 24 166 129 101 29 57 254 47 12 211 32 111 108 2 96 3 98 201 204 26 110 135 31 203 226 88 114 59 252 36 51 107 0 49 27 16 219 72 173 224 45 11 98 21 57 150 188 101 65 54 82 43 32 120 111 19 48 60 187 48 165 121 212 0 30 181 225 159 221 61 106 3 30 53 192 236 194 148 38 36 207 108 209 136 156 55 205 66 255 248 244 40 173 181 97 42 93 127 47 82 233 106 160 181 54 204 248 244 40 166 89 232 143 70 228 252 129 83 246 87 215 119 119 180 92 227 91 110 137 68 102 142 76 126 29 0 143 203 143 207 19 228 164 59 192 196 204 40 235 201 229 131 167 12 191 195 84 106 119 12 158 9 92 80 79 121 106 169 170 168 217 93 93 118 141 175 153 21 190 44 77 105 102 177 240 103 152 246 243 191 113 254 1 14 182 90 214 122 246 176 122 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

!DLFileLibrary methodsFor: 'uploaded' stamp: 'PL 5/24/2011 18:25:05.275'!
bubbleRedPng
	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 4 115 66 73 84 8 8 8 8 124 8 100 136 0 0 0 9 112 72 89 115 0 0 13 215 0 0 13 215 1 66 40 155 120 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 119 119 119 46 105 110 107 115 99 97 112 101 46 111 114 103 155 238 60 26 0 0 2 80 73 68 65 84 56 141 149 147 49 76 83 65 28 198 127 247 120 237 163 37 85 41 150 182 161 37 17 8 81 12 81 83 99 66 138 44 36 6 9 147 38 54 176 57 58 169 43 206 178 170 147 163 27 136 137 27 193 196 193 1 232 160 177 168 33 86 211 96 12 10 148 215 23 91 75 75 31 237 123 237 57 84 13 152 162 248 75 190 228 134 251 190 187 220 253 63 33 165 100 47 179 23 125 189 2 117 66 212 100 68 10 34 0 66 146 144 138 72 72 236 233 216 162 145 218 187 95 252 14 16 66 204 70 253 55 53 77 155 234 141 94 114 29 11 157 192 221 222 1 64 41 179 193 247 245 207 164 226 207 205 114 185 60 25 139 235 15 248 105 172 7 8 33 158 68 253 115 193 158 211 163 167 198 198 17 133 28 118 38 77 117 59 11 64 211 17 47 106 123 16 233 105 229 195 220 12 233 213 247 243 215 226 250 24 82 74 33 165 100 118 48 112 43 216 221 119 175 255 234 117 74 43 175 176 179 6 141 80 189 62 220 253 23 88 121 250 136 244 167 228 237 216 210 214 125 241 120 240 120 175 211 217 242 54 122 227 142 171 252 241 29 214 1 230 95 56 188 62 180 147 103 136 63 188 107 86 42 59 103 21 129 58 209 53 48 236 170 230 115 236 102 13 170 240 87 237 102 13 170 249 28 93 3 195 46 81 83 198 85 81 147 17 79 184 11 83 223 164 82 204 99 231 115 212 202 187 212 172 50 178 82 174 191 175 83 67 113 104 40 90 51 234 209 86 76 125 19 79 184 11 129 56 175 74 65 68 109 118 163 191 124 129 189 157 107 124 111 219 6 118 234 235 204 38 37 125 19 255 149 235 72 65 68 5 176 74 69 172 74 133 170 108 236 255 19 89 169 96 149 138 0 40 66 146 40 102 210 52 181 181 99 75 121 40 53 181 181 83 204 164 17 146 132 34 21 145 40 232 27 104 157 221 216 112 40 105 157 221 20 244 13 36 242 181 34 177 167 245 228 178 233 8 132 113 248 67 255 60 221 225 15 225 8 132 209 147 203 166 84 106 51 74 108 209 72 217 182 53 185 182 48 143 111 104 4 103 224 224 16 103 32 132 111 104 132 181 133 121 108 219 154 140 45 26 169 125 163 220 18 8 141 134 6 47 99 166 191 82 248 178 202 238 55 29 128 230 54 63 158 206 30 92 193 48 235 75 207 216 217 90 223 63 202 245 207 174 151 169 73 117 76 121 251 206 185 220 190 14 92 190 0 0 166 177 69 201 216 32 155 124 99 86 109 171 65 153 246 240 191 117 254 1 98 44 122 63 1 157 152 191 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

!DLFileLibrary methodsFor: 'uploaded' stamp: 'PL 5/24/2011 18:19:54.451'!
bubbleTransparentPng
	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 4 115 66 73 84 8 8 8 8 124 8 100 136 0 0 0 9 112 72 89 115 0 0 13 215 0 0 13 215 1 66 40 155 120 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 119 119 119 46 105 110 107 115 99 97 112 101 46 111 114 103 155 238 60 26 0 0 2 110 73 68 65 84 56 141 149 147 207 107 211 112 24 198 223 36 109 93 215 166 93 186 52 201 126 128 237 201 77 168 131 89 69 100 80 220 97 99 52 51 176 67 153 122 233 101 120 31 248 87 120 240 60 118 216 73 237 105 144 109 48 216 69 196 33 78 198 96 138 146 121 170 180 206 45 63 250 77 155 244 215 55 77 227 169 80 113 186 249 156 223 231 243 190 47 60 15 225 121 30 244 107 66 146 232 0 65 36 124 20 197 120 221 110 12 0 128 32 201 74 199 117 17 246 188 162 34 203 86 255 60 209 15 152 146 164 27 113 150 77 63 91 89 185 53 198 178 163 209 72 132 5 0 168 214 106 250 15 93 63 125 190 190 254 73 211 245 195 99 89 62 249 3 48 189 180 148 121 34 138 233 165 133 133 7 216 113 108 179 94 55 236 122 221 6 0 8 135 66 225 161 80 104 56 224 247 135 55 119 119 223 188 220 217 57 60 218 220 124 11 0 224 235 109 126 44 138 183 115 217 236 124 73 211 20 179 86 171 246 159 217 198 184 98 32 84 25 138 68 162 185 108 118 190 227 186 222 148 36 157 29 203 242 9 57 33 73 180 192 243 233 156 40 206 94 100 238 151 89 171 85 75 154 166 228 68 113 86 224 249 244 132 36 209 100 128 32 18 171 249 124 10 59 142 253 47 115 63 4 59 142 189 154 207 167 174 81 212 117 159 143 162 152 49 142 27 53 45 203 168 183 90 117 189 90 181 236 102 211 105 54 26 78 29 99 12 0 16 10 4 2 193 193 65 127 56 24 244 179 209 40 109 90 150 49 198 113 163 20 65 196 124 94 183 27 27 24 24 8 238 29 28 188 43 105 154 125 209 86 140 113 11 217 118 11 0 224 27 64 165 20 143 27 15 51 153 57 175 219 141 145 0 0 216 113 154 13 140 59 151 157 223 83 3 227 14 118 156 38 0 0 73 144 100 197 64 200 24 231 121 230 170 128 113 158 103 12 132 12 130 36 43 100 199 117 81 89 85 213 132 32 140 92 21 144 16 132 145 178 170 170 174 231 85 72 236 121 197 181 66 161 200 208 52 59 153 76 198 47 51 79 38 147 113 134 166 217 181 66 161 216 118 221 239 148 174 40 248 197 198 134 211 106 183 3 217 76 230 94 11 99 83 55 205 198 223 204 247 83 169 59 175 182 182 62 124 86 148 247 95 100 249 244 183 40 207 205 204 220 124 180 184 120 23 89 150 94 60 59 251 89 62 63 71 189 159 19 130 48 194 208 52 251 122 123 251 227 222 254 254 215 94 148 255 40 19 195 48 211 79 151 151 19 227 28 199 13 51 204 48 0 128 129 144 81 86 85 117 173 80 40 34 132 142 46 44 83 79 255 91 231 95 96 239 87 11 211 99 247 222 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

!DLFileLibrary methodsFor: 'uploaded' stamp: 'tfel 1/11/2011 18:17'!
choosePng
	| cache |
	cache := #(nil) asOrderedCollection.
	(cache first) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 4 103 65 77 65 0 0 175 200 55 5 138 233 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 1 171 73 68 65 84 56 203 189 147 217 46 67 97 20 133 123 231 56 239 98 110 213 24 83 66 170 134 84 39 234 232 41 69 41 141 27 170 167 173 86 171 67 74 12 199 165 24 106 142 196 20 148 32 18 151 90 213 134 103 16 47 161 186 252 149 104 194 133 24 18 23 255 221 191 214 222 251 219 107 11 0 8 254 242 4 255 110 160 94 107 226 91 150 234 157 191 50 80 173 54 242 166 99 61 250 15 88 72 248 42 238 71 6 202 96 3 63 120 212 133 217 123 55 188 55 86 232 182 212 168 240 20 217 190 37 86 172 72 121 227 161 14 211 113 23 166 226 78 116 110 183 162 210 91 140 18 135 144 74 127 50 94 178 53 134 51 166 231 179 88 190 44 229 83 45 79 198 156 8 196 28 111 149 203 221 226 68 241 88 1 149 30 193 120 193 150 245 158 50 79 220 181 9 236 174 114 232 93 76 96 241 125 251 90 4 238 198 224 191 179 131 221 84 161 204 85 152 40 178 231 83 105 136 253 231 218 218 222 80 251 163 47 204 97 58 54 14 205 150 44 65 96 13 201 22 37 83 134 61 6 190 168 29 222 91 14 29 27 10 148 142 139 18 98 91 30 245 97 141 61 39 154 76 253 97 27 204 87 3 152 123 240 192 27 182 194 120 164 131 233 68 143 137 176 5 238 91 11 152 117 57 74 156 194 151 66 235 71 113 122 4 102 71 78 147 202 48 133 244 111 115 250 163 54 184 34 102 184 194 102 104 214 90 82 176 146 34 46 151 250 50 72 4 22 45 91 144 160 123 183 29 238 200 40 28 55 195 104 11 202 64 96 37 69 150 28 234 91 73 148 204 87 211 117 51 149 164 101 5 212 43 205 32 176 146 194 209 108 234 71 81 38 251 165 203 39 196 32 176 158 11 204 217 25 191 186 5 2 139 206 31 201 202 248 151 107 124 5 190 162 169 60 82 10 3 72 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache first! !

!DLFileLibrary methodsFor: 'uploaded' stamp: 'tfel 1/11/2011 18:17'!
copyPng
	| cache |
	cache := #(nil) asOrderedCollection.
	(cache first) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 4 115 66 73 84 8 8 8 8 124 8 100 136 0 0 0 9 112 72 89 115 0 0 4 157 0 0 4 157 1 124 52 107 161 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 119 119 119 46 105 110 107 115 99 97 112 101 46 111 114 103 155 238 60 26 0 0 0 15 116 69 88 116 84 105 116 108 101 0 69 100 105 116 32 67 111 112 121 161 69 142 32 0 0 0 22 116 69 88 116 65 117 116 104 111 114 0 65 110 100 114 101 97 115 32 78 105 108 115 115 111 110 43 239 228 163 0 0 0 24 116 69 88 116 67 114 101 97 116 105 111 110 32 84 105 109 101 0 50 48 48 53 45 49 48 45 49 53 13 148 7 87 0 0 1 209 73 68 65 84 56 141 141 145 205 138 19 65 20 133 79 149 213 213 61 77 200 194 69 58 78 143 10 227 67 4 220 185 16 92 12 232 11 248 24 179 201 194 188 131 15 224 66 124 6 65 113 161 146 149 107 81 193 159 136 196 48 73 39 97 226 196 74 39 169 186 215 69 167 127 50 70 98 65 193 229 86 159 239 220 211 87 116 187 175 239 68 81 243 24 123 206 100 50 89 182 90 183 159 93 238 171 40 106 30 55 26 209 209 62 128 16 114 177 171 47 247 9 1 128 8 160 127 188 169 188 24 143 167 72 83 131 36 73 110 28 198 71 119 183 92 164 132 4 211 151 175 159 31 84 251 111 186 111 79 11 64 24 134 208 90 225 231 160 31 199 135 241 245 245 122 181 203 240 102 94 120 158 198 21 33 90 151 34 252 87 34 48 3 0 111 71 72 83 3 99 82 172 54 206 139 197 2 211 233 116 167 248 224 32 64 163 17 149 0 34 192 90 130 181 22 236 242 17 61 212 235 245 138 144 11 231 32 8 202 9 178 239 9 97 24 64 41 9 229 121 21 1 111 213 57 196 57 2 81 14 112 142 137 54 171 170 236 106 189 182 152 205 102 21 231 210 189 86 171 101 112 114 144 118 105 29 17 21 15 74 41 0 153 155 16 98 115 203 252 198 100 255 134 153 33 149 7 101 109 6 0 178 125 43 79 129 153 17 4 62 154 205 107 155 24 229 248 204 12 173 53 124 223 207 34 12 70 131 239 102 105 156 100 102 41 37 39 227 209 45 162 237 204 121 173 148 42 196 195 225 25 76 106 174 170 147 123 39 221 234 154 62 61 125 18 19 209 195 28 2 0 66 8 248 190 15 173 53 94 190 122 129 192 15 240 173 215 91 141 206 146 199 10 59 14 17 21 174 90 235 226 90 103 225 28 161 215 235 45 231 243 243 71 157 78 103 244 23 128 172 125 247 225 227 251 231 196 204 96 193 82 130 0 240 114 149 210 239 139 11 213 239 255 104 204 127 153 251 237 118 123 8 0 127 0 219 121 27 208 242 42 95 34 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache first! !

!DLFileLibrary methodsFor: 'uploaded' stamp: 'tfel 1/11/2011 18:17'!
deletePng
	| cache |
	cache := #(nil) asOrderedCollection.
	(cache first) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 4 103 65 77 65 0 0 175 200 55 5 138 233 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 2 33 73 68 65 84 56 203 149 147 235 78 19 81 20 133 137 137 201 137 207 160 86 137 134 200 145 128 196 27 66 91 6 40 173 13 8 38 208 251 133 94 164 128 180 165 237 164 77 161 54 234 15 77 124 18 159 11 68 197 222 176 210 153 118 58 211 229 174 152 74 45 37 225 199 78 206 100 206 250 246 172 181 247 12 0 24 184 76 213 215 66 215 206 62 119 95 16 51 58 42 222 87 236 15 114 217 237 141 215 108 78 67 47 160 45 206 236 162 149 206 66 139 39 123 32 117 95 128 215 3 97 52 54 182 240 235 229 202 231 234 226 210 189 127 128 191 98 228 223 161 69 165 37 68 52 55 183 59 16 217 187 198 169 59 154 209 56 144 203 163 125 62 54 91 227 229 25 211 149 83 64 42 205 90 9 81 107 237 190 1 62 126 130 150 205 181 1 104 4 66 92 246 248 57 117 135 178 29 3 232 189 236 15 224 120 254 185 90 22 230 174 118 89 208 98 9 166 190 142 169 154 152 1 222 127 128 154 74 163 30 12 131 186 67 217 138 2 217 189 63 231 138 201 66 226 89 118 110 136 205 200 38 107 132 214 213 102 116 135 236 188 5 246 242 36 204 1 153 44 100 143 15 149 57 179 90 158 158 97 253 167 112 26 22 147 92 94 13 89 178 227 246 1 14 55 32 166 81 153 157 215 74 70 129 253 127 191 7 32 57 61 237 81 1 52 13 216 156 192 138 29 216 73 146 111 11 10 19 83 252 66 128 228 112 115 201 229 129 18 142 0 73 145 132 41 32 70 118 40 64 121 213 142 178 222 136 239 99 227 252 92 64 205 238 226 146 211 13 37 180 14 208 24 37 135 11 20 150 90 156 50 104 39 139 203 64 100 3 181 23 203 40 60 124 140 195 161 97 222 5 160 205 226 212 29 74 240 21 117 77 64 162 79 167 176 212 226 164 129 21 158 76 176 163 241 71 106 213 100 6 130 33 156 88 172 56 26 25 197 193 173 65 222 1 208 102 9 53 155 3 74 32 4 105 213 1 10 75 45 62 211 119 2 251 54 50 198 190 14 223 87 127 26 5 72 214 5 252 24 125 128 253 27 58 161 203 2 109 150 80 93 88 66 201 48 173 81 88 61 105 31 222 29 98 95 6 239 168 103 197 61 33 150 244 70 161 240 116 146 245 251 153 14 116 183 217 254 245 155 194 133 99 188 108 253 6 114 187 164 199 219 237 190 20 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache first! !

!DLFileLibrary methodsFor: 'uploaded' stamp: 'tfel 1/11/2011 18:17'!
deliPng
	| cache |
	cache := #(nil) asOrderedCollection.
	(cache first) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 235 0 0 0 90 8 6 0 0 0 89 156 161 5 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 27 211 73 68 65 84 120 218 236 93 11 112 92 213 121 62 171 149 188 122 107 245 178 100 131 228 69 182 137 236 96 103 77 176 171 56 10 22 105 75 77 128 32 18 8 12 153 12 50 33 51 132 12 181 50 77 166 161 157 130 211 204 20 58 211 25 108 156 73 220 25 90 47 67 67 49 144 68 64 8 174 233 144 21 216 88 4 27 47 54 197 50 24 123 45 27 179 178 133 180 54 122 236 90 175 158 239 236 57 171 179 87 247 238 227 238 67 187 226 252 51 119 86 123 247 62 206 61 58 223 249 254 255 63 255 255 95 11 201 82 233 232 216 180 129 255 233 164 155 93 231 16 55 255 244 184 92 59 47 16 37 74 230 185 88 178 4 152 75 232 71 27 221 218 57 56 29 38 46 3 240 122 249 230 86 32 86 162 192 154 90 144 222 130 15 14 210 116 8 128 235 145 192 219 173 254 229 74 20 88 19 3 233 221 244 99 139 73 6 77 86 220 18 128 221 138 125 149 40 176 234 200 175 126 249 203 59 250 207 157 123 244 84 223 105 71 22 245 129 12 220 23 212 144 80 242 185 6 235 182 199 30 171 160 31 93 176 75 63 241 245 19 95 127 127 54 247 73 151 216 20 235 42 201 38 201 203 196 77 198 39 38 24 80 115 164 79 96 63 187 232 230 167 234 250 78 110 87 43 81 50 255 153 117 211 166 77 27 156 171 87 187 197 119 170 2 147 193 161 161 92 235 39 47 221 182 2 196 138 109 149 204 91 102 173 91 88 23 193 168 151 46 93 202 197 126 114 112 176 122 41 211 62 76 183 10 53 116 148 204 59 176 30 251 240 131 8 176 22 21 21 229 114 127 33 56 99 139 0 173 26 62 74 230 149 26 188 176 126 209 208 223 255 228 239 236 249 86 43 251 254 233 224 32 233 59 125 102 190 244 31 212 227 14 181 126 171 36 231 153 53 223 102 91 50 56 52 104 127 251 192 193 240 190 138 138 10 98 205 203 155 47 253 7 245 216 253 211 159 252 244 215 7 15 28 168 87 195 73 73 46 171 193 8 29 36 47 252 225 37 114 252 163 143 66 0 166 12 187 108 217 82 178 160 160 96 94 116 96 81 97 33 169 175 175 187 175 103 255 254 253 207 237 218 213 162 134 148 146 156 6 235 248 248 56 121 194 229 10 3 182 152 218 173 95 92 185 130 212 215 213 229 52 203 150 150 148 176 137 7 19 208 196 196 132 227 19 159 239 79 191 121 234 169 141 106 88 41 201 57 155 149 170 193 127 34 210 250 106 1 101 211 155 110 248 6 105 249 139 117 68 216 176 19 147 147 228 252 249 1 186 157 39 147 83 83 57 209 105 152 96 106 107 107 201 162 250 186 217 29 154 151 23 168 174 170 186 245 187 223 251 222 110 53 188 148 228 18 88 177 160 58 43 189 173 233 138 43 72 251 205 55 147 203 22 47 14 239 203 5 208 10 144 214 214 214 132 39 27 221 231 206 207 247 59 28 142 175 220 120 243 205 189 106 136 41 201 122 176 194 185 68 66 222 82 93 1 203 174 253 242 151 201 117 215 94 75 170 170 170 34 64 59 56 56 200 128 123 137 170 207 217 32 176 175 1 80 180 51 26 72 101 177 217 108 61 247 221 127 255 87 212 16 83 146 11 96 69 152 94 87 172 227 140 64 11 25 29 27 163 192 29 34 195 195 195 100 44 16 200 120 231 84 85 86 210 54 85 146 178 210 82 83 231 55 54 54 94 119 235 183 191 237 86 195 76 73 74 48 149 198 107 59 227 57 8 206 167 55 123 122 216 214 252 133 47 144 150 117 235 200 138 230 102 198 96 112 68 21 95 86 20 102 92 6 218 177 0 251 68 36 84 58 152 183 162 188 156 84 84 148 179 37 166 120 89 212 72 168 74 127 7 153 169 104 161 68 73 214 130 181 45 209 19 122 143 29 99 91 73 73 9 105 89 187 142 124 105 245 170 176 93 11 224 216 41 128 176 17 82 23 193 190 147 20 200 12 188 151 18 7 175 213 154 23 142 170 50 203 160 198 215 182 22 169 33 166 36 23 212 96 93 231 82 162 82 83 93 77 174 118 58 201 85 95 252 98 132 67 42 23 100 215 243 207 187 223 220 183 239 58 53 204 210 35 211 211 211 172 78 151 197 98 233 86 96 53 15 212 168 206 37 179 82 105 183 51 208 94 181 114 37 105 104 104 32 182 5 11 178 182 99 187 94 122 137 188 177 111 159 123 34 24 188 46 135 6 255 18 62 248 79 101 73 91 236 180 45 239 234 252 134 184 236 78 137 12 252 36 148 214 184 133 30 127 65 129 53 49 176 198 229 92 74 70 224 152 186 114 249 114 178 180 169 137 44 163 91 93 93 93 210 54 102 42 228 248 137 19 228 119 93 93 164 255 220 57 124 205 106 176 210 65 255 37 110 174 56 249 167 131 15 248 159 207 81 91 68 59 68 91 220 180 45 215 105 142 219 57 25 12 116 12 190 123 144 92 232 125 143 76 6 131 164 162 249 42 82 187 110 61 177 218 10 103 29 175 108 214 216 226 76 119 195 225 152 250 191 247 223 103 27 4 118 174 99 201 146 48 120 107 106 106 50 202 188 39 189 94 242 250 190 125 228 240 145 35 242 110 119 150 255 255 61 185 212 22 10 84 212 238 234 216 123 215 125 100 154 4 73 221 215 175 102 251 135 14 31 36 163 103 251 72 211 29 29 109 56 134 2 246 73 5 214 248 165 45 211 15 50 50 50 18 1 94 48 47 194 25 1 224 197 139 22 49 123 183 178 178 146 121 152 83 9 208 143 40 147 190 227 241 8 38 85 146 94 105 63 221 245 71 114 241 216 113 246 37 111 65 1 169 109 93 197 254 14 14 156 39 254 163 239 17 251 138 171 58 232 87 5 214 108 98 214 120 152 247 244 153 51 108 147 165 110 225 66 82 94 94 78 106 41 243 194 11 12 32 99 61 21 106 244 4 61 103 106 122 58 82 221 206 207 39 101 101 101 164 239 244 105 114 226 228 73 114 126 96 128 93 243 227 179 103 217 61 148 100 84 236 163 103 125 225 47 23 142 156 32 246 213 75 73 65 121 113 232 127 254 217 252 46 226 145 114 176 114 231 146 61 91 31 24 12 136 237 195 227 199 195 251 214 183 180 176 13 78 33 145 108 0 121 242 63 158 152 177 69 187 187 73 215 139 47 42 184 204 177 20 148 69 46 175 13 30 232 13 171 195 86 155 109 94 63 123 58 82 94 156 185 214 9 13 151 95 30 82 165 130 65 195 99 70 71 71 115 221 38 156 15 210 213 112 203 13 36 95 2 236 216 217 1 174 18 219 72 233 21 203 231 117 159 43 176 74 18 144 192 218 216 208 16 241 27 212 96 19 226 87 248 74 169 184 10 202 203 252 235 119 110 39 69 139 67 185 254 19 159 141 81 182 45 39 75 218 239 36 11 202 43 208 223 91 148 26 28 191 180 229 90 39 32 147 6 130 140 31 33 197 197 197 10 26 89 38 88 67 157 158 158 110 171 104 94 222 245 87 123 158 119 12 188 125 136 237 175 89 187 6 31 94 186 181 207 231 117 214 116 128 53 231 152 181 80 199 214 209 50 171 73 53 88 73 234 1 139 32 137 43 40 104 111 161 32 21 99 205 59 95 151 107 210 6 214 108 119 46 233 9 60 195 16 173 215 88 203 172 38 213 96 239 92 61 23 15 50 104 215 209 116 208 38 55 73 65 208 10 0 67 102 2 25 180 234 63 108 199 46 189 8 36 147 247 170 208 16 129 159 72 235 216 60 244 208 163 152 53 14 41 176 217 110 153 14 189 17 46 167 164 130 131 53 22 179 154 145 137 96 240 212 28 128 20 0 66 141 99 71 148 195 58 146 188 71 60 47 22 195 68 177 133 30 139 201 161 147 130 40 217 247 8 57 73 236 32 19 76 26 221 10 172 250 0 197 236 221 201 255 49 246 92 236 0 193 172 23 46 94 52 100 86 172 173 230 130 32 20 143 164 113 194 228 236 150 232 171 80 0 232 46 122 174 139 2 118 147 82 228 51 12 86 10 210 187 57 72 157 185 222 1 130 89 47 106 192 90 83 83 29 254 123 96 224 211 92 0 234 161 116 254 63 56 80 221 73 220 163 131 94 195 73 1 187 70 193 206 156 228 37 0 208 10 186 61 92 16 74 125 115 205 7 160 66 108 6 11 233 136 112 74 82 252 25 4 234 206 44 7 106 88 149 165 215 122 76 193 46 141 96 5 72 185 99 98 139 145 186 59 157 163 29 176 144 47 219 200 14 38 228 208 202 50 240 169 41 53 216 147 33 160 110 136 161 250 186 184 218 138 116 51 11 7 220 150 4 39 147 45 81 128 202 212 98 11 23 62 62 218 163 216 151 157 34 15 213 68 127 182 241 173 83 169 193 179 65 186 129 255 179 35 28 9 168 151 11 7 12 2 229 33 175 117 119 147 214 230 34 178 183 119 108 94 116 74 141 134 85 179 92 13 118 69 97 246 54 173 55 150 127 127 23 54 36 137 195 91 205 243 74 141 192 209 161 93 50 225 222 88 56 147 94 136 98 67 227 122 9 57 130 248 117 187 121 155 148 205 42 171 188 124 54 237 148 1 186 108 233 82 186 53 145 82 169 252 73 95 95 104 73 163 181 185 56 39 193 42 66 13 101 7 83 113 113 110 84 99 225 12 229 48 248 185 45 218 178 9 18 204 227 28 244 70 64 237 138 181 182 9 135 18 130 24 116 218 216 14 213 122 62 47 179 100 4 172 28 168 97 251 4 236 185 178 185 153 52 54 234 47 101 96 253 241 171 148 85 193 172 185 44 178 131 169 177 161 81 195 172 89 235 13 110 55 98 219 84 173 111 70 185 71 188 170 168 139 232 135 0 58 201 60 94 102 73 59 88 101 160 162 86 110 235 250 245 134 32 133 160 190 47 42 35 252 248 222 186 156 124 120 17 102 24 208 4 240 107 153 117 224 83 83 106 176 59 3 143 96 100 71 110 77 17 115 47 49 96 110 168 207 14 250 187 35 142 203 24 217 198 109 10 172 38 193 42 3 21 108 250 245 182 13 100 129 65 165 5 84 18 124 255 104 47 221 142 134 152 168 166 128 109 185 38 34 204 80 142 9 214 99 214 44 150 54 3 245 51 85 172 234 136 178 223 173 224 51 119 204 10 85 197 217 216 112 57 5 106 91 76 144 202 53 123 87 53 218 72 69 177 149 125 30 233 11 230 28 179 198 18 147 106 112 59 157 0 189 227 193 96 166 99 86 83 233 133 118 42 136 100 143 228 73 172 218 41 84 95 61 144 122 222 61 76 158 255 221 239 137 231 240 225 89 197 181 1 84 200 15 175 207 173 32 38 193 172 231 52 204 186 162 249 11 169 80 131 49 208 93 180 111 79 242 32 146 76 73 42 215 119 211 249 15 245 42 248 153 0 171 80 167 156 95 90 61 75 245 133 183 215 8 164 144 134 154 25 114 190 171 181 130 170 195 249 57 243 240 34 212 48 90 210 185 89 65 169 24 73 101 4 104 255 84 16 74 116 80 146 122 13 224 115 165 6 135 61 191 17 189 73 217 20 32 141 38 90 91 245 145 187 22 146 239 62 126 54 39 30 94 132 26 202 14 38 188 194 67 150 83 125 125 166 174 189 238 154 107 200 56 213 72 246 190 249 166 152 228 48 33 122 40 96 59 168 106 252 66 26 31 171 45 133 215 50 178 75 93 196 120 125 55 46 73 161 93 253 185 180 89 35 94 12 5 70 141 5 84 97 175 202 114 227 213 165 76 29 254 245 158 236 47 146 96 51 112 48 201 50 58 106 126 237 24 158 244 111 86 221 72 94 115 119 147 193 161 33 161 86 118 113 192 166 194 150 245 235 169 170 72 143 75 51 24 28 159 151 42 248 217 168 6 51 149 4 47 124 18 242 231 3 7 226 186 192 234 166 234 89 251 192 174 119 181 150 103 253 195 47 212 113 48 105 153 53 89 65 0 201 198 235 255 90 86 139 9 87 139 83 97 199 26 169 146 41 9 199 139 2 200 54 81 189 95 73 230 193 234 13 129 117 36 252 195 240 200 72 108 155 175 56 143 220 244 181 21 244 42 179 131 225 127 117 111 125 86 3 86 14 224 63 23 133 89 251 78 247 153 4 105 73 248 111 248 1 216 82 88 65 65 170 1 107 148 64 222 193 147 207 83 33 93 81 84 225 184 132 39 2 40 73 5 88 169 74 6 149 201 63 56 52 56 51 216 74 74 98 158 12 64 218 75 108 196 90 65 1 107 177 230 20 96 101 86 13 70 41 148 102 86 13 214 190 145 14 12 171 227 105 119 241 156 224 84 3 137 217 155 60 73 220 8 64 241 78 20 174 40 236 250 251 88 64 164 191 111 6 25 152 100 98 135 130 232 108 102 101 255 248 227 31 157 8 127 129 103 56 154 92 69 109 85 216 167 83 35 125 196 82 80 74 1 187 210 16 208 191 186 183 142 84 20 231 101 101 7 204 142 94 74 95 161 52 216 176 88 199 214 2 142 47 157 153 81 83 79 69 1 19 108 89 23 5 201 73 164 165 1 156 136 37 6 120 120 238 171 43 206 123 192 25 230 54 248 185 157 3 113 167 116 253 13 252 111 220 243 36 9 69 83 161 45 91 204 128 85 169 219 250 96 117 193 9 34 236 86 22 180 223 212 100 120 162 112 44 77 143 95 32 83 163 31 19 203 130 10 146 87 182 92 247 88 44 233 252 225 103 151 207 114 70 205 165 136 0 254 89 209 75 141 13 73 171 193 136 147 94 92 170 111 70 192 75 172 195 30 91 146 120 20 156 235 143 193 78 157 28 156 110 14 158 68 131 29 58 163 220 3 64 236 144 174 239 230 127 119 106 152 177 195 36 240 58 20 76 53 96 165 170 48 156 9 110 217 177 212 250 213 245 90 199 136 174 76 13 159 164 160 29 38 121 69 117 33 192 234 168 196 171 26 11 201 27 255 188 132 60 114 87 109 214 178 44 164 68 195 172 102 212 96 60 223 216 68 190 161 195 73 103 18 236 52 171 14 115 118 109 79 103 159 112 207 114 27 73 62 224 34 218 164 228 53 58 135 107 3 21 10 172 154 142 233 59 125 134 248 124 253 225 29 223 188 233 70 93 134 221 219 27 89 154 115 210 127 36 12 88 171 125 149 46 96 33 63 188 190 146 28 254 183 43 230 220 150 173 141 35 233 220 172 252 172 189 154 12 5 140 181 8 3 19 99 107 18 96 234 230 108 233 207 0 96 205 6 51 248 73 244 120 98 87 12 102 87 204 42 127 225 236 186 245 53 183 155 133 24 202 12 171 5 236 233 129 9 242 104 151 20 134 55 61 73 38 63 251 144 76 79 77 132 108 216 40 128 69 120 34 108 217 185 4 173 94 173 224 26 157 82 46 125 9 6 69 192 62 135 22 33 47 131 233 177 171 142 198 210 150 140 179 137 131 201 65 226 171 2 225 38 38 130 39 112 15 94 67 169 35 1 208 122 133 234 29 35 255 117 171 193 53 113 126 187 202 125 213 121 153 242 63 61 244 240 210 237 191 220 254 138 109 193 130 229 88 31 148 195 15 17 192 255 231 3 7 195 223 177 116 19 178 69 11 103 46 144 95 194 128 106 201 203 103 192 5 227 146 137 232 203 64 125 3 227 12 248 47 191 51 76 46 140 78 101 228 193 127 112 207 61 44 130 233 149 61 123 194 175 137 132 183 246 7 223 191 39 226 184 187 191 127 111 66 64 133 125 14 89 250 227 243 76 43 49 18 109 95 10 118 161 19 102 74 42 0 74 47 39 150 237 70 128 193 157 170 129 47 165 208 181 25 76 8 222 68 223 162 206 189 212 162 205 158 20 148 48 157 55 146 31 233 76 57 131 145 182 56 16 8 60 66 1 187 237 207 111 31 40 3 171 10 89 185 98 5 101 132 42 194 152 119 124 156 92 164 192 186 255 137 126 6 88 17 204 15 96 2 160 2 176 248 156 186 248 1 153 190 52 104 216 8 132 44 130 105 47 140 78 146 167 247 94 36 191 222 51 68 1 60 145 214 7 215 171 106 88 147 68 145 52 25 168 196 146 207 34 150 104 255 145 117 107 175 209 127 230 134 6 61 176 34 83 167 147 2 54 105 48 137 242 45 105 182 101 1 68 108 221 41 188 230 147 10 150 49 212 96 10 84 44 172 178 245 151 7 30 120 224 248 13 27 111 120 4 137 229 47 254 225 229 8 149 184 190 190 142 49 134 80 227 222 235 11 146 7 159 214 4 21 112 192 50 149 152 1 118 37 177 20 45 142 195 49 99 229 54 109 19 155 0 160 34 167 195 25 85 110 80 216 91 155 116 126 180 247 88 204 107 33 113 33 212 214 25 160 90 43 67 47 248 125 191 183 151 37 232 27 169 194 58 107 217 246 116 59 139 148 228 56 88 41 80 65 139 87 202 76 187 109 219 182 189 215 94 123 237 191 128 33 118 239 121 53 194 6 195 64 147 29 79 255 77 217 240 193 167 207 205 6 236 224 33 230 116 130 88 203 154 12 61 197 122 130 154 78 194 174 5 107 221 120 117 73 202 30 90 174 194 47 59 152 18 73 58 199 36 2 71 18 60 220 104 171 16 107 245 26 98 177 205 216 163 58 236 57 51 241 213 233 86 216 104 83 195 82 73 52 102 189 12 24 212 254 184 243 63 119 238 22 128 5 195 138 226 104 178 227 169 117 253 87 88 24 221 142 61 126 170 194 106 180 183 169 32 99 216 169 96 200 17 21 246 20 231 217 18 0 133 149 177 214 111 254 246 50 226 119 93 73 63 23 179 68 129 100 82 241 140 106 5 199 83 40 13 107 197 152 60 48 137 0 172 97 245 31 207 87 177 130 88 10 202 200 212 232 39 225 125 190 254 254 8 239 186 44 85 85 149 10 172 74 226 183 89 57 171 26 46 86 3 176 155 238 217 68 246 237 219 247 192 107 221 221 101 96 83 216 97 194 241 132 224 9 48 4 50 75 126 244 68 104 80 134 85 66 230 49 152 36 83 23 142 18 82 210 72 242 232 198 60 197 85 107 98 218 177 70 130 168 41 108 72 22 128 99 10 75 72 168 78 129 45 222 234 138 34 212 80 251 202 140 37 141 145 204 218 123 236 24 99 208 86 86 16 174 152 221 87 183 124 13 84 95 48 42 128 26 56 31 122 94 217 153 212 123 148 153 15 179 192 90 89 165 215 60 7 34 154 82 97 183 70 113 226 64 221 70 29 97 175 130 64 110 57 152 98 86 59 3 96 183 111 223 126 28 78 39 106 199 150 161 162 161 92 76 77 168 197 112 168 252 232 137 94 6 28 128 41 130 100 71 250 24 195 34 142 216 98 45 100 118 44 34 159 176 31 128 54 35 0 78 196 196 64 229 72 95 128 57 167 208 6 56 172 68 153 25 0 91 235 180 146 157 75 96 204 106 210 71 10 72 144 84 88 206 209 173 159 172 251 27 31 89 244 173 101 209 29 34 11 236 33 70 205 47 98 140 170 5 42 55 51 152 221 175 77 236 55 96 86 72 186 43 255 137 55 191 109 73 241 36 80 207 175 139 50 165 1 147 215 64 219 234 233 249 187 21 60 53 99 141 14 164 85 36 206 242 29 135 60 135 74 239 190 251 238 109 35 35 35 203 133 205 5 53 88 174 35 12 149 15 9 215 55 175 177 242 104 37 141 141 74 109 86 48 108 94 241 101 156 120 3 12 176 211 129 115 185 213 115 116 194 201 43 189 130 62 199 34 50 61 53 78 166 252 71 201 116 112 166 86 83 101 199 7 17 135 127 125 195 6 221 74 145 174 167 254 75 239 234 237 233 76 80 231 181 124 81 87 56 213 96 109 230 14 178 29 244 218 126 206 224 27 233 214 35 179 184 209 126 254 27 246 35 95 118 71 174 12 5 218 230 22 62 193 116 165 243 62 9 185 90 215 56 215 12 31 126 247 240 247 155 154 154 158 19 246 24 108 89 84 148 8 59 77 184 183 120 223 169 114 114 211 163 103 24 163 69 62 217 36 11 79 156 128 243 233 210 133 16 203 150 95 73 172 149 78 202 82 85 89 62 181 229 19 75 81 61 201 171 92 69 242 23 174 103 172 58 121 225 3 50 121 110 127 4 80 245 132 39 159 207 18 77 218 156 204 124 185 55 243 91 44 189 116 123 20 64 229 187 0 202 102 157 67 141 246 227 26 187 147 5 42 5 79 97 134 31 189 153 100 224 45 138 166 188 52 175 238 121 117 251 230 205 155 15 189 178 251 149 7 47 141 143 151 161 162 4 84 99 4 169 3 172 161 252 205 54 230 144 250 203 95 188 69 126 126 123 197 44 117 85 44 239 0 160 121 101 77 60 234 105 229 12 211 194 41 101 82 61 78 37 123 90 242 75 153 119 23 192 196 119 50 62 204 236 210 137 207 78 210 103 24 78 250 22 232 43 189 218 86 113 14 200 59 73 40 128 0 42 103 175 152 217 233 111 29 36 20 80 224 209 48 22 145 213 75 186 175 157 79 12 236 124 186 237 22 234 43 191 70 15 221 90 164 123 244 72 147 9 6 167 151 159 227 227 234 171 147 223 195 197 85 226 141 252 248 141 244 59 206 71 123 124 122 251 209 86 222 70 156 231 67 59 37 181 218 205 25 27 223 253 252 158 189 18 75 183 75 109 68 155 234 233 254 29 122 170 184 81 191 241 190 240 211 191 221 154 227 239 228 215 244 242 243 236 188 13 208 10 122 164 54 139 62 99 207 47 221 107 163 52 249 250 120 219 189 210 255 196 199 219 34 142 241 240 123 181 104 159 23 204 106 170 90 24 150 118 118 237 218 117 71 109 109 237 27 130 57 118 191 250 42 179 91 197 186 44 212 190 235 55 126 147 252 226 37 66 89 246 244 108 150 69 131 47 13 146 201 79 15 144 73 56 156 40 16 194 76 91 189 54 180 212 147 95 146 89 118 176 213 132 216 147 218 161 80 115 225 52 154 14 14 209 137 229 40 153 236 127 35 180 28 53 122 38 97 160 26 37 68 196 147 228 111 32 98 144 60 131 127 166 214 73 165 51 211 215 139 65 37 9 6 130 139 131 208 201 7 163 124 141 118 62 120 92 252 216 54 206 34 184 95 23 191 222 70 233 90 226 60 194 129 224 147 6 169 151 31 99 180 95 124 183 75 237 44 228 247 187 147 183 241 25 126 190 188 22 45 0 36 250 1 199 123 163 216 204 70 253 134 227 91 100 86 230 147 69 51 111 215 157 252 24 23 137 12 139 244 241 253 1 9 212 2 168 29 210 189 68 219 59 248 117 197 255 164 93 250 63 120 248 255 97 163 246 121 113 61 128 181 223 236 104 129 90 220 179 191 231 31 111 186 241 166 127 176 90 173 159 133 60 159 189 17 203 60 96 14 132 45 142 151 174 36 107 31 60 195 194 10 225 248 153 5 90 106 179 78 14 121 232 118 132 76 141 245 179 96 10 44 245 228 87 173 161 192 189 134 1 39 19 192 133 58 59 61 230 99 142 34 182 33 163 8 42 110 146 44 42 87 142 8 59 158 52 75 97 9 74 33 103 2 48 131 199 140 189 4 22 193 44 207 217 4 3 215 33 13 36 194 217 195 195 153 64 12 236 221 226 158 124 112 57 248 181 194 3 149 127 247 75 131 218 35 221 75 119 63 63 199 67 244 227 154 187 120 59 122 57 203 22 226 109 0 252 141 0 245 154 54 245 196 48 35 140 250 173 71 154 28 100 115 196 207 219 87 200 39 1 47 111 115 143 166 205 126 190 223 45 157 139 182 185 248 189 122 37 240 181 72 247 240 74 125 211 165 233 247 240 243 226 90 121 141 13 151 95 32 73 102 107 8 150 21 182 44 216 2 111 150 147 19 2 16 170 8 91 246 201 253 249 100 245 79 78 26 131 22 249 177 159 125 72 38 206 239 103 108 11 15 50 216 22 14 41 6 220 154 22 198 184 150 194 133 9 173 215 206 165 192 46 149 139 209 9 193 196 102 32 241 4 201 99 176 216 161 122 113 21 52 89 241 72 246 87 188 18 152 131 238 12 36 249 187 110 191 241 73 196 171 1 82 179 212 47 110 206 188 237 113 190 54 196 193 113 133 115 218 184 83 175 133 183 207 110 230 121 133 131 233 68 178 61 8 150 133 45 219 185 185 243 30 187 221 126 136 49 199 233 51 172 230 176 120 205 134 40 30 214 188 114 13 121 236 229 139 228 107 15 157 154 29 72 33 57 162 192 182 96 55 6 92 255 251 140 113 201 244 68 40 184 130 170 202 249 53 107 67 172 139 165 147 162 197 84 101 205 142 148 71 44 31 201 162 45 21 35 88 21 14 58 3 137 57 121 242 217 126 7 63 182 157 15 62 211 142 21 179 75 45 115 236 208 18 42 52 192 80 200 237 87 103 180 201 46 70 191 121 184 189 91 207 61 219 118 113 45 206 164 46 190 175 67 248 0 98 48 184 209 164 104 42 205 48 47 52 152 46 135 225 244 113 42 58 16 113 197 7 15 28 220 12 213 216 102 179 125 2 231 9 66 238 16 178 40 226 100 5 203 142 91 171 89 32 5 64 171 205 143 157 5 92 106 219 130 113 97 223 78 12 188 29 98 93 128 119 138 130 215 86 205 194 25 173 204 75 219 26 6 48 11 194 160 12 204 64 28 103 152 99 42 228 229 119 70 162 130 21 161 155 88 222 50 18 158 170 24 207 96 245 115 213 233 25 141 147 194 140 195 202 30 239 68 145 101 242 12 7 208 207 72 40 239 213 171 99 195 199 219 111 189 146 154 218 204 157 79 126 25 232 220 121 212 195 25 179 62 202 109 252 146 169 161 221 76 129 85 246 6 35 123 162 58 202 140 144 176 106 76 63 246 126 231 142 239 220 230 241 120 54 81 22 41 123 241 229 63 18 231 234 213 20 172 205 97 150 5 195 176 117 217 71 207 176 87 71 34 132 79 142 181 213 149 169 32 99 93 121 109 150 1 146 218 180 22 171 45 228 193 165 223 45 182 106 29 53 123 56 4 254 201 0 187 142 188 47 124 204 196 176 105 79 52 84 123 100 13 133 109 85 188 120 90 90 95 133 89 128 104 175 40 30 96 119 156 224 194 64 9 72 234 155 60 155 251 37 71 143 56 182 94 114 236 132 61 163 18 163 182 73 94 225 84 171 172 245 36 178 18 132 209 126 51 210 206 157 93 126 241 252 209 180 132 104 253 134 243 232 239 189 146 41 32 123 206 29 220 75 29 144 212 229 66 233 121 234 53 253 201 156 69 80 127 133 29 203 25 28 145 99 190 164 192 74 217 117 146 170 173 72 236 188 58 149 211 222 179 187 158 125 254 144 231 208 238 135 30 122 232 246 99 199 142 221 230 57 124 184 236 248 71 31 177 101 30 86 64 140 110 183 213 223 202 0 187 175 247 76 98 160 213 216 186 132 110 179 94 15 12 0 91 242 25 179 98 121 72 119 166 229 251 195 160 77 98 201 8 25 72 23 165 156 92 76 76 50 80 153 134 97 176 230 42 156 41 113 222 170 133 15 6 47 103 150 128 164 94 245 240 101 145 78 105 16 235 49 102 39 61 70 120 96 11 229 165 155 20 169 169 62 126 253 141 92 173 100 203 26 70 251 147 184 213 157 26 64 250 184 99 39 144 96 191 17 201 35 27 208 48 96 59 119 108 249 200 204 242 146 87 58 7 109 184 143 254 238 39 51 75 81 187 249 51 138 42 30 98 194 52 245 172 179 146 207 41 96 145 203 182 52 29 250 10 34 160 4 104 39 39 39 203 16 1 5 166 21 113 179 96 89 212 128 18 203 25 102 64 59 151 2 251 91 196 71 11 199 210 109 223 186 53 180 150 26 31 80 153 99 130 170 193 49 19 182 249 44 221 44 15 56 121 112 114 38 112 112 47 165 71 168 108 28 40 14 137 221 154 201 204 122 163 95 115 190 95 236 227 247 171 151 216 101 86 140 177 94 204 49 63 207 41 121 97 61 49 246 203 237 212 187 103 196 62 233 123 128 159 131 191 239 227 19 79 79 162 253 198 143 217 194 61 178 187 53 102 66 179 182 189 58 253 45 188 220 126 233 188 240 58 171 88 31 214 62 107 92 253 174 55 16 40 96 145 46 151 182 55 36 235 129 118 217 210 38 22 190 136 66 227 88 175 149 5 47 191 66 158 107 40 191 213 154 149 64 133 119 251 95 187 34 223 54 135 137 8 245 150 96 171 3 168 113 4 63 164 172 82 196 231 69 52 234 41 137 5 214 56 174 231 36 51 33 147 190 108 122 86 139 209 15 20 176 168 181 83 154 238 6 108 186 103 211 198 183 222 122 107 83 48 24 92 20 207 241 223 184 186 36 156 121 147 13 192 69 160 199 253 79 248 168 10 31 153 241 35 88 21 42 127 180 156 86 51 172 170 36 130 37 59 57 219 121 249 167 176 131 159 73 68 165 231 32 23 81 82 61 217 152 72 16 13 172 64 194 234 76 0 22 178 121 243 230 214 189 251 246 222 238 247 251 215 196 123 14 128 11 21 25 41 108 17 117 160 50 32 88 158 193 203 183 144 120 175 39 43 155 155 153 202 27 101 121 70 43 91 41 80 127 172 32 104 10 176 14 50 19 245 212 107 134 17 37 53 55 194 28 200 9 176 206 5 96 33 191 253 237 111 235 183 61 190 109 147 207 231 107 133 138 28 239 121 40 222 134 52 55 128 23 159 72 78 79 53 128 177 188 132 156 89 20 118 123 47 181 111 120 135 253 211 150 206 28 86 37 185 47 150 152 106 94 8 176 43 73 6 178 10 180 118 237 227 143 63 222 122 240 224 193 219 69 74 158 25 17 32 134 200 142 42 128 89 55 145 156 16 86 97 81 228 193 138 252 216 20 131 83 22 204 226 78 165 254 42 73 26 172 18 104 211 234 116 138 197 182 59 254 125 199 237 31 127 252 113 107 188 182 109 142 136 159 51 170 122 177 176 146 212 129 149 3 54 109 203 58 241 202 246 237 219 151 61 247 252 115 183 39 170 38 103 161 40 213 87 73 250 192 202 1 139 244 145 43 51 105 199 70 3 238 139 47 189 120 67 14 50 238 22 10 210 159 171 225 167 36 173 96 149 236 88 20 89 187 44 91 30 4 170 242 174 103 119 181 246 245 245 173 25 28 28 116 102 41 235 186 56 80 149 125 170 36 51 96 213 176 44 138 7 219 179 237 193 30 126 248 97 231 59 135 222 89 115 254 252 249 101 115 12 94 145 88 188 85 129 84 201 156 129 85 2 109 53 7 109 97 182 62 40 152 247 245 215 95 95 118 226 228 137 229 103 207 158 117 142 141 141 213 167 75 117 182 90 173 239 209 201 225 127 233 159 238 116 22 62 83 162 192 154 12 104 23 18 131 130 225 217 42 96 96 191 223 95 10 16 227 59 152 120 124 124 156 181 223 8 208 168 138 81 86 86 118 28 127 23 20 20 12 215 214 214 226 239 129 194 194 194 158 231 158 125 238 127 120 202 161 18 37 217 11 86 9 180 200 2 175 35 115 180 212 147 33 153 224 42 46 188 185 159 82 128 6 213 112 82 146 115 96 149 64 11 71 84 53 223 106 114 188 175 80 132 105 132 3 116 68 177 167 146 121 5 86 3 224 194 25 85 145 197 246 237 48 103 77 48 38 2 193 131 188 78 149 18 37 159 15 176 234 128 215 198 109 219 18 190 21 102 200 214 21 65 218 65 14 198 9 206 152 1 165 202 42 81 96 77 28 196 130 117 181 21 208 176 95 46 105 56 194 193 166 149 136 253 138 25 149 204 7 249 127 1 6 0 41 45 181 226 78 144 196 208 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache first! !

!DLFileLibrary methodsFor: 'uploaded' stamp: 'tfel 1/11/2011 18:17'!
detailsPng
	| cache |
	cache := #(nil) asOrderedCollection.
	(cache first) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 4 103 65 77 65 0 0 175 200 55 5 138 233 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 2 70 73 68 65 84 56 203 141 210 75 72 212 65 28 192 241 239 204 170 45 150 138 75 190 67 61 216 3 13 161 67 109 210 102 117 238 80 150 16 137 27 24 41 68 151 234 16 66 167 34 194 75 7 187 36 65 132 10 101 164 166 116 182 168 164 240 160 18 244 130 74 16 140 205 30 90 238 138 187 255 121 117 217 21 109 141 252 193 48 15 248 125 102 126 51 35 156 115 0 76 222 15 7 17 178 29 124 33 33 124 1 103 45 86 169 57 173 188 81 235 233 142 186 179 253 99 172 17 18 96 178 239 84 171 144 153 67 56 42 172 151 232 244 22 163 53 222 98 172 70 39 226 157 206 82 33 68 198 208 139 155 13 173 107 1 98 226 94 115 80 200 204 33 171 189 187 178 190 171 23 168 1 202 0 3 76 3 111 99 143 194 103 192 215 162 226 137 163 135 46 61 94 117 18 233 144 237 214 152 136 172 239 234 1 14 2 91 129 13 128 31 168 2 234 54 53 244 222 182 70 71 28 180 167 149 32 144 33 167 212 32 80 13 228 37 119 78 53 149 92 171 210 113 61 40 16 161 116 64 200 128 209 182 31 40 1 116 50 41 213 167 160 34 171 76 63 66 6 254 6 50 172 117 88 99 89 145 228 86 36 166 198 218 24 131 212 38 253 21 180 231 205 97 93 99 242 194 116 178 165 128 212 60 226 12 141 42 161 230 210 0 227 169 81 231 196 49 224 3 240 125 69 9 41 104 30 152 146 89 25 151 173 167 167 210 129 132 234 176 142 146 133 129 230 54 96 12 248 4 68 129 88 114 60 30 27 58 61 85 82 189 205 239 247 204 158 225 243 251 79 174 250 7 206 57 158 221 56 210 42 125 242 170 86 38 98 61 61 104 148 233 183 214 129 113 141 217 129 220 43 5 59 182 203 156 226 74 84 60 198 212 211 231 252 250 242 173 248 248 173 151 179 203 0 192 200 245 195 65 160 29 33 67 2 2 206 58 148 167 163 25 190 204 188 202 250 125 228 20 110 65 72 201 239 153 143 188 126 48 98 141 77 148 158 184 51 54 187 12 252 43 134 47 28 8 231 151 151 246 148 7 131 248 115 243 73 196 162 204 190 153 224 201 192 171 207 21 69 27 107 255 11 0 12 158 11 133 243 74 11 123 202 118 237 196 33 249 249 233 61 95 223 77 207 121 75 170 98 93 0 192 195 182 189 97 181 164 123 54 87 21 176 48 51 31 241 60 85 219 212 61 254 99 221 0 64 95 203 238 64 44 174 47 102 103 137 107 77 221 19 113 128 63 41 169 43 251 29 137 72 245 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache first! !

!DLFileLibrary methodsFor: 'uploaded' stamp: 'tfel 1/11/2011 18:16'!
diskCriticalPng
	| cache |
	cache := #(nil) asOrderedCollection.
	(cache first) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 1 115 82 71 66 0 174 206 28 233 0 0 0 6 98 75 71 68 0 255 0 255 0 255 160 189 167 147 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 0 7 116 73 77 69 7 217 7 23 16 42 29 150 64 87 240 0 0 4 27 73 68 65 84 56 17 1 16 4 239 251 1 54 107 188 113 0 0 0 31 0 0 0 60 0 0 0 34 0 0 0 12 0 0 255 4 0 0 0 1 0 255 0 0 0 0 0 0 3 2 1 0 2 2 1 0 255 255 254 0 254 254 0 240 6 5 0 220 247 249 251 137 203 151 74 172 4 0 0 0 42 155 117 58 100 0 0 1 0 39 27 7 0 255 0 0 0 255 254 255 0 250 252 255 0 250 251 254 0 3 2 1 0 9 7 2 0 1 1 0 0 244 247 254 0 244 248 253 15 222 231 244 48 161 185 221 152 0 105 181 15 2 0 0 0 61 0 255 0 0 175 202 242 0 254 255 0 0 255 255 255 0 110 147 203 0 254 254 255 0 0 1 1 0 5 4 1 0 2 2 1 0 250 252 255 0 247 251 254 0 252 254 0 1 253 0 2 4 95 71 35 19 9 7 6 149 2 0 0 0 24 255 0 0 0 254 254 255 0 251 252 254 0 251 252 255 0 0 0 0 0 251 254 255 0 4 3 0 0 5 4 1 0 254 254 255 0 247 250 254 0 251 252 255 0 0 255 255 0 192 211 243 0 6 5 3 0 247 249 252 6 4 0 0 0 10 252 254 255 0 0 0 255 0 247 250 254 0 0 0 0 0 2 1 1 0 0 255 0 0 5 4 2 0 1 0 1 0 248 251 254 0 247 249 255 0 254 255 255 0 254 255 0 0 254 255 255 0 230 237 248 0 0 255 255 1 4 0 0 255 4 253 255 255 0 255 255 0 0 249 252 255 0 0 0 0 0 125 96 48 0 5 4 2 0 4 2 0 0 251 253 255 0 246 249 254 0 252 254 254 0 254 254 0 0 255 0 255 0 255 254 254 0 251 252 253 0 255 255 254 0 4 0 0 0 1 254 253 0 0 0 255 255 0 131 160 207 0 1 1 1 0 2 1 0 0 5 4 2 0 1 0 0 0 252 254 255 0 252 252 254 0 255 0 0 0 0 0 0 0 0 0 0 0 16 16 18 0 251 252 3 0 0 255 255 0 4 0 255 0 0 254 255 254 0 254 254 253 0 22 23 27 0 0 1 0 0 1 0 255 0 0 255 0 0 0 0 255 0 254 255 0 0 255 254 251 0 14 0 234 0 8 255 242 0 252 255 1 0 240 252 12 0 251 251 3 0 0 255 254 0 4 0 0 0 0 253 253 0 0 255 255 0 0 0 0 0 0 1 255 255 0 0 0 0 0 0 1 0 0 254 254 0 0 9 255 240 0 47 3 185 0 44 2 194 0 16 1 233 0 251 255 6 0 221 4 48 0 230 14 57 0 255 255 11 0 2 0 0 0 0 252 253 254 0 0 0 255 0 0 0 255 0 255 0 255 0 0 0 0 0 0 255 255 0 0 254 253 0 47 1 185 0 58 3 175 0 23 2 225 0 19 90 203 0 12 2 242 0 45 4 195 0 45 229 182 0 31 10 232 0 4 0 0 255 0 253 254 255 0 0 255 0 0 126 89 28 0 0 0 0 0 0 0 0 0 0 0 0 0 255 238 234 0 253 204 199 0 0 242 244 0 0 0 0 0 0 0 0 0 0 0 0 0 2 1 255 0 23 255 217 0 53 18 25 0 4 2 1 1 0 253 254 0 0 255 0 255 0 255 255 0 0 145 198 100 0 0 0 0 0 0 0 0 0 21 239 254 0 81 249 222 0 6 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4 255 250 0 32 11 235 0 4 0 1 0 0 254 254 255 0 1 0 0 0 0 0 0 0 58 28 93 0 0 0 0 0 0 0 0 0 6 5 234 0 1 230 217 0 0 252 244 0 0 0 0 0 244 167 45 0 0 0 0 0 0 0 0 0 255 0 1 0 243 251 7 0 4 255 255 255 255 253 254 255 1 0 0 255 0 0 0 0 0 198 228 163 0 0 0 0 0 0 0 0 0 5 254 253 0 5 5 7 0 37 252 244 0 2 0 0 0 12 89 211 0 244 167 45 0 0 0 0 0 242 255 18 0 208 238 29 255 4 254 255 0 224 250 252 254 33 51 35 10 0 1 1 0 0 112 59 156 0 0 0 0 0 0 0 0 0 0 0 0 0 250 220 203 0 3 230 156 0 255 237 209 0 244 167 45 0 0 0 2 0 240 254 17 0 204 249 64 0 204 234 31 240 1 54 106 186 143 255 255 255 38 0 0 255 57 0 255 255 17 0 0 254 0 255 255 255 0 0 255 254 0 255 255 254 0 0 255 254 0 31 10 232 0 53 18 220 0 31 11 236 0 243 250 8 0 210 240 28 255 206 237 31 244 248 255 7 210 207 105 102 184 17 111 31 197 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache first! !

!DLFileLibrary methodsFor: 'uploaded' stamp: 'tfel 1/11/2011 18:16'!
diskOverPng
	| cache |
	cache := #(nil) asOrderedCollection.
	(cache first) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 1 115 82 71 66 0 174 206 28 233 0 0 0 6 98 75 71 68 0 255 0 255 0 255 160 189 167 147 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 0 7 116 73 77 69 7 217 7 21 11 55 46 108 134 222 224 0 0 4 27 73 68 65 84 56 17 1 16 4 239 251 1 54 107 188 113 0 0 0 31 0 0 0 60 0 0 0 34 0 0 0 12 0 0 255 4 0 0 0 1 0 255 0 0 0 0 0 0 3 2 1 0 2 2 1 0 255 255 254 0 254 254 0 240 6 5 0 220 247 249 251 137 203 151 74 172 4 0 0 0 42 155 117 58 100 0 0 1 0 39 27 7 0 255 0 0 0 255 254 255 0 250 252 255 0 250 251 254 0 3 2 1 0 9 7 2 0 1 1 0 0 244 247 254 0 244 248 253 15 222 231 244 48 161 185 221 152 0 105 181 15 2 0 0 0 61 0 255 0 0 175 202 242 0 254 255 0 0 255 255 255 0 110 147 203 0 254 254 255 0 0 1 1 0 5 4 1 0 2 2 1 0 250 252 255 0 247 251 254 0 252 254 0 1 253 0 2 4 95 71 35 19 9 7 6 149 2 0 0 0 24 255 0 0 0 254 254 255 0 251 252 254 0 251 252 255 0 0 0 0 0 251 254 255 0 4 3 0 0 5 4 1 0 254 254 255 0 247 250 254 0 251 252 255 0 0 255 255 0 192 211 243 0 6 5 3 0 247 249 252 6 4 0 0 0 10 252 254 255 0 0 0 255 0 247 250 254 0 0 0 0 0 2 1 1 0 0 255 0 0 5 4 2 0 1 0 1 0 248 251 254 0 247 249 255 0 254 255 255 0 254 255 0 0 254 255 255 0 232 233 243 0 0 255 255 1 4 0 0 255 4 253 255 255 0 255 255 0 0 249 252 255 0 0 0 0 0 125 96 48 0 7 243 241 0 6 219 227 0 250 40 43 0 246 250 1 0 252 254 254 0 254 254 0 0 255 0 255 0 45 231 210 0 37 233 236 0 27 251 7 0 4 0 0 0 1 254 253 0 0 0 255 255 0 131 160 207 0 1 1 1 0 22 253 245 0 102 244 206 0 15 252 241 0 200 3 201 0 164 15 49 0 255 0 0 0 0 0 0 0 70 233 207 0 84 241 210 0 2 8 8 0 80 247 12 0 2 0 255 0 0 254 255 254 0 254 254 253 0 22 23 27 0 21 23 26 0 33 13 8 0 30 248 237 0 255 11 11 0 60 250 227 0 109 236 198 0 18 19 22 0 82 240 212 0 79 240 209 0 6 19 19 0 253 242 241 0 0 250 250 0 4 0 0 0 0 253 253 0 0 255 255 0 0 0 0 0 0 1 255 255 0 223 12 28 0 189 17 46 0 65 235 206 0 2 16 17 0 40 238 228 0 123 192 135 0 5 4 2 0 6 22 20 0 248 228 228 0 227 255 9 0 147 16 56 0 2 0 0 0 0 252 253 254 0 0 0 255 0 0 0 255 0 255 0 255 0 0 0 0 0 191 28 58 0 204 6 29 0 250 231 230 0 5 15 15 0 14 25 22 0 9 23 21 0 248 227 227 0 227 243 252 0 180 79 108 0 0 254 253 0 4 0 0 255 0 253 254 255 0 0 255 0 0 126 89 28 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 108 0 253 101 101 0 0 247 249 0 0 219 218 0 0 26 25 0 250 235 236 0 147 79 137 0 29 252 253 0 255 0 255 0 4 2 1 1 0 253 254 0 0 255 0 255 0 255 255 0 0 145 198 100 0 0 0 0 0 0 0 0 0 56 203 252 0 55 0 4 0 0 255 254 0 0 23 23 0 0 4 4 0 5 12 11 0 84 193 154 0 195 76 97 0 0 255 255 0 4 0 1 0 0 254 254 255 0 1 0 0 0 0 0 0 0 58 28 93 0 0 0 0 0 24 194 208 0 31 211 210 0 6 19 18 0 248 228 227 0 247 233 233 0 4 8 9 0 13 28 27 0 50 227 222 0 8 175 147 0 174 15 71 0 4 255 255 255 255 253 254 255 1 0 0 255 0 0 0 0 0 198 228 163 0 38 219 253 0 54 193 0 0 5 18 17 0 247 229 229 0 230 253 236 0 172 126 30 0 57 169 227 0 46 214 217 0 16 34 33 0 40 222 223 0 103 237 183 0 4 254 255 0 224 250 252 254 33 51 35 10 0 1 1 0 0 112 59 156 0 254 5 202 0 255 198 155 0 247 227 228 0 250 23 23 0 28 147 165 0 111 255 255 0 1 59 1 0 243 121 120 0 238 193 193 0 2 11 12 0 241 4 10 246 1 54 106 186 143 255 255 255 38 0 0 255 57 0 255 255 17 0 0 254 0 255 255 255 0 61 244 219 0 42 244 227 0 152 21 60 0 255 255 254 0 0 255 254 0 0 254 254 0 255 0 0 0 87 224 189 255 2 4 4 250 167 29 63 204 75 62 121 113 17 192 250 162 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache first! !

!DLFileLibrary methodsFor: 'uploaded' stamp: 'tfel 1/11/2011 18:16'!
diskPng
	| cache |
	cache := #(nil) asOrderedCollection.
	(cache first) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 4 103 65 77 65 0 0 175 200 55 5 138 233 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 1 254 73 68 65 84 24 25 5 193 61 139 93 85 24 6 208 181 207 236 59 67 130 146 168 96 132 68 68 3 10 86 1 101 32 241 163 21 127 130 133 104 145 42 66 208 34 165 54 86 86 34 162 8 99 161 216 10 118 130 98 97 149 34 22 22 193 78 197 66 180 18 197 12 222 153 123 246 126 31 215 106 135 111 124 247 22 30 195 243 120 2 247 145 142 38 192 222 210 44 75 147 148 42 255 236 111 252 188 61 93 223 187 243 241 203 95 118 60 125 116 235 218 117 154 167 46 30 8 82 177 27 177 91 203 222 210 156 57 88 180 198 241 182 28 159 204 115 191 254 121 124 229 243 111 126 249 228 240 198 215 231 22 188 32 124 117 231 95 21 146 184 249 225 15 170 66 107 54 189 89 150 102 55 98 187 150 81 218 180 244 215 94 186 252 208 153 131 253 143 22 60 18 84 197 58 202 58 2 214 138 190 199 166 55 85 177 221 149 117 132 196 247 119 239 217 223 236 217 158 142 253 142 179 163 130 216 238 10 44 173 17 54 125 209 52 39 107 217 158 70 37 42 84 226 143 191 78 72 90 39 125 38 18 78 71 192 219 175 95 177 233 139 190 176 206 248 239 180 140 42 85 68 164 202 58 166 164 116 180 154 72 188 251 217 143 90 107 150 198 166 47 26 70 197 24 37 0 56 127 254 65 235 216 35 209 133 74 169 154 30 190 112 145 70 19 2 81 161 170 36 81 137 170 162 53 235 58 72 233 48 39 9 208 18 160 81 69 18 68 130 68 75 36 101 93 155 164 116 24 179 16 16 209 52 18 73 164 74 68 18 85 83 42 162 156 174 33 165 19 179 66 120 231 149 75 0 0 0 0 224 214 209 79 198 136 164 244 165 53 179 136 72 248 224 246 117 0 0 0 112 243 234 145 57 135 221 8 137 174 81 21 13 112 237 210 171 0 0 0 0 106 150 185 6 165 39 201 172 52 2 110 255 254 5 0 0 0 120 246 209 23 205 57 173 51 146 164 87 252 182 27 245 248 51 151 207 106 141 55 159 251 20 0 0 0 192 133 251 203 156 129 191 219 225 141 111 223 79 242 36 185 42 121 128 146 132 148 164 72 73 138 20 137 36 72 200 61 109 185 251 63 33 124 110 139 109 16 176 162 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache first! !

!DLFileLibrary methodsFor: 'uploaded' stamp: 'PL 6/23/2011 17:41:08.348'!
downPng
	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 18 0 0 0 16 8 6 0 0 0 27 6 47 92 0 0 0 4 115 66 73 84 8 8 8 8 124 8 100 136 0 0 0 9 112 72 89 115 0 0 13 215 0 0 13 215 1 66 40 155 120 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 119 119 119 46 105 110 107 115 99 97 112 101 46 111 114 103 155 238 60 26 0 0 2 151 73 68 65 84 56 141 173 210 221 79 82 113 24 7 240 239 239 192 209 36 124 41 84 82 32 34 51 179 80 196 14 243 37 33 195 115 81 212 210 185 201 92 181 145 115 165 172 91 255 4 111 187 114 140 219 46 90 55 109 109 165 115 109 161 149 181 165 139 196 183 94 156 210 52 5 134 130 44 223 6 158 195 57 93 56 157 58 180 46 122 238 126 191 231 121 62 55 207 151 136 162 136 255 81 212 222 135 166 214 158 161 179 180 119 18 66 200 97 11 132 16 162 179 180 119 106 106 237 25 41 33 21 211 33 147 208 242 190 236 28 185 91 107 110 115 165 194 8 33 68 107 110 115 101 231 200 221 18 90 222 167 98 58 100 251 32 21 211 33 163 101 241 222 38 91 189 181 167 187 11 140 161 212 169 53 59 246 97 219 136 195 197 24 74 157 61 221 93 104 178 213 91 105 89 188 119 7 35 234 154 150 12 138 74 239 107 180 177 86 27 107 193 194 242 26 180 249 114 184 159 60 135 111 98 202 61 255 241 233 35 0 208 214 221 115 25 203 245 78 231 253 22 204 47 173 67 147 151 137 126 207 16 94 246 123 6 5 33 113 75 146 165 174 120 92 82 172 107 189 107 111 132 63 248 27 28 47 34 182 193 161 225 138 17 129 224 146 105 51 45 47 63 91 163 191 105 44 211 59 31 58 236 240 135 214 176 197 9 88 89 139 131 41 63 143 89 255 156 46 18 93 205 148 200 149 122 111 52 22 185 177 178 206 43 11 10 213 16 68 128 79 138 136 173 39 192 214 85 34 16 10 155 78 41 243 77 15 28 173 152 9 174 130 227 5 8 34 144 20 128 254 55 239 48 230 27 157 20 120 210 78 68 81 132 138 185 147 75 200 214 64 181 249 106 249 101 83 13 54 226 28 86 55 183 32 8 34 244 103 78 0 0 166 230 98 160 40 130 44 89 26 142 31 163 241 229 243 39 12 127 120 63 33 138 105 13 1 239 179 8 217 201 145 138 185 157 11 72 60 103 47 49 6 117 9 179 123 41 90 186 125 88 142 23 118 255 22 167 189 248 249 213 59 14 36 217 128 247 85 4 0 200 222 64 170 171 154 21 2 199 15 20 22 27 13 167 47 86 165 204 209 175 111 35 8 206 248 198 41 90 218 176 56 242 34 186 123 213 131 201 86 87 53 43 248 68 194 83 112 206 88 81 120 161 122 95 47 248 99 24 161 89 223 152 52 61 157 221 139 164 132 0 64 163 191 126 146 167 224 201 45 170 52 42 75 182 177 240 244 48 34 254 81 159 84 0 187 48 245 122 229 224 78 74 8 0 212 165 172 130 147 144 183 138 34 166 12 0 162 126 239 36 157 20 175 45 126 247 68 83 205 31 10 1 64 65 177 37 47 73 75 7 1 64 194 241 214 208 204 208 242 97 179 71 66 0 160 44 99 149 0 16 158 244 132 143 154 251 43 244 175 245 7 42 236 10 189 103 90 221 41 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

!DLFileLibrary methodsFor: 'uploaded' stamp: 'tfel 1/11/2011 18:16'!
editPng
	| cache |
	cache := #(nil) asOrderedCollection.
	(cache first) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 4 103 65 77 65 0 0 175 200 55 5 138 233 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 1 84 73 68 65 84 56 203 173 147 63 72 2 113 24 134 93 91 11 131 150 112 169 150 64 4 155 92 228 104 136 134 20 90 114 48 140 6 43 146 134 160 173 165 166 16 202 144 192 224 220 178 212 72 130 108 72 168 72 139 238 188 224 42 36 58 212 226 50 44 194 26 236 196 83 146 183 188 225 32 42 251 65 13 239 246 61 207 7 223 31 13 0 205 95 66 92 120 31 211 55 165 195 150 167 164 215 90 99 60 3 184 244 235 111 111 214 122 218 136 5 66 208 138 235 192 4 202 34 11 57 199 33 185 66 33 62 103 136 144 118 135 148 218 128 44 158 160 146 59 83 82 78 239 131 245 88 106 68 176 252 156 128 124 23 68 54 50 9 137 15 40 169 11 56 239 96 153 8 126 147 118 80 18 198 240 202 79 225 220 111 67 118 115 26 236 178 5 13 135 248 9 206 56 32 93 245 162 250 178 136 124 212 14 97 201 132 134 91 32 133 191 21 28 122 186 136 225 47 130 189 133 78 20 243 7 196 176 42 240 141 234 116 117 88 228 182 193 132 156 196 176 42 240 186 218 81 20 25 84 31 46 176 59 107 68 98 213 128 204 177 11 60 221 143 211 121 35 126 61 229 186 160 242 113 93 133 240 8 30 125 102 196 157 90 132 29 173 136 206 116 131 232 23 108 84 51 82 180 29 37 126 29 5 62 132 35 119 31 17 172 10 134 204 45 24 166 180 160 199 59 20 48 230 54 109 253 251 55 254 148 119 85 92 247 38 28 31 157 2 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache first! !

!DLFileLibrary methodsFor: 'uploaded' stamp: 'tfel 1/11/2011 18:16'!
emailPng
	| cache |
	cache := #(nil) asOrderedCollection.
	(cache first) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 4 103 65 77 65 0 0 175 200 55 5 138 233 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 2 19 73 68 65 84 24 25 165 193 203 78 19 97 24 128 225 247 251 231 239 244 64 167 7 57 84 41 133 88 19 226 214 107 240 2 92 123 5 110 189 1 247 174 221 186 51 113 33 59 19 77 136 46 48 145 133 26 221 179 192 4 108 165 82 218 2 29 74 59 211 153 255 147 98 162 238 251 60 162 170 204 195 48 39 251 228 249 231 157 92 33 184 215 11 167 11 23 147 196 56 5 135 146 58 197 169 146 170 226 156 146 58 37 117 74 234 84 145 116 58 189 60 239 181 246 246 247 237 114 181 220 120 244 96 179 20 77 85 114 89 143 255 9 255 8 87 4 4 24 71 137 55 142 210 213 135 79 163 137 233 14 147 102 156 56 121 185 211 161 213 139 25 69 202 97 223 209 26 56 218 103 142 206 185 163 27 42 189 145 50 77 161 221 143 121 246 166 195 233 40 50 193 114 227 142 25 69 169 100 51 134 250 173 18 239 190 117 57 187 152 82 43 9 25 15 124 79 240 173 224 91 168 228 133 254 48 102 107 247 152 202 141 18 139 149 44 87 196 92 78 18 102 154 55 139 172 213 74 108 127 237 114 26 78 89 42 26 124 11 190 7 229 156 48 8 99 182 118 187 44 45 150 104 214 139 136 114 205 140 38 41 51 214 131 230 106 145 229 106 129 87 31 90 12 194 152 114 78 8 114 66 63 140 121 241 190 69 185 92 160 185 90 36 111 249 203 140 198 9 51 34 144 76 19 114 214 177 94 175 240 246 75 151 118 111 66 187 55 225 245 167 46 141 122 133 192 79 49 154 224 91 254 16 176 151 81 138 2 113 156 112 60 8 105 212 2 124 63 67 103 144 227 227 222 16 3 108 54 170 212 22 243 140 38 49 157 94 200 82 53 64 21 80 193 94 70 137 166 78 165 219 15 105 44 7 228 115 25 80 184 189 82 96 125 165 128 0 162 224 80 108 193 199 174 4 28 157 12 25 87 242 160 78 237 104 240 243 32 138 147 141 187 107 121 41 230 141 136 73 49 128 8 136 8 51 2 8 87 132 43 150 141 106 224 14 126 133 241 240 164 125 100 227 139 147 195 251 143 183 171 217 96 97 193 102 61 177 214 195 120 130 103 192 24 193 88 16 64 132 107 2 154 38 113 60 62 63 237 159 124 111 253 16 85 101 30 134 57 25 230 244 27 253 73 249 123 240 200 177 91 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache first! !

!DLFileLibrary methodsFor: 'uploaded' stamp: 'PL 6/27/2011 19:00:48.709'!
faviconPng
	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 4 115 66 73 84 8 8 8 8 124 8 100 136 0 0 0 9 112 72 89 115 0 0 13 215 0 0 13 215 1 66 40 155 120 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 119 119 119 46 105 110 107 115 99 97 112 101 46 111 114 103 155 238 60 26 0 0 2 5 73 68 65 84 56 141 165 147 205 107 83 65 20 197 127 247 189 78 223 203 203 167 53 154 164 188 104 42 21 149 128 146 130 32 86 4 55 74 11 93 184 112 161 224 210 210 22 5 55 186 40 66 220 10 18 68 112 97 11 130 255 128 208 20 69 165 224 34 187 52 186 209 133 139 82 109 55 1 69 139 129 88 147 52 142 139 190 132 212 164 171 30 184 204 204 157 185 103 206 25 238 136 214 154 189 192 216 83 53 208 247 127 226 81 46 247 96 101 101 245 118 163 217 48 250 149 170 41 213 95 117 108 251 67 40 24 200 221 157 157 93 2 118 72 150 78 11 34 50 60 61 53 245 201 117 93 107 109 109 157 122 163 177 131 220 239 56 181 67 73 247 241 102 173 118 47 155 205 214 123 89 24 155 155 159 183 10 133 2 131 137 56 67 169 20 145 72 4 219 182 9 6 2 36 226 49 203 182 237 59 126 199 121 185 155 130 87 192 152 55 103 40 149 98 36 147 33 153 76 18 10 133 48 12 3 17 97 185 84 34 191 184 40 0 104 173 241 72 124 192 111 207 99 87 164 211 105 173 148 106 175 91 117 134 136 164 69 36 15 148 61 146 158 48 77 179 103 222 0 158 3 19 147 23 247 135 149 41 61 15 137 8 74 41 122 245 140 225 73 226 214 120 148 185 25 151 176 211 125 147 101 89 109 187 29 164 247 91 4 47 0 190 124 171 115 229 108 132 210 195 163 92 59 191 15 199 50 186 8 90 56 121 216 6 200 138 200 117 147 109 223 205 124 177 114 42 22 81 114 238 132 159 137 211 33 166 47 69 25 78 88 4 125 6 3 97 63 202 10 82 253 245 157 209 227 14 79 38 93 158 190 253 1 224 19 96 20 24 0 46 0 51 35 71 124 214 205 241 40 151 207 132 217 237 77 0 2 87 63 2 84 76 160 9 36 128 175 192 235 242 198 86 117 161 88 73 62 91 250 233 123 191 186 73 121 163 129 105 8 170 79 168 53 52 155 117 205 66 177 66 126 185 2 240 78 180 214 136 200 1 32 3 180 204 154 158 178 99 64 12 136 123 99 107 255 15 240 6 184 209 238 68 17 17 224 32 48 8 248 1 135 237 207 246 183 35 194 64 13 248 12 172 107 173 235 255 0 201 47 163 195 168 155 52 228 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

!DLFileLibrary methodsFor: 'rendering' stamp: 'PL 5/25/2011 15:00:26.214'!
formUtilitiesJs

	^ 'function getDTByLabel(label)
{
	var allDTs = document.getElementsByTagName("dt");

    for (var i = 0; i < allDTs.length; i++)
    {
        var labels = allDTs[i].getElementsByTagName("label");
        
        for (var j = 0; j < labels.length; j++)
            if (labels[j].innerHTML == label)
            	return allDTs[i];
    }
}

function hideMagritteRow(label, visibility)
{
    var dt = getDTByLabel(label);
    
    dt.hidden = visibility;
    dt.nextSibling.hidden = visibility;
}

function hideMagritteRows(labels, visibility)
{
    for (var i = 0; i < labels.length; i++)
        hideMagritteRow(labels[i], visibility);
}

function getValueOfRadioGroupByLabel(label)
{
	var dt = getDTByLabel(label);
	var dd = dt.nextSiblings()[0];
	
	for (var i = 0; i < dd.firstChild.childNodes.length; i++)
   		if (dd.firstChild.childNodes[i].checked)
    	    return dd.firstChild.childNodes[i].nextSiblings()[0].innerHTML;
}'! !

!DLFileLibrary methodsFor: 'uploaded' stamp: 'tfel 1/11/2011 18:16'!
groupPng
	| cache |
	cache := #(nil) asOrderedCollection.
	(cache first) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 4 103 65 77 65 0 0 175 200 55 5 138 233 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 2 131 73 68 65 84 56 203 141 209 77 76 210 113 28 6 112 235 208 150 30 58 117 232 237 128 100 29 210 214 139 206 57 182 136 240 208 88 186 230 64 134 168 200 66 76 201 161 34 25 6 100 130 165 91 138 254 193 63 90 41 148 232 223 82 12 205 17 235 162 7 109 166 226 123 88 107 131 67 10 221 154 57 107 203 240 137 216 50 155 204 60 60 167 223 190 159 61 123 126 81 0 162 118 138 154 123 88 60 111 142 91 89 234 60 2 175 149 182 110 145 199 182 165 39 199 238 251 243 190 227 177 156 115 148 237 235 160 5 151 187 14 97 107 90 101 244 198 93 1 109 162 131 196 114 95 34 252 174 124 124 27 171 135 223 206 192 50 117 12 11 102 250 151 93 1 36 247 64 125 96 198 133 149 81 18 235 51 79 176 250 134 196 210 180 19 67 186 179 190 93 1 25 156 76 169 199 86 182 241 117 182 23 193 197 62 172 45 56 16 24 38 80 157 123 209 30 17 144 178 226 196 205 226 75 43 68 14 11 100 30 123 189 144 159 48 73 84 200 126 4 236 10 124 234 191 139 192 128 6 35 45 55 112 58 255 148 51 73 25 31 243 15 32 98 28 103 55 139 83 131 141 66 22 182 166 221 32 135 177 85 143 58 147 6 119 30 40 209 255 206 134 154 161 106 36 104 79 90 207 40 78 68 111 2 6 254 185 145 135 133 87 209 87 117 13 158 46 53 58 21 60 16 57 108 180 20 164 194 50 163 134 121 170 2 13 238 82 212 186 203 208 243 190 13 37 142 98 164 20 38 145 155 128 137 79 239 249 56 68 109 27 140 170 100 193 48 117 11 117 110 37 116 19 37 184 61 81 4 213 219 34 136 201 60 120 201 244 255 15 86 167 227 194 52 173 66 67 168 129 97 234 38 154 66 41 31 148 33 203 144 5 255 163 43 127 129 189 231 155 84 38 85 241 182 193 226 121 229 144 216 178 113 189 91 128 2 74 0 73 71 38 46 232 25 62 165 180 170 202 107 17 8 195 199 123 24 221 146 12 133 123 117 248 51 112 239 185 29 154 118 10 74 194 138 199 227 223 161 52 45 97 127 74 183 53 134 217 26 29 233 171 163 104 156 22 30 79 62 184 54 176 24 132 222 3 228 143 3 185 195 64 230 32 192 167 0 98 20 16 106 60 136 99 215 144 17 129 57 125 226 207 201 94 35 20 47 2 16 185 0 145 99 3 66 106 3 60 107 16 105 102 32 205 24 196 83 203 203 240 96 17 1 95 19 211 223 91 83 10 129 118 12 210 215 128 248 85 168 129 3 200 25 0 178 127 183 168 245 66 171 184 31 30 44 34 240 161 163 32 197 89 157 81 153 204 179 57 18 75 38 192 210 206 133 50 15 150 122 22 204 74 55 232 151 159 249 140 229 146 240 96 145 128 95 65 127 178 0 144 183 124 65 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache first! !

!DLFileLibrary methodsFor: 'uploaded' stamp: 'tfel 1/11/2011 18:16'!
leavePng
	| cache |
	cache := #(nil) asOrderedCollection.
	(cache first) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 1 115 82 71 66 0 174 206 28 233 0 0 0 6 98 75 71 68 0 255 0 255 0 255 160 189 167 147 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 0 7 116 73 77 69 7 217 7 23 18 49 16 66 67 52 185 0 0 4 27 73 68 65 84 56 17 1 16 4 239 251 1 255 255 255 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 213 157 110 137 254 254 253 114 253 253 252 243 4 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 215 159 113 219 254 254 253 36 6 21 24 0 223 224 213 0 18 2 6 252 4 0 0 0 0 0 0 0 0 129 129 129 255 254 254 254 0 254 254 254 0 254 254 254 0 253 253 253 0 254 254 254 0 253 253 253 0 98 44 255 0 2 0 254 0 6 20 24 0 12 33 36 0 254 253 254 0 255 223 211 0 251 251 249 0 4 0 0 0 0 0 0 0 0 253 253 253 0 28 28 28 0 0 0 0 0 1 1 1 0 0 0 0 0 1 1 1 0 0 0 0 0 255 255 212 0 17 52 59 0 0 0 1 0 249 244 237 0 253 251 249 0 255 255 254 0 251 251 252 0 2 0 0 0 0 0 0 0 0 253 253 253 0 0 0 0 0 83 109 109 0 255 0 255 0 1 1 1 0 1 1 1 0 1 1 1 0 253 253 253 0 254 253 253 0 248 240 228 0 251 246 241 0 254 251 250 0 255 254 253 0 251 251 249 0 2 0 0 0 0 0 0 0 0 253 253 253 0 1 1 1 0 0 0 0 0 83 108 109 0 1 1 1 0 1 1 1 0 1 1 1 0 252 252 250 0 254 253 251 0 253 252 250 0 254 252 250 0 254 252 249 0 255 254 254 0 250 250 248 0 4 237 7 7 255 0 0 0 0 117 0 0 0 0 0 0 0 0 60 60 0 0 0 0 0 80 106 106 0 178 152 152 0 0 0 0 0 253 252 250 0 255 252 252 0 254 251 250 0 253 252 250 0 0 255 1 0 255 254 254 0 252 251 248 0 4 0 0 0 0 254 132 132 0 0 0 0 0 0 0 0 0 0 0 0 0 3 229 229 0 255 0 0 0 78 104 104 0 179 153 153 0 251 252 250 0 254 252 250 0 253 251 249 0 255 252 248 0 23 21 234 0 220 255 252 0 250 250 249 0 2 0 0 0 0 0 0 0 0 3 229 229 0 3 229 229 0 3 229 229 0 0 0 0 0 1 45 45 0 0 60 60 0 77 103 103 0 251 251 250 0 253 252 252 0 253 250 249 0 11 9 239 0 18 16 237 0 5 3 247 0 251 251 248 0 4 0 0 0 0 0 0 0 0 253 27 27 0 0 0 0 0 0 0 0 0 0 0 0 0 2 184 184 0 228 199 199 0 209 155 155 0 25 227 171 0 254 252 249 0 253 251 249 0 240 238 3 0 254 252 20 0 249 250 232 0 251 251 249 0 4 0 0 0 0 237 126 126 0 249 1 1 0 0 0 0 0 28 57 57 0 0 0 0 0 228 199 199 0 209 152 152 0 1 1 1 0 250 250 249 0 254 252 251 0 254 251 249 0 253 251 251 0 237 249 4 0 0 254 254 0 251 251 250 0 4 19 249 249 1 19 0 0 0 97 97 97 255 64 64 64 0 0 105 105 0 0 0 0 0 210 153 153 0 1 0 0 0 1 1 1 0 252 251 248 0 254 252 250 0 253 252 251 0 253 252 249 0 1 1 4 0 254 254 254 0 252 252 250 0 4 0 0 0 0 0 0 0 0 252 252 252 0 1 1 1 0 0 0 0 0 209 152 151 0 2 1 1 0 0 0 0 0 1 1 1 0 250 251 249 0 253 252 251 0 253 251 249 0 254 251 250 0 1 1 254 0 255 255 254 0 252 252 250 0 4 0 0 0 0 0 0 0 0 252 252 252 0 1 1 1 0 210 153 153 0 2 1 1 0 1 1 1 0 0 0 0 0 1 1 1 0 251 251 249 0 254 252 251 0 10 17 29 0 254 252 251 0 252 249 246 0 0 255 232 0 253 253 252 0 1 153 153 153 255 216 216 216 0 227 227 227 0 253 253 253 0 254 254 254 0 253 253 253 0 254 254 254 0 253 253 253 0 254 254 254 0 88 34 224 0 11 13 13 0 7 8 11 0 6 8 10 0 5 6 7 0 243 244 240 0 226 217 206 235 1 255 255 255 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 156 100 30 22 253 253 252 35 253 253 251 41 253 253 252 38 254 254 253 28 2 4 6 88 253 251 249 241 236 202 118 155 98 198 180 57 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache first! !

!DLFileLibrary methodsFor: 'uploaded' stamp: 'tfel 1/11/2011 18:16'!
logPng
	| cache |
	cache := #(nil) asOrderedCollection.
	(cache first) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 4 103 65 77 65 0 0 175 200 55 5 138 233 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 2 27 73 68 65 84 56 203 141 83 207 107 19 81 16 158 253 65 233 218 212 67 186 187 241 144 244 40 133 162 224 169 228 84 16 17 61 10 66 240 80 108 15 237 169 255 129 8 69 232 201 171 130 151 178 133 30 74 14 189 136 166 82 148 232 69 60 136 73 91 108 150 34 38 164 44 36 45 65 170 198 252 216 221 183 206 188 237 190 108 232 37 143 29 246 189 217 249 102 190 55 223 172 20 4 1 148 203 229 123 127 222 191 220 245 90 14 120 205 42 220 181 236 57 24 109 157 74 165 82 233 166 239 251 159 153 219 157 80 192 135 179 87 43 112 103 227 251 72 104 85 85 231 212 124 62 111 103 179 217 213 241 163 130 149 152 66 111 0 224 186 238 80 32 99 12 136 105 252 172 105 90 152 36 151 203 205 32 131 23 204 92 0 5 60 248 253 169 120 169 146 44 203 28 20 45 73 146 68 66 193 96 236 160 96 77 154 232 100 97 0 173 103 59 77 32 28 133 114 0 227 15 172 61 212 7 215 16 12 12 100 32 121 112 254 225 163 72 64 224 217 140 118 145 32 180 253 90 155 127 67 204 48 3 117 255 173 117 85 15 120 37 145 0 247 135 181 127 188 106 192 240 27 243 209 23 246 0 175 197 239 52 80 161 143 42 32 3 231 249 50 220 207 31 241 68 241 123 211 217 243 60 225 71 107 39 147 201 249 1 131 111 111 172 73 35 228 25 5 61 217 110 224 219 71 186 1 248 193 133 18 168 208 90 206 36 6 19 152 87 137 245 224 49 87 225 215 94 81 116 122 253 209 53 14 34 67 205 5 155 110 183 11 213 106 21 20 69 145 101 98 224 56 206 106 179 176 9 127 191 110 1 22 20 18 69 114 69 13 139 192 149 74 5 82 169 20 249 89 140 193 34 200 200 160 181 91 140 169 192 132 145 175 211 233 128 109 219 144 201 100 64 215 245 97 21 228 47 175 173 132 137 77 243 47 79 32 49 160 202 4 78 167 211 96 24 198 96 168 226 42 16 131 218 211 37 120 176 247 131 131 9 72 157 239 245 122 208 104 52 120 85 211 52 227 19 25 254 11 24 116 227 86 229 221 207 43 73 141 15 11 53 136 128 100 17 11 26 103 74 82 175 215 249 190 223 239 135 73 162 134 45 93 159 154 159 78 140 221 118 218 238 201 198 113 235 96 212 223 249 63 187 234 124 213 62 200 182 149 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache first! !

!DLFileLibrary methodsFor: 'uploaded' stamp: 'PL 6/23/2011 17:39:55.453'!
minusPng
	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 4 115 66 73 84 8 8 8 8 124 8 100 136 0 0 0 9 112 72 89 115 0 0 13 215 0 0 13 215 1 66 40 155 120 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 119 119 119 46 105 110 107 115 99 97 112 101 46 111 114 103 155 238 60 26 0 0 0 68 73 68 65 84 56 141 99 252 255 255 63 3 37 128 137 34 221 195 195 0 150 137 19 39 82 20 138 44 12 12 12 12 49 49 49 100 105 94 178 100 9 196 128 71 143 30 81 230 130 47 95 190 12 176 1 183 110 221 34 219 0 198 209 164 76 185 1 0 119 229 22 195 241 250 35 244 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

!DLFileLibrary methodsFor: 'uploaded' stamp: 'CO 5/26/2011 15:48:24.547'!
MochiKitJs
	^ '/***

    MochiKit.MochiKit 1.4.2 : PACKED VERSION

    THIS FILE IS AUTOMATICALLY GENERATED.  If creating patches, please
    diff against the source tree, not this file.

    See <http://mochikit.com/> for documentation, downloads, license, etc.

    (c) 2005 Bob Ippolito.  All rights Reserved.

***/

if(typeof (dojo)!!="undefined"){
dojo.provide("MochiKit.Base");
}
if(typeof (MochiKit)=="undefined"){
MochiKit={};
}
if(typeof (MochiKit.Base)=="undefined"){
MochiKit.Base={};
}
if(typeof (MochiKit.__export__)=="undefined"){
MochiKit.__export__=(MochiKit.__compat__||(typeof (JSAN)=="undefined"&&typeof (dojo)=="undefined"));
}
MochiKit.Base.VERSION="1.4.2";
MochiKit.Base.NAME="MochiKit.Base";
MochiKit.Base.update=function(_1,_2){
if(_1===null||_1===undefined){
_1={};
}
for(var i=1;i<arguments.length;i++){
var o=arguments[i];
if(typeof (o)!!="undefined"&&o!!==null){
for(var k in o){
_1[k]=o[k];
}
}
}
return _1;
};
MochiKit.Base.update(MochiKit.Base,{__repr__:function(){
return "["+this.NAME+" "+this.VERSION+"]";
},toString:function(){
return this.__repr__();
},camelize:function(_6){
var _7=_6.split("-");
var cc=_7[0];
for(var i=1;i<_7.length;i++){
cc+=_7[i].charAt(0).toUpperCase()+_7[i].substring(1);
}
return cc;
},counter:function(n){
if(arguments.length===0){
n=1;
}
return function(){
return n++;
};
},clone:function(_b){
var me=arguments.callee;
if(arguments.length==1){
me.prototype=_b;
return new me();
}
},_deps:function(_d,_e){
if(!!(_d in MochiKit)){
MochiKit[_d]={};
}
if(typeof (dojo)!!="undefined"){
dojo.provide("MochiKit."+_d);
}
for(var i=0;i<_e.length;i++){
if(typeof (dojo)!!="undefined"){
dojo.require("MochiKit."+_e[i]);
}
if(typeof (JSAN)!!="undefined"){
JSAN.use("MochiKit."+_e[i],[]);
}
if(!!(_e[i] in MochiKit)){
throw "MochiKit."+_d+" depends on MochiKit."+_e[i]+"!!";
}
}
},_flattenArray:function(res,lst){
for(var i=0;i<lst.length;i++){
var o=lst[i];
if(o instanceof Array){
arguments.callee(res,o);
}else{
res.push(o);
}
}
return res;
},flattenArray:function(lst){
return MochiKit.Base._flattenArray([],lst);
},flattenArguments:function(lst){
var res=[];
var m=MochiKit.Base;
var _18=m.extend(null,arguments);
while(_18.length){
var o=_18.shift();
if(o&&typeof (o)=="object"&&typeof (o.length)=="number"){
for(var i=o.length-1;i>=0;i--){
_18.unshift(o[i]);
}
}else{
res.push(o);
}
}
return res;
},extend:function(_1b,obj,_1d){
if(!!_1d){
_1d=0;
}
if(obj){
var l=obj.length;
if(typeof (l)!!="number"){
if(typeof (MochiKit.Iter)!!="undefined"){
obj=MochiKit.Iter.list(obj);
l=obj.length;
}else{
throw new TypeError("Argument not an array-like and MochiKit.Iter not present");
}
}
if(!!_1b){
_1b=[];
}
for(var i=_1d;i<l;i++){
_1b.push(obj[i]);
}
}
return _1b;
},updatetree:function(_20,obj){
if(_20===null||_20===undefined){
_20={};
}
for(var i=1;i<arguments.length;i++){
var o=arguments[i];
if(typeof (o)!!="undefined"&&o!!==null){
for(var k in o){
var v=o[k];
if(typeof (_20[k])=="object"&&typeof (v)=="object"){
arguments.callee(_20[k],v);
}else{
_20[k]=v;
}
}
}
}
return _20;
},setdefault:function(_26,obj){
if(_26===null||_26===undefined){
_26={};
}
for(var i=1;i<arguments.length;i++){
var o=arguments[i];
for(var k in o){
if(!!(k in _26)){
_26[k]=o[k];
}
}
}
return _26;
},keys:function(obj){
var _2c=[];
for(var _2d in obj){
_2c.push(_2d);
}
return _2c;
},values:function(obj){
var _2f=[];
for(var _30 in obj){
_2f.push(obj[_30]);
}
return _2f;
},items:function(obj){
var _32=[];
var e;
for(var _34 in obj){
var v;
try{
v=obj[_34];
}
catch(e){
continue;
}
_32.push([_34,v]);
}
return _32;
},_newNamedError:function(_36,_37,_38){
_38.prototype=new MochiKit.Base.NamedError(_36.NAME+"."+_37);
_36[_37]=_38;
},operator:{truth:function(a){
return !!!!a;
},lognot:function(a){
return !!a;
},identity:function(a){
return a;
},not:function(a){
return ~a;
},neg:function(a){
return -a;
},add:function(a,b){
return a+b;
},sub:function(a,b){
return a-b;
},div:function(a,b){
return a/b;
},mod:function(a,b){
return a%b;
},mul:function(a,b){
return a*b;
},and:function(a,b){
return a&b;
},or:function(a,b){
return a|b;
},xor:function(a,b){
return a^b;
},lshift:function(a,b){
return a<<b;
},rshift:function(a,b){
return a>>b;
},zrshift:function(a,b){
return a>>>b;
},eq:function(a,b){
return a==b;
},ne:function(a,b){
return a!!=b;
},gt:function(a,b){
return a>b;
},ge:function(a,b){
return a>=b;
},lt:function(a,b){
return a<b;
},le:function(a,b){
return a<=b;
},seq:function(a,b){
return a===b;
},sne:function(a,b){
return a!!==b;
},ceq:function(a,b){
return MochiKit.Base.compare(a,b)===0;
},cne:function(a,b){
return MochiKit.Base.compare(a,b)!!==0;
},cgt:function(a,b){
return MochiKit.Base.compare(a,b)==1;
},cge:function(a,b){
return MochiKit.Base.compare(a,b)!!=-1;
},clt:function(a,b){
return MochiKit.Base.compare(a,b)==-1;
},cle:function(a,b){
return MochiKit.Base.compare(a,b)!!=1;
},logand:function(a,b){
return a&&b;
},logor:function(a,b){
return a||b;
},contains:function(a,b){
return b in a;
}},forwardCall:function(_76){
return function(){
return this[_76].apply(this,arguments);
};
},itemgetter:function(_77){
return function(arg){
return arg[_77];
};
},typeMatcher:function(){
var _79={};
for(var i=0;i<arguments.length;i++){
var typ=arguments[i];
_79[typ]=typ;
}
return function(){
for(var i=0;i<arguments.length;i++){
if(!!(typeof (arguments[i]) in _79)){
return false;
}
}
return true;
};
},isNull:function(){
for(var i=0;i<arguments.length;i++){
if(arguments[i]!!==null){
return false;
}
}
return true;
},isUndefinedOrNull:function(){
for(var i=0;i<arguments.length;i++){
var o=arguments[i];
if(!!(typeof (o)=="undefined"||o===null)){
return false;
}
}
return true;
},isEmpty:function(obj){
return !!MochiKit.Base.isNotEmpty.apply(this,arguments);
},isNotEmpty:function(obj){
for(var i=0;i<arguments.length;i++){
var o=arguments[i];
if(!!(o&&o.length)){
return false;
}
}
return true;
},isArrayLike:function(){
for(var i=0;i<arguments.length;i++){
var o=arguments[i];
var typ=typeof (o);
if((typ!!="object"&&!!(typ=="function"&&typeof (o.item)=="function"))||o===null||typeof (o.length)!!="number"||o.nodeType===3||o.nodeType===4){
return false;
}
}
return true;
},isDateLike:function(){
for(var i=0;i<arguments.length;i++){
var o=arguments[i];
if(typeof (o)!!="object"||o===null||typeof (o.getTime)!!="function"){
return false;
}
}
return true;
},xmap:function(fn){
if(fn===null){
return MochiKit.Base.extend(null,arguments,1);
}
var _8a=[];
for(var i=1;i<arguments.length;i++){
_8a.push(fn(arguments[i]));
}
return _8a;
},map:function(fn,lst){
var m=MochiKit.Base;
var itr=MochiKit.Iter;
var _90=m.isArrayLike;
if(arguments.length<=2){
if(!!_90(lst)){
if(itr){
lst=itr.list(lst);
if(fn===null){
return lst;
}
}else{
throw new TypeError("Argument not an array-like and MochiKit.Iter not present");
}
}
if(fn===null){
return m.extend(null,lst);
}
var _91=[];
for(var i=0;i<lst.length;i++){
_91.push(fn(lst[i]));
}
return _91;
}else{
if(fn===null){
fn=Array;
}
var _93=null;
for(i=1;i<arguments.length;i++){
if(!!_90(arguments[i])){
if(itr){
return itr.list(itr.imap.apply(null,arguments));
}else{
throw new TypeError("Argument not an array-like and MochiKit.Iter not present");
}
}
var l=arguments[i].length;
if(_93===null||_93>l){
_93=l;
}
}
_91=[];
for(i=0;i<_93;i++){
var _95=[];
for(var j=1;j<arguments.length;j++){
_95.push(arguments[j][i]);
}
_91.push(fn.apply(this,_95));
}
return _91;
}
},xfilter:function(fn){
var _98=[];
if(fn===null){
fn=MochiKit.Base.operator.truth;
}
for(var i=1;i<arguments.length;i++){
var o=arguments[i];
if(fn(o)){
_98.push(o);
}
}
return _98;
},filter:function(fn,lst,_9d){
var _9e=[];
var m=MochiKit.Base;
if(!!m.isArrayLike(lst)){
if(MochiKit.Iter){
lst=MochiKit.Iter.list(lst);
}else{
throw new TypeError("Argument not an array-like and MochiKit.Iter not present");
}
}
if(fn===null){
fn=m.operator.truth;
}
if(typeof (Array.prototype.filter)=="function"){
return Array.prototype.filter.call(lst,fn,_9d);
}else{
if(typeof (_9d)=="undefined"||_9d===null){
for(var i=0;i<lst.length;i++){
var o=lst[i];
if(fn(o)){
_9e.push(o);
}
}
}else{
for(i=0;i<lst.length;i++){
o=lst[i];
if(fn.call(_9d,o)){
_9e.push(o);
}
}
}
}
return _9e;
},_wrapDumbFunction:function(_a2){
return function(){
switch(arguments.length){
case 0:
return _a2();
case 1:
return _a2(arguments[0]);
case 2:
return _a2(arguments[0],arguments[1]);
case 3:
return _a2(arguments[0],arguments[1],arguments[2]);
}
var _a3=[];
for(var i=0;i<arguments.length;i++){
_a3.push("arguments["+i+"]");
}
return eval("(func("+_a3.join(",")+"))");
};
},methodcaller:function(_a5){
var _a6=MochiKit.Base.extend(null,arguments,1);
if(typeof (_a5)=="function"){
return function(obj){
return _a5.apply(obj,_a6);
};
}else{
return function(obj){
return obj[_a5].apply(obj,_a6);
};
}
},method:function(_a9,_aa){
var m=MochiKit.Base;
return m.bind.apply(this,m.extend([_aa,_a9],arguments,2));
},compose:function(f1,f2){
var _ae=[];
var m=MochiKit.Base;
if(arguments.length===0){
throw new TypeError("compose() requires at least one argument");
}
for(var i=0;i<arguments.length;i++){
var fn=arguments[i];
if(typeof (fn)!!="function"){
throw new TypeError(m.repr(fn)+" is not a function");
}
_ae.push(fn);
}
return function(){
var _b2=arguments;
for(var i=_ae.length-1;i>=0;i--){
_b2=[_ae[i].apply(this,_b2)];
}
return _b2[0];
};
},bind:function(_b4,_b5){
if(typeof (_b4)=="string"){
_b4=_b5[_b4];
}
var _b6=_b4.im_func;
var _b7=_b4.im_preargs;
var _b8=_b4.im_self;
var m=MochiKit.Base;
if(typeof (_b4)=="function"&&typeof (_b4.apply)=="undefined"){
_b4=m._wrapDumbFunction(_b4);
}
if(typeof (_b6)!!="function"){
_b6=_b4;
}
if(typeof (_b5)!!="undefined"){
_b8=_b5;
}
if(typeof (_b7)=="undefined"){
_b7=[];
}else{
_b7=_b7.slice();
}
m.extend(_b7,arguments,2);
var _ba=function(){
var _bb=arguments;
var me=arguments.callee;
if(me.im_preargs.length>0){
_bb=m.concat(me.im_preargs,_bb);
}
var _bd=me.im_self;
if(!!_bd){
_bd=this;
}
return me.im_func.apply(_bd,_bb);
};
_ba.im_self=_b8;
_ba.im_func=_b6;
_ba.im_preargs=_b7;
return _ba;
},bindLate:function(_be,_bf){
var m=MochiKit.Base;
if(typeof (_be)!!="string"){
return m.bind.apply(this,arguments);
}
var _c1=m.extend([],arguments,2);
var _c2=function(){
var _c3=arguments;
var me=arguments.callee;
if(me.im_preargs.length>0){
_c3=m.concat(me.im_preargs,_c3);
}
var _c5=me.im_self;
if(!!_c5){
_c5=this;
}
return _c5[me.im_func].apply(_c5,_c3);
};
_c2.im_self=_bf;
_c2.im_func=_be;
_c2.im_preargs=_c1;
return _c2;
},bindMethods:function(_c6){
var _c7=MochiKit.Base.bind;
for(var k in _c6){
var _c9=_c6[k];
if(typeof (_c9)=="function"){
_c6[k]=_c7(_c9,_c6);
}
}
},registerComparator:function(_ca,_cb,_cc,_cd){
MochiKit.Base.comparatorRegistry.register(_ca,_cb,_cc,_cd);
},_primitives:{"boolean":true,"string":true,"number":true},compare:function(a,b){
if(a==b){
return 0;
}
var _d0=(typeof (a)=="undefined"||a===null);
var _d1=(typeof (b)=="undefined"||b===null);
if(_d0&&_d1){
return 0;
}else{
if(_d0){
return -1;
}else{
if(_d1){
return 1;
}
}
}
var m=MochiKit.Base;
var _d3=m._primitives;
if(!!(typeof (a) in _d3&&typeof (b) in _d3)){
try{
return m.comparatorRegistry.match(a,b);
}
catch(e){
if(e!!=m.NotFound){
throw e;
}
}
}
if(a<b){
return -1;
}else{
if(a>b){
return 1;
}
}
var _d4=m.repr;
throw new TypeError(_d4(a)+" and "+_d4(b)+" can not be compared");
},compareDateLike:function(a,b){
return MochiKit.Base.compare(a.getTime(),b.getTime());
},compareArrayLike:function(a,b){
var _d9=MochiKit.Base.compare;
var _da=a.length;
var _db=0;
if(_da>b.length){
_db=1;
_da=b.length;
}else{
if(_da<b.length){
_db=-1;
}
}
for(var i=0;i<_da;i++){
var cmp=_d9(a[i],b[i]);
if(cmp){
return cmp;
}
}
return _db;
},registerRepr:function(_de,_df,_e0,_e1){
MochiKit.Base.reprRegistry.register(_de,_df,_e0,_e1);
},repr:function(o){
if(typeof (o)=="undefined"){
return "undefined";
}else{
if(o===null){
return "null";
}
}
try{
if(typeof (o.__repr__)=="function"){
return o.__repr__();
}else{
if(typeof (o.repr)=="function"&&o.repr!!=arguments.callee){
return o.repr();
}
}
return MochiKit.Base.reprRegistry.match(o);
}
catch(e){
if(typeof (o.NAME)=="string"&&(o.toString==Function.prototype.toString||o.toString==Object.prototype.toString)){
return o.NAME;
}
}
try{
var _e3=(o+"");
}
catch(e){
return "["+typeof (o)+"]";
}
if(typeof (o)=="function"){
_e3=_e3.replace(/^\s+/,"").replace(/\s+/g," ");
_e3=_e3.replace(/,(\S)/,", $1");
var idx=_e3.indexOf("{");
if(idx!!=-1){
_e3=_e3.substr(0,idx)+"{...}";
}
}
return _e3;
},reprArrayLike:function(o){
var m=MochiKit.Base;
return "["+m.map(m.repr,o).join(", ")+"]";
},reprString:function(o){
return ("\""+o.replace(/(["\\])/g,"\\$1")+"\"").replace(/[\f]/g,"\\f").replace(/[\b]/g,"\\b").replace(/[\n]/g,"\\n").replace(/[\t]/g,"\\t").replace(/[\v]/g,"\\v").replace(/[\r]/g,"\\r");
},reprNumber:function(o){
return o+"";
},registerJSON:function(_e9,_ea,_eb,_ec){
MochiKit.Base.jsonRegistry.register(_e9,_ea,_eb,_ec);
},evalJSON:function(){
return eval("("+MochiKit.Base._filterJSON(arguments[0])+")");
},_filterJSON:function(s){
var m=s.match(/^\s*\/\*(.*)\*\/\s*$/);
if(m){
return m[1];
}
return s;
},serializeJSON:function(o){
var _f0=typeof (o);
if(_f0=="number"||_f0=="boolean"){
return o+"";
}else{
if(o===null){
return "null";
}else{
if(_f0=="string"){
var res="";
for(var i=0;i<o.length;i++){
var c=o.charAt(i);
if(c=="\""){
res+="\\\"";
}else{
if(c=="\\"){
res+="\\\\";
}else{
if(c=="\b"){
res+="\\b";
}else{
if(c=="\f"){
res+="\\f";
}else{
if(c=="\n"){
res+="\\n";
}else{
if(c=="\r"){
res+="\\r";
}else{
if(c=="\t"){
res+="\\t";
}else{
if(o.charCodeAt(i)<=31){
var hex=o.charCodeAt(i).toString(16);
if(hex.length<2){
hex="0"+hex;
}
res+="\\u00"+hex.toUpperCase();
}else{
res+=c;
}
}
}
}
}
}
}
}
}
return "\""+res+"\"";
}
}
}
var me=arguments.callee;
var _f6;
if(typeof (o.__json__)=="function"){
_f6=o.__json__();
if(o!!==_f6){
return me(_f6);
}
}
if(typeof (o.json)=="function"){
_f6=o.json();
if(o!!==_f6){
return me(_f6);
}
}
if(_f0!!="function"&&typeof (o.length)=="number"){
var res=[];
for(var i=0;i<o.length;i++){
var val=me(o[i]);
if(typeof (val)!!="string"){
continue;
}
res.push(val);
}
return "["+res.join(", ")+"]";
}
var m=MochiKit.Base;
try{
_f6=m.jsonRegistry.match(o);
if(o!!==_f6){
return me(_f6);
}
}
catch(e){
if(e!!=m.NotFound){
throw e;
}
}
if(_f0=="undefined"){
throw new TypeError("undefined can not be serialized as JSON");
}
if(_f0=="function"){
return null;
}
res=[];
for(var k in o){
var _fa;
if(typeof (k)=="number"){
_fa="\""+k+"\"";
}else{
if(typeof (k)=="string"){
_fa=me(k);
}else{
continue;
}
}
val=me(o[k]);
if(typeof (val)!!="string"){
continue;
}
res.push(_fa+":"+val);
}
return "{"+res.join(", ")+"}";
},objEqual:function(a,b){
return (MochiKit.Base.compare(a,b)===0);
},arrayEqual:function(_fd,arr){
if(_fd.length!!=arr.length){
return false;
}
return (MochiKit.Base.compare(_fd,arr)===0);
},concat:function(){
var _ff=[];
var _100=MochiKit.Base.extend;
for(var i=0;i<arguments.length;i++){
_100(_ff,arguments[i]);
}
return _ff;
},keyComparator:function(key){
var m=MochiKit.Base;
var _104=m.compare;
if(arguments.length==1){
return function(a,b){
return _104(a[key],b[key]);
};
}
var _107=m.extend(null,arguments);
return function(a,b){
var rval=0;
for(var i=0;(rval===0)&&(i<_107.length);i++){
var key=_107[i];
rval=_104(a[key],b[key]);
}
return rval;
};
},reverseKeyComparator:function(key){
var _10e=MochiKit.Base.keyComparator.apply(this,arguments);
return function(a,b){
return _10e(b,a);
};
},partial:function(func){
var m=MochiKit.Base;
return m.bind.apply(this,m.extend([func,undefined],arguments,1));
},listMinMax:function(_113,lst){
if(lst.length===0){
return null;
}
var cur=lst[0];
var _116=MochiKit.Base.compare;
for(var i=1;i<lst.length;i++){
var o=lst[i];
if(_116(o,cur)==_113){
cur=o;
}
}
return cur;
},objMax:function(){
return MochiKit.Base.listMinMax(1,arguments);
},objMin:function(){
return MochiKit.Base.listMinMax(-1,arguments);
},findIdentical:function(lst,_11a,_11b,end){
if(typeof (end)=="undefined"||end===null){
end=lst.length;
}
if(typeof (_11b)=="undefined"||_11b===null){
_11b=0;
}
for(var i=_11b;i<end;i++){
if(lst[i]===_11a){
return i;
}
}
return -1;
},mean:function(){
var sum=0;
var m=MochiKit.Base;
var args=m.extend(null,arguments);
var _121=args.length;
while(args.length){
var o=args.shift();
if(o&&typeof (o)=="object"&&typeof (o.length)=="number"){
_121+=o.length-1;
for(var i=o.length-1;i>=0;i--){
sum+=o[i];
}
}else{
sum+=o;
}
}
if(_121<=0){
throw new TypeError("mean() requires at least one argument");
}
return sum/_121;
},median:function(){
var data=MochiKit.Base.flattenArguments(arguments);
if(data.length===0){
throw new TypeError("median() requires at least one argument");
}
data.sort(compare);
if(data.length%2==0){
var _125=data.length/2;
return (data[_125]+data[_125-1])/2;
}else{
return data[(data.length-1)/2];
}
},findValue:function(lst,_127,_128,end){
if(typeof (end)=="undefined"||end===null){
end=lst.length;
}
if(typeof (_128)=="undefined"||_128===null){
_128=0;
}
var cmp=MochiKit.Base.compare;
for(var i=_128;i<end;i++){
if(cmp(lst[i],_127)===0){
return i;
}
}
return -1;
},nodeWalk:function(node,_12d){
var _12e=[node];
var _12f=MochiKit.Base.extend;
while(_12e.length){
var res=_12d(_12e.shift());
if(res){
_12f(_12e,res);
}
}
},nameFunctions:function(_131){
var base=_131.NAME;
if(typeof (base)=="undefined"){
base="";
}else{
base=base+".";
}
for(var name in _131){
var o=_131[name];
if(typeof (o)=="function"&&typeof (o.NAME)=="undefined"){
try{
o.NAME=base+name;
}
catch(e){
}
}
}
},queryString:function(_135,_136){
if(typeof (MochiKit.DOM)!!="undefined"&&arguments.length==1&&(typeof (_135)=="string"||(typeof (_135.nodeType)!!="undefined"&&_135.nodeType>0))){
var kv=MochiKit.DOM.formContents(_135);
_135=kv[0];
_136=kv[1];
}else{
if(arguments.length==1){
if(typeof (_135.length)=="number"&&_135.length==2){
return arguments.callee(_135[0],_135[1]);
}
var o=_135;
_135=[];
_136=[];
for(var k in o){
var v=o[k];
if(typeof (v)=="function"){
continue;
}else{
if(MochiKit.Base.isArrayLike(v)){
for(var i=0;i<v.length;i++){
_135.push(k);
_136.push(v[i]);
}
}else{
_135.push(k);
_136.push(v);
}
}
}
}
}
var rval=[];
var len=Math.min(_135.length,_136.length);
var _13e=MochiKit.Base.urlEncode;
for(var i=0;i<len;i++){
v=_136[i];
if(typeof (v)!!="undefined"&&v!!==null){
rval.push(_13e(_135[i])+"="+_13e(v));
}
}
return rval.join("&");
},parseQueryString:function(_13f,_140){
var qstr=(_13f.charAt(0)=="?")?_13f.substring(1):_13f;
var _142=qstr.replace(/\+/g,"%20").split(/\&amp\;|\&\#38\;|\&#x26;|\&/);
var o={};
var _144;
if(typeof (decodeURIComponent)!!="undefined"){
_144=decodeURIComponent;
}else{
_144=unescape;
}
if(_140){
for(var i=0;i<_142.length;i++){
var pair=_142[i].split("=");
var name=_144(pair.shift());
if(!!name){
continue;
}
var arr=o[name];
if(!!(arr instanceof Array)){
arr=[];
o[name]=arr;
}
arr.push(_144(pair.join("=")));
}
}else{
for(i=0;i<_142.length;i++){
pair=_142[i].split("=");
var name=pair.shift();
if(!!name){
continue;
}
o[_144(name)]=_144(pair.join("="));
}
}
return o;
}});
MochiKit.Base.AdapterRegistry=function(){
this.pairs=[];
};
MochiKit.Base.AdapterRegistry.prototype={register:function(name,_14a,wrap,_14c){
if(_14c){
this.pairs.unshift([name,_14a,wrap]);
}else{
this.pairs.push([name,_14a,wrap]);
}
},match:function(){
for(var i=0;i<this.pairs.length;i++){
var pair=this.pairs[i];
if(pair[1].apply(this,arguments)){
return pair[2].apply(this,arguments);
}
}
throw MochiKit.Base.NotFound;
},unregister:function(name){
for(var i=0;i<this.pairs.length;i++){
var pair=this.pairs[i];
if(pair[0]==name){
this.pairs.splice(i,1);
return true;
}
}
return false;
}};
MochiKit.Base.EXPORT=["flattenArray","noop","camelize","counter","clone","extend","update","updatetree","setdefault","keys","values","items","NamedError","operator","forwardCall","itemgetter","typeMatcher","isCallable","isUndefined","isUndefinedOrNull","isNull","isEmpty","isNotEmpty","isArrayLike","isDateLike","xmap","map","xfilter","filter","methodcaller","compose","bind","bindLate","bindMethods","NotFound","AdapterRegistry","registerComparator","compare","registerRepr","repr","objEqual","arrayEqual","concat","keyComparator","reverseKeyComparator","partial","merge","listMinMax","listMax","listMin","objMax","objMin","nodeWalk","zip","urlEncode","queryString","serializeJSON","registerJSON","evalJSON","parseQueryString","findValue","findIdentical","flattenArguments","method","average","mean","median"];
MochiKit.Base.EXPORT_OK=["nameFunctions","comparatorRegistry","reprRegistry","jsonRegistry","compareDateLike","compareArrayLike","reprArrayLike","reprString","reprNumber"];
MochiKit.Base._exportSymbols=function(_152,_153){
if(!!MochiKit.__export__){
return;
}
var all=_153.EXPORT_TAGS[":all"];
for(var i=0;i<all.length;i++){
_152[all[i]]=_153[all[i]];
}
};
MochiKit.Base.__new__=function(){
var m=this;
m.noop=m.operator.identity;
m.forward=m.forwardCall;
m.find=m.findValue;
if(typeof (encodeURIComponent)!!="undefined"){
m.urlEncode=function(_157){
return encodeURIComponent(_157).replace(/\''/g,"%27");
};
}else{
m.urlEncode=function(_158){
return escape(_158).replace(/\+/g,"%2B").replace(/\"/g,"%22").rval.replace(/\''/g,"%27");
};
}
m.NamedError=function(name){
this.message=name;
this.name=name;
};
m.NamedError.prototype=new Error();
m.update(m.NamedError.prototype,{repr:function(){
if(this.message&&this.message!!=this.name){
return this.name+"("+m.repr(this.message)+")";
}else{
return this.name+"()";
}
},toString:m.forwardCall("repr")});
m.NotFound=new m.NamedError("MochiKit.Base.NotFound");
m.listMax=m.partial(m.listMinMax,1);
m.listMin=m.partial(m.listMinMax,-1);
m.isCallable=m.typeMatcher("function");
m.isUndefined=m.typeMatcher("undefined");
m.merge=m.partial(m.update,null);
m.zip=m.partial(m.map,null);
m.average=m.mean;
m.comparatorRegistry=new m.AdapterRegistry();
m.registerComparator("dateLike",m.isDateLike,m.compareDateLike);
m.registerComparator("arrayLike",m.isArrayLike,m.compareArrayLike);
m.reprRegistry=new m.AdapterRegistry();
m.registerRepr("arrayLike",m.isArrayLike,m.reprArrayLike);
m.registerRepr("string",m.typeMatcher("string"),m.reprString);
m.registerRepr("numbers",m.typeMatcher("number","boolean"),m.reprNumber);
m.jsonRegistry=new m.AdapterRegistry();
var all=m.concat(m.EXPORT,m.EXPORT_OK);
m.EXPORT_TAGS={":common":m.concat(m.EXPORT_OK),":all":all};
m.nameFunctions(this);
};
MochiKit.Base.__new__();
if(MochiKit.__export__){
compare=MochiKit.Base.compare;
compose=MochiKit.Base.compose;
serializeJSON=MochiKit.Base.serializeJSON;
mean=MochiKit.Base.mean;
median=MochiKit.Base.median;
}
MochiKit.Base._exportSymbols(this,MochiKit.Base);
MochiKit.Base._deps("Iter",["Base"]);
MochiKit.Iter.NAME="MochiKit.Iter";
MochiKit.Iter.VERSION="1.4.2";
MochiKit.Base.update(MochiKit.Iter,{__repr__:function(){
return "["+this.NAME+" "+this.VERSION+"]";
},toString:function(){
return this.__repr__();
},registerIteratorFactory:function(name,_15c,_15d,_15e){
MochiKit.Iter.iteratorRegistry.register(name,_15c,_15d,_15e);
},isIterable:function(o){
return o!!=null&&(typeof (o.next)=="function"||typeof (o.iter)=="function");
},iter:function(_160,_161){
var self=MochiKit.Iter;
if(arguments.length==2){
return self.takewhile(function(a){
return a!!=_161;
},_160);
}
if(typeof (_160.next)=="function"){
return _160;
}else{
if(typeof (_160.iter)=="function"){
return _160.iter();
}
}
try{
return self.iteratorRegistry.match(_160);
}
catch(e){
var m=MochiKit.Base;
if(e==m.NotFound){
e=new TypeError(typeof (_160)+": "+m.repr(_160)+" is not iterable");
}
throw e;
}
},count:function(n){
if(!!n){
n=0;
}
var m=MochiKit.Base;
return {repr:function(){
return "count("+n+")";
},toString:m.forwardCall("repr"),next:m.counter(n)};
},cycle:function(p){
var self=MochiKit.Iter;
var m=MochiKit.Base;
var lst=[];
var _16b=self.iter(p);
return {repr:function(){
return "cycle(...)";
},toString:m.forwardCall("repr"),next:function(){
try{
var rval=_16b.next();
lst.push(rval);
return rval;
}
catch(e){
if(e!!=self.StopIteration){
throw e;
}
if(lst.length===0){
this.next=function(){
throw self.StopIteration;
};
}else{
var i=-1;
this.next=function(){
i=(i+1)%lst.length;
return lst[i];
};
}
return this.next();
}
}};
},repeat:function(elem,n){
var m=MochiKit.Base;
if(typeof (n)=="undefined"){
return {repr:function(){
return "repeat("+m.repr(elem)+")";
},toString:m.forwardCall("repr"),next:function(){
return elem;
}};
}
return {repr:function(){
return "repeat("+m.repr(elem)+", "+n+")";
},toString:m.forwardCall("repr"),next:function(){
if(n<=0){
throw MochiKit.Iter.StopIteration;
}
n-=1;
return elem;
}};
},next:function(_171){
return _171.next();
},izip:function(p,q){
var m=MochiKit.Base;
var self=MochiKit.Iter;
var next=self.next;
var _177=m.map(self.iter,arguments);
return {repr:function(){
return "izip(...)";
},toString:m.forwardCall("repr"),next:function(){
return m.map(next,_177);
}};
},ifilter:function(pred,seq){
var m=MochiKit.Base;
seq=MochiKit.Iter.iter(seq);
if(pred===null){
pred=m.operator.truth;
}
return {repr:function(){
return "ifilter(...)";
},toString:m.forwardCall("repr"),next:function(){
while(true){
var rval=seq.next();
if(pred(rval)){
return rval;
}
}
return undefined;
}};
},ifilterfalse:function(pred,seq){
var m=MochiKit.Base;
seq=MochiKit.Iter.iter(seq);
if(pred===null){
pred=m.operator.truth;
}
return {repr:function(){
return "ifilterfalse(...)";
},toString:m.forwardCall("repr"),next:function(){
while(true){
var rval=seq.next();
if(!!pred(rval)){
return rval;
}
}
return undefined;
}};
},islice:function(seq){
var self=MochiKit.Iter;
var m=MochiKit.Base;
seq=self.iter(seq);
var _183=0;
var stop=0;
var step=1;
var i=-1;
if(arguments.length==2){
stop=arguments[1];
}else{
if(arguments.length==3){
_183=arguments[1];
stop=arguments[2];
}else{
_183=arguments[1];
stop=arguments[2];
step=arguments[3];
}
}
return {repr:function(){
return "islice("+["...",_183,stop,step].join(", ")+")";
},toString:m.forwardCall("repr"),next:function(){
var rval;
while(i<_183){
rval=seq.next();
i++;
}
if(_183>=stop){
throw self.StopIteration;
}
_183+=step;
return rval;
}};
},imap:function(fun,p,q){
var m=MochiKit.Base;
var self=MochiKit.Iter;
var _18d=m.map(self.iter,m.extend(null,arguments,1));
var map=m.map;
var next=self.next;
return {repr:function(){
return "imap(...)";
},toString:m.forwardCall("repr"),next:function(){
return fun.apply(this,map(next,_18d));
}};
},applymap:function(fun,seq,self){
seq=MochiKit.Iter.iter(seq);
var m=MochiKit.Base;
return {repr:function(){
return "applymap(...)";
},toString:m.forwardCall("repr"),next:function(){
return fun.apply(self,seq.next());
}};
},chain:function(p,q){
var self=MochiKit.Iter;
var m=MochiKit.Base;
if(arguments.length==1){
return self.iter(arguments[0]);
}
var _198=m.map(self.iter,arguments);
return {repr:function(){
return "chain(...)";
},toString:m.forwardCall("repr"),next:function(){
while(_198.length>1){
try{
var _199=_198[0].next();
return _199;
}
catch(e){
if(e!!=self.StopIteration){
throw e;
}
_198.shift();
var _199=_198[0].next();
return _199;
}
}
if(_198.length==1){
var arg=_198.shift();
this.next=m.bind("next",arg);
return this.next();
}
throw self.StopIteration;
}};
},takewhile:function(pred,seq){
var self=MochiKit.Iter;
seq=self.iter(seq);
return {repr:function(){
return "takewhile(...)";
},toString:MochiKit.Base.forwardCall("repr"),next:function(){
var rval=seq.next();
if(!!pred(rval)){
this.next=function(){
throw self.StopIteration;
};
this.next();
}
return rval;
}};
},dropwhile:function(pred,seq){
seq=MochiKit.Iter.iter(seq);
var m=MochiKit.Base;
var bind=m.bind;
return {"repr":function(){
return "dropwhile(...)";
},"toString":m.forwardCall("repr"),"next":function(){
while(true){
var rval=seq.next();
if(!!pred(rval)){
break;
}
}
this.next=bind("next",seq);
return rval;
}};
},_tee:function(_1a4,sync,_1a6){
sync.pos[_1a4]=-1;
var m=MochiKit.Base;
var _1a8=m.listMin;
return {repr:function(){
return "tee("+_1a4+", ...)";
},toString:m.forwardCall("repr"),next:function(){
var rval;
var i=sync.pos[_1a4];
if(i==sync.max){
rval=_1a6.next();
sync.deque.push(rval);
sync.max+=1;
sync.pos[_1a4]+=1;
}else{
rval=sync.deque[i-sync.min];
sync.pos[_1a4]+=1;
if(i==sync.min&&_1a8(sync.pos)!!=sync.min){
sync.min+=1;
sync.deque.shift();
}
}
return rval;
}};
},tee:function(_1ab,n){
var rval=[];
var sync={"pos":[],"deque":[],"max":-1,"min":-1};
if(arguments.length==1||typeof (n)=="undefined"||n===null){
n=2;
}
var self=MochiKit.Iter;
_1ab=self.iter(_1ab);
var _tee=self._tee;
for(var i=0;i<n;i++){
rval.push(_tee(i,sync,_1ab));
}
return rval;
},list:function(_1b2){
var rval;
if(_1b2 instanceof Array){
return _1b2.slice();
}
if(typeof (_1b2)=="function"&&!!(_1b2 instanceof Function)&&typeof (_1b2.length)=="number"){
rval=[];
for(var i=0;i<_1b2.length;i++){
rval.push(_1b2[i]);
}
return rval;
}
var self=MochiKit.Iter;
_1b2=self.iter(_1b2);
var rval=[];
var _1b6;
try{
while(true){
_1b6=_1b2.next();
rval.push(_1b6);
}
}
catch(e){
if(e!!=self.StopIteration){
throw e;
}
return rval;
}
return undefined;
},reduce:function(fn,_1b8,_1b9){
var i=0;
var x=_1b9;
var self=MochiKit.Iter;
_1b8=self.iter(_1b8);
if(arguments.length<3){
try{
x=_1b8.next();
}
catch(e){
if(e==self.StopIteration){
e=new TypeError("reduce() of empty sequence with no initial value");
}
throw e;
}
i++;
}
try{
while(true){
x=fn(x,_1b8.next());
}
}
catch(e){
if(e!!=self.StopIteration){
throw e;
}
}
return x;
},range:function(){
var _1bd=0;
var stop=0;
var step=1;
if(arguments.length==1){
stop=arguments[0];
}else{
if(arguments.length==2){
_1bd=arguments[0];
stop=arguments[1];
}else{
if(arguments.length==3){
_1bd=arguments[0];
stop=arguments[1];
step=arguments[2];
}else{
throw new TypeError("range() takes 1, 2, or 3 arguments!!");
}
}
}
if(step===0){
throw new TypeError("range() step must not be 0");
}
return {next:function(){
if((step>0&&_1bd>=stop)||(step<0&&_1bd<=stop)){
throw MochiKit.Iter.StopIteration;
}
var rval=_1bd;
_1bd+=step;
return rval;
},repr:function(){
return "range("+[_1bd,stop,step].join(", ")+")";
},toString:MochiKit.Base.forwardCall("repr")};
},sum:function(_1c1,_1c2){
if(typeof (_1c2)=="undefined"||_1c2===null){
_1c2=0;
}
var x=_1c2;
var self=MochiKit.Iter;
_1c1=self.iter(_1c1);
try{
while(true){
x+=_1c1.next();
}
}
catch(e){
if(e!!=self.StopIteration){
throw e;
}
}
return x;
},exhaust:function(_1c5){
var self=MochiKit.Iter;
_1c5=self.iter(_1c5);
try{
while(true){
_1c5.next();
}
}
catch(e){
if(e!!=self.StopIteration){
throw e;
}
}
},forEach:function(_1c7,func,obj){
var m=MochiKit.Base;
var self=MochiKit.Iter;
if(arguments.length>2){
func=m.bind(func,obj);
}
if(m.isArrayLike(_1c7)&&!!self.isIterable(_1c7)){
try{
for(var i=0;i<_1c7.length;i++){
func(_1c7[i]);
}
}
catch(e){
if(e!!=self.StopIteration){
throw e;
}
}
}else{
self.exhaust(self.imap(func,_1c7));
}
},every:function(_1cd,func){
var self=MochiKit.Iter;
try{
self.ifilterfalse(func,_1cd).next();
return false;
}
catch(e){
if(e!!=self.StopIteration){
throw e;
}
return true;
}
},sorted:function(_1d0,cmp){
var rval=MochiKit.Iter.list(_1d0);
if(arguments.length==1){
cmp=MochiKit.Base.compare;
}
rval.sort(cmp);
return rval;
},reversed:function(_1d3){
var rval=MochiKit.Iter.list(_1d3);
rval.reverse();
return rval;
},some:function(_1d5,func){
var self=MochiKit.Iter;
try{
self.ifilter(func,_1d5).next();
return true;
}
catch(e){
if(e!!=self.StopIteration){
throw e;
}
return false;
}
},iextend:function(lst,_1d9){
var m=MochiKit.Base;
var self=MochiKit.Iter;
if(m.isArrayLike(_1d9)&&!!self.isIterable(_1d9)){
for(var i=0;i<_1d9.length;i++){
lst.push(_1d9[i]);
}
}else{
_1d9=self.iter(_1d9);
try{
while(true){
lst.push(_1d9.next());
}
}
catch(e){
if(e!!=self.StopIteration){
throw e;
}
}
}
return lst;
},groupby:function(_1dd,_1de){
var m=MochiKit.Base;
var self=MochiKit.Iter;
if(arguments.length<2){
_1de=m.operator.identity;
}
_1dd=self.iter(_1dd);
var pk=undefined;
var k=undefined;
var v;
function fetch(){
v=_1dd.next();
k=_1de(v);
}
function eat(){
var ret=v;
v=undefined;
return ret;
}
var _1e5=true;
var _1e6=m.compare;
return {repr:function(){
return "groupby(...)";
},next:function(){
while(_1e6(k,pk)===0){
fetch();
if(_1e5){
_1e5=false;
break;
}
}
pk=k;
return [k,{next:function(){
if(v==undefined){
fetch();
}
if(_1e6(k,pk)!!==0){
throw self.StopIteration;
}
return eat();
}}];
}};
},groupby_as_array:function(_1e7,_1e8){
var m=MochiKit.Base;
var self=MochiKit.Iter;
if(arguments.length<2){
_1e8=m.operator.identity;
}
_1e7=self.iter(_1e7);
var _1eb=[];
var _1ec=true;
var _1ed;
var _1ee=m.compare;
while(true){
try{
var _1ef=_1e7.next();
var key=_1e8(_1ef);
}
catch(e){
if(e==self.StopIteration){
break;
}
throw e;
}
if(_1ec||_1ee(key,_1ed)!!==0){
var _1f1=[];
_1eb.push([key,_1f1]);
}
_1f1.push(_1ef);
_1ec=false;
_1ed=key;
}
return _1eb;
},arrayLikeIter:function(_1f2){
var i=0;
return {repr:function(){
return "arrayLikeIter(...)";
},toString:MochiKit.Base.forwardCall("repr"),next:function(){
if(i>=_1f2.length){
throw MochiKit.Iter.StopIteration;
}
return _1f2[i++];
}};
},hasIterateNext:function(_1f4){
return (_1f4&&typeof (_1f4.iterateNext)=="function");
},iterateNextIter:function(_1f5){
return {repr:function(){
return "iterateNextIter(...)";
},toString:MochiKit.Base.forwardCall("repr"),next:function(){
var rval=_1f5.iterateNext();
if(rval===null||rval===undefined){
throw MochiKit.Iter.StopIteration;
}
return rval;
}};
}});
MochiKit.Iter.EXPORT_OK=["iteratorRegistry","arrayLikeIter","hasIterateNext","iterateNextIter"];
MochiKit.Iter.EXPORT=["StopIteration","registerIteratorFactory","iter","count","cycle","repeat","next","izip","ifilter","ifilterfalse","islice","imap","applymap","chain","takewhile","dropwhile","tee","list","reduce","range","sum","exhaust","forEach","every","sorted","reversed","some","iextend","groupby","groupby_as_array"];
MochiKit.Iter.__new__=function(){
var m=MochiKit.Base;
if(typeof (StopIteration)!!="undefined"){
this.StopIteration=StopIteration;
}else{
this.StopIteration=new m.NamedError("StopIteration");
}
this.iteratorRegistry=new m.AdapterRegistry();
this.registerIteratorFactory("arrayLike",m.isArrayLike,this.arrayLikeIter);
this.registerIteratorFactory("iterateNext",this.hasIterateNext,this.iterateNextIter);
this.EXPORT_TAGS={":common":this.EXPORT,":all":m.concat(this.EXPORT,this.EXPORT_OK)};
m.nameFunctions(this);
};
MochiKit.Iter.__new__();
if(MochiKit.__export__){
reduce=MochiKit.Iter.reduce;
}
MochiKit.Base._exportSymbols(this,MochiKit.Iter);
MochiKit.Base._deps("Logging",["Base"]);
MochiKit.Logging.NAME="MochiKit.Logging";
MochiKit.Logging.VERSION="1.4.2";
MochiKit.Logging.__repr__=function(){
return "["+this.NAME+" "+this.VERSION+"]";
};
MochiKit.Logging.toString=function(){
return this.__repr__();
};
MochiKit.Logging.EXPORT=["LogLevel","LogMessage","Logger","alertListener","logger","log","logError","logDebug","logFatal","logWarning"];
MochiKit.Logging.EXPORT_OK=["logLevelAtLeast","isLogMessage","compareLogMessage"];
MochiKit.Logging.LogMessage=function(num,_1f9,info){
this.num=num;
this.level=_1f9;
this.info=info;
this.timestamp=new Date();
};
MochiKit.Logging.LogMessage.prototype={repr:function(){
var m=MochiKit.Base;
return "LogMessage("+m.map(m.repr,[this.num,this.level,this.info]).join(", ")+")";
},toString:MochiKit.Base.forwardCall("repr")};
MochiKit.Base.update(MochiKit.Logging,{logLevelAtLeast:function(_1fc){
var self=MochiKit.Logging;
if(typeof (_1fc)=="string"){
_1fc=self.LogLevel[_1fc];
}
return function(msg){
var _1ff=msg.level;
if(typeof (_1ff)=="string"){
_1ff=self.LogLevel[_1ff];
}
return _1ff>=_1fc;
};
},isLogMessage:function(){
var _200=MochiKit.Logging.LogMessage;
for(var i=0;i<arguments.length;i++){
if(!!(arguments[i] instanceof _200)){
return false;
}
}
return true;
},compareLogMessage:function(a,b){
return MochiKit.Base.compare([a.level,a.info],[b.level,b.info]);
},alertListener:function(msg){
alert("num: "+msg.num+"\nlevel: "+msg.level+"\ninfo: "+msg.info.join(" "));
}});
MochiKit.Logging.Logger=function(_205){
this.counter=0;
if(typeof (_205)=="undefined"||_205===null){
_205=-1;
}
this.maxSize=_205;
this._messages=[];
this.listeners={};
this.useNativeConsole=false;
};
MochiKit.Logging.Logger.prototype={clear:function(){
this._messages.splice(0,this._messages.length);
},logToConsole:function(msg){
if(typeof (window)!!="undefined"&&window.console&&window.console.log){
window.console.log(msg.replace(/%/g,"\uff05"));
}else{
if(typeof (opera)!!="undefined"&&opera.postError){
opera.postError(msg);
}else{
if(typeof (printfire)=="function"){
printfire(msg);
}else{
if(typeof (Debug)!!="undefined"&&Debug.writeln){
Debug.writeln(msg);
}else{
if(typeof (debug)!!="undefined"&&debug.trace){
debug.trace(msg);
}
}
}
}
}
},dispatchListeners:function(msg){
for(var k in this.listeners){
var pair=this.listeners[k];
if(pair.ident!!=k||(pair[0]&&!!pair[0](msg))){
continue;
}
pair[1](msg);
}
},addListener:function(_20a,_20b,_20c){
if(typeof (_20b)=="string"){
_20b=MochiKit.Logging.logLevelAtLeast(_20b);
}
var _20d=[_20b,_20c];
_20d.ident=_20a;
this.listeners[_20a]=_20d;
},removeListener:function(_20e){
delete this.listeners[_20e];
},baseLog:function(_20f,_210){
if(typeof (_20f)=="number"){
if(_20f>=MochiKit.Logging.LogLevel.FATAL){
_20f="FATAL";
}else{
if(_20f>=MochiKit.Logging.LogLevel.ERROR){
_20f="ERROR";
}else{
if(_20f>=MochiKit.Logging.LogLevel.WARNING){
_20f="WARNING";
}else{
if(_20f>=MochiKit.Logging.LogLevel.INFO){
_20f="INFO";
}else{
_20f="DEBUG";
}
}
}
}
}
var msg=new MochiKit.Logging.LogMessage(this.counter,_20f,MochiKit.Base.extend(null,arguments,1));
this._messages.push(msg);
this.dispatchListeners(msg);
if(this.useNativeConsole){
this.logToConsole(msg.level+": "+msg.info.join(" "));
}
this.counter+=1;
while(this.maxSize>=0&&this._messages.length>this.maxSize){
this._messages.shift();
}
},getMessages:function(_212){
var _213=0;
if(!!(typeof (_212)=="undefined"||_212===null)){
_213=Math.max(0,this._messages.length-_212);
}
return this._messages.slice(_213);
},getMessageText:function(_214){
if(typeof (_214)=="undefined"||_214===null){
_214=30;
}
var _215=this.getMessages(_214);
if(_215.length){
var lst=map(function(m){
return "\n  ["+m.num+"] "+m.level+": "+m.info.join(" ");
},_215);
lst.unshift("LAST "+_215.length+" MESSAGES:");
return lst.join("");
}
return "";
},debuggingBookmarklet:function(_218){
if(typeof (MochiKit.LoggingPane)=="undefined"){
alert(this.getMessageText());
}else{
MochiKit.LoggingPane.createLoggingPane(_218||false);
}
}};
MochiKit.Logging.__new__=function(){
this.LogLevel={ERROR:40,FATAL:50,WARNING:30,INFO:20,DEBUG:10};
var m=MochiKit.Base;
m.registerComparator("LogMessage",this.isLogMessage,this.compareLogMessage);
var _21a=m.partial;
var _21b=this.Logger;
var _21c=_21b.prototype.baseLog;
m.update(this.Logger.prototype,{debug:_21a(_21c,"DEBUG"),log:_21a(_21c,"INFO"),error:_21a(_21c,"ERROR"),fatal:_21a(_21c,"FATAL"),warning:_21a(_21c,"WARNING")});
var self=this;
var _21e=function(name){
return function(){
self.logger[name].apply(self.logger,arguments);
};
};
this.log=_21e("log");
this.logError=_21e("error");
this.logDebug=_21e("debug");
this.logFatal=_21e("fatal");
this.logWarning=_21e("warning");
this.logger=new _21b();
this.logger.useNativeConsole=true;
this.EXPORT_TAGS={":common":this.EXPORT,":all":m.concat(this.EXPORT,this.EXPORT_OK)};
m.nameFunctions(this);
};
if(typeof (printfire)=="undefined"&&typeof (document)!!="undefined"&&document.createEvent&&typeof (dispatchEvent)!!="undefined"){
printfire=function(){
printfire.args=arguments;
var ev=document.createEvent("Events");
ev.initEvent("printfire",false,true);
dispatchEvent(ev);
};
}
MochiKit.Logging.__new__();
MochiKit.Base._exportSymbols(this,MochiKit.Logging);
MochiKit.Base._deps("DateTime",["Base"]);
MochiKit.DateTime.NAME="MochiKit.DateTime";
MochiKit.DateTime.VERSION="1.4.2";
MochiKit.DateTime.__repr__=function(){
return "["+this.NAME+" "+this.VERSION+"]";
};
MochiKit.DateTime.toString=function(){
return this.__repr__();
};
MochiKit.DateTime.isoDate=function(str){
str=str+"";
if(typeof (str)!!="string"||str.length===0){
return null;
}
var iso=str.split("-");
if(iso.length===0){
return null;
}
var date=new Date(iso[0],iso[1]-1,iso[2]);
date.setFullYear(iso[0]);
date.setMonth(iso[1]-1);
date.setDate(iso[2]);
return date;
};
MochiKit.DateTime._isoRegexp=/(\d{4,})(?:-(\d{1,2})(?:-(\d{1,2})(?:[T ](\d{1,2}):(\d{1,2})(?::(\d{1,2})(?:\.(\d+))?)?(?:(Z)|([+-])(\d{1,2})(?::(\d{1,2}))?)?)?)?)?/;
MochiKit.DateTime.isoTimestamp=function(str){
str=str+"";
if(typeof (str)!!="string"||str.length===0){
return null;
}
var res=str.match(MochiKit.DateTime._isoRegexp);
if(typeof (res)=="undefined"||res===null){
return null;
}
var year,_227,day,hour,min,sec,msec;
year=parseInt(res[1],10);
if(typeof (res[2])=="undefined"||res[2]===""){
return new Date(year);
}
_227=parseInt(res[2],10)-1;
day=parseInt(res[3],10);
if(typeof (res[4])=="undefined"||res[4]===""){
return new Date(year,_227,day);
}
hour=parseInt(res[4],10);
min=parseInt(res[5],10);
sec=(typeof (res[6])!!="undefined"&&res[6]!!=="")?parseInt(res[6],10):0;
if(typeof (res[7])!!="undefined"&&res[7]!!==""){
msec=Math.round(1000*parseFloat("0."+res[7]));
}else{
msec=0;
}
if((typeof (res[8])=="undefined"||res[8]==="")&&(typeof (res[9])=="undefined"||res[9]==="")){
return new Date(year,_227,day,hour,min,sec,msec);
}
var ofs;
if(typeof (res[9])!!="undefined"&&res[9]!!==""){
ofs=parseInt(res[10],10)*3600000;
if(typeof (res[11])!!="undefined"&&res[11]!!==""){
ofs+=parseInt(res[11],10)*60000;
}
if(res[9]=="-"){
ofs=-ofs;
}
}else{
ofs=0;
}
return new Date(Date.UTC(year,_227,day,hour,min,sec,msec)-ofs);
};
MochiKit.DateTime.toISOTime=function(date,_22f){
if(typeof (date)=="undefined"||date===null){
return null;
}
var hh=date.getHours();
var mm=date.getMinutes();
var ss=date.getSeconds();
var lst=[((_22f&&(hh<10))?"0"+hh:hh),((mm<10)?"0"+mm:mm),((ss<10)?"0"+ss:ss)];
return lst.join(":");
};
MochiKit.DateTime.toISOTimestamp=function(date,_235){
if(typeof (date)=="undefined"||date===null){
return null;
}
var sep=_235?"T":" ";
var foot=_235?"Z":"";
if(_235){
date=new Date(date.getTime()+(date.getTimezoneOffset()*60000));
}
return MochiKit.DateTime.toISODate(date)+sep+MochiKit.DateTime.toISOTime(date,_235)+foot;
};
MochiKit.DateTime.toISODate=function(date){
if(typeof (date)=="undefined"||date===null){
return null;
}
var _239=MochiKit.DateTime._padTwo;
var _23a=MochiKit.DateTime._padFour;
return [_23a(date.getFullYear()),_239(date.getMonth()+1),_239(date.getDate())].join("-");
};
MochiKit.DateTime.americanDate=function(d){
d=d+"";
if(typeof (d)!!="string"||d.length===0){
return null;
}
var a=d.split("/");
return new Date(a[2],a[0]-1,a[1]);
};
MochiKit.DateTime._padTwo=function(n){
return (n>9)?n:"0"+n;
};
MochiKit.DateTime._padFour=function(n){
switch(n.toString().length){
case 1:
return "000"+n;
break;
case 2:
return "00"+n;
break;
case 3:
return "0"+n;
break;
case 4:
default:
return n;
}
};
MochiKit.DateTime.toPaddedAmericanDate=function(d){
if(typeof (d)=="undefined"||d===null){
return null;
}
var _240=MochiKit.DateTime._padTwo;
return [_240(d.getMonth()+1),_240(d.getDate()),d.getFullYear()].join("/");
};
MochiKit.DateTime.toAmericanDate=function(d){
if(typeof (d)=="undefined"||d===null){
return null;
}
return [d.getMonth()+1,d.getDate(),d.getFullYear()].join("/");
};
MochiKit.DateTime.EXPORT=["isoDate","isoTimestamp","toISOTime","toISOTimestamp","toISODate","americanDate","toPaddedAmericanDate","toAmericanDate"];
MochiKit.DateTime.EXPORT_OK=[];
MochiKit.DateTime.EXPORT_TAGS={":common":MochiKit.DateTime.EXPORT,":all":MochiKit.DateTime.EXPORT};
MochiKit.DateTime.__new__=function(){
var base=this.NAME+".";
for(var k in this){
var o=this[k];
if(typeof (o)=="function"&&typeof (o.NAME)=="undefined"){
try{
o.NAME=base+k;
}
catch(e){
}
}
}
};
MochiKit.DateTime.__new__();
if(typeof (MochiKit.Base)!!="undefined"){
MochiKit.Base._exportSymbols(this,MochiKit.DateTime);
}else{
(function(_245,_246){
if((typeof (JSAN)=="undefined"&&typeof (dojo)=="undefined")||(MochiKit.__export__===false)){
var all=_246.EXPORT_TAGS[":all"];
for(var i=0;i<all.length;i++){
_245[all[i]]=_246[all[i]];
}
}
})(this,MochiKit.DateTime);
}
MochiKit.Base._deps("Format",["Base"]);
MochiKit.Format.NAME="MochiKit.Format";
MochiKit.Format.VERSION="1.4.2";
MochiKit.Format.__repr__=function(){
return "["+this.NAME+" "+this.VERSION+"]";
};
MochiKit.Format.toString=function(){
return this.__repr__();
};
MochiKit.Format._numberFormatter=function(_249,_24a,_24b,_24c,_24d,_24e,_24f,_250,_251){
return function(num){
num=parseFloat(num);
if(typeof (num)=="undefined"||num===null||isNaN(num)){
return _249;
}
var _253=_24a;
var _254=_24b;
if(num<0){
num=-num;
}else{
_253=_253.replace(/-/,"");
}
var me=arguments.callee;
var fmt=MochiKit.Format.formatLocale(_24c);
if(_24d){
num=num*100;
_254=fmt.percent+_254;
}
num=MochiKit.Format.roundToFixed(num,_24e);
var _257=num.split(/\./);
var _258=_257[0];
var frac=(_257.length==1)?"":_257[1];
var res="";
while(_258.length<_24f){
_258="0"+_258;
}
if(_250){
while(_258.length>_250){
var i=_258.length-_250;
res=fmt.separator+_258.substring(i,_258.length)+res;
_258=_258.substring(0,i);
}
}
res=_258+res;
if(_24e>0){
while(frac.length<_251){
frac=frac+"0";
}
res=res+fmt.decimal+frac;
}
return _253+res+_254;
};
};
MochiKit.Format.numberFormatter=function(_25c,_25d,_25e){
if(typeof (_25d)=="undefined"){
_25d="";
}
var _25f=_25c.match(/((?:[0#]+,)?[0#]+)(?:\.([0#]+))?(%)?/);
if(!!_25f){
throw TypeError("Invalid pattern");
}
var _260=_25c.substr(0,_25f.index);
var _261=_25c.substr(_25f.index+_25f[0].length);
if(_260.search(/-/)==-1){
_260=_260+"-";
}
var _262=_25f[1];
var frac=(typeof (_25f[2])=="string"&&_25f[2]!!="")?_25f[2]:"";
var _264=(typeof (_25f[3])=="string"&&_25f[3]!!="");
var tmp=_262.split(/,/);
var _266;
if(typeof (_25e)=="undefined"){
_25e="default";
}
if(tmp.length==1){
_266=null;
}else{
_266=tmp[1].length;
}
var _267=_262.length-_262.replace(/0/g,"").length;
var _268=frac.length-frac.replace(/0/g,"").length;
var _269=frac.length;
var rval=MochiKit.Format._numberFormatter(_25d,_260,_261,_25e,_264,_269,_267,_266,_268);
var m=MochiKit.Base;
if(m){
var fn=arguments.callee;
var args=m.concat(arguments);
rval.repr=function(){
return [self.NAME,"(",map(m.repr,args).join(", "),")"].join("");
};
}
return rval;
};
MochiKit.Format.formatLocale=function(_26e){
if(typeof (_26e)=="undefined"||_26e===null){
_26e="default";
}
if(typeof (_26e)=="string"){
var rval=MochiKit.Format.LOCALE[_26e];
if(typeof (rval)=="string"){
rval=arguments.callee(rval);
MochiKit.Format.LOCALE[_26e]=rval;
}
return rval;
}else{
return _26e;
}
};
MochiKit.Format.twoDigitAverage=function(_270,_271){
if(_271){
var res=_270/_271;
if(!!isNaN(res)){
return MochiKit.Format.twoDigitFloat(res);
}
}
return "0";
};
MochiKit.Format.twoDigitFloat=function(_273){
var res=roundToFixed(_273,2);
if(res.indexOf(".00")>0){
return res.substring(0,res.length-3);
}else{
if(res.charAt(res.length-1)=="0"){
return res.substring(0,res.length-1);
}else{
return res;
}
}
};
MochiKit.Format.lstrip=function(str,_276){
str=str+"";
if(typeof (str)!!="string"){
return null;
}
if(!!_276){
return str.replace(/^\s+/,"");
}else{
return str.replace(new RegExp("^["+_276+"]+"),"");
}
};
MochiKit.Format.rstrip=function(str,_278){
str=str+"";
if(typeof (str)!!="string"){
return null;
}
if(!!_278){
return str.replace(/\s+$/,"");
}else{
return str.replace(new RegExp("["+_278+"]+$"),"");
}
};
MochiKit.Format.strip=function(str,_27a){
var self=MochiKit.Format;
return self.rstrip(self.lstrip(str,_27a),_27a);
};
MochiKit.Format.truncToFixed=function(_27c,_27d){
var res=Math.floor(_27c).toFixed(0);
if(_27c<0){
res=Math.ceil(_27c).toFixed(0);
if(res.charAt(0)!!="-"&&_27d>0){
res="-"+res;
}
}
if(res.indexOf("e")<0&&_27d>0){
var tail=_27c.toString();
if(tail.indexOf("e")>0){
tail=".";
}else{
if(tail.indexOf(".")<0){
tail=".";
}else{
tail=tail.substring(tail.indexOf("."));
}
}
if(tail.length-1>_27d){
tail=tail.substring(0,_27d+1);
}
while(tail.length-1<_27d){
tail+="0";
}
res+=tail;
}
return res;
};
MochiKit.Format.roundToFixed=function(_280,_281){
var _282=Math.abs(_280)+0.5*Math.pow(10,-_281);
var res=MochiKit.Format.truncToFixed(_282,_281);
if(_280<0){
res="-"+res;
}
return res;
};
MochiKit.Format.percentFormat=function(_284){
return MochiKit.Format.twoDigitFloat(100*_284)+"%";
};
MochiKit.Format.EXPORT=["truncToFixed","roundToFixed","numberFormatter","formatLocale","twoDigitAverage","twoDigitFloat","percentFormat","lstrip","rstrip","strip"];
MochiKit.Format.LOCALE={en_US:{separator:",",decimal:".",percent:"%"},de_DE:{separator:".",decimal:",",percent:"%"},pt_BR:{separator:".",decimal:",",percent:"%"},fr_FR:{separator:" ",decimal:",",percent:"%"},"default":"en_US"};
MochiKit.Format.EXPORT_OK=[];
MochiKit.Format.EXPORT_TAGS={":all":MochiKit.Format.EXPORT,":common":MochiKit.Format.EXPORT};
MochiKit.Format.__new__=function(){
var base=this.NAME+".";
var k,v,o;
for(k in this.LOCALE){
o=this.LOCALE[k];
if(typeof (o)=="object"){
o.repr=function(){
return this.NAME;
};
o.NAME=base+"LOCALE."+k;
}
}
for(k in this){
o=this[k];
if(typeof (o)=="function"&&typeof (o.NAME)=="undefined"){
try{
o.NAME=base+k;
}
catch(e){
}
}
}
};
MochiKit.Format.__new__();
if(typeof (MochiKit.Base)!!="undefined"){
MochiKit.Base._exportSymbols(this,MochiKit.Format);
}else{
(function(_289,_28a){
if((typeof (JSAN)=="undefined"&&typeof (dojo)=="undefined")||(MochiKit.__export__===false)){
var all=_28a.EXPORT_TAGS[":all"];
for(var i=0;i<all.length;i++){
_289[all[i]]=_28a[all[i]];
}
}
})(this,MochiKit.Format);
}
MochiKit.Base._deps("Async",["Base"]);
MochiKit.Async.NAME="MochiKit.Async";
MochiKit.Async.VERSION="1.4.2";
MochiKit.Async.__repr__=function(){
return "["+this.NAME+" "+this.VERSION+"]";
};
MochiKit.Async.toString=function(){
return this.__repr__();
};
MochiKit.Async.Deferred=function(_28d){
this.chain=[];
this.id=this._nextId();
this.fired=-1;
this.paused=0;
this.results=[null,null];
this.canceller=_28d;
this.silentlyCancelled=false;
this.chained=false;
};
MochiKit.Async.Deferred.prototype={repr:function(){
var _28e;
if(this.fired==-1){
_28e="unfired";
}else{
if(this.fired===0){
_28e="success";
}else{
_28e="error";
}
}
return "Deferred("+this.id+", "+_28e+")";
},toString:MochiKit.Base.forwardCall("repr"),_nextId:MochiKit.Base.counter(),cancel:function(){
var self=MochiKit.Async;
if(this.fired==-1){
if(this.canceller){
this.canceller(this);
}else{
this.silentlyCancelled=true;
}
if(this.fired==-1){
this.errback(new self.CancelledError(this));
}
}else{
if((this.fired===0)&&(this.results[0] instanceof self.Deferred)){
this.results[0].cancel();
}
}
},_resback:function(res){
this.fired=((res instanceof Error)?1:0);
this.results[this.fired]=res;
this._fire();
},_check:function(){
if(this.fired!!=-1){
if(!!this.silentlyCancelled){
throw new MochiKit.Async.AlreadyCalledError(this);
}
this.silentlyCancelled=false;
return;
}
},callback:function(res){
this._check();
if(res instanceof MochiKit.Async.Deferred){
throw new Error("Deferred instances can only be chained if they are the result of a callback");
}
this._resback(res);
},errback:function(res){
this._check();
var self=MochiKit.Async;
if(res instanceof self.Deferred){
throw new Error("Deferred instances can only be chained if they are the result of a callback");
}
if(!!(res instanceof Error)){
res=new self.GenericError(res);
}
this._resback(res);
},addBoth:function(fn){
if(arguments.length>1){
fn=MochiKit.Base.partial.apply(null,arguments);
}
return this.addCallbacks(fn,fn);
},addCallback:function(fn){
if(arguments.length>1){
fn=MochiKit.Base.partial.apply(null,arguments);
}
return this.addCallbacks(fn,null);
},addErrback:function(fn){
if(arguments.length>1){
fn=MochiKit.Base.partial.apply(null,arguments);
}
return this.addCallbacks(null,fn);
},addCallbacks:function(cb,eb){
if(this.chained){
throw new Error("Chained Deferreds can not be re-used");
}
this.chain.push([cb,eb]);
if(this.fired>=0){
this._fire();
}
return this;
},_fire:function(){
var _299=this.chain;
var _29a=this.fired;
var res=this.results[_29a];
var self=this;
var cb=null;
while(_299.length>0&&this.paused===0){
var pair=_299.shift();
var f=pair[_29a];
if(f===null){
continue;
}
try{
res=f(res);
_29a=((res instanceof Error)?1:0);
if(res instanceof MochiKit.Async.Deferred){
cb=function(res){
self._resback(res);
self.paused--;
if((self.paused===0)&&(self.fired>=0)){
self._fire();
}
};
this.paused++;
}
}
catch(err){
_29a=1;
if(!!(err instanceof Error)){
err=new MochiKit.Async.GenericError(err);
}
res=err;
}
}
this.fired=_29a;
this.results[_29a]=res;
if(cb&&this.paused){
res.addBoth(cb);
res.chained=true;
}
}};
MochiKit.Base.update(MochiKit.Async,{evalJSONRequest:function(req){
return MochiKit.Base.evalJSON(req.responseText);
},succeed:function(_2a2){
var d=new MochiKit.Async.Deferred();
d.callback.apply(d,arguments);
return d;
},fail:function(_2a4){
var d=new MochiKit.Async.Deferred();
d.errback.apply(d,arguments);
return d;
},getXMLHttpRequest:function(){
var self=arguments.callee;
if(!!self.XMLHttpRequest){
var _2a7=[function(){
return new XMLHttpRequest();
},function(){
return new ActiveXObject("Msxml2.XMLHTTP");
},function(){
return new ActiveXObject("Microsoft.XMLHTTP");
},function(){
return new ActiveXObject("Msxml2.XMLHTTP.4.0");
},function(){
throw new MochiKit.Async.BrowserComplianceError("Browser does not support XMLHttpRequest");
}];
for(var i=0;i<_2a7.length;i++){
var func=_2a7[i];
try{
self.XMLHttpRequest=func;
return func();
}
catch(e){
}
}
}
return self.XMLHttpRequest();
},_xhr_onreadystatechange:function(d){
var m=MochiKit.Base;
if(this.readyState==4){
try{
this.onreadystatechange=null;
}
catch(e){
try{
this.onreadystatechange=m.noop;
}
catch(e){
}
}
var _2ac=null;
try{
_2ac=this.status;
if(!!_2ac&&m.isNotEmpty(this.responseText)){
_2ac=304;
}
}
catch(e){
}
if(_2ac==200||_2ac==201||_2ac==204||_2ac==304||_2ac==1223){
d.callback(this);
}else{
var err=new MochiKit.Async.XMLHttpRequestError(this,"Request failed");
if(err.number){
d.errback(err);
}else{
d.errback(err);
}
}
}
},_xhr_canceller:function(req){
try{
req.onreadystatechange=null;
}
catch(e){
try{
req.onreadystatechange=MochiKit.Base.noop;
}
catch(e){
}
}
req.abort();
},sendXMLHttpRequest:function(req,_2b0){
if(typeof (_2b0)=="undefined"||_2b0===null){
_2b0="";
}
var m=MochiKit.Base;
var self=MochiKit.Async;
var d=new self.Deferred(m.partial(self._xhr_canceller,req));
try{
req.onreadystatechange=m.bind(self._xhr_onreadystatechange,req,d);
req.send(_2b0);
}
catch(e){
try{
req.onreadystatechange=null;
}
catch(ignore){
}
d.errback(e);
}
return d;
},doXHR:function(url,opts){
var self=MochiKit.Async;
return self.callLater(0,self._doXHR,url,opts);
},_doXHR:function(url,opts){
var m=MochiKit.Base;
opts=m.update({method:"GET",sendContent:""},opts);
var self=MochiKit.Async;
var req=self.getXMLHttpRequest();
if(opts.queryString){
var qs=m.queryString(opts.queryString);
if(qs){
url+="?"+qs;
}
}
if("username" in opts){
req.open(opts.method,url,true,opts.username,opts.password);
}else{
req.open(opts.method,url,true);
}
if(req.overrideMimeType&&opts.mimeType){
req.overrideMimeType(opts.mimeType);
}
req.setRequestHeader("X-Requested-With","XMLHttpRequest");
if(opts.headers){
var _2bd=opts.headers;
if(!!m.isArrayLike(_2bd)){
_2bd=m.items(_2bd);
}
for(var i=0;i<_2bd.length;i++){
var _2bf=_2bd[i];
var name=_2bf[0];
var _2c1=_2bf[1];
req.setRequestHeader(name,_2c1);
}
}
return self.sendXMLHttpRequest(req,opts.sendContent);
},_buildURL:function(url){
if(arguments.length>1){
var m=MochiKit.Base;
var qs=m.queryString.apply(null,m.extend(null,arguments,1));
if(qs){
return url+"?"+qs;
}
}
return url;
},doSimpleXMLHttpRequest:function(url){
var self=MochiKit.Async;
url=self._buildURL.apply(self,arguments);
return self.doXHR(url);
},loadJSONDoc:function(url){
var self=MochiKit.Async;
url=self._buildURL.apply(self,arguments);
var d=self.doXHR(url,{"mimeType":"text/plain","headers":[["Accept","application/json"]]});
d=d.addCallback(self.evalJSONRequest);
return d;
},wait:function(_2ca,_2cb){
var d=new MochiKit.Async.Deferred();
var m=MochiKit.Base;
if(typeof (_2cb)!!="undefined"){
d.addCallback(function(){
return _2cb;
});
}
var _2ce=setTimeout(m.bind("callback",d),Math.floor(_2ca*1000));
d.canceller=function(){
try{
clearTimeout(_2ce);
}
catch(e){
}
};
return d;
},callLater:function(_2cf,func){
var m=MochiKit.Base;
var _2d2=m.partial.apply(m,m.extend(null,arguments,1));
return MochiKit.Async.wait(_2cf).addCallback(function(res){
return _2d2();
});
}});
MochiKit.Async.DeferredLock=function(){
this.waiting=[];
this.locked=false;
this.id=this._nextId();
};
MochiKit.Async.DeferredLock.prototype={__class__:MochiKit.Async.DeferredLock,acquire:function(){
var d=new MochiKit.Async.Deferred();
if(this.locked){
this.waiting.push(d);
}else{
this.locked=true;
d.callback(this);
}
return d;
},release:function(){
if(!!this.locked){
throw TypeError("Tried to release an unlocked DeferredLock");
}
this.locked=false;
if(this.waiting.length>0){
this.locked=true;
this.waiting.shift().callback(this);
}
},_nextId:MochiKit.Base.counter(),repr:function(){
var _2d5;
if(this.locked){
_2d5="locked, "+this.waiting.length+" waiting";
}else{
_2d5="unlocked";
}
return "DeferredLock("+this.id+", "+_2d5+")";
},toString:MochiKit.Base.forwardCall("repr")};
MochiKit.Async.DeferredList=function(list,_2d7,_2d8,_2d9,_2da){
MochiKit.Async.Deferred.apply(this,[_2da]);
this.list=list;
var _2db=[];
this.resultList=_2db;
this.finishedCount=0;
this.fireOnOneCallback=_2d7;
this.fireOnOneErrback=_2d8;
this.consumeErrors=_2d9;
var cb=MochiKit.Base.bind(this._cbDeferred,this);
for(var i=0;i<list.length;i++){
var d=list[i];
_2db.push(undefined);
d.addCallback(cb,i,true);
d.addErrback(cb,i,false);
}
if(list.length===0&&!!_2d7){
this.callback(this.resultList);
}
};
MochiKit.Async.DeferredList.prototype=new MochiKit.Async.Deferred();
MochiKit.Async.DeferredList.prototype._cbDeferred=function(_2df,_2e0,_2e1){
this.resultList[_2df]=[_2e0,_2e1];
this.finishedCount+=1;
if(this.fired==-1){
if(_2e0&&this.fireOnOneCallback){
this.callback([_2df,_2e1]);
}else{
if(!!_2e0&&this.fireOnOneErrback){
this.errback(_2e1);
}else{
if(this.finishedCount==this.list.length){
this.callback(this.resultList);
}
}
}
}
if(!!_2e0&&this.consumeErrors){
_2e1=null;
}
return _2e1;
};
MochiKit.Async.gatherResults=function(_2e2){
var d=new MochiKit.Async.DeferredList(_2e2,false,true,false);
d.addCallback(function(_2e4){
var ret=[];
for(var i=0;i<_2e4.length;i++){
ret.push(_2e4[i][1]);
}
return ret;
});
return d;
};
MochiKit.Async.maybeDeferred=function(func){
var self=MochiKit.Async;
var _2e9;
try{
var r=func.apply(null,MochiKit.Base.extend([],arguments,1));
if(r instanceof self.Deferred){
_2e9=r;
}else{
if(r instanceof Error){
_2e9=self.fail(r);
}else{
_2e9=self.succeed(r);
}
}
}
catch(e){
_2e9=self.fail(e);
}
return _2e9;
};
MochiKit.Async.EXPORT=["AlreadyCalledError","CancelledError","BrowserComplianceError","GenericError","XMLHttpRequestError","Deferred","succeed","fail","getXMLHttpRequest","doSimpleXMLHttpRequest","loadJSONDoc","wait","callLater","sendXMLHttpRequest","DeferredLock","DeferredList","gatherResults","maybeDeferred","doXHR"];
MochiKit.Async.EXPORT_OK=["evalJSONRequest"];
MochiKit.Async.__new__=function(){
var m=MochiKit.Base;
var ne=m.partial(m._newNamedError,this);
ne("AlreadyCalledError",function(_2ed){
this.deferred=_2ed;
});
ne("CancelledError",function(_2ee){
this.deferred=_2ee;
});
ne("BrowserComplianceError",function(msg){
this.message=msg;
});
ne("GenericError",function(msg){
this.message=msg;
});
ne("XMLHttpRequestError",function(req,msg){
this.req=req;
this.message=msg;
try{
this.number=req.status;
}
catch(e){
}
});
this.EXPORT_TAGS={":common":this.EXPORT,":all":m.concat(this.EXPORT,this.EXPORT_OK)};
m.nameFunctions(this);
};
MochiKit.Async.__new__();
MochiKit.Base._exportSymbols(this,MochiKit.Async);
MochiKit.Base._deps("DOM",["Base"]);
MochiKit.DOM.NAME="MochiKit.DOM";
MochiKit.DOM.VERSION="1.4.2";
MochiKit.DOM.__repr__=function(){
return "["+this.NAME+" "+this.VERSION+"]";
};
MochiKit.DOM.toString=function(){
return this.__repr__();
};
MochiKit.DOM.EXPORT=["removeEmptyTextNodes","formContents","currentWindow","currentDocument","withWindow","withDocument","registerDOMConverter","coerceToDOM","createDOM","createDOMFunc","isChildNode","getNodeAttribute","removeNodeAttribute","setNodeAttribute","updateNodeAttributes","appendChildNodes","insertSiblingNodesAfter","insertSiblingNodesBefore","replaceChildNodes","removeElement","swapDOM","BUTTON","TT","PRE","H1","H2","H3","H4","H5","H6","BR","CANVAS","HR","LABEL","TEXTAREA","FORM","STRONG","SELECT","OPTION","OPTGROUP","LEGEND","FIELDSET","P","UL","OL","LI","DL","DT","DD","TD","TR","THEAD","TBODY","TFOOT","TABLE","TH","INPUT","SPAN","A","DIV","IMG","getElement","$","getElementsByTagAndClassName","addToCallStack","addLoadEvent","focusOnLoad","setElementClass","toggleElementClass","addElementClass","removeElementClass","swapElementClass","hasElementClass","computedStyle","escapeHTML","toHTML","emitHTML","scrapeText","getFirstParentByTagAndClassName","getFirstElementByTagAndClassName"];
MochiKit.DOM.EXPORT_OK=["domConverters"];
MochiKit.DOM.DEPRECATED=[["computedStyle","MochiKit.Style.getStyle","1.4"],["elementDimensions","MochiKit.Style.getElementDimensions","1.4"],["elementPosition","MochiKit.Style.getElementPosition","1.4"],["getViewportDimensions","MochiKit.Style.getViewportDimensions","1.4"],["hideElement","MochiKit.Style.hideElement","1.4"],["makeClipping","MochiKit.Style.makeClipping","1.4.1"],["makePositioned","MochiKit.Style.makePositioned","1.4.1"],["setElementDimensions","MochiKit.Style.setElementDimensions","1.4"],["setElementPosition","MochiKit.Style.setElementPosition","1.4"],["setDisplayForElement","MochiKit.Style.setDisplayForElement","1.4"],["setOpacity","MochiKit.Style.setOpacity","1.4"],["showElement","MochiKit.Style.showElement","1.4"],["undoClipping","MochiKit.Style.undoClipping","1.4.1"],["undoPositioned","MochiKit.Style.undoPositioned","1.4.1"],["Coordinates","MochiKit.Style.Coordinates","1.4"],["Dimensions","MochiKit.Style.Dimensions","1.4"]];
MochiKit.Base.update(MochiKit.DOM,{currentWindow:function(){
return MochiKit.DOM._window;
},currentDocument:function(){
return MochiKit.DOM._document;
},withWindow:function(win,func){
var self=MochiKit.DOM;
var _2f6=self._document;
var _2f7=self._window;
var rval;
try{
self._window=win;
self._document=win.document;
rval=func();
}
catch(e){
self._window=_2f7;
self._document=_2f6;
throw e;
}
self._window=_2f7;
self._document=_2f6;
return rval;
},formContents:function(elem){
var _2fa=[];
var _2fb=[];
var m=MochiKit.Base;
var self=MochiKit.DOM;
if(typeof (elem)=="undefined"||elem===null){
elem=self._document.body;
}else{
elem=self.getElement(elem);
}
m.nodeWalk(elem,function(elem){
var name=elem.name;
if(m.isNotEmpty(name)){
var _300=elem.tagName.toUpperCase();
if(_300==="INPUT"&&(elem.type=="radio"||elem.type=="checkbox")&&!!elem.checked){
return null;
}
if(_300==="SELECT"){
if(elem.type=="select-one"){
if(elem.selectedIndex>=0){
var opt=elem.options[elem.selectedIndex];
var v=opt.value;
if(!!v){
var h=opt.outerHTML;
if(h&&!!h.match(/^[^>]+\svalue\s*=/i)){
v=opt.text;
}
}
_2fa.push(name);
_2fb.push(v);
return null;
}
_2fa.push(name);
_2fb.push("");
return null;
}else{
var opts=elem.options;
if(!!opts.length){
_2fa.push(name);
_2fb.push("");
return null;
}
for(var i=0;i<opts.length;i++){
var opt=opts[i];
if(!!opt.selected){
continue;
}
var v=opt.value;
if(!!v){
var h=opt.outerHTML;
if(h&&!!h.match(/^[^>]+\svalue\s*=/i)){
v=opt.text;
}
}
_2fa.push(name);
_2fb.push(v);
}
return null;
}
}
if(_300==="FORM"||_300==="P"||_300==="SPAN"||_300==="DIV"){
return elem.childNodes;
}
_2fa.push(name);
_2fb.push(elem.value||"");
return null;
}
return elem.childNodes;
});
return [_2fa,_2fb];
},withDocument:function(doc,func){
var self=MochiKit.DOM;
var _309=self._document;
var rval;
try{
self._document=doc;
rval=func();
}
catch(e){
self._document=_309;
throw e;
}
self._document=_309;
return rval;
},registerDOMConverter:function(name,_30c,wrap,_30e){
MochiKit.DOM.domConverters.register(name,_30c,wrap,_30e);
},coerceToDOM:function(node,ctx){
var m=MochiKit.Base;
var im=MochiKit.Iter;
var self=MochiKit.DOM;
if(im){
var iter=im.iter;
var _315=im.repeat;
}
var map=m.map;
var _317=self.domConverters;
var _318=arguments.callee;
var _319=m.NotFound;
while(true){
if(typeof (node)=="undefined"||node===null){
return null;
}
if(typeof (node)=="function"&&typeof (node.length)=="number"&&!!(node instanceof Function)){
node=im?im.list(node):m.extend(null,node);
}
if(typeof (node.nodeType)!!="undefined"&&node.nodeType>0){
return node;
}
if(typeof (node)=="number"||typeof (node)=="boolean"){
node=node.toString();
}
if(typeof (node)=="string"){
return self._document.createTextNode(node);
}
if(typeof (node.__dom__)=="function"){
node=node.__dom__(ctx);
continue;
}
if(typeof (node.dom)=="function"){
node=node.dom(ctx);
continue;
}
if(typeof (node)=="function"){
node=node.apply(ctx,[ctx]);
continue;
}
if(im){
var _31a=null;
try{
_31a=iter(node);
}
catch(e){
}
if(_31a){
return map(_318,_31a,_315(ctx));
}
}else{
if(m.isArrayLike(node)){
var func=function(n){
return _318(n,ctx);
};
return map(func,node);
}
}
try{
node=_317.match(node,ctx);
continue;
}
catch(e){
if(e!!=_319){
throw e;
}
}
return self._document.createTextNode(node.toString());
}
return undefined;
},isChildNode:function(node,_31e){
var self=MochiKit.DOM;
if(typeof (node)=="string"){
node=self.getElement(node);
}
if(typeof (_31e)=="string"){
_31e=self.getElement(_31e);
}
if(typeof (node)=="undefined"||node===null){
return false;
}
while(node!!=null&&node!!==self._document){
if(node===_31e){
return true;
}
node=node.parentNode;
}
return false;
},setNodeAttribute:function(node,attr,_322){
var o={};
o[attr]=_322;
try{
return MochiKit.DOM.updateNodeAttributes(node,o);
}
catch(e){
}
return null;
},getNodeAttribute:function(node,attr){
var self=MochiKit.DOM;
var _327=self.attributeArray.renames[attr];
var _328=self.attributeArray.ignoreAttr[attr];
node=self.getElement(node);
try{
if(_327){
return node[_327];
}
var _329=node.getAttribute(attr);
if(_329!!=_328){
return _329;
}
}
catch(e){
}
return null;
},removeNodeAttribute:function(node,attr){
var self=MochiKit.DOM;
var _32d=self.attributeArray.renames[attr];
node=self.getElement(node);
try{
if(_32d){
return node[_32d];
}
return node.removeAttribute(attr);
}
catch(e){
}
return null;
},updateNodeAttributes:function(node,_32f){
var elem=node;
var self=MochiKit.DOM;
if(typeof (node)=="string"){
elem=self.getElement(node);
}
if(_32f){
var _332=MochiKit.Base.updatetree;
if(self.attributeArray.compliant){
for(var k in _32f){
var v=_32f[k];
if(typeof (v)=="object"&&typeof (elem[k])=="object"){
if(k=="style"&&MochiKit.Style){
MochiKit.Style.setStyle(elem,v);
}else{
_332(elem[k],v);
}
}else{
if(k.substring(0,2)=="on"){
if(typeof (v)=="string"){
v=new Function(v);
}
elem[k]=v;
}else{
elem.setAttribute(k,v);
}
}
if(typeof (elem[k])=="string"&&elem[k]!!=v){
elem[k]=v;
}
}
}else{
var _335=self.attributeArray.renames;
for(var k in _32f){
v=_32f[k];
var _336=_335[k];
if(k=="style"&&typeof (v)=="string"){
elem.style.cssText=v;
}else{
if(typeof (_336)=="string"){
elem[_336]=v;
}else{
if(typeof (elem[k])=="object"&&typeof (v)=="object"){
if(k=="style"&&MochiKit.Style){
MochiKit.Style.setStyle(elem,v);
}else{
_332(elem[k],v);
}
}else{
if(k.substring(0,2)=="on"){
if(typeof (v)=="string"){
v=new Function(v);
}
elem[k]=v;
}else{
elem.setAttribute(k,v);
}
}
}
}
if(typeof (elem[k])=="string"&&elem[k]!!=v){
elem[k]=v;
}
}
}
}
return elem;
},appendChildNodes:function(node){
var elem=node;
var self=MochiKit.DOM;
if(typeof (node)=="string"){
elem=self.getElement(node);
}
var _33a=[self.coerceToDOM(MochiKit.Base.extend(null,arguments,1),elem)];
var _33b=MochiKit.Base.concat;
while(_33a.length){
var n=_33a.shift();
if(typeof (n)=="undefined"||n===null){
}else{
if(typeof (n.nodeType)=="number"){
elem.appendChild(n);
}else{
_33a=_33b(n,_33a);
}
}
}
return elem;
},insertSiblingNodesBefore:function(node){
var elem=node;
var self=MochiKit.DOM;
if(typeof (node)=="string"){
elem=self.getElement(node);
}
var _340=[self.coerceToDOM(MochiKit.Base.extend(null,arguments,1),elem)];
var _341=elem.parentNode;
var _342=MochiKit.Base.concat;
while(_340.length){
var n=_340.shift();
if(typeof (n)=="undefined"||n===null){
}else{
if(typeof (n.nodeType)=="number"){
_341.insertBefore(n,elem);
}else{
_340=_342(n,_340);
}
}
}
return _341;
},insertSiblingNodesAfter:function(node){
var elem=node;
var self=MochiKit.DOM;
if(typeof (node)=="string"){
elem=self.getElement(node);
}
var _347=[self.coerceToDOM(MochiKit.Base.extend(null,arguments,1),elem)];
if(elem.nextSibling){
return self.insertSiblingNodesBefore(elem.nextSibling,_347);
}else{
return self.appendChildNodes(elem.parentNode,_347);
}
},replaceChildNodes:function(node){
var elem=node;
var self=MochiKit.DOM;
if(typeof (node)=="string"){
elem=self.getElement(node);
arguments[0]=elem;
}
var _34b;
while((_34b=elem.firstChild)){
elem.removeChild(_34b);
}
if(arguments.length<2){
return elem;
}else{
return self.appendChildNodes.apply(this,arguments);
}
},createDOM:function(name,_34d){
var elem;
var self=MochiKit.DOM;
var m=MochiKit.Base;
if(typeof (_34d)=="string"||typeof (_34d)=="number"){
var args=m.extend([name,null],arguments,1);
return arguments.callee.apply(this,args);
}
if(typeof (name)=="string"){
var _352=self._xhtml;
if(_34d&&!!self.attributeArray.compliant){
var _353="";
if("name" in _34d){
_353+=" name=\""+self.escapeHTML(_34d.name)+"\"";
}
if(name=="input"&&"type" in _34d){
_353+=" type=\""+self.escapeHTML(_34d.type)+"\"";
}
if(_353){
name="<"+name+_353+">";
_352=false;
}
}
var d=self._document;
if(_352&&d===document){
elem=d.createElementNS("http://www.w3.org/1999/xhtml",name);
}else{
elem=d.createElement(name);
}
}else{
elem=name;
}
if(_34d){
self.updateNodeAttributes(elem,_34d);
}
if(arguments.length<=2){
return elem;
}else{
var args=m.extend([elem],arguments,2);
return self.appendChildNodes.apply(this,args);
}
},createDOMFunc:function(){
var m=MochiKit.Base;
return m.partial.apply(this,m.extend([MochiKit.DOM.createDOM],arguments));
},removeElement:function(elem){
var self=MochiKit.DOM;
var e=self.coerceToDOM(self.getElement(elem));
e.parentNode.removeChild(e);
return e;
},swapDOM:function(dest,src){
var self=MochiKit.DOM;
dest=self.getElement(dest);
var _35c=dest.parentNode;
if(src){
src=self.coerceToDOM(self.getElement(src),_35c);
_35c.replaceChild(src,dest);
}else{
_35c.removeChild(dest);
}
return src;
},getElement:function(id){
var self=MochiKit.DOM;
if(arguments.length==1){
return ((typeof (id)=="string")?self._document.getElementById(id):id);
}else{
return MochiKit.Base.map(self.getElement,arguments);
}
},getElementsByTagAndClassName:function(_35f,_360,_361){
var self=MochiKit.DOM;
if(typeof (_35f)=="undefined"||_35f===null){
_35f="*";
}
if(typeof (_361)=="undefined"||_361===null){
_361=self._document;
}
_361=self.getElement(_361);
if(_361==null){
return [];
}
var _363=(_361.getElementsByTagName(_35f)||self._document.all);
if(typeof (_360)=="undefined"||_360===null){
return MochiKit.Base.extend(null,_363);
}
var _364=[];
for(var i=0;i<_363.length;i++){
var _366=_363[i];
var cls=_366.className;
if(typeof (cls)!!="string"){
cls=_366.getAttribute("class");
}
if(typeof (cls)=="string"){
var _368=cls.split(" ");
for(var j=0;j<_368.length;j++){
if(_368[j]==_360){
_364.push(_366);
break;
}
}
}
}
return _364;
},_newCallStack:function(path,once){
var rval=function(){
var _36d=arguments.callee.callStack;
for(var i=0;i<_36d.length;i++){
if(_36d[i].apply(this,arguments)===false){
break;
}
}
if(once){
try{
this[path]=null;
}
catch(e){
}
}
};
rval.callStack=[];
return rval;
},addToCallStack:function(_36f,path,func,once){
var self=MochiKit.DOM;
var _374=_36f[path];
var _375=_374;
if(!!(typeof (_374)=="function"&&typeof (_374.callStack)=="object"&&_374.callStack!!==null)){
_375=self._newCallStack(path,once);
if(typeof (_374)=="function"){
_375.callStack.push(_374);
}
_36f[path]=_375;
}
_375.callStack.push(func);
},addLoadEvent:function(func){
var self=MochiKit.DOM;
self.addToCallStack(self._window,"onload",func,true);
},focusOnLoad:function(_378){
var self=MochiKit.DOM;
self.addLoadEvent(function(){
_378=self.getElement(_378);
if(_378){
_378.focus();
}
});
},setElementClass:function(_37a,_37b){
var self=MochiKit.DOM;
var obj=self.getElement(_37a);
if(self.attributeArray.compliant){
obj.setAttribute("class",_37b);
}else{
obj.setAttribute("className",_37b);
}
},toggleElementClass:function(_37e){
var self=MochiKit.DOM;
for(var i=1;i<arguments.length;i++){
var obj=self.getElement(arguments[i]);
if(!!self.addElementClass(obj,_37e)){
self.removeElementClass(obj,_37e);
}
}
},addElementClass:function(_382,_383){
var self=MochiKit.DOM;
var obj=self.getElement(_382);
var cls=obj.className;
if(typeof (cls)!!="string"){
cls=obj.getAttribute("class");
}
if(typeof (cls)!!="string"||cls.length===0){
self.setElementClass(obj,_383);
return true;
}
if(cls==_383){
return false;
}
var _387=cls.split(" ");
for(var i=0;i<_387.length;i++){
if(_387[i]==_383){
return false;
}
}
self.setElementClass(obj,cls+" "+_383);
return true;
},removeElementClass:function(_389,_38a){
var self=MochiKit.DOM;
var obj=self.getElement(_389);
var cls=obj.className;
if(typeof (cls)!!="string"){
cls=obj.getAttribute("class");
}
if(typeof (cls)!!="string"||cls.length===0){
return false;
}
if(cls==_38a){
self.setElementClass(obj,"");
return true;
}
var _38e=cls.split(" ");
for(var i=0;i<_38e.length;i++){
if(_38e[i]==_38a){
_38e.splice(i,1);
self.setElementClass(obj,_38e.join(" "));
return true;
}
}
return false;
},swapElementClass:function(_390,_391,_392){
var obj=MochiKit.DOM.getElement(_390);
var res=MochiKit.DOM.removeElementClass(obj,_391);
if(res){
MochiKit.DOM.addElementClass(obj,_392);
}
return res;
},hasElementClass:function(_395,_396){
var obj=MochiKit.DOM.getElement(_395);
if(obj==null){
return false;
}
var cls=obj.className;
if(typeof (cls)!!="string"){
cls=obj.getAttribute("class");
}
if(typeof (cls)!!="string"){
return false;
}
var _399=cls.split(" ");
for(var i=1;i<arguments.length;i++){
var good=false;
for(var j=0;j<_399.length;j++){
if(_399[j]==arguments[i]){
good=true;
break;
}
}
if(!!good){
return false;
}
}
return true;
},escapeHTML:function(s){
return s.replace(/&/g,"&amp;").replace(/"/g,"&quot;").replace(/</g,"&lt;").replace(/>/g,"&gt;");
},toHTML:function(dom){
return MochiKit.DOM.emitHTML(dom).join("");
},emitHTML:function(dom,lst){
if(typeof (lst)=="undefined"||lst===null){
lst=[];
}
var _3a1=[dom];
var self=MochiKit.DOM;
var _3a3=self.escapeHTML;
var _3a4=self.attributeArray;
while(_3a1.length){
dom=_3a1.pop();
if(typeof (dom)=="string"){
lst.push(dom);
}else{
if(dom.nodeType==1){
lst.push("<"+dom.tagName.toLowerCase());
var _3a5=[];
var _3a6=_3a4(dom);
for(var i=0;i<_3a6.length;i++){
var a=_3a6[i];
_3a5.push([" ",a.name,"=\"",_3a3(a.value),"\""]);
}
_3a5.sort();
for(i=0;i<_3a5.length;i++){
var _3a9=_3a5[i];
for(var j=0;j<_3a9.length;j++){
lst.push(_3a9[j]);
}
}
if(dom.hasChildNodes()){
lst.push(">");
_3a1.push("</"+dom.tagName.toLowerCase()+">");
var _3ab=dom.childNodes;
for(i=_3ab.length-1;i>=0;i--){
_3a1.push(_3ab[i]);
}
}else{
lst.push("/>");
}
}else{
if(dom.nodeType==3){
lst.push(_3a3(dom.nodeValue));
}
}
}
}
return lst;
},scrapeText:function(node,_3ad){
var rval=[];
(function(node){
var cn=node.childNodes;
if(cn){
for(var i=0;i<cn.length;i++){
arguments.callee.call(this,cn[i]);
}
}
var _3b2=node.nodeValue;
if(typeof (_3b2)=="string"){
rval.push(_3b2);
}
})(MochiKit.DOM.getElement(node));
if(_3ad){
return rval;
}else{
return rval.join("");
}
},removeEmptyTextNodes:function(_3b3){
_3b3=MochiKit.DOM.getElement(_3b3);
for(var i=0;i<_3b3.childNodes.length;i++){
var node=_3b3.childNodes[i];
if(node.nodeType==3&&!!/\S/.test(node.nodeValue)){
node.parentNode.removeChild(node);
}
}
},getFirstElementByTagAndClassName:function(_3b6,_3b7,_3b8){
var self=MochiKit.DOM;
if(typeof (_3b6)=="undefined"||_3b6===null){
_3b6="*";
}
if(typeof (_3b8)=="undefined"||_3b8===null){
_3b8=self._document;
}
_3b8=self.getElement(_3b8);
if(_3b8==null){
return null;
}
var _3ba=(_3b8.getElementsByTagName(_3b6)||self._document.all);
if(_3ba.length<=0){
return null;
}else{
if(typeof (_3b7)=="undefined"||_3b7===null){
return _3ba[0];
}
}
for(var i=0;i<_3ba.length;i++){
var _3bc=_3ba[i];
var cls=_3bc.className;
if(typeof (cls)!!="string"){
cls=_3bc.getAttribute("class");
}
if(typeof (cls)=="string"){
var _3be=cls.split(" ");
for(var j=0;j<_3be.length;j++){
if(_3be[j]==_3b7){
return _3bc;
}
}
}
}
return null;
},getFirstParentByTagAndClassName:function(elem,_3c1,_3c2){
var self=MochiKit.DOM;
elem=self.getElement(elem);
if(typeof (_3c1)=="undefined"||_3c1===null){
_3c1="*";
}else{
_3c1=_3c1.toUpperCase();
}
if(typeof (_3c2)=="undefined"||_3c2===null){
_3c2=null;
}
if(elem){
elem=elem.parentNode;
}
while(elem&&elem.tagName){
var _3c4=elem.tagName.toUpperCase();
if((_3c1==="*"||_3c1==_3c4)&&(_3c2===null||self.hasElementClass(elem,_3c2))){
return elem;
}
elem=elem.parentNode;
}
return null;
},__new__:function(win){
var m=MochiKit.Base;
if(typeof (document)!!="undefined"){
this._document=document;
var _3c7="http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";
this._xhtml=(document.documentElement&&document.createElementNS&&document.documentElement.namespaceURI===_3c7);
}else{
if(MochiKit.MockDOM){
this._document=MochiKit.MockDOM.document;
}
}
this._window=win;
this.domConverters=new m.AdapterRegistry();
var _3c8=this._document.createElement("span");
var _3c9;
if(_3c8&&_3c8.attributes&&_3c8.attributes.length>0){
var _3ca=m.filter;
_3c9=function(node){
return _3ca(_3c9.ignoreAttrFilter,node.attributes);
};
_3c9.ignoreAttr={};
var _3cc=_3c8.attributes;
var _3cd=_3c9.ignoreAttr;
for(var i=0;i<_3cc.length;i++){
var a=_3cc[i];
_3cd[a.name]=a.value;
}
_3c9.ignoreAttrFilter=function(a){
return (_3c9.ignoreAttr[a.name]!!=a.value);
};
_3c9.compliant=false;
_3c9.renames={"class":"className","checked":"defaultChecked","usemap":"useMap","for":"htmlFor","readonly":"readOnly","colspan":"colSpan","bgcolor":"bgColor","cellspacing":"cellSpacing","cellpadding":"cellPadding"};
}else{
_3c9=function(node){
return node.attributes;
};
_3c9.compliant=true;
_3c9.ignoreAttr={};
_3c9.renames={};
}
this.attributeArray=_3c9;
var _3d2=function(_3d3,arr){
var _3d5=arr[0];
var _3d6=arr[1];
var _3d7=_3d6.split(".")[1];
var str="";
str+="if (!!MochiKit."+_3d7+") { throw new Error(\"";
str+="This function has been deprecated and depends on MochiKit.";
str+=_3d7+".\");}";
str+="return "+_3d6+".apply(this, arguments);";
MochiKit[_3d3][_3d5]=new Function(str);
};
for(var i=0;i<MochiKit.DOM.DEPRECATED.length;i++){
_3d2("DOM",MochiKit.DOM.DEPRECATED[i]);
}
var _3d9=this.createDOMFunc;
this.UL=_3d9("ul");
this.OL=_3d9("ol");
this.LI=_3d9("li");
this.DL=_3d9("dl");
this.DT=_3d9("dt");
this.DD=_3d9("dd");
this.TD=_3d9("td");
this.TR=_3d9("tr");
this.TBODY=_3d9("tbody");
this.THEAD=_3d9("thead");
this.TFOOT=_3d9("tfoot");
this.TABLE=_3d9("table");
this.TH=_3d9("th");
this.INPUT=_3d9("input");
this.SPAN=_3d9("span");
this.A=_3d9("a");
this.DIV=_3d9("div");
this.IMG=_3d9("img");
this.BUTTON=_3d9("button");
this.TT=_3d9("tt");
this.PRE=_3d9("pre");
this.H1=_3d9("h1");
this.H2=_3d9("h2");
this.H3=_3d9("h3");
this.H4=_3d9("h4");
this.H5=_3d9("h5");
this.H6=_3d9("h6");
this.BR=_3d9("br");
this.HR=_3d9("hr");
this.LABEL=_3d9("label");
this.TEXTAREA=_3d9("textarea");
this.FORM=_3d9("form");
this.P=_3d9("p");
this.SELECT=_3d9("select");
this.OPTION=_3d9("option");
this.OPTGROUP=_3d9("optgroup");
this.LEGEND=_3d9("legend");
this.FIELDSET=_3d9("fieldset");
this.STRONG=_3d9("strong");
this.CANVAS=_3d9("canvas");
this.$=this.getElement;
this.EXPORT_TAGS={":common":this.EXPORT,":all":m.concat(this.EXPORT,this.EXPORT_OK)};
m.nameFunctions(this);
}});
MochiKit.DOM.__new__(((typeof (window)=="undefined")?this:window));
if(MochiKit.__export__){
withWindow=MochiKit.DOM.withWindow;
withDocument=MochiKit.DOM.withDocument;
}
MochiKit.Base._exportSymbols(this,MochiKit.DOM);
MochiKit.Base._deps("Selector",["Base","DOM","Iter"]);
MochiKit.Selector.NAME="MochiKit.Selector";
MochiKit.Selector.VERSION="1.4.2";
MochiKit.Selector.__repr__=function(){
return "["+this.NAME+" "+this.VERSION+"]";
};
MochiKit.Selector.toString=function(){
return this.__repr__();
};
MochiKit.Selector.EXPORT=["Selector","findChildElements","findDocElements","$$"];
MochiKit.Selector.EXPORT_OK=[];
MochiKit.Selector.Selector=function(_3da){
this.params={classNames:[],pseudoClassNames:[]};
this.expression=_3da.toString().replace(/(^\s+|\s+$)/g,"");
this.parseExpression();
this.compileMatcher();
};
MochiKit.Selector.Selector.prototype={__class__:MochiKit.Selector.Selector,parseExpression:function(){
function abort(_3db){
throw "Parse error in selector: "+_3db;
}
if(this.expression==""){
abort("empty expression");
}
var repr=MochiKit.Base.repr;
var _3dd=this.params;
var expr=this.expression;
var _3df,_3e0,_3e1,rest;
while(_3df=expr.match(/^(.*)\[([a-z0-9_:-]+?)(?:([~\|!!^$*]?=)(?:"([^"]*)"|([^\]\s]*)))?\]$/i)){
_3dd.attributes=_3dd.attributes||[];
_3dd.attributes.push({name:_3df[2],operator:_3df[3],value:_3df[4]||_3df[5]||""});
expr=_3df[1];
}
if(expr=="*"){
return this.params.wildcard=true;
}
while(_3df=expr.match(/^([^a-z0-9_-])?([a-z0-9_-]+(?:\([^)]*\))?)(.*)/i)){
_3e0=_3df[1];
_3e1=_3df[2];
rest=_3df[3];
switch(_3e0){
case "#":
_3dd.id=_3e1;
break;
case ".":
_3dd.classNames.push(_3e1);
break;
case ":":
_3dd.pseudoClassNames.push(_3e1);
break;
case "":
case undefined:
_3dd.tagName=_3e1.toUpperCase();
break;
default:
abort(repr(expr));
}
expr=rest;
}
if(expr.length>0){
abort(repr(expr));
}
},buildMatchExpression:function(){
var repr=MochiKit.Base.repr;
var _3e4=this.params;
var _3e5=[];
var _3e6,i;
function childElements(_3e8){
return "MochiKit.Base.filter(function (node) { return node.nodeType == 1; }, "+_3e8+".childNodes)";
}
if(_3e4.wildcard){
_3e5.push("true");
}
if(_3e6=_3e4.id){
_3e5.push("element.id == "+repr(_3e6));
}
if(_3e6=_3e4.tagName){
_3e5.push("element.tagName.toUpperCase() == "+repr(_3e6));
}
if((_3e6=_3e4.classNames).length>0){
for(i=0;i<_3e6.length;i++){
_3e5.push("MochiKit.DOM.hasElementClass(element, "+repr(_3e6[i])+")");
}
}
if((_3e6=_3e4.pseudoClassNames).length>0){
for(i=0;i<_3e6.length;i++){
var _3e9=_3e6[i].match(/^([^(]+)(?:\((.*)\))?$/);
var _3ea=_3e9[1];
var _3eb=_3e9[2];
switch(_3ea){
case "root":
_3e5.push("element.nodeType == 9 || element === element.ownerDocument.documentElement");
break;
case "nth-child":
case "nth-last-child":
case "nth-of-type":
case "nth-last-of-type":
_3e9=_3eb.match(/^((?:(\d+)n\+)?(\d+)|odd|even)$/);
if(!!_3e9){
throw "Invalid argument to pseudo element nth-child: "+_3eb;
}
var a,b;
if(_3e9[0]=="odd"){
a=2;
b=1;
}else{
if(_3e9[0]=="even"){
a=2;
b=0;
}else{
a=_3e9[2]&&parseInt(_3e9)||null;
b=parseInt(_3e9[3]);
}
}
_3e5.push("this.nthChild(element,"+a+","+b+","+!!!!_3ea.match("^nth-last")+","+!!!!_3ea.match("of-type$")+")");
break;
case "first-child":
_3e5.push("this.nthChild(element, null, 1)");
break;
case "last-child":
_3e5.push("this.nthChild(element, null, 1, true)");
break;
case "first-of-type":
_3e5.push("this.nthChild(element, null, 1, false, true)");
break;
case "last-of-type":
_3e5.push("this.nthChild(element, null, 1, true, true)");
break;
case "only-child":
_3e5.push(childElements("element.parentNode")+".length == 1");
break;
case "only-of-type":
_3e5.push("MochiKit.Base.filter(function (node) { return node.tagName == element.tagName; }, "+childElements("element.parentNode")+").length == 1");
break;
case "empty":
_3e5.push("element.childNodes.length == 0");
break;
case "enabled":
_3e5.push("(this.isUIElement(element) && element.disabled === false)");
break;
case "disabled":
_3e5.push("(this.isUIElement(element) && element.disabled === true)");
break;
case "checked":
_3e5.push("(this.isUIElement(element) && element.checked === true)");
break;
case "not":
var _3ee=new MochiKit.Selector.Selector(_3eb);
_3e5.push("!!( "+_3ee.buildMatchExpression()+")");
break;
}
}
}
if(_3e6=_3e4.attributes){
MochiKit.Base.map(function(_3ef){
var _3f0="MochiKit.DOM.getNodeAttribute(element, "+repr(_3ef.name)+")";
var _3f1=function(_3f2){
return _3f0+".split("+repr(_3f2)+")";
};
_3e5.push(_3f0+" !!= null");
switch(_3ef.operator){
case "=":
_3e5.push(_3f0+" == "+repr(_3ef.value));
break;
case "~=":
_3e5.push("MochiKit.Base.findValue("+_3f1(" ")+", "+repr(_3ef.value)+") > -1");
break;
case "^=":
_3e5.push(_3f0+".substring(0, "+_3ef.value.length+") == "+repr(_3ef.value));
break;
case "$=":
_3e5.push(_3f0+".substring("+_3f0+".length - "+_3ef.value.length+") == "+repr(_3ef.value));
break;
case "*=":
_3e5.push(_3f0+".match("+repr(_3ef.value)+")");
break;
case "|=":
_3e5.push(_3f1("-")+"[0].toUpperCase() == "+repr(_3ef.value.toUpperCase()));
break;
case "!!=":
_3e5.push(_3f0+" !!= "+repr(_3ef.value));
break;
case "":
case undefined:
break;
default:
throw "Unknown operator "+_3ef.operator+" in selector";
}
},_3e6);
}
return _3e5.join(" && ");
},compileMatcher:function(){
var code="return (!!element.tagName) ? false : "+this.buildMatchExpression()+";";
this.match=new Function("element",code);
},nthChild:function(_3f4,a,b,_3f7,_3f8){
var _3f9=MochiKit.Base.filter(function(node){
return node.nodeType==1;
},_3f4.parentNode.childNodes);
if(_3f8){
_3f9=MochiKit.Base.filter(function(node){
return node.tagName==_3f4.tagName;
},_3f9);
}
if(_3f7){
_3f9=MochiKit.Iter.reversed(_3f9);
}
if(a){
var _3fc=MochiKit.Base.findIdentical(_3f9,_3f4);
return ((_3fc+1-b)/a)%1==0;
}else{
return b==MochiKit.Base.findIdentical(_3f9,_3f4)+1;
}
},isUIElement:function(_3fd){
return MochiKit.Base.findValue(["input","button","select","option","textarea","object"],_3fd.tagName.toLowerCase())>-1;
},findElements:function(_3fe,axis){
var _400;
if(axis==undefined){
axis="";
}
function inScope(_401,_402){
if(axis==""){
return MochiKit.DOM.isChildNode(_401,_402);
}else{
if(axis==">"){
return _401.parentNode===_402;
}else{
if(axis=="+"){
return _401===nextSiblingElement(_402);
}else{
if(axis=="~"){
var _403=_402;
while(_403=nextSiblingElement(_403)){
if(_401===_403){
return true;
}
}
return false;
}else{
throw "Invalid axis: "+axis;
}
}
}
}
}
if(_400=MochiKit.DOM.getElement(this.params.id)){
if(this.match(_400)){
if(!!_3fe||inScope(_400,_3fe)){
return [_400];
}
}
}
function nextSiblingElement(node){
node=node.nextSibling;
while(node&&node.nodeType!!=1){
node=node.nextSibling;
}
return node;
}
if(axis==""){
_3fe=(_3fe||MochiKit.DOM.currentDocument()).getElementsByTagName(this.params.tagName||"*");
}else{
if(axis==">"){
if(!!_3fe){
throw "> combinator not allowed without preceeding expression";
}
_3fe=MochiKit.Base.filter(function(node){
return node.nodeType==1;
},_3fe.childNodes);
}else{
if(axis=="+"){
if(!!_3fe){
throw "+ combinator not allowed without preceeding expression";
}
_3fe=nextSiblingElement(_3fe)&&[nextSiblingElement(_3fe)];
}else{
if(axis=="~"){
if(!!_3fe){
throw "~ combinator not allowed without preceeding expression";
}
var _406=[];
while(nextSiblingElement(_3fe)){
_3fe=nextSiblingElement(_3fe);
_406.push(_3fe);
}
_3fe=_406;
}
}
}
}
if(!!_3fe){
return [];
}
var _407=MochiKit.Base.filter(MochiKit.Base.bind(function(_408){
return this.match(_408);
},this),_3fe);
return _407;
},repr:function(){
return "Selector("+this.expression+")";
},toString:MochiKit.Base.forwardCall("repr")};
MochiKit.Base.update(MochiKit.Selector,{findChildElements:function(_409,_40a){
var uniq=function(arr){
var res=[];
for(var i=0;i<arr.length;i++){
if(MochiKit.Base.findIdentical(res,arr[i])<0){
res.push(arr[i]);
}
}
return res;
};
return MochiKit.Base.flattenArray(MochiKit.Base.map(function(_40f){
var _410="";
var _411=function(_412,expr){
if(match=expr.match(/^[>+~]$/)){
_410=match[0];
return _412;
}else{
var _414=new MochiKit.Selector.Selector(expr);
var _415=MochiKit.Iter.reduce(function(_416,_417){
return MochiKit.Base.extend(_416,_414.findElements(_417||_409,_410));
},_412,[]);
_410="";
return _415;
}
};
var _418=_40f.replace(/(^\s+|\s+$)/g,"").split(/\s+/);
return uniq(MochiKit.Iter.reduce(_411,_418,[null]));
},_40a));
},findDocElements:function(){
return MochiKit.Selector.findChildElements(MochiKit.DOM.currentDocument(),arguments);
},__new__:function(){
var m=MochiKit.Base;
this.$$=this.findDocElements;
this.EXPORT_TAGS={":common":this.EXPORT,":all":m.concat(this.EXPORT,this.EXPORT_OK)};
m.nameFunctions(this);
}});
MochiKit.Selector.__new__();
MochiKit.Base._exportSymbols(this,MochiKit.Selector);
MochiKit.Base._deps("Style",["Base","DOM"]);
MochiKit.Style.NAME="MochiKit.Style";
MochiKit.Style.VERSION="1.4.2";
MochiKit.Style.__repr__=function(){
return "["+this.NAME+" "+this.VERSION+"]";
};
MochiKit.Style.toString=function(){
return this.__repr__();
};
MochiKit.Style.EXPORT_OK=[];
MochiKit.Style.EXPORT=["setStyle","setOpacity","getStyle","getElementDimensions","elementDimensions","setElementDimensions","getElementPosition","elementPosition","setElementPosition","makePositioned","undoPositioned","makeClipping","undoClipping","setDisplayForElement","hideElement","showElement","getViewportDimensions","getViewportPosition","Dimensions","Coordinates"];
MochiKit.Style.Dimensions=function(w,h){
this.w=w;
this.h=h;
};
MochiKit.Style.Dimensions.prototype.__repr__=function(){
var repr=MochiKit.Base.repr;
return "{w: "+repr(this.w)+", h: "+repr(this.h)+"}";
};
MochiKit.Style.Dimensions.prototype.toString=function(){
return this.__repr__();
};
MochiKit.Style.Coordinates=function(x,y){
this.x=x;
this.y=y;
};
MochiKit.Style.Coordinates.prototype.__repr__=function(){
var repr=MochiKit.Base.repr;
return "{x: "+repr(this.x)+", y: "+repr(this.y)+"}";
};
MochiKit.Style.Coordinates.prototype.toString=function(){
return this.__repr__();
};
MochiKit.Base.update(MochiKit.Style,{getStyle:function(elem,_421){
var dom=MochiKit.DOM;
var d=dom._document;
elem=dom.getElement(elem);
_421=MochiKit.Base.camelize(_421);
if(!!elem||elem==d){
return undefined;
}
if(_421=="opacity"&&typeof (elem.filters)!!="undefined"){
var _424=(MochiKit.Style.getStyle(elem,"filter")||"").match(/alpha\(opacity=(.*)\)/);
if(_424&&_424[1]){
return parseFloat(_424[1])/100;
}
return 1;
}
if(_421=="float"||_421=="cssFloat"||_421=="styleFloat"){
if(elem.style["float"]){
return elem.style["float"];
}else{
if(elem.style.cssFloat){
return elem.style.cssFloat;
}else{
if(elem.style.styleFloat){
return elem.style.styleFloat;
}else{
return "none";
}
}
}
}
var _425=elem.style?elem.style[_421]:null;
if(!!_425){
if(d.defaultView&&d.defaultView.getComputedStyle){
var css=d.defaultView.getComputedStyle(elem,null);
_421=_421.replace(/([A-Z])/g,"-$1").toLowerCase();
_425=css?css.getPropertyValue(_421):null;
}else{
if(elem.currentStyle){
_425=elem.currentStyle[_421];
if(/^\d/.test(_425)&&!!/px$/.test(_425)&&_421!!="fontWeight"){
var left=elem.style.left;
var _428=elem.runtimeStyle.left;
elem.runtimeStyle.left=elem.currentStyle.left;
elem.style.left=_425||0;
_425=elem.style.pixelLeft+"px";
elem.style.left=left;
elem.runtimeStyle.left=_428;
}
}
}
}
if(_421=="opacity"){
_425=parseFloat(_425);
}
if(/Opera/.test(navigator.userAgent)&&(MochiKit.Base.findValue(["left","top","right","bottom"],_421)!!=-1)){
if(MochiKit.Style.getStyle(elem,"position")=="static"){
_425="auto";
}
}
return _425=="auto"?null:_425;
},setStyle:function(elem,_42a){
elem=MochiKit.DOM.getElement(elem);
for(var name in _42a){
switch(name){
case "opacity":
MochiKit.Style.setOpacity(elem,_42a[name]);
break;
case "float":
case "cssFloat":
case "styleFloat":
if(typeof (elem.style["float"])!!="undefined"){
elem.style["float"]=_42a[name];
}else{
if(typeof (elem.style.cssFloat)!!="undefined"){
elem.style.cssFloat=_42a[name];
}else{
elem.style.styleFloat=_42a[name];
}
}
break;
default:
elem.style[MochiKit.Base.camelize(name)]=_42a[name];
}
}
},setOpacity:function(elem,o){
elem=MochiKit.DOM.getElement(elem);
var self=MochiKit.Style;
if(o==1){
var _42f=/Gecko/.test(navigator.userAgent)&&!!(/Konqueror|AppleWebKit|KHTML/.test(navigator.userAgent));
elem.style["opacity"]=_42f?0.999999:1;
if(/MSIE/.test(navigator.userAgent)){
elem.style["filter"]=self.getStyle(elem,"filter").replace(/alpha\([^\)]*\)/gi,"");
}
}else{
if(o<0.00001){
o=0;
}
elem.style["opacity"]=o;
if(/MSIE/.test(navigator.userAgent)){
elem.style["filter"]=self.getStyle(elem,"filter").replace(/alpha\([^\)]*\)/gi,"")+"alpha(opacity="+o*100+")";
}
}
},getElementPosition:function(elem,_431){
var self=MochiKit.Style;
var dom=MochiKit.DOM;
elem=dom.getElement(elem);
if(!!elem||(!!(elem.x&&elem.y)&&(!!elem.parentNode===null||self.getStyle(elem,"display")=="none"))){
return undefined;
}
var c=new self.Coordinates(0,0);
var box=null;
var _436=null;
var d=MochiKit.DOM._document;
var de=d.documentElement;
var b=d.body;
if(!!elem.parentNode&&elem.x&&elem.y){
c.x+=elem.x||0;
c.y+=elem.y||0;
}else{
if(elem.getBoundingClientRect){
box=elem.getBoundingClientRect();
c.x+=box.left+(de.scrollLeft||b.scrollLeft)-(de.clientLeft||0);
c.y+=box.top+(de.scrollTop||b.scrollTop)-(de.clientTop||0);
}else{
if(elem.offsetParent){
c.x+=elem.offsetLeft;
c.y+=elem.offsetTop;
_436=elem.offsetParent;
if(_436!!=elem){
while(_436){
c.x+=parseInt(_436.style.borderLeftWidth)||0;
c.y+=parseInt(_436.style.borderTopWidth)||0;
c.x+=_436.offsetLeft;
c.y+=_436.offsetTop;
_436=_436.offsetParent;
}
}
var ua=navigator.userAgent.toLowerCase();
if((typeof (opera)!!="undefined"&&parseFloat(opera.version())<9)||(ua.indexOf("AppleWebKit")!!=-1&&self.getStyle(elem,"position")=="absolute")){
c.x-=b.offsetLeft;
c.y-=b.offsetTop;
}
if(elem.parentNode){
_436=elem.parentNode;
}else{
_436=null;
}
while(_436){
var _43b=_436.tagName.toUpperCase();
if(_43b==="BODY"||_43b==="HTML"){
break;
}
var disp=self.getStyle(_436,"display");
if(disp.search(/^inline|table-row.*$/i)){
c.x-=_436.scrollLeft;
c.y-=_436.scrollTop;
}
if(_436.parentNode){
_436=_436.parentNode;
}else{
_436=null;
}
}
}
}
}
if(typeof (_431)!!="undefined"){
_431=arguments.callee(_431);
if(_431){
c.x-=(_431.x||0);
c.y-=(_431.y||0);
}
}
return c;
},setElementPosition:function(elem,_43e,_43f){
elem=MochiKit.DOM.getElement(elem);
if(typeof (_43f)=="undefined"){
_43f="px";
}
var _440={};
var _441=MochiKit.Base.isUndefinedOrNull;
if(!!_441(_43e.x)){
_440["left"]=_43e.x+_43f;
}
if(!!_441(_43e.y)){
_440["top"]=_43e.y+_43f;
}
MochiKit.DOM.updateNodeAttributes(elem,{"style":_440});
},makePositioned:function(_442){
_442=MochiKit.DOM.getElement(_442);
var pos=MochiKit.Style.getStyle(_442,"position");
if(pos=="static"||!!pos){
_442.style.position="relative";
if(/Opera/.test(navigator.userAgent)){
_442.style.top=0;
_442.style.left=0;
}
}
},undoPositioned:function(_444){
_444=MochiKit.DOM.getElement(_444);
if(_444.style.position=="relative"){
_444.style.position=_444.style.top=_444.style.left=_444.style.bottom=_444.style.right="";
}
},makeClipping:function(_445){
_445=MochiKit.DOM.getElement(_445);
var s=_445.style;
var _447={"overflow":s.overflow,"overflow-x":s.overflowX,"overflow-y":s.overflowY};
if((MochiKit.Style.getStyle(_445,"overflow")||"visible")!!="hidden"){
_445.style.overflow="hidden";
_445.style.overflowX="hidden";
_445.style.overflowY="hidden";
}
return _447;
},undoClipping:function(_448,_449){
_448=MochiKit.DOM.getElement(_448);
if(typeof (_449)=="string"){
_448.style.overflow=_449;
}else{
if(_449!!=null){
_448.style.overflow=_449["overflow"];
_448.style.overflowX=_449["overflow-x"];
_448.style.overflowY=_449["overflow-y"];
}
}
},getElementDimensions:function(elem,_44b){
var self=MochiKit.Style;
var dom=MochiKit.DOM;
if(typeof (elem.w)=="number"||typeof (elem.h)=="number"){
return new self.Dimensions(elem.w||0,elem.h||0);
}
elem=dom.getElement(elem);
if(!!elem){
return undefined;
}
var disp=self.getStyle(elem,"display");
if(disp=="none"||disp==""||typeof (disp)=="undefined"){
var s=elem.style;
var _450=s.visibility;
var _451=s.position;
var _452=s.display;
s.visibility="hidden";
s.position="absolute";
s.display=self._getDefaultDisplay(elem);
var _453=elem.offsetWidth;
var _454=elem.offsetHeight;
s.display=_452;
s.position=_451;
s.visibility=_450;
}else{
_453=elem.offsetWidth||0;
_454=elem.offsetHeight||0;
}
if(_44b){
var _455="colSpan" in elem&&"rowSpan" in elem;
var _456=(_455&&elem.parentNode&&self.getStyle(elem.parentNode,"borderCollapse")=="collapse");
if(_456){
if(/MSIE/.test(navigator.userAgent)){
var _457=elem.previousSibling?0.5:1;
var _458=elem.nextSibling?0.5:1;
}else{
var _457=0.5;
var _458=0.5;
}
}else{
var _457=1;
var _458=1;
}
_453-=Math.round((parseFloat(self.getStyle(elem,"paddingLeft"))||0)+(parseFloat(self.getStyle(elem,"paddingRight"))||0)+_457*(parseFloat(self.getStyle(elem,"borderLeftWidth"))||0)+_458*(parseFloat(self.getStyle(elem,"borderRightWidth"))||0));
if(_455){
if(/Gecko|Opera/.test(navigator.userAgent)&&!!/Konqueror|AppleWebKit|KHTML/.test(navigator.userAgent)){
var _459=0;
}else{
if(/MSIE/.test(navigator.userAgent)){
var _459=1;
}else{
var _459=_456?0.5:1;
}
}
}else{
var _459=1;
}
_454-=Math.round((parseFloat(self.getStyle(elem,"paddingTop"))||0)+(parseFloat(self.getStyle(elem,"paddingBottom"))||0)+_459*((parseFloat(self.getStyle(elem,"borderTopWidth"))||0)+(parseFloat(self.getStyle(elem,"borderBottomWidth"))||0)));
}
return new self.Dimensions(_453,_454);
},setElementDimensions:function(elem,_45b,_45c){
elem=MochiKit.DOM.getElement(elem);
if(typeof (_45c)=="undefined"){
_45c="px";
}
var _45d={};
var _45e=MochiKit.Base.isUndefinedOrNull;
if(!!_45e(_45b.w)){
_45d["width"]=_45b.w+_45c;
}
if(!!_45e(_45b.h)){
_45d["height"]=_45b.h+_45c;
}
MochiKit.DOM.updateNodeAttributes(elem,{"style":_45d});
},_getDefaultDisplay:function(elem){
var self=MochiKit.Style;
var dom=MochiKit.DOM;
elem=dom.getElement(elem);
if(!!elem){
return undefined;
}
var _462=elem.tagName.toUpperCase();
return self._defaultDisplay[_462]||"block";
},setDisplayForElement:function(_463,_464){
var _465=MochiKit.Base.extend(null,arguments,1);
var _466=MochiKit.DOM.getElement;
for(var i=0;i<_465.length;i++){
_464=_466(_465[i]);
if(_464){
_464.style.display=_463;
}
}
},getViewportDimensions:function(){
var d=new MochiKit.Style.Dimensions();
var w=MochiKit.DOM._window;
var b=MochiKit.DOM._document.body;
if(w.innerWidth){
d.w=w.innerWidth;
d.h=w.innerHeight;
}else{
if(b&&b.parentElement&&b.parentElement.clientWidth){
d.w=b.parentElement.clientWidth;
d.h=b.parentElement.clientHeight;
}else{
if(b&&b.clientWidth){
d.w=b.clientWidth;
d.h=b.clientHeight;
}
}
}
return d;
},getViewportPosition:function(){
var c=new MochiKit.Style.Coordinates(0,0);
var d=MochiKit.DOM._document;
var de=d.documentElement;
var db=d.body;
if(de&&(de.scrollTop||de.scrollLeft)){
c.x=de.scrollLeft;
c.y=de.scrollTop;
}else{
if(db){
c.x=db.scrollLeft;
c.y=db.scrollTop;
}
}
return c;
},__new__:function(){
var m=MochiKit.Base;
var _470=["A","ABBR","ACRONYM","B","BASEFONT","BDO","BIG","BR","CITE","CODE","DFN","EM","FONT","I","IMG","KBD","LABEL","Q","S","SAMP","SMALL","SPAN","STRIKE","STRONG","SUB","SUP","TEXTAREA","TT","U","VAR"];
this._defaultDisplay={"TABLE":"table","THEAD":"table-header-group","TBODY":"table-row-group","TFOOT":"table-footer-group","COLGROUP":"table-column-group","COL":"table-column","TR":"table-row","TD":"table-cell","TH":"table-cell","CAPTION":"table-caption","LI":"list-item","INPUT":"inline-block","SELECT":"inline-block"};
if(/MSIE/.test(navigator.userAgent)){
for(var k in this._defaultDisplay){
var v=this._defaultDisplay[k];
if(v.indexOf("table")==0){
this._defaultDisplay[k]="block";
}
}
}
for(var i=0;i<_470.length;i++){
this._defaultDisplay[_470[i]]="inline";
}
this.elementPosition=this.getElementPosition;
this.elementDimensions=this.getElementDimensions;
this.hideElement=m.partial(this.setDisplayForElement,"none");
this.showElement=m.partial(this.setDisplayForElement,"block");
this.EXPORT_TAGS={":common":this.EXPORT,":all":m.concat(this.EXPORT,this.EXPORT_OK)};
m.nameFunctions(this);
}});
MochiKit.Style.__new__();
MochiKit.Base._exportSymbols(this,MochiKit.Style);
MochiKit.Base._deps("LoggingPane",["Base","Logging"]);
MochiKit.LoggingPane.NAME="MochiKit.LoggingPane";
MochiKit.LoggingPane.VERSION="1.4.2";
MochiKit.LoggingPane.__repr__=function(){
return "["+this.NAME+" "+this.VERSION+"]";
};
MochiKit.LoggingPane.toString=function(){
return this.__repr__();
};
MochiKit.LoggingPane.createLoggingPane=function(_474){
var m=MochiKit.LoggingPane;
_474=!!(!!_474);
if(m._loggingPane&&m._loggingPane.inline!!=_474){
m._loggingPane.closePane();
m._loggingPane=null;
}
if(!!m._loggingPane||m._loggingPane.closed){
m._loggingPane=new m.LoggingPane(_474,MochiKit.Logging.logger);
}
return m._loggingPane;
};
MochiKit.LoggingPane.LoggingPane=function(_476,_477){
if(typeof (_477)=="undefined"||_477===null){
_477=MochiKit.Logging.logger;
}
this.logger=_477;
var _478=MochiKit.Base.update;
var _479=MochiKit.Base.updatetree;
var bind=MochiKit.Base.bind;
var _47b=MochiKit.Base.clone;
var win=window;
var uid="_MochiKit_LoggingPane";
if(typeof (MochiKit.DOM)!!="undefined"){
win=MochiKit.DOM.currentWindow();
}
if(!!_476){
var url=win.location.href.split("?")[0].replace(/[#:\/.><&%-]/g,"_");
var name=uid+"_"+url;
var nwin=win.open("",name,"dependent,resizable,height=200");
if(!!nwin){
alert("Not able to open debugging window due to pop-up blocking.");
return undefined;
}
nwin.document.write("<!!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Transitional//EN\" "+"\"http://www.w3.org/TR/html4/loose.dtd\">"+"<html><head><title>[MochiKit.LoggingPane]</title></head>"+"<body></body></html>");
nwin.document.close();
nwin.document.title+=" "+win.document.title;
win=nwin;
}
var doc=win.document;
this.doc=doc;
var _482=doc.getElementById(uid);
var _483=!!!!_482;
if(_482&&typeof (_482.loggingPane)!!="undefined"){
_482.loggingPane.logger=this.logger;
_482.loggingPane.buildAndApplyFilter();
return _482.loggingPane;
}
if(_483){
var _484;
while((_484=_482.firstChild)){
_482.removeChild(_484);
}
}else{
_482=doc.createElement("div");
_482.id=uid;
}
_482.loggingPane=this;
var _485=doc.createElement("input");
var _486=doc.createElement("input");
var _487=doc.createElement("button");
var _488=doc.createElement("button");
var _489=doc.createElement("button");
var _48a=doc.createElement("button");
var _48b=doc.createElement("div");
var _48c=doc.createElement("div");
var _48d=uid+"_Listener";
this.colorTable=_47b(this.colorTable);
var _48e=[];
var _48f=null;
var _490=function(msg){
var _492=msg.level;
if(typeof (_492)=="number"){
_492=MochiKit.Logging.LogLevel[_492];
}
return _492;
};
var _493=function(msg){
return msg.info.join(" ");
};
var _495=bind(function(msg){
var _497=_490(msg);
var text=_493(msg);
var c=this.colorTable[_497];
var p=doc.createElement("span");
p.className="MochiKit-LogMessage MochiKit-LogLevel-"+_497;
p.style.cssText="margin: 0px; white-space: -moz-pre-wrap; white-space: -o-pre-wrap; white-space: pre-wrap; white-space: pre-line; word-wrap: break-word; wrap-option: emergency; color: "+c;
p.appendChild(doc.createTextNode(_497+": "+text));
_48c.appendChild(p);
_48c.appendChild(doc.createElement("br"));
if(_48b.offsetHeight>_48b.scrollHeight){
_48b.scrollTop=0;
}else{
_48b.scrollTop=_48b.scrollHeight;
}
},this);
var _49b=function(msg){
_48e[_48e.length]=msg;
_495(msg);
};
var _49d=function(){
var _49e,_49f;
try{
_49e=new RegExp(_485.value);
_49f=new RegExp(_486.value);
}
catch(e){
logDebug("Error in filter regex: "+e.message);
return null;
}
return function(msg){
return (_49e.test(_490(msg))&&_49f.test(_493(msg)));
};
};
var _4a1=function(){
while(_48c.firstChild){
_48c.removeChild(_48c.firstChild);
}
};
var _4a2=function(){
_48e=[];
_4a1();
};
var _4a3=bind(function(){
if(this.closed){
return;
}
this.closed=true;
if(MochiKit.LoggingPane._loggingPane==this){
MochiKit.LoggingPane._loggingPane=null;
}
this.logger.removeListener(_48d);
try{
try{
_482.loggingPane=null;
}
catch(e){
logFatal("Bookmarklet was closed incorrectly.");
}
if(_476){
_482.parentNode.removeChild(_482);
}else{
this.win.close();
}
}
catch(e){
}
},this);
var _4a4=function(){
_4a1();
for(var i=0;i<_48e.length;i++){
var msg=_48e[i];
if(_48f===null||_48f(msg)){
_495(msg);
}
}
};
this.buildAndApplyFilter=function(){
_48f=_49d();
_4a4();
this.logger.removeListener(_48d);
this.logger.addListener(_48d,_48f,_49b);
};
var _4a7=bind(function(){
_48e=this.logger.getMessages();
_4a4();
},this);
var _4a8=bind(function(_4a9){
_4a9=_4a9||window.event;
key=_4a9.which||_4a9.keyCode;
if(key==13){
this.buildAndApplyFilter();
}
},this);
var _4aa="display: block; z-index: 1000; left: 0px; bottom: 0px; position: fixed; width: 100%; background-color: white; font: "+this.logFont;
if(_476){
_4aa+="; height: 10em; border-top: 2px solid black";
}else{
_4aa+="; height: 100%;";
}
_482.style.cssText=_4aa;
if(!!_483){
doc.body.appendChild(_482);
}
_4aa={"cssText":"width: 33%; display: inline; font: "+this.logFont};
_479(_485,{"value":"FATAL|ERROR|WARNING|INFO|DEBUG","onkeypress":_4a8,"style":_4aa});
_482.appendChild(_485);
_479(_486,{"value":".*","onkeypress":_4a8,"style":_4aa});
_482.appendChild(_486);
_4aa="width: 8%; display:inline; font: "+this.logFont;
_487.appendChild(doc.createTextNode("Filter"));
_487.onclick=bind("buildAndApplyFilter",this);
_487.style.cssText=_4aa;
_482.appendChild(_487);
_488.appendChild(doc.createTextNode("Load"));
_488.onclick=_4a7;
_488.style.cssText=_4aa;
_482.appendChild(_488);
_489.appendChild(doc.createTextNode("Clear"));
_489.onclick=_4a2;
_489.style.cssText=_4aa;
_482.appendChild(_489);
_48a.appendChild(doc.createTextNode("Close"));
_48a.onclick=_4a3;
_48a.style.cssText=_4aa;
_482.appendChild(_48a);
_48b.style.cssText="overflow: auto; width: 100%";
_48c.style.cssText="width: 100%; height: "+(_476?"8em":"100%");
_48b.appendChild(_48c);
_482.appendChild(_48b);
this.buildAndApplyFilter();
_4a7();
if(_476){
this.win=undefined;
}else{
this.win=win;
}
this.inline=_476;
this.closePane=_4a3;
this.closed=false;
return this;
};
MochiKit.LoggingPane.LoggingPane.prototype={"logFont":"8pt Verdana,sans-serif","colorTable":{"ERROR":"red","FATAL":"darkred","WARNING":"blue","INFO":"black","DEBUG":"green"}};
MochiKit.LoggingPane.EXPORT_OK=["LoggingPane"];
MochiKit.LoggingPane.EXPORT=["createLoggingPane"];
MochiKit.LoggingPane.__new__=function(){
this.EXPORT_TAGS={":common":this.EXPORT,":all":MochiKit.Base.concat(this.EXPORT,this.EXPORT_OK)};
MochiKit.Base.nameFunctions(this);
MochiKit.LoggingPane._loggingPane=null;
};
MochiKit.LoggingPane.__new__();
MochiKit.Base._exportSymbols(this,MochiKit.LoggingPane);
MochiKit.Base._deps("Color",["Base","DOM","Style"]);
MochiKit.Color.NAME="MochiKit.Color";
MochiKit.Color.VERSION="1.4.2";
MochiKit.Color.__repr__=function(){
return "["+this.NAME+" "+this.VERSION+"]";
};
MochiKit.Color.toString=function(){
return this.__repr__();
};
MochiKit.Color.Color=function(red,_4ac,blue,_4ae){
if(typeof (_4ae)=="undefined"||_4ae===null){
_4ae=1;
}
this.rgb={r:red,g:_4ac,b:blue,a:_4ae};
};
MochiKit.Color.Color.prototype={__class__:MochiKit.Color.Color,colorWithAlpha:function(_4af){
var rgb=this.rgb;
var m=MochiKit.Color;
return m.Color.fromRGB(rgb.r,rgb.g,rgb.b,_4af);
},colorWithHue:function(hue){
var hsl=this.asHSL();
hsl.h=hue;
var m=MochiKit.Color;
return m.Color.fromHSL(hsl);
},colorWithSaturation:function(_4b5){
var hsl=this.asHSL();
hsl.s=_4b5;
var m=MochiKit.Color;
return m.Color.fromHSL(hsl);
},colorWithLightness:function(_4b8){
var hsl=this.asHSL();
hsl.l=_4b8;
var m=MochiKit.Color;
return m.Color.fromHSL(hsl);
},darkerColorWithLevel:function(_4bb){
var hsl=this.asHSL();
hsl.l=Math.max(hsl.l-_4bb,0);
var m=MochiKit.Color;
return m.Color.fromHSL(hsl);
},lighterColorWithLevel:function(_4be){
var hsl=this.asHSL();
hsl.l=Math.min(hsl.l+_4be,1);
var m=MochiKit.Color;
return m.Color.fromHSL(hsl);
},blendedColor:function(_4c1,_4c2){
if(typeof (_4c2)=="undefined"||_4c2===null){
_4c2=0.5;
}
var sf=1-_4c2;
var s=this.rgb;
var d=_4c1.rgb;
var df=_4c2;
return MochiKit.Color.Color.fromRGB((s.r*sf)+(d.r*df),(s.g*sf)+(d.g*df),(s.b*sf)+(d.b*df),(s.a*sf)+(d.a*df));
},compareRGB:function(_4c7){
var a=this.asRGB();
var b=_4c7.asRGB();
return MochiKit.Base.compare([a.r,a.g,a.b,a.a],[b.r,b.g,b.b,b.a]);
},isLight:function(){
return this.asHSL().b>0.5;
},isDark:function(){
return (!!this.isLight());
},toHSLString:function(){
var c=this.asHSL();
var ccc=MochiKit.Color.clampColorComponent;
var rval=this._hslString;
if(!!rval){
var mid=(ccc(c.h,360).toFixed(0)+","+ccc(c.s,100).toPrecision(4)+"%"+","+ccc(c.l,100).toPrecision(4)+"%");
var a=c.a;
if(a>=1){
a=1;
rval="hsl("+mid+")";
}else{
if(a<=0){
a=0;
}
rval="hsla("+mid+","+a+")";
}
this._hslString=rval;
}
return rval;
},toRGBString:function(){
var c=this.rgb;
var ccc=MochiKit.Color.clampColorComponent;
var rval=this._rgbString;
if(!!rval){
var mid=(ccc(c.r,255).toFixed(0)+","+ccc(c.g,255).toFixed(0)+","+ccc(c.b,255).toFixed(0));
if(c.a!!=1){
rval="rgba("+mid+","+c.a+")";
}else{
rval="rgb("+mid+")";
}
this._rgbString=rval;
}
return rval;
},asRGB:function(){
return MochiKit.Base.clone(this.rgb);
},toHexString:function(){
var m=MochiKit.Color;
var c=this.rgb;
var ccc=MochiKit.Color.clampColorComponent;
var rval=this._hexString;
if(!!rval){
rval=("#"+m.toColorPart(ccc(c.r,255))+m.toColorPart(ccc(c.g,255))+m.toColorPart(ccc(c.b,255)));
this._hexString=rval;
}
return rval;
},asHSV:function(){
var hsv=this.hsv;
var c=this.rgb;
if(typeof (hsv)=="undefined"||hsv===null){
hsv=MochiKit.Color.rgbToHSV(this.rgb);
this.hsv=hsv;
}
return MochiKit.Base.clone(hsv);
},asHSL:function(){
var hsl=this.hsl;
var c=this.rgb;
if(typeof (hsl)=="undefined"||hsl===null){
hsl=MochiKit.Color.rgbToHSL(this.rgb);
this.hsl=hsl;
}
return MochiKit.Base.clone(hsl);
},toString:function(){
return this.toRGBString();
},repr:function(){
var c=this.rgb;
var col=[c.r,c.g,c.b,c.a];
return this.__class__.NAME+"("+col.join(", ")+")";
}};
MochiKit.Base.update(MochiKit.Color.Color,{fromRGB:function(red,_4de,blue,_4e0){
var _4e1=MochiKit.Color.Color;
if(arguments.length==1){
var rgb=red;
red=rgb.r;
_4de=rgb.g;
blue=rgb.b;
if(typeof (rgb.a)=="undefined"){
_4e0=undefined;
}else{
_4e0=rgb.a;
}
}
return new _4e1(red,_4de,blue,_4e0);
},fromHSL:function(hue,_4e4,_4e5,_4e6){
var m=MochiKit.Color;
return m.Color.fromRGB(m.hslToRGB.apply(m,arguments));
},fromHSV:function(hue,_4e9,_4ea,_4eb){
var m=MochiKit.Color;
return m.Color.fromRGB(m.hsvToRGB.apply(m,arguments));
},fromName:function(name){
var _4ee=MochiKit.Color.Color;
if(name.charAt(0)=="\""){
name=name.substr(1,name.length-2);
}
var _4ef=_4ee._namedColors[name.toLowerCase()];
if(typeof (_4ef)=="string"){
return _4ee.fromHexString(_4ef);
}else{
if(name=="transparent"){
return _4ee.transparentColor();
}
}
return null;
},fromString:function(_4f0){
var self=MochiKit.Color.Color;
var _4f2=_4f0.substr(0,3);
if(_4f2=="rgb"){
return self.fromRGBString(_4f0);
}else{
if(_4f2=="hsl"){
return self.fromHSLString(_4f0);
}else{
if(_4f0.charAt(0)=="#"){
return self.fromHexString(_4f0);
}
}
}
return self.fromName(_4f0);
},fromHexString:function(_4f3){
if(_4f3.charAt(0)=="#"){
_4f3=_4f3.substring(1);
}
var _4f4=[];
var i,hex;
if(_4f3.length==3){
for(i=0;i<3;i++){
hex=_4f3.substr(i,1);
_4f4.push(parseInt(hex+hex,16)/255);
}
}else{
for(i=0;i<6;i+=2){
hex=_4f3.substr(i,2);
_4f4.push(parseInt(hex,16)/255);
}
}
var _4f7=MochiKit.Color.Color;
return _4f7.fromRGB.apply(_4f7,_4f4);
},_fromColorString:function(pre,_4f9,_4fa,_4fb){
if(_4fb.indexOf(pre)===0){
_4fb=_4fb.substring(_4fb.indexOf("(",3)+1,_4fb.length-1);
}
var _4fc=_4fb.split(/\s*,\s*/);
var _4fd=[];
for(var i=0;i<_4fc.length;i++){
var c=_4fc[i];
var val;
var _501=c.substring(c.length-3);
if(c.charAt(c.length-1)=="%"){
val=0.01*parseFloat(c.substring(0,c.length-1));
}else{
if(_501=="deg"){
val=parseFloat(c)/360;
}else{
if(_501=="rad"){
val=parseFloat(c)/(Math.PI*2);
}else{
val=_4fa[i]*parseFloat(c);
}
}
}
_4fd.push(val);
}
return this[_4f9].apply(this,_4fd);
},fromComputedStyle:function(elem,_503){
var d=MochiKit.DOM;
var cls=MochiKit.Color.Color;
for(elem=d.getElement(elem);elem;elem=elem.parentNode){
var _506=MochiKit.Style.getStyle.apply(d,arguments);
if(!!_506){
continue;
}
var _507=cls.fromString(_506);
if(!!_507){
break;
}
if(_507.asRGB().a>0){
return _507;
}
}
return null;
},fromBackground:function(elem){
var cls=MochiKit.Color.Color;
return cls.fromComputedStyle(elem,"backgroundColor","background-color")||cls.whiteColor();
},fromText:function(elem){
var cls=MochiKit.Color.Color;
return cls.fromComputedStyle(elem,"color","color")||cls.blackColor();
},namedColors:function(){
return MochiKit.Base.clone(MochiKit.Color.Color._namedColors);
}});
MochiKit.Base.update(MochiKit.Color,{clampColorComponent:function(v,_50d){
v*=_50d;
if(v<0){
return 0;
}else{
if(v>_50d){
return _50d;
}else{
return v;
}
}
},_hslValue:function(n1,n2,hue){
if(hue>6){
hue-=6;
}else{
if(hue<0){
hue+=6;
}
}
var val;
if(hue<1){
val=n1+(n2-n1)*hue;
}else{
if(hue<3){
val=n2;
}else{
if(hue<4){
val=n1+(n2-n1)*(4-hue);
}else{
val=n1;
}
}
}
return val;
},hsvToRGB:function(hue,_513,_514,_515){
if(arguments.length==1){
var hsv=hue;
hue=hsv.h;
_513=hsv.s;
_514=hsv.v;
_515=hsv.a;
}
var red;
var _518;
var blue;
if(_513===0){
red=_514;
_518=_514;
blue=_514;
}else{
var i=Math.floor(hue*6);
var f=(hue*6)-i;
var p=_514*(1-_513);
var q=_514*(1-(_513*f));
var t=_514*(1-(_513*(1-f)));
switch(i){
case 1:
red=q;
_518=_514;
blue=p;
break;
case 2:
red=p;
_518=_514;
blue=t;
break;
case 3:
red=p;
_518=q;
blue=_514;
break;
case 4:
red=t;
_518=p;
blue=_514;
break;
case 5:
red=_514;
_518=p;
blue=q;
break;
case 6:
case 0:
red=_514;
_518=t;
blue=p;
break;
}
}
return {r:red,g:_518,b:blue,a:_515};
},hslToRGB:function(hue,_520,_521,_522){
if(arguments.length==1){
var hsl=hue;
hue=hsl.h;
_520=hsl.s;
_521=hsl.l;
_522=hsl.a;
}
var red;
var _525;
var blue;
if(_520===0){
red=_521;
_525=_521;
blue=_521;
}else{
var m2;
if(_521<=0.5){
m2=_521*(1+_520);
}else{
m2=_521+_520-(_521*_520);
}
var m1=(2*_521)-m2;
var f=MochiKit.Color._hslValue;
var h6=hue*6;
red=f(m1,m2,h6+2);
_525=f(m1,m2,h6);
blue=f(m1,m2,h6-2);
}
return {r:red,g:_525,b:blue,a:_522};
},rgbToHSV:function(red,_52c,blue,_52e){
if(arguments.length==1){
var rgb=red;
red=rgb.r;
_52c=rgb.g;
blue=rgb.b;
_52e=rgb.a;
}
var max=Math.max(Math.max(red,_52c),blue);
var min=Math.min(Math.min(red,_52c),blue);
var hue;
var _533;
var _534=max;
if(min==max){
hue=0;
_533=0;
}else{
var _535=(max-min);
_533=_535/max;
if(red==max){
hue=(_52c-blue)/_535;
}else{
if(_52c==max){
hue=2+((blue-red)/_535);
}else{
hue=4+((red-_52c)/_535);
}
}
hue/=6;
if(hue<0){
hue+=1;
}
if(hue>1){
hue-=1;
}
}
return {h:hue,s:_533,v:_534,a:_52e};
},rgbToHSL:function(red,_537,blue,_539){
if(arguments.length==1){
var rgb=red;
red=rgb.r;
_537=rgb.g;
blue=rgb.b;
_539=rgb.a;
}
var max=Math.max(red,Math.max(_537,blue));
var min=Math.min(red,Math.min(_537,blue));
var hue;
var _53e;
var _53f=(max+min)/2;
var _540=max-min;
if(_540===0){
hue=0;
_53e=0;
}else{
if(_53f<=0.5){
_53e=_540/(max+min);
}else{
_53e=_540/(2-max-min);
}
if(red==max){
hue=(_537-blue)/_540;
}else{
if(_537==max){
hue=2+((blue-red)/_540);
}else{
hue=4+((red-_537)/_540);
}
}
hue/=6;
if(hue<0){
hue+=1;
}
if(hue>1){
hue-=1;
}
}
return {h:hue,s:_53e,l:_53f,a:_539};
},toColorPart:function(num){
num=Math.round(num);
var _542=num.toString(16);
if(num<16){
return "0"+_542;
}
return _542;
},__new__:function(){
var m=MochiKit.Base;
this.Color.fromRGBString=m.bind(this.Color._fromColorString,this.Color,"rgb","fromRGB",[1/255,1/255,1/255,1]);
this.Color.fromHSLString=m.bind(this.Color._fromColorString,this.Color,"hsl","fromHSL",[1/360,0.01,0.01,1]);
var _544=1/3;
var _545={black:[0,0,0],blue:[0,0,1],brown:[0.6,0.4,0.2],cyan:[0,1,1],darkGray:[_544,_544,_544],gray:[0.5,0.5,0.5],green:[0,1,0],lightGray:[2*_544,2*_544,2*_544],magenta:[1,0,1],orange:[1,0.5,0],purple:[0.5,0,0.5],red:[1,0,0],transparent:[0,0,0,0],white:[1,1,1],yellow:[1,1,0]};
var _546=function(name,r,g,b,a){
var rval=this.fromRGB(r,g,b,a);
this[name]=function(){
return rval;
};
return rval;
};
for(var k in _545){
var name=k+"Color";
var _54f=m.concat([_546,this.Color,name],_545[k]);
this.Color[name]=m.bind.apply(null,_54f);
}
var _550=function(){
for(var i=0;i<arguments.length;i++){
if(!!(arguments[i] instanceof MochiKit.Color.Color)){
return false;
}
}
return true;
};
var _552=function(a,b){
return a.compareRGB(b);
};
m.nameFunctions(this);
m.registerComparator(this.Color.NAME,_550,_552);
this.EXPORT_TAGS={":common":this.EXPORT,":all":m.concat(this.EXPORT,this.EXPORT_OK)};
}});
MochiKit.Color.EXPORT=["Color"];
MochiKit.Color.EXPORT_OK=["clampColorComponent","rgbToHSL","hslToRGB","rgbToHSV","hsvToRGB","toColorPart"];
MochiKit.Color.__new__();
MochiKit.Base._exportSymbols(this,MochiKit.Color);
MochiKit.Color.Color._namedColors={aliceblue:"#f0f8ff",antiquewhite:"#faebd7",aqua:"#00ffff",aquamarine:"#7fffd4",azure:"#f0ffff",beige:"#f5f5dc",bisque:"#ffe4c4",black:"#000000",blanchedalmond:"#ffebcd",blue:"#0000ff",blueviolet:"#8a2be2",brown:"#a52a2a",burlywood:"#deb887",cadetblue:"#5f9ea0",chartreuse:"#7fff00",chocolate:"#d2691e",coral:"#ff7f50",cornflowerblue:"#6495ed",cornsilk:"#fff8dc",crimson:"#dc143c",cyan:"#00ffff",darkblue:"#00008b",darkcyan:"#008b8b",darkgoldenrod:"#b8860b",darkgray:"#a9a9a9",darkgreen:"#006400",darkgrey:"#a9a9a9",darkkhaki:"#bdb76b",darkmagenta:"#8b008b",darkolivegreen:"#556b2f",darkorange:"#ff8c00",darkorchid:"#9932cc",darkred:"#8b0000",darksalmon:"#e9967a",darkseagreen:"#8fbc8f",darkslateblue:"#483d8b",darkslategray:"#2f4f4f",darkslategrey:"#2f4f4f",darkturquoise:"#00ced1",darkviolet:"#9400d3",deeppink:"#ff1493",deepskyblue:"#00bfff",dimgray:"#696969",dimgrey:"#696969",dodgerblue:"#1e90ff",firebrick:"#b22222",floralwhite:"#fffaf0",forestgreen:"#228b22",fuchsia:"#ff00ff",gainsboro:"#dcdcdc",ghostwhite:"#f8f8ff",gold:"#ffd700",goldenrod:"#daa520",gray:"#808080",green:"#008000",greenyellow:"#adff2f",grey:"#808080",honeydew:"#f0fff0",hotpink:"#ff69b4",indianred:"#cd5c5c",indigo:"#4b0082",ivory:"#fffff0",khaki:"#f0e68c",lavender:"#e6e6fa",lavenderblush:"#fff0f5",lawngreen:"#7cfc00",lemonchiffon:"#fffacd",lightblue:"#add8e6",lightcoral:"#f08080",lightcyan:"#e0ffff",lightgoldenrodyellow:"#fafad2",lightgray:"#d3d3d3",lightgreen:"#90ee90",lightgrey:"#d3d3d3",lightpink:"#ffb6c1",lightsalmon:"#ffa07a",lightseagreen:"#20b2aa",lightskyblue:"#87cefa",lightslategray:"#778899",lightslategrey:"#778899",lightsteelblue:"#b0c4de",lightyellow:"#ffffe0",lime:"#00ff00",limegreen:"#32cd32",linen:"#faf0e6",magenta:"#ff00ff",maroon:"#800000",mediumaquamarine:"#66cdaa",mediumblue:"#0000cd",mediumorchid:"#ba55d3",mediumpurple:"#9370db",mediumseagreen:"#3cb371",mediumslateblue:"#7b68ee",mediumspringgreen:"#00fa9a",mediumturquoise:"#48d1cc",mediumvioletred:"#c71585",midnightblue:"#191970",mintcream:"#f5fffa",mistyrose:"#ffe4e1",moccasin:"#ffe4b5",navajowhite:"#ffdead",navy:"#000080",oldlace:"#fdf5e6",olive:"#808000",olivedrab:"#6b8e23",orange:"#ffa500",orangered:"#ff4500",orchid:"#da70d6",palegoldenrod:"#eee8aa",palegreen:"#98fb98",paleturquoise:"#afeeee",palevioletred:"#db7093",papayawhip:"#ffefd5",peachpuff:"#ffdab9",peru:"#cd853f",pink:"#ffc0cb",plum:"#dda0dd",powderblue:"#b0e0e6",purple:"#800080",red:"#ff0000",rosybrown:"#bc8f8f",royalblue:"#4169e1",saddlebrown:"#8b4513",salmon:"#fa8072",sandybrown:"#f4a460",seagreen:"#2e8b57",seashell:"#fff5ee",sienna:"#a0522d",silver:"#c0c0c0",skyblue:"#87ceeb",slateblue:"#6a5acd",slategray:"#708090",slategrey:"#708090",snow:"#fffafa",springgreen:"#00ff7f",steelblue:"#4682b4",tan:"#d2b48c",teal:"#008080",thistle:"#d8bfd8",tomato:"#ff6347",turquoise:"#40e0d0",violet:"#ee82ee",wheat:"#f5deb3",white:"#ffffff",whitesmoke:"#f5f5f5",yellow:"#ffff00",yellowgreen:"#9acd32"};
MochiKit.Base._deps("Signal",["Base","DOM","Style"]);
MochiKit.Signal.NAME="MochiKit.Signal";
MochiKit.Signal.VERSION="1.4.2";
MochiKit.Signal._observers=[];
MochiKit.Signal.Event=function(src,e){
this._event=e||window.event;
this._src=src;
};
MochiKit.Base.update(MochiKit.Signal.Event.prototype,{__repr__:function(){
var repr=MochiKit.Base.repr;
var str="{event(): "+repr(this.event())+", src(): "+repr(this.src())+", type(): "+repr(this.type())+", target(): "+repr(this.target());
if(this.type()&&this.type().indexOf("key")===0||this.type().indexOf("mouse")===0||this.type().indexOf("click")!!=-1||this.type()=="contextmenu"){
str+=", modifier(): "+"{alt: "+repr(this.modifier().alt)+", ctrl: "+repr(this.modifier().ctrl)+", meta: "+repr(this.modifier().meta)+", shift: "+repr(this.modifier().shift)+", any: "+repr(this.modifier().any)+"}";
}
if(this.type()&&this.type().indexOf("key")===0){
str+=", key(): {code: "+repr(this.key().code)+", string: "+repr(this.key().string)+"}";
}
if(this.type()&&(this.type().indexOf("mouse")===0||this.type().indexOf("click")!!=-1||this.type()=="contextmenu")){
str+=", mouse(): {page: "+repr(this.mouse().page)+", client: "+repr(this.mouse().client);
if(this.type()!!="mousemove"&&this.type()!!="mousewheel"){
str+=", button: {left: "+repr(this.mouse().button.left)+", middle: "+repr(this.mouse().button.middle)+", right: "+repr(this.mouse().button.right)+"}";
}
if(this.type()=="mousewheel"){
str+=", wheel: "+repr(this.mouse().wheel);
}
str+="}";
}
if(this.type()=="mouseover"||this.type()=="mouseout"||this.type()=="mouseenter"||this.type()=="mouseleave"){
str+=", relatedTarget(): "+repr(this.relatedTarget());
}
str+="}";
return str;
},toString:function(){
return this.__repr__();
},src:function(){
return this._src;
},event:function(){
return this._event;
},type:function(){
if(this._event.type==="DOMMouseScroll"){
return "mousewheel";
}else{
return this._event.type||undefined;
}
},target:function(){
return this._event.target||this._event.srcElement;
},_relatedTarget:null,relatedTarget:function(){
if(this._relatedTarget!!==null){
return this._relatedTarget;
}
var elem=null;
if(this.type()=="mouseover"||this.type()=="mouseenter"){
elem=(this._event.relatedTarget||this._event.fromElement);
}else{
if(this.type()=="mouseout"||this.type()=="mouseleave"){
elem=(this._event.relatedTarget||this._event.toElement);
}
}
try{
if(elem!!==null&&elem.nodeType!!==null){
this._relatedTarget=elem;
return elem;
}
}
catch(ignore){
}
return undefined;
},_modifier:null,modifier:function(){
if(this._modifier!!==null){
return this._modifier;
}
var m={};
m.alt=this._event.altKey;
m.ctrl=this._event.ctrlKey;
m.meta=this._event.metaKey||false;
m.shift=this._event.shiftKey;
m.any=m.alt||m.ctrl||m.shift||m.meta;
this._modifier=m;
return m;
},_key:null,key:function(){
if(this._key!!==null){
return this._key;
}
var k={};
if(this.type()&&this.type().indexOf("key")===0){
if(this.type()=="keydown"||this.type()=="keyup"){
k.code=this._event.keyCode;
k.string=(MochiKit.Signal._specialKeys[k.code]||"KEY_UNKNOWN");
this._key=k;
return k;
}else{
if(this.type()=="keypress"){
k.code=0;
k.string="";
if(typeof (this._event.charCode)!!="undefined"&&this._event.charCode!!==0&&!!MochiKit.Signal._specialMacKeys[this._event.charCode]){
k.code=this._event.charCode;
k.string=String.fromCharCode(k.code);
}else{
if(this._event.keyCode&&typeof (this._event.charCode)=="undefined"){
k.code=this._event.keyCode;
k.string=String.fromCharCode(k.code);
}
}
this._key=k;
return k;
}
}
}
return undefined;
},_mouse:null,mouse:function(){
if(this._mouse!!==null){
return this._mouse;
}
var m={};
var e=this._event;
if(this.type()&&(this.type().indexOf("mouse")===0||this.type().indexOf("click")!!=-1||this.type()=="contextmenu")){
m.client=new MochiKit.Style.Coordinates(0,0);
if(e.clientX||e.clientY){
m.client.x=(!!e.clientX||e.clientX<0)?0:e.clientX;
m.client.y=(!!e.clientY||e.clientY<0)?0:e.clientY;
}
m.page=new MochiKit.Style.Coordinates(0,0);
if(e.pageX||e.pageY){
m.page.x=(!!e.pageX||e.pageX<0)?0:e.pageX;
m.page.y=(!!e.pageY||e.pageY<0)?0:e.pageY;
}else{
var de=MochiKit.DOM._document.documentElement;
var b=MochiKit.DOM._document.body;
m.page.x=e.clientX+(de.scrollLeft||b.scrollLeft)-(de.clientLeft||0);
m.page.y=e.clientY+(de.scrollTop||b.scrollTop)-(de.clientTop||0);
}
if(this.type()!!="mousemove"&&this.type()!!="mousewheel"){
m.button={};
m.button.left=false;
m.button.right=false;
m.button.middle=false;
if(e.which){
m.button.left=(e.which==1);
m.button.middle=(e.which==2);
m.button.right=(e.which==3);
}else{
m.button.left=!!!!(e.button&1);
m.button.right=!!!!(e.button&2);
m.button.middle=!!!!(e.button&4);
}
}
if(this.type()=="mousewheel"){
m.wheel=new MochiKit.Style.Coordinates(0,0);
if(e.wheelDeltaX||e.wheelDeltaY){
m.wheel.x=e.wheelDeltaX/-40||0;
m.wheel.y=e.wheelDeltaY/-40||0;
}else{
if(e.wheelDelta){
m.wheel.y=e.wheelDelta/-40;
}else{
m.wheel.y=e.detail||0;
}
}
}
this._mouse=m;
return m;
}
return undefined;
},stop:function(){
this.stopPropagation();
this.preventDefault();
},stopPropagation:function(){
if(this._event.stopPropagation){
this._event.stopPropagation();
}else{
this._event.cancelBubble=true;
}
},preventDefault:function(){
if(this._event.preventDefault){
this._event.preventDefault();
}else{
if(this._confirmUnload===null){
this._event.returnValue=false;
}
}
},_confirmUnload:null,confirmUnload:function(msg){
if(this.type()=="beforeunload"){
this._confirmUnload=msg;
this._event.returnValue=msg;
}
}});
MochiKit.Signal._specialMacKeys={3:"KEY_ENTER",63289:"KEY_NUM_PAD_CLEAR",63276:"KEY_PAGE_UP",63277:"KEY_PAGE_DOWN",63275:"KEY_END",63273:"KEY_HOME",63234:"KEY_ARROW_LEFT",63232:"KEY_ARROW_UP",63235:"KEY_ARROW_RIGHT",63233:"KEY_ARROW_DOWN",63302:"KEY_INSERT",63272:"KEY_DELETE"};
(function(){
var _561=MochiKit.Signal._specialMacKeys;
for(i=63236;i<=63242;i++){
_561[i]="KEY_F"+(i-63236+1);
}
})();
MochiKit.Signal._specialKeys={8:"KEY_BACKSPACE",9:"KEY_TAB",12:"KEY_NUM_PAD_CLEAR",13:"KEY_ENTER",16:"KEY_SHIFT",17:"KEY_CTRL",18:"KEY_ALT",19:"KEY_PAUSE",20:"KEY_CAPS_LOCK",27:"KEY_ESCAPE",32:"KEY_SPACEBAR",33:"KEY_PAGE_UP",34:"KEY_PAGE_DOWN",35:"KEY_END",36:"KEY_HOME",37:"KEY_ARROW_LEFT",38:"KEY_ARROW_UP",39:"KEY_ARROW_RIGHT",40:"KEY_ARROW_DOWN",44:"KEY_PRINT_SCREEN",45:"KEY_INSERT",46:"KEY_DELETE",59:"KEY_SEMICOLON",91:"KEY_WINDOWS_LEFT",92:"KEY_WINDOWS_RIGHT",93:"KEY_SELECT",106:"KEY_NUM_PAD_ASTERISK",107:"KEY_NUM_PAD_PLUS_SIGN",109:"KEY_NUM_PAD_HYPHEN-MINUS",110:"KEY_NUM_PAD_FULL_STOP",111:"KEY_NUM_PAD_SOLIDUS",144:"KEY_NUM_LOCK",145:"KEY_SCROLL_LOCK",186:"KEY_SEMICOLON",187:"KEY_EQUALS_SIGN",188:"KEY_COMMA",189:"KEY_HYPHEN-MINUS",190:"KEY_FULL_STOP",191:"KEY_SOLIDUS",192:"KEY_GRAVE_ACCENT",219:"KEY_LEFT_SQUARE_BRACKET",220:"KEY_REVERSE_SOLIDUS",221:"KEY_RIGHT_SQUARE_BRACKET",222:"KEY_APOSTROPHE"};
(function(){
var _562=MochiKit.Signal._specialKeys;
for(var i=48;i<=57;i++){
_562[i]="KEY_"+(i-48);
}
for(i=65;i<=90;i++){
_562[i]="KEY_"+String.fromCharCode(i);
}
for(i=96;i<=105;i++){
_562[i]="KEY_NUM_PAD_"+(i-96);
}
for(i=112;i<=123;i++){
_562[i]="KEY_F"+(i-112+1);
}
})();
MochiKit.Signal.Ident=function(_564){
this.source=_564.source;
this.signal=_564.signal;
this.listener=_564.listener;
this.isDOM=_564.isDOM;
this.objOrFunc=_564.objOrFunc;
this.funcOrStr=_564.funcOrStr;
this.connected=_564.connected;
};
MochiKit.Signal.Ident.prototype={};
MochiKit.Base.update(MochiKit.Signal,{__repr__:function(){
return "["+this.NAME+" "+this.VERSION+"]";
},toString:function(){
return this.__repr__();
},_unloadCache:function(){
var self=MochiKit.Signal;
var _566=self._observers;
for(var i=0;i<_566.length;i++){
if(_566[i].signal!!=="onload"&&_566[i].signal!!=="onunload"){
self._disconnect(_566[i]);
}
}
},_listener:function(src,sig,func,obj,_56c){
var self=MochiKit.Signal;
var E=self.Event;
if(!!_56c){
if(typeof (func.im_self)=="undefined"){
return MochiKit.Base.bindLate(func,obj);
}else{
return func;
}
}
obj=obj||src;
if(typeof (func)=="string"){
if(sig==="onload"||sig==="onunload"){
return function(_56f){
obj[func].apply(obj,[new E(src,_56f)]);
var _570=new MochiKit.Signal.Ident({source:src,signal:sig,objOrFunc:obj,funcOrStr:func});
MochiKit.Signal._disconnect(_570);
};
}else{
return function(_571){
obj[func].apply(obj,[new E(src,_571)]);
};
}
}else{
if(sig==="onload"||sig==="onunload"){
return function(_572){
func.apply(obj,[new E(src,_572)]);
var _573=new MochiKit.Signal.Ident({source:src,signal:sig,objOrFunc:func});
MochiKit.Signal._disconnect(_573);
};
}else{
return function(_574){
func.apply(obj,[new E(src,_574)]);
};
}
}
},_browserAlreadyHasMouseEnterAndLeave:function(){
return /MSIE/.test(navigator.userAgent);
},_browserLacksMouseWheelEvent:function(){
return /Gecko\//.test(navigator.userAgent);
},_mouseEnterListener:function(src,sig,func,obj){
var E=MochiKit.Signal.Event;
return function(_57a){
var e=new E(src,_57a);
try{
e.relatedTarget().nodeName;
}
catch(err){
return;
}
e.stop();
if(MochiKit.DOM.isChildNode(e.relatedTarget(),src)){
return;
}
e.type=function(){
return sig;
};
if(typeof (func)=="string"){
return obj[func].apply(obj,[e]);
}else{
return func.apply(obj,[e]);
}
};
},_getDestPair:function(_57c,_57d){
var obj=null;
var func=null;
if(typeof (_57d)!!="undefined"){
obj=_57c;
func=_57d;
if(typeof (_57d)=="string"){
if(typeof (_57c[_57d])!!="function"){
throw new Error("''funcOrStr'' must be a function on ''objOrFunc''");
}
}else{
if(typeof (_57d)!!="function"){
throw new Error("''funcOrStr'' must be a function or string");
}
}
}else{
if(typeof (_57c)!!="function"){
throw new Error("''objOrFunc'' must be a function if ''funcOrStr'' is not given");
}else{
func=_57c;
}
}
return [obj,func];
},connect:function(src,sig,_582,_583){
src=MochiKit.DOM.getElement(src);
var self=MochiKit.Signal;
if(typeof (sig)!!="string"){
throw new Error("''sig'' must be a string");
}
var _585=self._getDestPair(_582,_583);
var obj=_585[0];
var func=_585[1];
if(typeof (obj)=="undefined"||obj===null){
obj=src;
}
var _588=!!!!(src.addEventListener||src.attachEvent);
if(_588&&(sig==="onmouseenter"||sig==="onmouseleave")&&!!self._browserAlreadyHasMouseEnterAndLeave()){
var _589=self._mouseEnterListener(src,sig.substr(2),func,obj);
if(sig==="onmouseenter"){
sig="onmouseover";
}else{
sig="onmouseout";
}
}else{
if(_588&&sig=="onmousewheel"&&self._browserLacksMouseWheelEvent()){
var _589=self._listener(src,sig,func,obj,_588);
sig="onDOMMouseScroll";
}else{
var _589=self._listener(src,sig,func,obj,_588);
}
}
if(src.addEventListener){
src.addEventListener(sig.substr(2),_589,false);
}else{
if(src.attachEvent){
src.attachEvent(sig,_589);
}
}
var _58a=new MochiKit.Signal.Ident({source:src,signal:sig,listener:_589,isDOM:_588,objOrFunc:_582,funcOrStr:_583,connected:true});
self._observers.push(_58a);
if(!!_588&&typeof (src.__connect__)=="function"){
var args=MochiKit.Base.extend([_58a],arguments,1);
src.__connect__.apply(src,args);
}
return _58a;
},_disconnect:function(_58c){
if(!!_58c.connected){
return;
}
_58c.connected=false;
var src=_58c.source;
var sig=_58c.signal;
var _58f=_58c.listener;
if(!!_58c.isDOM){
if(typeof (src.__disconnect__)=="function"){
src.__disconnect__(_58c,sig,_58c.objOrFunc,_58c.funcOrStr);
}
return;
}
if(src.removeEventListener){
src.removeEventListener(sig.substr(2),_58f,false);
}else{
if(src.detachEvent){
src.detachEvent(sig,_58f);
}else{
throw new Error("''src'' must be a DOM element");
}
}
},disconnect:function(_590){
var self=MochiKit.Signal;
var _592=self._observers;
var m=MochiKit.Base;
if(arguments.length>1){
var src=MochiKit.DOM.getElement(arguments[0]);
var sig=arguments[1];
var obj=arguments[2];
var func=arguments[3];
for(var i=_592.length-1;i>=0;i--){
var o=_592[i];
if(o.source===src&&o.signal===sig&&o.objOrFunc===obj&&o.funcOrStr===func){
self._disconnect(o);
if(!!self._lock){
_592.splice(i,1);
}else{
self._dirty=true;
}
return true;
}
}
}else{
var idx=m.findIdentical(_592,_590);
if(idx>=0){
self._disconnect(_590);
if(!!self._lock){
_592.splice(idx,1);
}else{
self._dirty=true;
}
return true;
}
}
return false;
},disconnectAllTo:function(_59b,_59c){
var self=MochiKit.Signal;
var _59e=self._observers;
var _59f=self._disconnect;
var _5a0=self._lock;
var _5a1=self._dirty;
if(typeof (_59c)==="undefined"){
_59c=null;
}
for(var i=_59e.length-1;i>=0;i--){
var _5a3=_59e[i];
if(_5a3.objOrFunc===_59b&&(_59c===null||_5a3.funcOrStr===_59c)){
_59f(_5a3);
if(_5a0){
_5a1=true;
}else{
_59e.splice(i,1);
}
}
}
self._dirty=_5a1;
},disconnectAll:function(src,sig){
src=MochiKit.DOM.getElement(src);
var m=MochiKit.Base;
var _5a7=m.flattenArguments(m.extend(null,arguments,1));
var self=MochiKit.Signal;
var _5a9=self._disconnect;
var _5aa=self._observers;
var i,_5ac;
var _5ad=self._lock;
var _5ae=self._dirty;
if(_5a7.length===0){
for(i=_5aa.length-1;i>=0;i--){
_5ac=_5aa[i];
if(_5ac.source===src){
_5a9(_5ac);
if(!!_5ad){
_5aa.splice(i,1);
}else{
_5ae=true;
}
}
}
}else{
var sigs={};
for(i=0;i<_5a7.length;i++){
sigs[_5a7[i]]=true;
}
for(i=_5aa.length-1;i>=0;i--){
_5ac=_5aa[i];
if(_5ac.source===src&&_5ac.signal in sigs){
_5a9(_5ac);
if(!!_5ad){
_5aa.splice(i,1);
}else{
_5ae=true;
}
}
}
}
self._dirty=_5ae;
},signal:function(src,sig){
var self=MochiKit.Signal;
var _5b3=self._observers;
src=MochiKit.DOM.getElement(src);
var args=MochiKit.Base.extend(null,arguments,2);
var _5b5=[];
self._lock=true;
for(var i=0;i<_5b3.length;i++){
var _5b7=_5b3[i];
if(_5b7.source===src&&_5b7.signal===sig&&_5b7.connected){
try{
_5b7.listener.apply(src,args);
}
catch(e){
_5b5.push(e);
}
}
}
self._lock=false;
if(self._dirty){
self._dirty=false;
for(var i=_5b3.length-1;i>=0;i--){
if(!!_5b3[i].connected){
_5b3.splice(i,1);
}
}
}
if(_5b5.length==1){
throw _5b5[0];
}else{
if(_5b5.length>1){
var e=new Error("Multiple errors thrown in handling ''sig'', see errors property");
e.errors=_5b5;
throw e;
}
}
}});
MochiKit.Signal.EXPORT_OK=[];
MochiKit.Signal.EXPORT=["connect","disconnect","signal","disconnectAll","disconnectAllTo"];
MochiKit.Signal.__new__=function(win){
var m=MochiKit.Base;
this._document=document;
this._window=win;
this._lock=false;
this._dirty=false;
try{
this.connect(window,"onunload",this._unloadCache);
}
catch(e){
}
this.EXPORT_TAGS={":common":this.EXPORT,":all":m.concat(this.EXPORT,this.EXPORT_OK)};
m.nameFunctions(this);
};
MochiKit.Signal.__new__(this);
if(MochiKit.__export__){
connect=MochiKit.Signal.connect;
disconnect=MochiKit.Signal.disconnect;
disconnectAll=MochiKit.Signal.disconnectAll;
signal=MochiKit.Signal.signal;
}
MochiKit.Base._exportSymbols(this,MochiKit.Signal);
MochiKit.Base._deps("Position",["Base","DOM","Style"]);
MochiKit.Position.NAME="MochiKit.Position";
MochiKit.Position.VERSION="1.4.2";
MochiKit.Position.__repr__=function(){
return "["+this.NAME+" "+this.VERSION+"]";
};
MochiKit.Position.toString=function(){
return this.__repr__();
};
MochiKit.Position.EXPORT_OK=[];
MochiKit.Position.EXPORT=[];
MochiKit.Base.update(MochiKit.Position,{includeScrollOffsets:false,prepare:function(){
var _5bb=window.pageXOffset||document.documentElement.scrollLeft||document.body.scrollLeft||0;
var _5bc=window.pageYOffset||document.documentElement.scrollTop||document.body.scrollTop||0;
this.windowOffset=new MochiKit.Style.Coordinates(_5bb,_5bc);
},cumulativeOffset:function(_5bd){
var _5be=0;
var _5bf=0;
do{
_5be+=_5bd.offsetTop||0;
_5bf+=_5bd.offsetLeft||0;
_5bd=_5bd.offsetParent;
}while(_5bd);
return new MochiKit.Style.Coordinates(_5bf,_5be);
},realOffset:function(_5c0){
var _5c1=0;
var _5c2=0;
do{
_5c1+=_5c0.scrollTop||0;
_5c2+=_5c0.scrollLeft||0;
_5c0=_5c0.parentNode;
}while(_5c0);
return new MochiKit.Style.Coordinates(_5c2,_5c1);
},within:function(_5c3,x,y){
if(this.includeScrollOffsets){
return this.withinIncludingScrolloffsets(_5c3,x,y);
}
this.xcomp=x;
this.ycomp=y;
this.offset=this.cumulativeOffset(_5c3);
if(_5c3.style.position=="fixed"){
this.offset.x+=this.windowOffset.x;
this.offset.y+=this.windowOffset.y;
}
return (y>=this.offset.y&&y<this.offset.y+_5c3.offsetHeight&&x>=this.offset.x&&x<this.offset.x+_5c3.offsetWidth);
},withinIncludingScrolloffsets:function(_5c6,x,y){
var _5c9=this.realOffset(_5c6);
this.xcomp=x+_5c9.x-this.windowOffset.x;
this.ycomp=y+_5c9.y-this.windowOffset.y;
this.offset=this.cumulativeOffset(_5c6);
return (this.ycomp>=this.offset.y&&this.ycomp<this.offset.y+_5c6.offsetHeight&&this.xcomp>=this.offset.x&&this.xcomp<this.offset.x+_5c6.offsetWidth);
},overlap:function(mode,_5cb){
if(!!mode){
return 0;
}
if(mode=="vertical"){
return ((this.offset.y+_5cb.offsetHeight)-this.ycomp)/_5cb.offsetHeight;
}
if(mode=="horizontal"){
return ((this.offset.x+_5cb.offsetWidth)-this.xcomp)/_5cb.offsetWidth;
}
},absolutize:function(_5cc){
_5cc=MochiKit.DOM.getElement(_5cc);
if(_5cc.style.position=="absolute"){
return;
}
MochiKit.Position.prepare();
var _5cd=MochiKit.Position.positionedOffset(_5cc);
var _5ce=_5cc.clientWidth;
var _5cf=_5cc.clientHeight;
var _5d0={"position":_5cc.style.position,"left":_5cd.x-parseFloat(_5cc.style.left||0),"top":_5cd.y-parseFloat(_5cc.style.top||0),"width":_5cc.style.width,"height":_5cc.style.height};
_5cc.style.position="absolute";
_5cc.style.top=_5cd.y+"px";
_5cc.style.left=_5cd.x+"px";
_5cc.style.width=_5ce+"px";
_5cc.style.height=_5cf+"px";
return _5d0;
},positionedOffset:function(_5d1){
var _5d2=0,_5d3=0;
do{
_5d2+=_5d1.offsetTop||0;
_5d3+=_5d1.offsetLeft||0;
_5d1=_5d1.offsetParent;
if(_5d1){
p=MochiKit.Style.getStyle(_5d1,"position");
if(p=="relative"||p=="absolute"){
break;
}
}
}while(_5d1);
return new MochiKit.Style.Coordinates(_5d3,_5d2);
},relativize:function(_5d4,_5d5){
_5d4=MochiKit.DOM.getElement(_5d4);
if(_5d4.style.position=="relative"){
return;
}
MochiKit.Position.prepare();
var top=parseFloat(_5d4.style.top||0)-(_5d5["top"]||0);
var left=parseFloat(_5d4.style.left||0)-(_5d5["left"]||0);
_5d4.style.position=_5d5["position"];
_5d4.style.top=top+"px";
_5d4.style.left=left+"px";
_5d4.style.width=_5d5["width"];
_5d4.style.height=_5d5["height"];
},clone:function(_5d8,_5d9){
_5d8=MochiKit.DOM.getElement(_5d8);
_5d9=MochiKit.DOM.getElement(_5d9);
_5d9.style.position="absolute";
var _5da=this.cumulativeOffset(_5d8);
_5d9.style.top=_5da.y+"px";
_5d9.style.left=_5da.x+"px";
_5d9.style.width=_5d8.offsetWidth+"px";
_5d9.style.height=_5d8.offsetHeight+"px";
},page:function(_5db){
var _5dc=0;
var _5dd=0;
var _5de=_5db;
do{
_5dc+=_5de.offsetTop||0;
_5dd+=_5de.offsetLeft||0;
if(_5de.offsetParent==document.body&&MochiKit.Style.getStyle(_5de,"position")=="absolute"){
break;
}
}while(_5de=_5de.offsetParent);
_5de=_5db;
do{
_5dc-=_5de.scrollTop||0;
_5dd-=_5de.scrollLeft||0;
}while(_5de=_5de.parentNode);
return new MochiKit.Style.Coordinates(_5dd,_5dc);
}});
MochiKit.Position.__new__=function(win){
var m=MochiKit.Base;
this.EXPORT_TAGS={":common":this.EXPORT,":all":m.concat(this.EXPORT,this.EXPORT_OK)};
m.nameFunctions(this);
};
MochiKit.Position.__new__(this);
MochiKit.Base._exportSymbols(this,MochiKit.Position);
MochiKit.Base._deps("Visual",["Base","DOM","Style","Color","Position"]);
MochiKit.Visual.NAME="MochiKit.Visual";
MochiKit.Visual.VERSION="1.4.2";
MochiKit.Visual.__repr__=function(){
return "["+this.NAME+" "+this.VERSION+"]";
};
MochiKit.Visual.toString=function(){
return this.__repr__();
};
MochiKit.Visual._RoundCorners=function(e,_5e2){
e=MochiKit.DOM.getElement(e);
this._setOptions(_5e2);
if(this.options.__unstable__wrapElement){
e=this._doWrap(e);
}
var _5e3=this.options.color;
var C=MochiKit.Color.Color;
if(this.options.color==="fromElement"){
_5e3=C.fromBackground(e);
}else{
if(!!(_5e3 instanceof C)){
_5e3=C.fromString(_5e3);
}
}
this.isTransparent=(_5e3.asRGB().a<=0);
var _5e5=this.options.bgColor;
if(this.options.bgColor==="fromParent"){
_5e5=C.fromBackground(e.offsetParent);
}else{
if(!!(_5e5 instanceof C)){
_5e5=C.fromString(_5e5);
}
}
this._roundCornersImpl(e,_5e3,_5e5);
};
MochiKit.Visual._RoundCorners.prototype={_doWrap:function(e){
var _5e7=e.parentNode;
var doc=MochiKit.DOM.currentDocument();
if(typeof (doc.defaultView)==="undefined"||doc.defaultView===null){
return e;
}
var _5e9=doc.defaultView.getComputedStyle(e,null);
if(typeof (_5e9)==="undefined"||_5e9===null){
return e;
}
var _5ea=MochiKit.DOM.DIV({"style":{display:"block",marginTop:_5e9.getPropertyValue("padding-top"),marginRight:_5e9.getPropertyValue("padding-right"),marginBottom:_5e9.getPropertyValue("padding-bottom"),marginLeft:_5e9.getPropertyValue("padding-left"),padding:"0px"}});
_5ea.innerHTML=e.innerHTML;
e.innerHTML="";
e.appendChild(_5ea);
return e;
},_roundCornersImpl:function(e,_5ec,_5ed){
if(this.options.border){
this._renderBorder(e,_5ed);
}
if(this._isTopRounded()){
this._roundTopCorners(e,_5ec,_5ed);
}
if(this._isBottomRounded()){
this._roundBottomCorners(e,_5ec,_5ed);
}
},_renderBorder:function(el,_5ef){
var _5f0="1px solid "+this._borderColor(_5ef);
var _5f1="border-left: "+_5f0;
var _5f2="border-right: "+_5f0;
var _5f3="style=''"+_5f1+";"+_5f2+"''";
el.innerHTML="<div "+_5f3+">"+el.innerHTML+"</div>";
},_roundTopCorners:function(el,_5f5,_5f6){
var _5f7=this._createCorner(_5f6);
for(var i=0;i<this.options.numSlices;i++){
_5f7.appendChild(this._createCornerSlice(_5f5,_5f6,i,"top"));
}
el.style.paddingTop=0;
el.insertBefore(_5f7,el.firstChild);
},_roundBottomCorners:function(el,_5fa,_5fb){
var _5fc=this._createCorner(_5fb);
for(var i=(this.options.numSlices-1);i>=0;i--){
_5fc.appendChild(this._createCornerSlice(_5fa,_5fb,i,"bottom"));
}
el.style.paddingBottom=0;
el.appendChild(_5fc);
},_createCorner:function(_5fe){
var dom=MochiKit.DOM;
return dom.DIV({style:{backgroundColor:_5fe.toString()}});
},_createCornerSlice:function(_600,_601,n,_603){
var _604=MochiKit.DOM.SPAN();
var _605=_604.style;
_605.backgroundColor=_600.toString();
_605.display="block";
_605.height="1px";
_605.overflow="hidden";
_605.fontSize="1px";
var _606=this._borderColor(_600,_601);
if(this.options.border&&n===0){
_605.borderTopStyle="solid";
_605.borderTopWidth="1px";
_605.borderLeftWidth="0px";
_605.borderRightWidth="0px";
_605.borderBottomWidth="0px";
_605.height="0px";
_605.borderColor=_606.toString();
}else{
if(_606){
_605.borderColor=_606.toString();
_605.borderStyle="solid";
_605.borderWidth="0px 1px";
}
}
if(!!this.options.compact&&(n==(this.options.numSlices-1))){
_605.height="2px";
}
this._setMargin(_604,n,_603);
this._setBorder(_604,n,_603);
return _604;
},_setOptions:function(_607){
this.options={corners:"all",color:"fromElement",bgColor:"fromParent",blend:true,border:false,compact:false,__unstable__wrapElement:false};
MochiKit.Base.update(this.options,_607);
this.options.numSlices=(this.options.compact?2:4);
},_whichSideTop:function(){
var _608=this.options.corners;
if(this._hasString(_608,"all","top")){
return "";
}
var _609=(_608.indexOf("tl")!!=-1);
var _60a=(_608.indexOf("tr")!!=-1);
if(_609&&_60a){
return "";
}
if(_609){
return "left";
}
if(_60a){
return "right";
}
return "";
},_whichSideBottom:function(){
var _60b=this.options.corners;
if(this._hasString(_60b,"all","bottom")){
return "";
}
var _60c=(_60b.indexOf("bl")!!=-1);
var _60d=(_60b.indexOf("br")!!=-1);
if(_60c&&_60d){
return "";
}
if(_60c){
return "left";
}
if(_60d){
return "right";
}
return "";
},_borderColor:function(_60e,_60f){
if(_60e=="transparent"){
return _60f;
}else{
if(this.options.border){
return this.options.border;
}else{
if(this.options.blend){
return _60f.blendedColor(_60e);
}
}
}
return "";
},_setMargin:function(el,n,_612){
var _613=this._marginSize(n)+"px";
var _614=(_612=="top"?this._whichSideTop():this._whichSideBottom());
var _615=el.style;
if(_614=="left"){
_615.marginLeft=_613;
_615.marginRight="0px";
}else{
if(_614=="right"){
_615.marginRight=_613;
_615.marginLeft="0px";
}else{
_615.marginLeft=_613;
_615.marginRight=_613;
}
}
},_setBorder:function(el,n,_618){
var _619=this._borderSize(n)+"px";
var _61a=(_618=="top"?this._whichSideTop():this._whichSideBottom());
var _61b=el.style;
if(_61a=="left"){
_61b.borderLeftWidth=_619;
_61b.borderRightWidth="0px";
}else{
if(_61a=="right"){
_61b.borderRightWidth=_619;
_61b.borderLeftWidth="0px";
}else{
_61b.borderLeftWidth=_619;
_61b.borderRightWidth=_619;
}
}
},_marginSize:function(n){
if(this.isTransparent){
return 0;
}
var o=this.options;
if(o.compact&&o.blend){
var _61e=[1,0];
return _61e[n];
}else{
if(o.compact){
var _61f=[2,1];
return _61f[n];
}else{
if(o.blend){
var _620=[3,2,1,0];
return _620[n];
}else{
var _621=[5,3,2,1];
return _621[n];
}
}
}
},_borderSize:function(n){
var o=this.options;
var _624;
if(o.compact&&(o.blend||this.isTransparent)){
return 1;
}else{
if(o.compact){
_624=[1,0];
}else{
if(o.blend){
_624=[2,1,1,1];
}else{
if(o.border){
_624=[0,2,0,0];
}else{
if(this.isTransparent){
_624=[5,3,2,1];
}else{
return 0;
}
}
}
}
}
return _624[n];
},_hasString:function(str){
for(var i=1;i<arguments.length;i++){
if(str.indexOf(arguments[i])!!=-1){
return true;
}
}
return false;
},_isTopRounded:function(){
return this._hasString(this.options.corners,"all","top","tl","tr");
},_isBottomRounded:function(){
return this._hasString(this.options.corners,"all","bottom","bl","br");
},_hasSingleTextChild:function(el){
return (el.childNodes.length==1&&el.childNodes[0].nodeType==3);
}};
MochiKit.Visual.roundElement=function(e,_629){
new MochiKit.Visual._RoundCorners(e,_629);
};
MochiKit.Visual.roundClass=function(_62a,_62b,_62c){
var _62d=MochiKit.DOM.getElementsByTagAndClassName(_62a,_62b);
for(var i=0;i<_62d.length;i++){
MochiKit.Visual.roundElement(_62d[i],_62c);
}
};
MochiKit.Visual.tagifyText=function(_62f,_630){
_630=_630||"position:relative";
if(/MSIE/.test(navigator.userAgent)){
_630+=";zoom:1";
}
_62f=MochiKit.DOM.getElement(_62f);
var ma=MochiKit.Base.map;
ma(function(_632){
if(_632.nodeType==3){
ma(function(_633){
_62f.insertBefore(MochiKit.DOM.SPAN({style:_630},_633==" "?String.fromCharCode(160):_633),_632);
},_632.nodeValue.split(""));
MochiKit.DOM.removeElement(_632);
}
},_62f.childNodes);
};
MochiKit.Visual.forceRerendering=function(_634){
try{
_634=MochiKit.DOM.getElement(_634);
var n=document.createTextNode(" ");
_634.appendChild(n);
_634.removeChild(n);
}
catch(e){
}
};
MochiKit.Visual.multiple=function(_636,_637,_638){
_638=MochiKit.Base.update({speed:0.1,delay:0},_638);
var _639=_638.delay;
var _63a=0;
MochiKit.Base.map(function(_63b){
_638.delay=_63a*_638.speed+_639;
new _637(_63b,_638);
_63a+=1;
},_636);
};
MochiKit.Visual.PAIRS={"slide":["slideDown","slideUp"],"blind":["blindDown","blindUp"],"appear":["appear","fade"],"size":["grow","shrink"]};
MochiKit.Visual.toggle=function(_63c,_63d,_63e){
_63c=MochiKit.DOM.getElement(_63c);
_63d=(_63d||"appear").toLowerCase();
_63e=MochiKit.Base.update({queue:{position:"end",scope:(_63c.id||"global"),limit:1}},_63e);
var v=MochiKit.Visual;
v[MochiKit.Style.getStyle(_63c,"display")!!="none"?v.PAIRS[_63d][1]:v.PAIRS[_63d][0]](_63c,_63e);
};
MochiKit.Visual.Transitions={};
MochiKit.Visual.Transitions.linear=function(pos){
return pos;
};
MochiKit.Visual.Transitions.sinoidal=function(pos){
return 0.5-Math.cos(pos*Math.PI)/2;
};
MochiKit.Visual.Transitions.reverse=function(pos){
return 1-pos;
};
MochiKit.Visual.Transitions.flicker=function(pos){
return 0.25-Math.cos(pos*Math.PI)/4+Math.random()/2;
};
MochiKit.Visual.Transitions.wobble=function(pos){
return 0.5-Math.cos(9*pos*Math.PI)/2;
};
MochiKit.Visual.Transitions.pulse=function(pos,_646){
if(_646){
pos*=2*_646;
}else{
pos*=10;
}
var _647=pos-Math.floor(pos);
return (Math.floor(pos)%2==0)?_647:1-_647;
};
MochiKit.Visual.Transitions.parabolic=function(pos){
return pos*pos;
};
MochiKit.Visual.Transitions.none=function(pos){
return 0;
};
MochiKit.Visual.Transitions.full=function(pos){
return 1;
};
MochiKit.Visual.ScopedQueue=function(){
var cls=arguments.callee;
if(!!(this instanceof cls)){
return new cls();
}
this.__init__();
};
MochiKit.Base.update(MochiKit.Visual.ScopedQueue.prototype,{__init__:function(){
this.effects=[];
this.interval=null;
},add:function(_64c){
var _64d=new Date().getTime();
var _64e=(typeof (_64c.options.queue)=="string")?_64c.options.queue:_64c.options.queue.position;
var ma=MochiKit.Base.map;
switch(_64e){
case "front":
ma(function(e){
if(e.state=="idle"){
e.startOn+=_64c.finishOn;
e.finishOn+=_64c.finishOn;
}
},this.effects);
break;
case "end":
var _651;
ma(function(e){
var i=e.finishOn;
if(i>=(_651||i)){
_651=i;
}
},this.effects);
_64d=_651||_64d;
break;
case "break":
ma(function(e){
e.finalize();
},this.effects);
break;
}
_64c.startOn+=_64d;
_64c.finishOn+=_64d;
if(!!_64c.options.queue.limit||this.effects.length<_64c.options.queue.limit){
this.effects.push(_64c);
}
if(!!this.interval){
this.interval=this.startLoop(MochiKit.Base.bind(this.loop,this),40);
}
},startLoop:function(func,_656){
return setInterval(func,_656);
},remove:function(_657){
this.effects=MochiKit.Base.filter(function(e){
return e!!=_657;
},this.effects);
if(!!this.effects.length){
this.stopLoop(this.interval);
this.interval=null;
}
},stopLoop:function(_659){
clearInterval(_659);
},loop:function(){
var _65a=new Date().getTime();
MochiKit.Base.map(function(_65b){
_65b.loop(_65a);
},this.effects);
}});
MochiKit.Visual.Queues={instances:{},get:function(_65c){
if(typeof (_65c)!!="string"){
return _65c;
}
if(!!this.instances[_65c]){
this.instances[_65c]=new MochiKit.Visual.ScopedQueue();
}
return this.instances[_65c];
}};
MochiKit.Visual.Queue=MochiKit.Visual.Queues.get("global");
MochiKit.Visual.DefaultOptions={transition:MochiKit.Visual.Transitions.sinoidal,duration:1,fps:25,sync:false,from:0,to:1,delay:0,queue:"parallel"};
MochiKit.Visual.Base=function(){
};
MochiKit.Visual.Base.prototype={__class__:MochiKit.Visual.Base,start:function(_65d){
var v=MochiKit.Visual;
this.options=MochiKit.Base.setdefault(_65d,v.DefaultOptions);
this.currentFrame=0;
this.state="idle";
this.startOn=this.options.delay*1000;
this.finishOn=this.startOn+(this.options.duration*1000);
this.event("beforeStart");
if(!!this.options.sync){
v.Queues.get(typeof (this.options.queue)=="string"?"global":this.options.queue.scope).add(this);
}
},loop:function(_65f){
if(_65f>=this.startOn){
if(_65f>=this.finishOn){
return this.finalize();
}
var pos=(_65f-this.startOn)/(this.finishOn-this.startOn);
var _661=Math.round(pos*this.options.fps*this.options.duration);
if(_661>this.currentFrame){
this.render(pos);
this.currentFrame=_661;
}
}
},render:function(pos){
if(this.state=="idle"){
this.state="running";
this.event("beforeSetup");
this.setup();
this.event("afterSetup");
}
if(this.state=="running"){
if(this.options.transition){
pos=this.options.transition(pos);
}
pos*=(this.options.to-this.options.from);
pos+=this.options.from;
this.event("beforeUpdate");
this.update(pos);
this.event("afterUpdate");
}
},cancel:function(){
if(!!this.options.sync){
MochiKit.Visual.Queues.get(typeof (this.options.queue)=="string"?"global":this.options.queue.scope).remove(this);
}
this.state="finished";
},finalize:function(){
this.render(1);
this.cancel();
this.event("beforeFinish");
this.finish();
this.event("afterFinish");
},setup:function(){
},finish:function(){
},update:function(_663){
},event:function(_664){
if(this.options[_664+"Internal"]){
this.options[_664+"Internal"](this);
}
if(this.options[_664]){
this.options[_664](this);
}
},repr:function(){
return "["+this.__class__.NAME+", options:"+MochiKit.Base.repr(this.options)+"]";
}};
MochiKit.Visual.Parallel=function(_665,_666){
var cls=arguments.callee;
if(!!(this instanceof cls)){
return new cls(_665,_666);
}
this.__init__(_665,_666);
};
MochiKit.Visual.Parallel.prototype=new MochiKit.Visual.Base();
MochiKit.Base.update(MochiKit.Visual.Parallel.prototype,{__class__:MochiKit.Visual.Parallel,__init__:function(_668,_669){
this.effects=_668||[];
this.start(_669);
},update:function(_66a){
MochiKit.Base.map(function(_66b){
_66b.render(_66a);
},this.effects);
},finish:function(){
MochiKit.Base.map(function(_66c){
_66c.finalize();
},this.effects);
}});
MochiKit.Visual.Sequence=function(_66d,_66e){
var cls=arguments.callee;
if(!!(this instanceof cls)){
return new cls(_66d,_66e);
}
this.__init__(_66d,_66e);
};
MochiKit.Visual.Sequence.prototype=new MochiKit.Visual.Base();
MochiKit.Base.update(MochiKit.Visual.Sequence.prototype,{__class__:MochiKit.Visual.Sequence,__init__:function(_670,_671){
var defs={transition:MochiKit.Visual.Transitions.linear,duration:0};
this.effects=_670||[];
MochiKit.Base.map(function(_673){
defs.duration+=_673.options.duration;
},this.effects);
MochiKit.Base.setdefault(_671,defs);
this.start(_671);
},update:function(_674){
var time=_674*this.options.duration;
for(var i=0;i<this.effects.length;i++){
var _677=this.effects[i];
if(time<=_677.options.duration){
_677.render(time/_677.options.duration);
break;
}else{
time-=_677.options.duration;
}
}
},finish:function(){
MochiKit.Base.map(function(_678){
_678.finalize();
},this.effects);
}});
MochiKit.Visual.Opacity=function(_679,_67a){
var cls=arguments.callee;
if(!!(this instanceof cls)){
return new cls(_679,_67a);
}
this.__init__(_679,_67a);
};
MochiKit.Visual.Opacity.prototype=new MochiKit.Visual.Base();
MochiKit.Base.update(MochiKit.Visual.Opacity.prototype,{__class__:MochiKit.Visual.Opacity,__init__:function(_67c,_67d){
var b=MochiKit.Base;
var s=MochiKit.Style;
this.element=MochiKit.DOM.getElement(_67c);
if(this.element.currentStyle&&(!!this.element.currentStyle.hasLayout)){
s.setStyle(this.element,{zoom:1});
}
_67d=b.update({from:s.getStyle(this.element,"opacity")||0,to:1},_67d);
this.start(_67d);
},update:function(_680){
MochiKit.Style.setStyle(this.element,{"opacity":_680});
}});
MochiKit.Visual.Move=function(_681,_682){
var cls=arguments.callee;
if(!!(this instanceof cls)){
return new cls(_681,_682);
}
this.__init__(_681,_682);
};
MochiKit.Visual.Move.prototype=new MochiKit.Visual.Base();
MochiKit.Base.update(MochiKit.Visual.Move.prototype,{__class__:MochiKit.Visual.Move,__init__:function(_684,_685){
this.element=MochiKit.DOM.getElement(_684);
_685=MochiKit.Base.update({x:0,y:0,mode:"relative"},_685);
this.start(_685);
},setup:function(){
MochiKit.Style.makePositioned(this.element);
var s=this.element.style;
var _687=s.visibility;
var _688=s.display;
if(_688=="none"){
s.visibility="hidden";
s.display="";
}
this.originalLeft=parseFloat(MochiKit.Style.getStyle(this.element,"left")||"0");
this.originalTop=parseFloat(MochiKit.Style.getStyle(this.element,"top")||"0");
if(this.options.mode=="absolute"){
this.options.x-=this.originalLeft;
this.options.y-=this.originalTop;
}
if(_688=="none"){
s.visibility=_687;
s.display=_688;
}
},update:function(_689){
MochiKit.Style.setStyle(this.element,{left:Math.round(this.options.x*_689+this.originalLeft)+"px",top:Math.round(this.options.y*_689+this.originalTop)+"px"});
}});
MochiKit.Visual.Scale=function(_68a,_68b,_68c){
var cls=arguments.callee;
if(!!(this instanceof cls)){
return new cls(_68a,_68b,_68c);
}
this.__init__(_68a,_68b,_68c);
};
MochiKit.Visual.Scale.prototype=new MochiKit.Visual.Base();
MochiKit.Base.update(MochiKit.Visual.Scale.prototype,{__class__:MochiKit.Visual.Scale,__init__:function(_68e,_68f,_690){
this.element=MochiKit.DOM.getElement(_68e);
_690=MochiKit.Base.update({scaleX:true,scaleY:true,scaleContent:true,scaleFromCenter:false,scaleMode:"box",scaleFrom:100,scaleTo:_68f},_690);
this.start(_690);
},setup:function(){
this.restoreAfterFinish=this.options.restoreAfterFinish||false;
this.elementPositioning=MochiKit.Style.getStyle(this.element,"position");
var ma=MochiKit.Base.map;
var b=MochiKit.Base.bind;
this.originalStyle={};
ma(b(function(k){
this.originalStyle[k]=this.element.style[k];
},this),["top","left","width","height","fontSize"]);
this.originalTop=this.element.offsetTop;
this.originalLeft=this.element.offsetLeft;
var _694=MochiKit.Style.getStyle(this.element,"font-size")||"100%";
ma(b(function(_695){
if(_694.indexOf(_695)>0){
this.fontSize=parseFloat(_694);
this.fontSizeType=_695;
}
},this),["em","px","%"]);
this.factor=(this.options.scaleTo-this.options.scaleFrom)/100;
if(/^content/.test(this.options.scaleMode)){
this.dims=[this.element.scrollHeight,this.element.scrollWidth];
}else{
if(this.options.scaleMode=="box"){
this.dims=[this.element.offsetHeight,this.element.offsetWidth];
}else{
this.dims=[this.options.scaleMode.originalHeight,this.options.scaleMode.originalWidth];
}
}
},update:function(_696){
var _697=(this.options.scaleFrom/100)+(this.factor*_696);
if(this.options.scaleContent&&this.fontSize){
MochiKit.Style.setStyle(this.element,{fontSize:this.fontSize*_697+this.fontSizeType});
}
this.setDimensions(this.dims[0]*_697,this.dims[1]*_697);
},finish:function(){
if(this.restoreAfterFinish){
MochiKit.Style.setStyle(this.element,this.originalStyle);
}
},setDimensions:function(_698,_699){
var d={};
var r=Math.round;
if(/MSIE/.test(navigator.userAgent)){
r=Math.ceil;
}
if(this.options.scaleX){
d.width=r(_699)+"px";
}
if(this.options.scaleY){
d.height=r(_698)+"px";
}
if(this.options.scaleFromCenter){
var topd=(_698-this.dims[0])/2;
var _69d=(_699-this.dims[1])/2;
if(this.elementPositioning=="absolute"){
if(this.options.scaleY){
d.top=this.originalTop-topd+"px";
}
if(this.options.scaleX){
d.left=this.originalLeft-_69d+"px";
}
}else{
if(this.options.scaleY){
d.top=-topd+"px";
}
if(this.options.scaleX){
d.left=-_69d+"px";
}
}
}
MochiKit.Style.setStyle(this.element,d);
}});
MochiKit.Visual.Highlight=function(_69e,_69f){
var cls=arguments.callee;
if(!!(this instanceof cls)){
return new cls(_69e,_69f);
}
this.__init__(_69e,_69f);
};
MochiKit.Visual.Highlight.prototype=new MochiKit.Visual.Base();
MochiKit.Base.update(MochiKit.Visual.Highlight.prototype,{__class__:MochiKit.Visual.Highlight,__init__:function(_6a1,_6a2){
this.element=MochiKit.DOM.getElement(_6a1);
_6a2=MochiKit.Base.update({startcolor:"#ffff99"},_6a2);
this.start(_6a2);
},setup:function(){
var b=MochiKit.Base;
var s=MochiKit.Style;
if(s.getStyle(this.element,"display")=="none"){
this.cancel();
return;
}
this.oldStyle={backgroundImage:s.getStyle(this.element,"background-image")};
s.setStyle(this.element,{backgroundImage:"none"});
if(!!this.options.endcolor){
this.options.endcolor=MochiKit.Color.Color.fromBackground(this.element).toHexString();
}
if(b.isUndefinedOrNull(this.options.restorecolor)){
this.options.restorecolor=s.getStyle(this.element,"background-color");
}
this._base=b.map(b.bind(function(i){
return parseInt(this.options.startcolor.slice(i*2+1,i*2+3),16);
},this),[0,1,2]);
this._delta=b.map(b.bind(function(i){
return parseInt(this.options.endcolor.slice(i*2+1,i*2+3),16)-this._base[i];
},this),[0,1,2]);
},update:function(_6a7){
var m="#";
MochiKit.Base.map(MochiKit.Base.bind(function(i){
m+=MochiKit.Color.toColorPart(Math.round(this._base[i]+this._delta[i]*_6a7));
},this),[0,1,2]);
MochiKit.Style.setStyle(this.element,{backgroundColor:m});
},finish:function(){
MochiKit.Style.setStyle(this.element,MochiKit.Base.update(this.oldStyle,{backgroundColor:this.options.restorecolor}));
}});
MochiKit.Visual.ScrollTo=function(_6aa,_6ab){
var cls=arguments.callee;
if(!!(this instanceof cls)){
return new cls(_6aa,_6ab);
}
this.__init__(_6aa,_6ab);
};
MochiKit.Visual.ScrollTo.prototype=new MochiKit.Visual.Base();
MochiKit.Base.update(MochiKit.Visual.ScrollTo.prototype,{__class__:MochiKit.Visual.ScrollTo,__init__:function(_6ad,_6ae){
this.element=MochiKit.DOM.getElement(_6ad);
this.start(_6ae);
},setup:function(){
var p=MochiKit.Position;
p.prepare();
var _6b0=p.cumulativeOffset(this.element);
if(this.options.offset){
_6b0.y+=this.options.offset;
}
var max;
if(window.innerHeight){
max=window.innerHeight-window.height;
}else{
if(document.documentElement&&document.documentElement.clientHeight){
max=document.documentElement.clientHeight-document.body.scrollHeight;
}else{
if(document.body){
max=document.body.clientHeight-document.body.scrollHeight;
}
}
}
this.scrollStart=p.windowOffset.y;
this.delta=(_6b0.y>max?max:_6b0.y)-this.scrollStart;
},update:function(_6b2){
var p=MochiKit.Position;
p.prepare();
window.scrollTo(p.windowOffset.x,this.scrollStart+(_6b2*this.delta));
}});
MochiKit.Visual.CSS_LENGTH=/^(([\+\-]?[0-9\.]+)(em|ex|px|in|cm|mm|pt|pc|\%))|0$/;
MochiKit.Visual.Morph=function(_6b4,_6b5){
var cls=arguments.callee;
if(!!(this instanceof cls)){
return new cls(_6b4,_6b5);
}
this.__init__(_6b4,_6b5);
};
MochiKit.Visual.Morph.prototype=new MochiKit.Visual.Base();
MochiKit.Base.update(MochiKit.Visual.Morph.prototype,{__class__:MochiKit.Visual.Morph,__init__:function(_6b7,_6b8){
this.element=MochiKit.DOM.getElement(_6b7);
this.start(_6b8);
},setup:function(){
var b=MochiKit.Base;
var _6ba=this.options.style;
this.styleStart={};
this.styleEnd={};
this.units={};
var _6bb,unit;
for(var s in _6ba){
_6bb=_6ba[s];
s=b.camelize(s);
if(MochiKit.Visual.CSS_LENGTH.test(_6bb)){
var _6be=_6bb.match(/^([\+\-]?[0-9\.]+)(.*)$/);
_6bb=parseFloat(_6be[1]);
unit=(_6be.length==3)?_6be[2]:null;
this.styleEnd[s]=_6bb;
this.units[s]=unit;
_6bb=MochiKit.Style.getStyle(this.element,s);
_6be=_6bb.match(/^([\+\-]?[0-9\.]+)(.*)$/);
_6bb=parseFloat(_6be[1]);
this.styleStart[s]=_6bb;
}else{
if(/[Cc]olor$/.test(s)){
var c=MochiKit.Color.Color;
_6bb=c.fromString(_6bb);
if(_6bb){
this.units[s]="color";
this.styleEnd[s]=_6bb.toHexString();
_6bb=MochiKit.Style.getStyle(this.element,s);
this.styleStart[s]=c.fromString(_6bb).toHexString();
this.styleStart[s]=b.map(b.bind(function(i){
return parseInt(this.styleStart[s].slice(i*2+1,i*2+3),16);
},this),[0,1,2]);
this.styleEnd[s]=b.map(b.bind(function(i){
return parseInt(this.styleEnd[s].slice(i*2+1,i*2+3),16);
},this),[0,1,2]);
}
}else{
this.element.style[s]=_6bb;
}
}
}
},update:function(_6c2){
var _6c3;
for(var s in this.styleStart){
if(this.units[s]=="color"){
var m="#";
var _6c6=this.styleStart[s];
var end=this.styleEnd[s];
MochiKit.Base.map(MochiKit.Base.bind(function(i){
m+=MochiKit.Color.toColorPart(Math.round(_6c6[i]+(end[i]-_6c6[i])*_6c2));
},this),[0,1,2]);
this.element.style[s]=m;
}else{
_6c3=this.styleStart[s]+Math.round((this.styleEnd[s]-this.styleStart[s])*_6c2*1000)/1000+this.units[s];
this.element.style[s]=_6c3;
}
}
}});
MochiKit.Visual.fade=function(_6c9,_6ca){
var s=MochiKit.Style;
var _6cc=s.getStyle(_6c9,"opacity");
_6ca=MochiKit.Base.update({from:s.getStyle(_6c9,"opacity")||1,to:0,afterFinishInternal:function(_6cd){
if(_6cd.options.to!!==0){
return;
}
s.hideElement(_6cd.element);
s.setStyle(_6cd.element,{"opacity":_6cc});
}},_6ca);
return new MochiKit.Visual.Opacity(_6c9,_6ca);
};
MochiKit.Visual.appear=function(_6ce,_6cf){
var s=MochiKit.Style;
var v=MochiKit.Visual;
_6cf=MochiKit.Base.update({from:(s.getStyle(_6ce,"display")=="none"?0:s.getStyle(_6ce,"opacity")||0),to:1,afterFinishInternal:function(_6d2){
v.forceRerendering(_6d2.element);
},beforeSetupInternal:function(_6d3){
s.setStyle(_6d3.element,{"opacity":_6d3.options.from});
s.showElement(_6d3.element);
}},_6cf);
return new v.Opacity(_6ce,_6cf);
};
MochiKit.Visual.puff=function(_6d4,_6d5){
var s=MochiKit.Style;
var v=MochiKit.Visual;
_6d4=MochiKit.DOM.getElement(_6d4);
var _6d8=MochiKit.Style.getElementDimensions(_6d4,true);
var _6d9={position:s.getStyle(_6d4,"position"),top:_6d4.style.top,left:_6d4.style.left,width:_6d4.style.width,height:_6d4.style.height,opacity:s.getStyle(_6d4,"opacity")};
_6d5=MochiKit.Base.update({beforeSetupInternal:function(_6da){
MochiKit.Position.absolutize(_6da.effects[0].element);
},afterFinishInternal:function(_6db){
s.hideElement(_6db.effects[0].element);
s.setStyle(_6db.effects[0].element,_6d9);
},scaleContent:true,scaleFromCenter:true},_6d5);
return new v.Parallel([new v.Scale(_6d4,200,{sync:true,scaleFromCenter:_6d5.scaleFromCenter,scaleMode:{originalHeight:_6d8.h,originalWidth:_6d8.w},scaleContent:_6d5.scaleContent,restoreAfterFinish:true}),new v.Opacity(_6d4,{sync:true,to:0})],_6d5);
};
MochiKit.Visual.blindUp=function(_6dc,_6dd){
var d=MochiKit.DOM;
var s=MochiKit.Style;
_6dc=d.getElement(_6dc);
var _6e0=s.getElementDimensions(_6dc,true);
var _6e1=s.makeClipping(_6dc);
_6dd=MochiKit.Base.update({scaleContent:false,scaleX:false,scaleMode:{originalHeight:_6e0.h,originalWidth:_6e0.w},restoreAfterFinish:true,afterFinishInternal:function(_6e2){
s.hideElement(_6e2.element);
s.undoClipping(_6e2.element,_6e1);
}},_6dd);
return new MochiKit.Visual.Scale(_6dc,0,_6dd);
};
MochiKit.Visual.blindDown=function(_6e3,_6e4){
var d=MochiKit.DOM;
var s=MochiKit.Style;
_6e3=d.getElement(_6e3);
var _6e7=s.getElementDimensions(_6e3,true);
var _6e8;
_6e4=MochiKit.Base.update({scaleContent:false,scaleX:false,scaleFrom:0,scaleMode:{originalHeight:_6e7.h,originalWidth:_6e7.w},restoreAfterFinish:true,afterSetupInternal:function(_6e9){
_6e8=s.makeClipping(_6e9.element);
s.setStyle(_6e9.element,{height:"0px"});
s.showElement(_6e9.element);
},afterFinishInternal:function(_6ea){
s.undoClipping(_6ea.element,_6e8);
}},_6e4);
return new MochiKit.Visual.Scale(_6e3,100,_6e4);
};
MochiKit.Visual.switchOff=function(_6eb,_6ec){
var d=MochiKit.DOM;
var s=MochiKit.Style;
_6eb=d.getElement(_6eb);
var _6ef=s.getElementDimensions(_6eb,true);
var _6f0=s.getStyle(_6eb,"opacity");
var _6f1;
_6ec=MochiKit.Base.update({duration:0.7,restoreAfterFinish:true,beforeSetupInternal:function(_6f2){
s.makePositioned(_6eb);
_6f1=s.makeClipping(_6eb);
},afterFinishInternal:function(_6f3){
s.hideElement(_6eb);
s.undoClipping(_6eb,_6f1);
s.undoPositioned(_6eb);
s.setStyle(_6eb,{"opacity":_6f0});
}},_6ec);
var v=MochiKit.Visual;
return new v.Sequence([new v.appear(_6eb,{sync:true,duration:0.57*_6ec.duration,from:0,transition:v.Transitions.flicker}),new v.Scale(_6eb,1,{sync:true,duration:0.43*_6ec.duration,scaleFromCenter:true,scaleX:false,scaleMode:{originalHeight:_6ef.h,originalWidth:_6ef.w},scaleContent:false,restoreAfterFinish:true})],_6ec);
};
MochiKit.Visual.dropOut=function(_6f5,_6f6){
var d=MochiKit.DOM;
var s=MochiKit.Style;
_6f5=d.getElement(_6f5);
var _6f9={top:s.getStyle(_6f5,"top"),left:s.getStyle(_6f5,"left"),opacity:s.getStyle(_6f5,"opacity")};
_6f6=MochiKit.Base.update({duration:0.5,distance:100,beforeSetupInternal:function(_6fa){
s.makePositioned(_6fa.effects[0].element);
},afterFinishInternal:function(_6fb){
s.hideElement(_6fb.effects[0].element);
s.undoPositioned(_6fb.effects[0].element);
s.setStyle(_6fb.effects[0].element,_6f9);
}},_6f6);
var v=MochiKit.Visual;
return new v.Parallel([new v.Move(_6f5,{x:0,y:_6f6.distance,sync:true}),new v.Opacity(_6f5,{sync:true,to:0})],_6f6);
};
MochiKit.Visual.shake=function(_6fd,_6fe){
var d=MochiKit.DOM;
var v=MochiKit.Visual;
var s=MochiKit.Style;
_6fd=d.getElement(_6fd);
var _702={top:s.getStyle(_6fd,"top"),left:s.getStyle(_6fd,"left")};
_6fe=MochiKit.Base.update({duration:0.5,afterFinishInternal:function(_703){
s.undoPositioned(_6fd);
s.setStyle(_6fd,_702);
}},_6fe);
return new v.Sequence([new v.Move(_6fd,{sync:true,duration:0.1*_6fe.duration,x:20,y:0}),new v.Move(_6fd,{sync:true,duration:0.2*_6fe.duration,x:-40,y:0}),new v.Move(_6fd,{sync:true,duration:0.2*_6fe.duration,x:40,y:0}),new v.Move(_6fd,{sync:true,duration:0.2*_6fe.duration,x:-40,y:0}),new v.Move(_6fd,{sync:true,duration:0.2*_6fe.duration,x:40,y:0}),new v.Move(_6fd,{sync:true,duration:0.1*_6fe.duration,x:-20,y:0})],_6fe);
};
MochiKit.Visual.slideDown=function(_704,_705){
var d=MochiKit.DOM;
var b=MochiKit.Base;
var s=MochiKit.Style;
_704=d.getElement(_704);
if(!!_704.firstChild){
throw new Error("MochiKit.Visual.slideDown must be used on a element with a child");
}
d.removeEmptyTextNodes(_704);
var _709=s.getStyle(_704.firstChild,"bottom")||0;
var _70a=s.getElementDimensions(_704,true);
var _70b;
_705=b.update({scaleContent:false,scaleX:false,scaleFrom:0,scaleMode:{originalHeight:_70a.h,originalWidth:_70a.w},restoreAfterFinish:true,afterSetupInternal:function(_70c){
s.makePositioned(_70c.element);
s.makePositioned(_70c.element.firstChild);
if(/Opera/.test(navigator.userAgent)){
s.setStyle(_70c.element,{top:""});
}
_70b=s.makeClipping(_70c.element);
s.setStyle(_70c.element,{height:"0px"});
s.showElement(_70c.element);
},afterUpdateInternal:function(_70d){
var _70e=s.getElementDimensions(_70d.element,true);
s.setStyle(_70d.element.firstChild,{bottom:(_70d.dims[0]-_70e.h)+"px"});
},afterFinishInternal:function(_70f){
s.undoClipping(_70f.element,_70b);
if(/MSIE/.test(navigator.userAgent)){
s.undoPositioned(_70f.element);
s.undoPositioned(_70f.element.firstChild);
}else{
s.undoPositioned(_70f.element.firstChild);
s.undoPositioned(_70f.element);
}
s.setStyle(_70f.element.firstChild,{bottom:_709});
}},_705);
return new MochiKit.Visual.Scale(_704,100,_705);
};
MochiKit.Visual.slideUp=function(_710,_711){
var d=MochiKit.DOM;
var b=MochiKit.Base;
var s=MochiKit.Style;
_710=d.getElement(_710);
if(!!_710.firstChild){
throw new Error("MochiKit.Visual.slideUp must be used on a element with a child");
}
d.removeEmptyTextNodes(_710);
var _715=s.getStyle(_710.firstChild,"bottom");
var _716=s.getElementDimensions(_710,true);
var _717;
_711=b.update({scaleContent:false,scaleX:false,scaleMode:{originalHeight:_716.h,originalWidth:_716.w},scaleFrom:100,restoreAfterFinish:true,beforeStartInternal:function(_718){
s.makePositioned(_718.element);
s.makePositioned(_718.element.firstChild);
if(/Opera/.test(navigator.userAgent)){
s.setStyle(_718.element,{top:""});
}
_717=s.makeClipping(_718.element);
s.showElement(_718.element);
},afterUpdateInternal:function(_719){
var _71a=s.getElementDimensions(_719.element,true);
s.setStyle(_719.element.firstChild,{bottom:(_719.dims[0]-_71a.h)+"px"});
},afterFinishInternal:function(_71b){
s.hideElement(_71b.element);
s.undoClipping(_71b.element,_717);
s.undoPositioned(_71b.element.firstChild);
s.undoPositioned(_71b.element);
s.setStyle(_71b.element.firstChild,{bottom:_715});
}},_711);
return new MochiKit.Visual.Scale(_710,0,_711);
};
MochiKit.Visual.squish=function(_71c,_71d){
var d=MochiKit.DOM;
var b=MochiKit.Base;
var s=MochiKit.Style;
var _721=s.getElementDimensions(_71c,true);
var _722;
_71d=b.update({restoreAfterFinish:true,scaleMode:{originalHeight:_721.w,originalWidth:_721.h},beforeSetupInternal:function(_723){
_722=s.makeClipping(_723.element);
},afterFinishInternal:function(_724){
s.hideElement(_724.element);
s.undoClipping(_724.element,_722);
}},_71d);
return new MochiKit.Visual.Scale(_71c,/Opera/.test(navigator.userAgent)?1:0,_71d);
};
MochiKit.Visual.grow=function(_725,_726){
var d=MochiKit.DOM;
var v=MochiKit.Visual;
var s=MochiKit.Style;
_725=d.getElement(_725);
_726=MochiKit.Base.update({direction:"center",moveTransition:v.Transitions.sinoidal,scaleTransition:v.Transitions.sinoidal,opacityTransition:v.Transitions.full,scaleContent:true,scaleFromCenter:false},_726);
var _72a={top:_725.style.top,left:_725.style.left,height:_725.style.height,width:_725.style.width,opacity:s.getStyle(_725,"opacity")};
var dims=s.getElementDimensions(_725,true);
var _72c,_72d;
var _72e,_72f;
switch(_726.direction){
case "top-left":
_72c=_72d=_72e=_72f=0;
break;
case "top-right":
_72c=dims.w;
_72d=_72f=0;
_72e=-dims.w;
break;
case "bottom-left":
_72c=_72e=0;
_72d=dims.h;
_72f=-dims.h;
break;
case "bottom-right":
_72c=dims.w;
_72d=dims.h;
_72e=-dims.w;
_72f=-dims.h;
break;
case "center":
_72c=dims.w/2;
_72d=dims.h/2;
_72e=-dims.w/2;
_72f=-dims.h/2;
break;
}
var _730=MochiKit.Base.update({beforeSetupInternal:function(_731){
s.setStyle(_731.effects[0].element,{height:"0px"});
s.showElement(_731.effects[0].element);
},afterFinishInternal:function(_732){
s.undoClipping(_732.effects[0].element);
s.undoPositioned(_732.effects[0].element);
s.setStyle(_732.effects[0].element,_72a);
}},_726);
return new v.Move(_725,{x:_72c,y:_72d,duration:0.01,beforeSetupInternal:function(_733){
s.hideElement(_733.element);
s.makeClipping(_733.element);
s.makePositioned(_733.element);
},afterFinishInternal:function(_734){
new v.Parallel([new v.Opacity(_734.element,{sync:true,to:1,from:0,transition:_726.opacityTransition}),new v.Move(_734.element,{x:_72e,y:_72f,sync:true,transition:_726.moveTransition}),new v.Scale(_734.element,100,{scaleMode:{originalHeight:dims.h,originalWidth:dims.w},sync:true,scaleFrom:/Opera/.test(navigator.userAgent)?1:0,transition:_726.scaleTransition,scaleContent:_726.scaleContent,scaleFromCenter:_726.scaleFromCenter,restoreAfterFinish:true})],_730);
}});
};
MochiKit.Visual.shrink=function(_735,_736){
var d=MochiKit.DOM;
var v=MochiKit.Visual;
var s=MochiKit.Style;
_735=d.getElement(_735);
_736=MochiKit.Base.update({direction:"center",moveTransition:v.Transitions.sinoidal,scaleTransition:v.Transitions.sinoidal,opacityTransition:v.Transitions.none,scaleContent:true,scaleFromCenter:false},_736);
var _73a={top:_735.style.top,left:_735.style.left,height:_735.style.height,width:_735.style.width,opacity:s.getStyle(_735,"opacity")};
var dims=s.getElementDimensions(_735,true);
var _73c,_73d;
switch(_736.direction){
case "top-left":
_73c=_73d=0;
break;
case "top-right":
_73c=dims.w;
_73d=0;
break;
case "bottom-left":
_73c=0;
_73d=dims.h;
break;
case "bottom-right":
_73c=dims.w;
_73d=dims.h;
break;
case "center":
_73c=dims.w/2;
_73d=dims.h/2;
break;
}
var _73e;
var _73f=MochiKit.Base.update({beforeStartInternal:function(_740){
s.makePositioned(_740.effects[0].element);
_73e=s.makeClipping(_740.effects[0].element);
},afterFinishInternal:function(_741){
s.hideElement(_741.effects[0].element);
s.undoClipping(_741.effects[0].element,_73e);
s.undoPositioned(_741.effects[0].element);
s.setStyle(_741.effects[0].element,_73a);
}},_736);
return new v.Parallel([new v.Opacity(_735,{sync:true,to:0,from:1,transition:_736.opacityTransition}),new v.Scale(_735,/Opera/.test(navigator.userAgent)?1:0,{scaleMode:{originalHeight:dims.h,originalWidth:dims.w},sync:true,transition:_736.scaleTransition,scaleContent:_736.scaleContent,scaleFromCenter:_736.scaleFromCenter,restoreAfterFinish:true}),new v.Move(_735,{x:_73c,y:_73d,sync:true,transition:_736.moveTransition})],_73f);
};
MochiKit.Visual.pulsate=function(_742,_743){
var d=MochiKit.DOM;
var v=MochiKit.Visual;
var b=MochiKit.Base;
var _747=MochiKit.Style.getStyle(_742,"opacity");
_743=b.update({duration:3,from:0,afterFinishInternal:function(_748){
MochiKit.Style.setStyle(_748.element,{"opacity":_747});
}},_743);
var _749=_743.transition||v.Transitions.sinoidal;
_743.transition=function(pos){
return _749(1-v.Transitions.pulse(pos,_743.pulses));
};
return new v.Opacity(_742,_743);
};
MochiKit.Visual.fold=function(_74b,_74c){
var d=MochiKit.DOM;
var v=MochiKit.Visual;
var s=MochiKit.Style;
_74b=d.getElement(_74b);
var _750=s.getElementDimensions(_74b,true);
var _751={top:_74b.style.top,left:_74b.style.left,width:_74b.style.width,height:_74b.style.height};
var _752=s.makeClipping(_74b);
_74c=MochiKit.Base.update({scaleContent:false,scaleX:false,scaleMode:{originalHeight:_750.h,originalWidth:_750.w},afterFinishInternal:function(_753){
new v.Scale(_74b,1,{scaleContent:false,scaleY:false,scaleMode:{originalHeight:_750.h,originalWidth:_750.w},afterFinishInternal:function(_754){
s.hideElement(_754.element);
s.undoClipping(_754.element,_752);
s.setStyle(_754.element,_751);
}});
}},_74c);
return new v.Scale(_74b,5,_74c);
};
MochiKit.Visual.Color=MochiKit.Color.Color;
MochiKit.Visual.getElementsComputedStyle=MochiKit.DOM.computedStyle;
MochiKit.Visual.__new__=function(){
var m=MochiKit.Base;
m.nameFunctions(this);
this.EXPORT_TAGS={":common":this.EXPORT,":all":m.concat(this.EXPORT,this.EXPORT_OK)};
};
MochiKit.Visual.EXPORT=["roundElement","roundClass","tagifyText","multiple","toggle","Parallel","Sequence","Opacity","Move","Scale","Highlight","ScrollTo","Morph","fade","appear","puff","blindUp","blindDown","switchOff","dropOut","shake","slideDown","slideUp","squish","grow","shrink","pulsate","fold"];
MochiKit.Visual.EXPORT_OK=["Base","PAIRS"];
MochiKit.Visual.__new__();
MochiKit.Base._exportSymbols(this,MochiKit.Visual);
MochiKit.Base._deps("DragAndDrop",["Base","Iter","DOM","Signal","Visual","Position"]);
MochiKit.DragAndDrop.NAME="MochiKit.DragAndDrop";
MochiKit.DragAndDrop.VERSION="1.4.2";
MochiKit.DragAndDrop.__repr__=function(){
return "["+this.NAME+" "+this.VERSION+"]";
};
MochiKit.DragAndDrop.toString=function(){
return this.__repr__();
};
MochiKit.DragAndDrop.EXPORT=["Droppable","Draggable"];
MochiKit.DragAndDrop.EXPORT_OK=["Droppables","Draggables"];
MochiKit.DragAndDrop.Droppables={drops:[],remove:function(_756){
this.drops=MochiKit.Base.filter(function(d){
return d.element!!=MochiKit.DOM.getElement(_756);
},this.drops);
},register:function(drop){
this.drops.push(drop);
},unregister:function(drop){
this.drops=MochiKit.Base.filter(function(d){
return d!!=drop;
},this.drops);
},prepare:function(_75b){
MochiKit.Base.map(function(drop){
if(drop.isAccepted(_75b)){
if(drop.options.activeclass){
MochiKit.DOM.addElementClass(drop.element,drop.options.activeclass);
}
drop.options.onactive(drop.element,_75b);
}
},this.drops);
},findDeepestChild:function(_75d){
deepest=_75d[0];
for(i=1;i<_75d.length;++i){
if(MochiKit.DOM.isChildNode(_75d[i].element,deepest.element)){
deepest=_75d[i];
}
}
return deepest;
},show:function(_75e,_75f){
if(!!this.drops.length){
return;
}
var _760=[];
if(this.last_active){
this.last_active.deactivate();
}
MochiKit.Iter.forEach(this.drops,function(drop){
if(drop.isAffected(_75e,_75f)){
_760.push(drop);
}
});
if(_760.length>0){
drop=this.findDeepestChild(_760);
MochiKit.Position.within(drop.element,_75e.page.x,_75e.page.y);
drop.options.onhover(_75f,drop.element,MochiKit.Position.overlap(drop.options.overlap,drop.element));
drop.activate();
}
},fire:function(_762,_763){
if(!!this.last_active){
return;
}
MochiKit.Position.prepare();
if(this.last_active.isAffected(_762.mouse(),_763)){
this.last_active.options.ondrop(_763,this.last_active.element,_762);
}
},reset:function(_764){
MochiKit.Base.map(function(drop){
if(drop.options.activeclass){
MochiKit.DOM.removeElementClass(drop.element,drop.options.activeclass);
}
drop.options.ondesactive(drop.element,_764);
},this.drops);
if(this.last_active){
this.last_active.deactivate();
}
}};
MochiKit.DragAndDrop.Droppable=function(_766,_767){
var cls=arguments.callee;
if(!!(this instanceof cls)){
return new cls(_766,_767);
}
this.__init__(_766,_767);
};
MochiKit.DragAndDrop.Droppable.prototype={__class__:MochiKit.DragAndDrop.Droppable,__init__:function(_769,_76a){
var d=MochiKit.DOM;
var b=MochiKit.Base;
this.element=d.getElement(_769);
this.options=b.update({greedy:true,hoverclass:null,activeclass:null,hoverfunc:b.noop,accept:null,onactive:b.noop,ondesactive:b.noop,onhover:b.noop,ondrop:b.noop,containment:[],tree:false},_76a);
this.options._containers=[];
b.map(MochiKit.Base.bind(function(c){
this.options._containers.push(d.getElement(c));
},this),this.options.containment);
MochiKit.Style.makePositioned(this.element);
MochiKit.DragAndDrop.Droppables.register(this);
},isContained:function(_76e){
if(this.options._containers.length){
var _76f;
if(this.options.tree){
_76f=_76e.treeNode;
}else{
_76f=_76e.parentNode;
}
return MochiKit.Iter.some(this.options._containers,function(c){
return _76f==c;
});
}else{
return true;
}
},isAccepted:function(_771){
return ((!!this.options.accept)||MochiKit.Iter.some(this.options.accept,function(c){
return MochiKit.DOM.hasElementClass(_771,c);
}));
},isAffected:function(_773,_774){
return ((this.element!!=_774)&&this.isContained(_774)&&this.isAccepted(_774)&&MochiKit.Position.within(this.element,_773.page.x,_773.page.y));
},deactivate:function(){
if(this.options.hoverclass){
MochiKit.DOM.removeElementClass(this.element,this.options.hoverclass);
}
this.options.hoverfunc(this.element,false);
MochiKit.DragAndDrop.Droppables.last_active=null;
},activate:function(){
if(this.options.hoverclass){
MochiKit.DOM.addElementClass(this.element,this.options.hoverclass);
}
this.options.hoverfunc(this.element,true);
MochiKit.DragAndDrop.Droppables.last_active=this;
},destroy:function(){
MochiKit.DragAndDrop.Droppables.unregister(this);
},repr:function(){
return "["+this.__class__.NAME+", options:"+MochiKit.Base.repr(this.options)+"]";
}};
MochiKit.DragAndDrop.Draggables={drags:[],register:function(_775){
if(this.drags.length===0){
var conn=MochiKit.Signal.connect;
this.eventMouseUp=conn(document,"onmouseup",this,this.endDrag);
this.eventMouseMove=conn(document,"onmousemove",this,this.updateDrag);
this.eventKeypress=conn(document,"onkeypress",this,this.keyPress);
}
this.drags.push(_775);
},unregister:function(_777){
this.drags=MochiKit.Base.filter(function(d){
return d!!=_777;
},this.drags);
if(this.drags.length===0){
var disc=MochiKit.Signal.disconnect;
disc(this.eventMouseUp);
disc(this.eventMouseMove);
disc(this.eventKeypress);
}
},activate:function(_77a){
window.focus();
this.activeDraggable=_77a;
},deactivate:function(){
this.activeDraggable=null;
},updateDrag:function(_77b){
if(!!this.activeDraggable){
return;
}
var _77c=_77b.mouse();
if(this._lastPointer&&(MochiKit.Base.repr(this._lastPointer.page)==MochiKit.Base.repr(_77c.page))){
return;
}
this._lastPointer=_77c;
this.activeDraggable.updateDrag(_77b,_77c);
},endDrag:function(_77d){
if(!!this.activeDraggable){
return;
}
this._lastPointer=null;
this.activeDraggable.endDrag(_77d);
this.activeDraggable=null;
},keyPress:function(_77e){
if(this.activeDraggable){
this.activeDraggable.keyPress(_77e);
}
},notify:function(_77f,_780,_781){
MochiKit.Signal.signal(this,_77f,_780,_781);
}};
MochiKit.DragAndDrop.Draggable=function(_782,_783){
var cls=arguments.callee;
if(!!(this instanceof cls)){
return new cls(_782,_783);
}
this.__init__(_782,_783);
};
MochiKit.DragAndDrop.Draggable.prototype={__class__:MochiKit.DragAndDrop.Draggable,__init__:function(_785,_786){
var v=MochiKit.Visual;
var b=MochiKit.Base;
_786=b.update({handle:false,starteffect:function(_789){
this._savedOpacity=MochiKit.Style.getStyle(_789,"opacity")||1;
new v.Opacity(_789,{duration:0.2,from:this._savedOpacity,to:0.7});
},reverteffect:function(_78a,_78b,_78c){
var dur=Math.sqrt(Math.abs(_78b^2)+Math.abs(_78c^2))*0.02;
return new v.Move(_78a,{x:-_78c,y:-_78b,duration:dur});
},endeffect:function(_78e){
new v.Opacity(_78e,{duration:0.2,from:0.7,to:this._savedOpacity});
},onchange:b.noop,zindex:1000,revert:false,scroll:false,scrollSensitivity:20,scrollSpeed:15,snap:false},_786);
var d=MochiKit.DOM;
this.element=d.getElement(_785);
if(_786.handle&&(typeof (_786.handle)=="string")){
this.handle=d.getFirstElementByTagAndClassName(null,_786.handle,this.element);
}
if(!!this.handle){
this.handle=d.getElement(_786.handle);
}
if(!!this.handle){
this.handle=this.element;
}
if(_786.scroll&&!!_786.scroll.scrollTo&&!!_786.scroll.outerHTML){
_786.scroll=d.getElement(_786.scroll);
this._isScrollChild=MochiKit.DOM.isChildNode(this.element,_786.scroll);
}
MochiKit.Style.makePositioned(this.element);
this.delta=this.currentDelta();
this.options=_786;
this.dragging=false;
this.eventMouseDown=MochiKit.Signal.connect(this.handle,"onmousedown",this,this.initDrag);
MochiKit.DragAndDrop.Draggables.register(this);
},destroy:function(){
MochiKit.Signal.disconnect(this.eventMouseDown);
MochiKit.DragAndDrop.Draggables.unregister(this);
},currentDelta:function(){
var s=MochiKit.Style.getStyle;
return [parseInt(s(this.element,"left")||"0"),parseInt(s(this.element,"top")||"0")];
},initDrag:function(_791){
if(!!_791.mouse().button.left){
return;
}
var src=_791.target();
var _793=(src.tagName||"").toUpperCase();
if(_793==="INPUT"||_793==="SELECT"||_793==="OPTION"||_793==="BUTTON"||_793==="TEXTAREA"){
return;
}
if(this._revert){
this._revert.cancel();
this._revert=null;
}
var _794=_791.mouse();
var pos=MochiKit.Position.cumulativeOffset(this.element);
this.offset=[_794.page.x-pos.x,_794.page.y-pos.y];
MochiKit.DragAndDrop.Draggables.activate(this);
_791.stop();
},startDrag:function(_796){
this.dragging=true;
if(this.options.selectclass){
MochiKit.DOM.addElementClass(this.element,this.options.selectclass);
}
if(this.options.zindex){
this.originalZ=parseInt(MochiKit.Style.getStyle(this.element,"z-index")||"0");
this.element.style.zIndex=this.options.zindex;
}
if(this.options.ghosting){
this._clone=this.element.cloneNode(true);
this.ghostPosition=MochiKit.Position.absolutize(this.element);
this.element.parentNode.insertBefore(this._clone,this.element);
}
if(this.options.scroll){
if(this.options.scroll==window){
var _797=this._getWindowScroll(this.options.scroll);
this.originalScrollLeft=_797.left;
this.originalScrollTop=_797.top;
}else{
this.originalScrollLeft=this.options.scroll.scrollLeft;
this.originalScrollTop=this.options.scroll.scrollTop;
}
}
MochiKit.DragAndDrop.Droppables.prepare(this.element);
MochiKit.DragAndDrop.Draggables.notify("start",this,_796);
if(this.options.starteffect){
this.options.starteffect(this.element);
}
},updateDrag:function(_798,_799){
if(!!this.dragging){
this.startDrag(_798);
}
MochiKit.Position.prepare();
MochiKit.DragAndDrop.Droppables.show(_799,this.element);
MochiKit.DragAndDrop.Draggables.notify("drag",this,_798);
this.draw(_799);
this.options.onchange(this);
if(this.options.scroll){
this.stopScrolling();
var p,q;
if(this.options.scroll==window){
var s=this._getWindowScroll(this.options.scroll);
p=new MochiKit.Style.Coordinates(s.left,s.top);
q=new MochiKit.Style.Coordinates(s.left+s.width,s.top+s.height);
}else{
p=MochiKit.Position.page(this.options.scroll);
p.x+=this.options.scroll.scrollLeft;
p.y+=this.options.scroll.scrollTop;
p.x+=(window.pageXOffset||document.documentElement.scrollLeft||document.body.scrollLeft||0);
p.y+=(window.pageYOffset||document.documentElement.scrollTop||document.body.scrollTop||0);
q=new MochiKit.Style.Coordinates(p.x+this.options.scroll.offsetWidth,p.y+this.options.scroll.offsetHeight);
}
var _79d=[0,0];
if(_799.page.x>(q.x-this.options.scrollSensitivity)){
_79d[0]=_799.page.x-(q.x-this.options.scrollSensitivity);
}else{
if(_799.page.x<(p.x+this.options.scrollSensitivity)){
_79d[0]=_799.page.x-(p.x+this.options.scrollSensitivity);
}
}
if(_799.page.y>(q.y-this.options.scrollSensitivity)){
_79d[1]=_799.page.y-(q.y-this.options.scrollSensitivity);
}else{
if(_799.page.y<(p.y+this.options.scrollSensitivity)){
_79d[1]=_799.page.y-(p.y+this.options.scrollSensitivity);
}
}
this.startScrolling(_79d);
}
if(/AppleWebKit/.test(navigator.appVersion)){
window.scrollBy(0,0);
}
_798.stop();
},finishDrag:function(_79e,_79f){
var dr=MochiKit.DragAndDrop;
this.dragging=false;
if(this.options.selectclass){
MochiKit.DOM.removeElementClass(this.element,this.options.selectclass);
}
if(this.options.ghosting){
MochiKit.Position.relativize(this.element,this.ghostPosition);
MochiKit.DOM.removeElement(this._clone);
this._clone=null;
}
if(_79f){
dr.Droppables.fire(_79e,this.element);
}
dr.Draggables.notify("end",this,_79e);
var _7a1=this.options.revert;
if(_7a1&&typeof (_7a1)=="function"){
_7a1=_7a1(this.element);
}
var d=this.currentDelta();
if(_7a1&&this.options.reverteffect){
this._revert=this.options.reverteffect(this.element,d[1]-this.delta[1],d[0]-this.delta[0]);
}else{
this.delta=d;
}
if(this.options.zindex){
this.element.style.zIndex=this.originalZ;
}
if(this.options.endeffect){
this.options.endeffect(this.element);
}
dr.Draggables.deactivate();
dr.Droppables.reset(this.element);
},keyPress:function(_7a3){
if(_7a3.key().string!!="KEY_ESCAPE"){
return;
}
this.finishDrag(_7a3,false);
_7a3.stop();
},endDrag:function(_7a4){
if(!!this.dragging){
return;
}
this.stopScrolling();
this.finishDrag(_7a4,true);
_7a4.stop();
},draw:function(_7a5){
var pos=MochiKit.Position.cumulativeOffset(this.element);
var d=this.currentDelta();
pos.x-=d[0];
pos.y-=d[1];
if(this.options.scroll&&(this.options.scroll!!=window&&this._isScrollChild)){
pos.x-=this.options.scroll.scrollLeft-this.originalScrollLeft;
pos.y-=this.options.scroll.scrollTop-this.originalScrollTop;
}
var p=[_7a5.page.x-pos.x-this.offset[0],_7a5.page.y-pos.y-this.offset[1]];
if(this.options.snap){
if(typeof (this.options.snap)=="function"){
p=this.options.snap(p[0],p[1]);
}else{
if(this.options.snap instanceof Array){
var i=-1;
p=MochiKit.Base.map(MochiKit.Base.bind(function(v){
i+=1;
return Math.round(v/this.options.snap[i])*this.options.snap[i];
},this),p);
}else{
p=MochiKit.Base.map(MochiKit.Base.bind(function(v){
return Math.round(v/this.options.snap)*this.options.snap;
},this),p);
}
}
}
var _7ac=this.element.style;
if((!!this.options.constraint)||(this.options.constraint=="horizontal")){
_7ac.left=p[0]+"px";
}
if((!!this.options.constraint)||(this.options.constraint=="vertical")){
_7ac.top=p[1]+"px";
}
if(_7ac.visibility=="hidden"){
_7ac.visibility="";
}
},stopScrolling:function(){
if(this.scrollInterval){
clearInterval(this.scrollInterval);
this.scrollInterval=null;
MochiKit.DragAndDrop.Draggables._lastScrollPointer=null;
}
},startScrolling:function(_7ad){
if(!!_7ad[0]&&!!_7ad[1]){
return;
}
this.scrollSpeed=[_7ad[0]*this.options.scrollSpeed,_7ad[1]*this.options.scrollSpeed];
this.lastScrolled=new Date();
this.scrollInterval=setInterval(MochiKit.Base.bind(this.scroll,this),10);
},scroll:function(){
var _7ae=new Date();
var _7af=_7ae-this.lastScrolled;
this.lastScrolled=_7ae;
if(this.options.scroll==window){
var s=this._getWindowScroll(this.options.scroll);
if(this.scrollSpeed[0]||this.scrollSpeed[1]){
var dm=_7af/1000;
this.options.scroll.scrollTo(s.left+dm*this.scrollSpeed[0],s.top+dm*this.scrollSpeed[1]);
}
}else{
this.options.scroll.scrollLeft+=this.scrollSpeed[0]*_7af/1000;
this.options.scroll.scrollTop+=this.scrollSpeed[1]*_7af/1000;
}
var d=MochiKit.DragAndDrop;
MochiKit.Position.prepare();
d.Droppables.show(d.Draggables._lastPointer,this.element);
d.Draggables.notify("drag",this);
if(this._isScrollChild){
d.Draggables._lastScrollPointer=d.Draggables._lastScrollPointer||d.Draggables._lastPointer;
d.Draggables._lastScrollPointer.x+=this.scrollSpeed[0]*_7af/1000;
d.Draggables._lastScrollPointer.y+=this.scrollSpeed[1]*_7af/1000;
if(d.Draggables._lastScrollPointer.x<0){
d.Draggables._lastScrollPointer.x=0;
}
if(d.Draggables._lastScrollPointer.y<0){
d.Draggables._lastScrollPointer.y=0;
}
this.draw(d.Draggables._lastScrollPointer);
}
this.options.onchange(this);
},_getWindowScroll:function(win){
var vp,w,h;
MochiKit.DOM.withWindow(win,function(){
vp=MochiKit.Style.getViewportPosition(win.document);
});
if(win.innerWidth){
w=win.innerWidth;
h=win.innerHeight;
}else{
if(win.document.documentElement&&win.document.documentElement.clientWidth){
w=win.document.documentElement.clientWidth;
h=win.document.documentElement.clientHeight;
}else{
w=win.document.body.offsetWidth;
h=win.document.body.offsetHeight;
}
}
return {top:vp.y,left:vp.x,width:w,height:h};
},repr:function(){
return "["+this.__class__.NAME+", options:"+MochiKit.Base.repr(this.options)+"]";
}};
MochiKit.DragAndDrop.__new__=function(){
MochiKit.Base.nameFunctions(this);
this.EXPORT_TAGS={":common":this.EXPORT,":all":MochiKit.Base.concat(this.EXPORT,this.EXPORT_OK)};
};
MochiKit.DragAndDrop.__new__();
MochiKit.Base._exportSymbols(this,MochiKit.DragAndDrop);
MochiKit.Base._deps("Sortable",["Base","Iter","DOM","Position","DragAndDrop"]);
MochiKit.Sortable.NAME="MochiKit.Sortable";
MochiKit.Sortable.VERSION="1.4.2";
MochiKit.Sortable.__repr__=function(){
return "["+this.NAME+" "+this.VERSION+"]";
};
MochiKit.Sortable.toString=function(){
return this.__repr__();
};
MochiKit.Sortable.EXPORT=[];
MochiKit.Sortable.EXPORT_OK=[];
MochiKit.Base.update(MochiKit.Sortable,{sortables:{},_findRootElement:function(_7b7){
while(_7b7.tagName.toUpperCase()!!="BODY"){
if(_7b7.id&&MochiKit.Sortable.sortables[_7b7.id]){
return _7b7;
}
_7b7=_7b7.parentNode;
}
},_createElementId:function(_7b8){
if(_7b8.id==null||_7b8.id==""){
var d=MochiKit.DOM;
var id;
var _7bb=1;
while(d.getElement(id="sortable"+_7bb)!!=null){
_7bb+=1;
}
d.setNodeAttribute(_7b8,"id",id);
}
},options:function(_7bc){
_7bc=MochiKit.Sortable._findRootElement(MochiKit.DOM.getElement(_7bc));
if(!!_7bc){
return;
}
return MochiKit.Sortable.sortables[_7bc.id];
},destroy:function(_7bd){
var s=MochiKit.Sortable.options(_7bd);
var b=MochiKit.Base;
var d=MochiKit.DragAndDrop;
if(s){
MochiKit.Signal.disconnect(s.startHandle);
MochiKit.Signal.disconnect(s.endHandle);
b.map(function(dr){
d.Droppables.remove(dr);
},s.droppables);
b.map(function(dr){
dr.destroy();
},s.draggables);
delete MochiKit.Sortable.sortables[s.element.id];
}
},create:function(_7c3,_7c4){
_7c3=MochiKit.DOM.getElement(_7c3);
var self=MochiKit.Sortable;
self._createElementId(_7c3);
_7c4=MochiKit.Base.update({element:_7c3,tag:"li",dropOnEmpty:false,tree:false,treeTag:"ul",overlap:"vertical",constraint:"vertical",containment:[_7c3],handle:false,only:false,hoverclass:null,ghosting:false,scroll:false,scrollSensitivity:20,scrollSpeed:15,format:/^[^_]*_(.*)$/,onChange:MochiKit.Base.noop,onUpdate:MochiKit.Base.noop,accept:null},_7c4);
self.destroy(_7c3);
var _7c6={revert:true,ghosting:_7c4.ghosting,scroll:_7c4.scroll,scrollSensitivity:_7c4.scrollSensitivity,scrollSpeed:_7c4.scrollSpeed,constraint:_7c4.constraint,handle:_7c4.handle};
if(_7c4.starteffect){
_7c6.starteffect=_7c4.starteffect;
}
if(_7c4.reverteffect){
_7c6.reverteffect=_7c4.reverteffect;
}else{
if(_7c4.ghosting){
_7c6.reverteffect=function(_7c7){
_7c7.style.top=0;
_7c7.style.left=0;
};
}
}
if(_7c4.endeffect){
_7c6.endeffect=_7c4.endeffect;
}
if(_7c4.zindex){
_7c6.zindex=_7c4.zindex;
}
var _7c8={overlap:_7c4.overlap,containment:_7c4.containment,hoverclass:_7c4.hoverclass,onhover:self.onHover,tree:_7c4.tree,accept:_7c4.accept};
var _7c9={onhover:self.onEmptyHover,overlap:_7c4.overlap,containment:_7c4.containment,hoverclass:_7c4.hoverclass,accept:_7c4.accept};
MochiKit.DOM.removeEmptyTextNodes(_7c3);
_7c4.draggables=[];
_7c4.droppables=[];
if(_7c4.dropOnEmpty||_7c4.tree){
new MochiKit.DragAndDrop.Droppable(_7c3,_7c9);
_7c4.droppables.push(_7c3);
}
MochiKit.Base.map(function(e){
var _7cb=_7c4.handle?MochiKit.DOM.getFirstElementByTagAndClassName(null,_7c4.handle,e):e;
_7c4.draggables.push(new MochiKit.DragAndDrop.Draggable(e,MochiKit.Base.update(_7c6,{handle:_7cb})));
new MochiKit.DragAndDrop.Droppable(e,_7c8);
if(_7c4.tree){
e.treeNode=_7c3;
}
_7c4.droppables.push(e);
},(self.findElements(_7c3,_7c4)||[]));
if(_7c4.tree){
MochiKit.Base.map(function(e){
new MochiKit.DragAndDrop.Droppable(e,_7c9);
e.treeNode=_7c3;
_7c4.droppables.push(e);
},(self.findTreeElements(_7c3,_7c4)||[]));
}
self.sortables[_7c3.id]=_7c4;
_7c4.lastValue=self.serialize(_7c3);
_7c4.startHandle=MochiKit.Signal.connect(MochiKit.DragAndDrop.Draggables,"start",MochiKit.Base.partial(self.onStart,_7c3));
_7c4.endHandle=MochiKit.Signal.connect(MochiKit.DragAndDrop.Draggables,"end",MochiKit.Base.partial(self.onEnd,_7c3));
},onStart:function(_7cd,_7ce){
var self=MochiKit.Sortable;
var _7d0=self.options(_7cd);
_7d0.lastValue=self.serialize(_7d0.element);
},onEnd:function(_7d1,_7d2){
var self=MochiKit.Sortable;
self.unmark();
var _7d4=self.options(_7d1);
if(_7d4.lastValue!!=self.serialize(_7d4.element)){
_7d4.onUpdate(_7d4.element);
}
},findElements:function(_7d5,_7d6){
return MochiKit.Sortable.findChildren(_7d5,_7d6.only,_7d6.tree,_7d6.tag);
},findTreeElements:function(_7d7,_7d8){
return MochiKit.Sortable.findChildren(_7d7,_7d8.only,_7d8.tree?true:false,_7d8.treeTag);
},findChildren:function(_7d9,only,_7db,_7dc){
if(!!_7d9.hasChildNodes()){
return null;
}
_7dc=_7dc.toUpperCase();
if(only){
only=MochiKit.Base.flattenArray([only]);
}
var _7dd=[];
MochiKit.Base.map(function(e){
if(e.tagName&&e.tagName.toUpperCase()==_7dc&&(!!only||MochiKit.Iter.some(only,function(c){
return MochiKit.DOM.hasElementClass(e,c);
}))){
_7dd.push(e);
}
if(_7db){
var _7e0=MochiKit.Sortable.findChildren(e,only,_7db,_7dc);
if(_7e0&&_7e0.length>0){
_7dd=_7dd.concat(_7e0);
}
}
},_7d9.childNodes);
return _7dd;
},onHover:function(_7e1,_7e2,_7e3){
if(MochiKit.DOM.isChildNode(_7e2,_7e1)){
return;
}
var self=MochiKit.Sortable;
if(_7e3>0.33&&_7e3<0.66&&self.options(_7e2).tree){
return;
}else{
if(_7e3>0.5){
self.mark(_7e2,"before");
if(_7e2.previousSibling!!=_7e1){
var _7e5=_7e1.parentNode;
_7e1.style.visibility="hidden";
_7e2.parentNode.insertBefore(_7e1,_7e2);
if(_7e2.parentNode!!=_7e5){
self.options(_7e5).onChange(_7e1);
}
self.options(_7e2.parentNode).onChange(_7e1);
}
}else{
self.mark(_7e2,"after");
var _7e6=_7e2.nextSibling||null;
if(_7e6!!=_7e1){
var _7e5=_7e1.parentNode;
_7e1.style.visibility="hidden";
_7e2.parentNode.insertBefore(_7e1,_7e6);
if(_7e2.parentNode!!=_7e5){
self.options(_7e5).onChange(_7e1);
}
self.options(_7e2.parentNode).onChange(_7e1);
}
}
}
},_offsetSize:function(_7e7,type){
if(type=="vertical"||type=="height"){
return _7e7.offsetHeight;
}else{
return _7e7.offsetWidth;
}
},onEmptyHover:function(_7e9,_7ea,_7eb){
var _7ec=_7e9.parentNode;
var self=MochiKit.Sortable;
var _7ee=self.options(_7ea);
if(!!MochiKit.DOM.isChildNode(_7ea,_7e9)){
var _7ef;
var _7f0=self.findElements(_7ea,{tag:_7ee.tag,only:_7ee.only});
var _7f1=null;
if(_7f0){
var _7f2=self._offsetSize(_7ea,_7ee.overlap)*(1-_7eb);
for(_7ef=0;_7ef<_7f0.length;_7ef+=1){
if(_7f2-self._offsetSize(_7f0[_7ef],_7ee.overlap)>=0){
_7f2-=self._offsetSize(_7f0[_7ef],_7ee.overlap);
}else{
if(_7f2-(self._offsetSize(_7f0[_7ef],_7ee.overlap)/2)>=0){
_7f1=_7ef+1<_7f0.length?_7f0[_7ef+1]:null;
break;
}else{
_7f1=_7f0[_7ef];
break;
}
}
}
}
_7ea.insertBefore(_7e9,_7f1);
self.options(_7ec).onChange(_7e9);
_7ee.onChange(_7e9);
}
},unmark:function(){
var m=MochiKit.Sortable._marker;
if(m){
MochiKit.Style.hideElement(m);
}
},mark:function(_7f4,_7f5){
var d=MochiKit.DOM;
var self=MochiKit.Sortable;
var _7f8=self.options(_7f4.parentNode);
if(_7f8&&!!_7f8.ghosting){
return;
}
if(!!self._marker){
self._marker=d.getElement("dropmarker")||document.createElement("DIV");
MochiKit.Style.hideElement(self._marker);
d.addElementClass(self._marker,"dropmarker");
self._marker.style.position="absolute";
document.getElementsByTagName("body").item(0).appendChild(self._marker);
}
var _7f9=MochiKit.Position.cumulativeOffset(_7f4);
self._marker.style.left=_7f9.x+"px";
self._marker.style.top=_7f9.y+"px";
if(_7f5=="after"){
if(_7f8.overlap=="horizontal"){
self._marker.style.left=(_7f9.x+_7f4.clientWidth)+"px";
}else{
self._marker.style.top=(_7f9.y+_7f4.clientHeight)+"px";
}
}
MochiKit.Style.showElement(self._marker);
},_tree:function(_7fa,_7fb,_7fc){
var self=MochiKit.Sortable;
var _7fe=self.findElements(_7fa,_7fb)||[];
for(var i=0;i<_7fe.length;++i){
var _800=_7fe[i].id.match(_7fb.format);
if(!!_800){
continue;
}
var _801={id:encodeURIComponent(_800?_800[1]:null),element:_7fa,parent:_7fc,children:[],position:_7fc.children.length,container:self._findChildrenElement(_7fe[i],_7fb.treeTag.toUpperCase())};
if(_801.container){
self._tree(_801.container,_7fb,_801);
}
_7fc.children.push(_801);
}
return _7fc;
},_findChildrenElement:function(_802,_803){
if(_802&&_802.hasChildNodes){
_803=_803.toUpperCase();
for(var i=0;i<_802.childNodes.length;++i){
if(_802.childNodes[i].tagName.toUpperCase()==_803){
return _802.childNodes[i];
}
}
}
return null;
},tree:function(_805,_806){
_805=MochiKit.DOM.getElement(_805);
var _807=MochiKit.Sortable.options(_805);
_806=MochiKit.Base.update({tag:_807.tag,treeTag:_807.treeTag,only:_807.only,name:_805.id,format:_807.format},_806||{});
var root={id:null,parent:null,children:new Array,container:_805,position:0};
return MochiKit.Sortable._tree(_805,_806,root);
},setSequence:function(_809,_80a,_80b){
var self=MochiKit.Sortable;
var b=MochiKit.Base;
_809=MochiKit.DOM.getElement(_809);
_80b=b.update(self.options(_809),_80b||{});
var _80e={};
b.map(function(n){
var m=n.id.match(_80b.format);
if(m){
_80e[m[1]]=[n,n.parentNode];
}
n.parentNode.removeChild(n);
},self.findElements(_809,_80b));
b.map(function(_811){
var n=_80e[_811];
if(n){
n[1].appendChild(n[0]);
delete _80e[_811];
}
},_80a);
},_constructIndex:function(node){
var _814="";
do{
if(node.id){
_814="["+node.position+"]"+_814;
}
}while((node=node.parent)!!=null);
return _814;
},sequence:function(_815,_816){
_815=MochiKit.DOM.getElement(_815);
var self=MochiKit.Sortable;
var _816=MochiKit.Base.update(self.options(_815),_816||{});
return MochiKit.Base.map(function(item){
return item.id.match(_816.format)?item.id.match(_816.format)[1]:"";
},MochiKit.DOM.getElement(self.findElements(_815,_816)||[]));
},serialize:function(_819,_81a){
_819=MochiKit.DOM.getElement(_819);
var self=MochiKit.Sortable;
_81a=MochiKit.Base.update(self.options(_819),_81a||{});
var name=encodeURIComponent(_81a.name||_819.id);
if(_81a.tree){
return MochiKit.Base.flattenArray(MochiKit.Base.map(function(item){
return [name+self._constructIndex(item)+"[id]="+encodeURIComponent(item.id)].concat(item.children.map(arguments.callee));
},self.tree(_819,_81a).children)).join("&");
}else{
return MochiKit.Base.map(function(item){
return name+"[]="+encodeURIComponent(item);
},self.sequence(_819,_81a)).join("&");
}
}});
MochiKit.Sortable.Sortable=MochiKit.Sortable;
MochiKit.Sortable.__new__=function(){
MochiKit.Base.nameFunctions(this);
this.EXPORT_TAGS={":common":this.EXPORT,":all":MochiKit.Base.concat(this.EXPORT,this.EXPORT_OK)};
};
MochiKit.Sortable.__new__();
MochiKit.Base._exportSymbols(this,MochiKit.Sortable);
if(typeof (MochiKit)=="undefined"){
MochiKit={};
}
if(typeof (MochiKit.MochiKit)=="undefined"){
MochiKit.MochiKit={};
}
MochiKit.MochiKit.NAME="MochiKit.MochiKit";
MochiKit.MochiKit.VERSION="1.4.2";
MochiKit.MochiKit.__repr__=function(){
return "["+this.NAME+" "+this.VERSION+"]";
};
MochiKit.MochiKit.toString=function(){
return this.__repr__();
};
MochiKit.MochiKit.SUBMODULES=["Base","Iter","Logging","DateTime","Format","Async","DOM","Selector","Style","LoggingPane","Color","Signal","Position","Visual","DragAndDrop","Sortable"];
if(typeof (JSAN)!!="undefined"||typeof (dojo)!!="undefined"){
if(typeof (dojo)!!="undefined"){
dojo.provide("MochiKit.MochiKit");
(function(lst){
for(var i=0;i<lst.length;i++){
dojo.require("MochiKit."+lst[i]);
}
})(MochiKit.MochiKit.SUBMODULES);
}
if(typeof (JSAN)!!="undefined"){
(function(lst){
for(var i=0;i<lst.length;i++){
JSAN.use("MochiKit."+lst[i],[]);
}
})(MochiKit.MochiKit.SUBMODULES);
}
(function(){
var _823=MochiKit.Base.extend;
var self=MochiKit.MochiKit;
var _825=self.SUBMODULES;
var _826=[];
var _827=[];
var _828={};
var i,k,m,all;
for(i=0;i<_825.length;i++){
m=MochiKit[_825[i]];
_823(_826,m.EXPORT);
_823(_827,m.EXPORT_OK);
for(k in m.EXPORT_TAGS){
_828[k]=_823(_828[k],m.EXPORT_TAGS[k]);
}
all=m.EXPORT_TAGS[":all"];
if(!!all){
all=_823(null,m.EXPORT,m.EXPORT_OK);
}
var j;
for(j=0;j<all.length;j++){
k=all[j];
self[k]=m[k];
}
}
self.EXPORT=_826;
self.EXPORT_OK=_827;
self.EXPORT_TAGS=_828;
}());
}else{
if(typeof (MochiKit.__compat__)=="undefined"){
MochiKit.__compat__=true;
}
(function(){
if(typeof (document)=="undefined"){
return;
}
var _82e=document.getElementsByTagName("script");
var _82f="http://www.w3.org/1999/xhtml";
var _830="http://www.w3.org/2000/svg";
var _831="http://www.w3.org/1999/xlink";
var _832="http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";
var base=null;
var _834=null;
var _835={};
var i;
var src;
for(i=0;i<_82e.length;i++){
src=null;
switch(_82e[i].namespaceURI){
case _830:
src=_82e[i].getAttributeNS(_831,"href");
break;
default:
src=_82e[i].getAttribute("src");
break;
}
if(!!src){
continue;
}
_835[src]=true;
if(src.match(/MochiKit.js(\?.*)?$/)){
base=src.substring(0,src.lastIndexOf("MochiKit.js"));
_834=_82e[i];
}
}
if(base===null){
return;
}
var _838=MochiKit.MochiKit.SUBMODULES;
for(var i=0;i<_838.length;i++){
if(MochiKit[_838[i]]){
continue;
}
var uri=base+_838[i]+".js";
if(uri in _835){
continue;
}
if(_834.namespaceURI==_830||_834.namespaceURI==_832){
var s=document.createElementNS(_834.namespaceURI,"script");
s.setAttribute("id","MochiKit_"+base+_838[i]);
if(_834.namespaceURI==_830){
s.setAttributeNS(_831,"href",uri);
}else{
s.setAttribute("src",uri);
}
s.setAttribute("type","application/x-javascript");
_834.parentNode.appendChild(s);
}else{
document.write("<"+_834.nodeName+" src=\""+uri+"\" type=\"text/javascript\"></script>");
}
}
})();
}


'! !

!DLFileLibrary methodsFor: 'rendering' stamp: 'PL 7/12/2011 12:10:37.602'!
multiCheckBoxJs

	^ 'function updateCheckMarkImage(checkMarkImageID, inputID)
{
	var input = document.getElementById(inputID);
	var checkMarkImage = document.getElementById(checkMarkImageID);
	
	if (input.value < 4)
	{
		checkMarkImage.style.backgroundPosition = "0px -" + (24 * input.value) + "px";
		checkMarkImage.firstChild.hidden = true;
	}
	else
	{
		checkMarkImage.style.backgroundPosition = "0px -96px";
		checkMarkImage.firstChild.innerHTML = " " + input.value;
		checkMarkImage.firstChild.hidden = false;
	}
}

function addVote(checkMarkImageID, inputID, maxAnswers, maxAnswersPerChoice)
{
	var input = document.getElementById(inputID);
	if (input.value == "")
		input.value = 0;
	
	if (parseInt(input.value) + 1 > maxAnswersPerChoice)
		return;
	
	if (sumUpValues(getSiblingCheckBoxes(inputID)) + 1 > maxAnswers)
		return;
	
	input.value = parseInt(input.value) + 1;
	
	updateCheckMarkImage(checkMarkImageID, inputID);
}

function removeVote(checkMarkImageID, inputID)
{
	var input = document.getElementById(inputID);
	if (input.value == "")
		input.value = 0;
	
	input.value = parseInt(input.value) - 1;
	if (input.value < 0)
		input.value = 0;
	
	updateCheckMarkImage(checkMarkImageID, inputID);
}

function updateMultiCheckBoxes(multiCheckBoxes)
{
	for (var i = 0; i < multiCheckBoxes.length; i++)
		updateCheckMarkImage(multiCheckBoxes[i][0], multiCheckBoxes[i][1]);
}

function getSiblingCheckBoxes(checkBoxId)
{
    var root = document.getElementById(checkBoxId);

    while (root && root.tagName !!= "DL")
        root = root.parentNode;

    return root.getElementsByTagName("input");
}

function sumUpValues(multiCheckBoxes)
{
	var sum = 0;
	
	for (var i = 0; i < multiCheckBoxes.length; i++)
		sum += parseInt(multiCheckBoxes[i].value);
	
	return sum;
}'! !

!DLFileLibrary methodsFor: 'uploaded' stamp: 'PL 5/28/2011 01:19:32.251'!
multiCheckBoxPng
	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 78 0 0 0 120 8 6 0 0 0 92 137 196 173 0 0 0 1 115 82 71 66 0 174 206 28 233 0 0 0 6 98 75 71 68 0 255 0 255 0 255 160 189 167 147 0 0 0 9 112 72 89 115 0 0 13 215 0 0 13 215 1 66 40 155 120 0 0 0 7 116 73 77 69 7 219 5 27 23 19 14 100 235 192 194 0 0 7 189 73 68 65 84 120 218 237 156 121 108 84 85 24 197 207 157 229 81 10 69 74 161 84 17 166 51 66 107 75 41 130 86 145 68 24 21 84 226 2 4 106 34 66 209 68 107 112 131 196 24 140 91 36 198 168 113 65 76 52 38 34 9 18 99 130 11 162 81 43 136 20 89 90 65 150 150 118 40 148 182 175 29 104 107 25 186 206 62 243 222 245 15 136 75 157 234 107 125 243 238 29 230 158 63 231 246 37 55 103 206 247 122 191 251 203 124 128 80 114 72 150 229 60 30 246 97 74 36 211 154 154 154 178 1 28 145 101 121 183 219 237 158 38 140 211 40 66 200 155 0 82 0 56 85 85 61 42 203 242 123 110 183 123 12 147 189 36 80 218 156 132 144 221 49 150 58 41 165 247 219 237 246 50 145 184 126 162 148 154 9 33 27 6 88 78 5 80 39 74 53 246 63 132 82 0 133 3 44 191 101 183 219 101 81 170 253 212 220 220 156 78 41 173 7 144 17 99 185 53 37 37 37 39 43 43 203 39 18 247 207 50 93 55 128 105 32 132 172 101 97 26 23 137 171 175 175 31 38 73 210 118 0 111 216 108 182 93 253 210 150 15 160 138 82 106 137 241 104 165 205 102 155 77 8 161 73 121 28 177 90 173 235 41 165 183 83 74 119 200 178 252 44 165 244 143 47 83 85 213 119 6 48 141 170 170 186 154 149 105 204 19 39 203 242 50 0 159 244 43 205 111 0 148 0 152 75 8 249 106 128 242 253 216 110 183 175 100 122 166 100 217 58 17 66 14 81 74 71 196 88 110 188 88 13 217 49 222 107 94 66 72 238 164 73 147 90 147 174 115 184 88 126 159 15 96 26 0 56 98 153 118 241 217 87 89 155 198 204 56 66 72 148 16 178 26 192 185 193 54 16 148 210 183 147 186 201 183 217 108 63 154 205 230 25 0 14 12 226 177 167 237 118 123 48 233 111 71 38 78 156 120 214 227 241 56 41 165 27 52 252 121 121 118 118 246 23 220 92 56 112 212 33 20 83 74 63 2 144 22 163 180 21 69 81 102 58 28 142 106 94 246 203 77 231 96 179 217 62 83 85 181 8 64 77 140 229 141 60 153 198 93 203 229 112 56 78 74 146 116 3 128 77 127 249 184 39 28 14 191 0 33 205 165 91 34 203 178 79 150 229 167 132 27 131 84 75 75 75 65 109 109 173 36 156 16 18 18 74 22 45 126 25 92 112 85 146 72 166 45 122 9 217 20 56 65 128 74 106 194 147 219 95 196 113 86 123 49 39 146 113 185 115 176 113 201 109 43 10 175 43 152 147 221 216 82 87 106 159 21 26 95 120 11 42 93 229 8 8 227 6 208 93 207 195 153 149 113 249 235 11 157 15 65 26 30 133 115 70 177 105 88 138 185 232 180 124 234 225 156 57 180 250 228 207 56 109 228 126 44 137 96 90 113 49 204 1 5 27 22 221 242 0 58 131 245 240 248 107 32 153 79 97 220 21 18 64 73 106 56 42 184 106 76 121 29 40 45 152 50 179 240 138 204 171 112 206 119 2 170 10 4 35 125 216 95 121 0 193 176 242 86 217 107 144 141 222 19 247 137 187 243 25 164 155 84 211 203 119 206 93 142 246 190 99 80 20 5 0 112 190 179 11 117 117 238 86 21 120 53 233 155 252 88 82 194 88 231 156 125 87 134 85 50 163 59 208 2 170 2 170 10 84 30 168 1 84 172 221 241 38 152 112 85 230 137 91 240 4 134 169 102 108 87 85 188 177 243 93 236 234 183 150 63 60 101 228 170 57 51 239 134 187 119 31 84 245 194 231 77 242 25 180 183 117 85 238 220 240 119 66 150 84 137 83 76 88 159 51 57 247 246 81 35 211 118 204 127 2 207 254 245 108 25 37 120 103 225 109 203 45 222 200 111 240 6 59 17 138 4 225 245 247 224 96 133 139 42 42 86 3 96 198 85 153 38 110 222 227 88 54 110 236 248 85 119 207 91 6 69 137 152 182 149 125 250 202 173 143 53 204 82 172 40 177 68 48 55 51 35 115 190 109 130 29 135 90 54 34 16 233 6 64 209 232 242 193 215 23 220 242 211 251 56 200 114 239 204 206 113 243 30 69 158 85 146 190 89 177 244 17 169 165 103 47 60 254 83 184 233 154 37 48 89 144 219 220 40 223 75 41 22 44 185 231 190 209 158 208 113 120 188 13 160 20 8 120 21 212 253 234 245 154 76 88 212 120 16 125 73 103 156 243 37 88 148 94 236 158 86 152 51 193 146 214 137 246 222 19 240 135 186 208 225 61 137 233 87 221 12 135 109 74 186 197 108 26 93 144 55 29 174 246 111 65 85 10 74 129 186 35 94 248 186 149 117 63 125 128 239 88 191 98 152 24 39 151 67 181 207 196 169 246 86 207 2 95 248 252 136 180 116 43 40 5 34 209 16 218 122 106 144 153 158 141 107 243 231 163 182 237 59 248 130 157 160 20 232 58 23 129 236 242 55 153 20 44 151 143 33 154 212 77 254 141 37 152 96 177 96 235 152 241 210 236 41 51 210 96 177 254 185 157 209 169 87 162 219 127 6 0 64 41 112 180 188 11 1 175 178 116 239 38 112 129 8 153 246 170 103 170 208 55 174 8 91 66 61 202 40 207 153 240 172 81 233 86 88 37 211 133 247 89 184 23 148 94 48 173 173 41 136 14 57 84 190 111 51 214 242 114 190 100 222 228 183 29 134 234 62 134 178 172 60 234 234 104 9 221 97 145 76 195 82 71 89 254 48 45 18 166 168 59 216 171 68 40 22 159 173 194 111 194 184 254 233 171 134 107 226 52 124 233 105 13 59 131 126 53 243 178 12 43 0 130 102 151 31 221 231 34 31 254 242 9 62 226 169 163 225 234 90 201 93 141 243 227 237 216 28 240 71 47 239 108 139 204 176 74 38 52 215 250 122 194 10 22 183 187 224 135 208 127 235 250 165 40 41 42 134 175 104 41 4 87 29 172 174 91 140 130 169 197 16 92 85 72 72 232 146 147 86 126 202 138 179 114 201 85 181 242 83 150 156 149 75 60 168 149 159 178 228 172 220 25 167 149 159 178 230 172 92 81 46 173 252 148 7 206 202 21 229 210 202 79 121 224 172 220 36 78 43 63 229 133 179 114 147 56 173 252 148 23 206 106 88 226 180 242 83 185 107 15 118 252 80 137 169 83 39 35 24 14 254 141 159 242 196 89 13 75 156 86 126 186 103 239 62 140 28 158 142 138 253 199 113 224 231 106 26 141 98 13 46 242 83 158 56 171 33 137 211 202 79 191 222 191 30 93 157 20 43 139 31 132 162 68 176 173 236 83 210 208 216 240 156 115 13 127 156 53 238 231 56 173 252 180 177 163 2 135 42 26 176 124 73 41 18 129 179 198 213 56 173 252 52 255 234 105 216 186 109 43 114 115 38 35 81 56 107 92 141 211 202 79 93 237 223 131 90 123 113 162 170 21 125 1 15 18 129 179 26 210 228 107 229 167 193 128 138 163 187 187 48 122 172 21 188 115 86 67 122 85 173 252 180 195 29 194 249 179 225 61 62 159 178 157 119 206 106 88 147 63 8 126 186 168 114 51 54 243 206 89 13 191 29 209 202 79 121 231 172 76 174 149 180 242 83 193 89 255 69 90 249 169 224 172 49 164 149 159 10 206 42 36 36 148 168 210 155 163 198 155 183 114 193 85 245 230 168 70 240 86 46 240 160 222 28 213 8 222 202 220 56 189 57 170 81 188 149 41 229 210 155 163 26 201 91 153 82 46 189 57 170 145 188 149 89 226 244 230 168 70 243 86 102 137 211 155 163 26 205 91 227 150 56 189 57 42 111 188 53 110 137 211 155 163 242 198 91 227 146 56 189 57 42 143 188 85 247 115 156 222 28 149 87 222 170 171 113 122 115 84 158 121 171 174 198 233 205 81 121 230 173 113 105 242 245 230 168 60 242 214 184 244 170 122 115 84 30 121 107 220 154 252 56 112 84 174 120 107 220 111 71 244 230 168 188 240 86 67 174 149 244 230 168 73 201 91 245 230 168 73 197 91 245 230 168 130 183 10 9 9 241 38 94 230 249 114 213 114 253 151 120 154 231 203 245 57 174 191 120 154 231 155 48 198 241 54 207 119 168 50 148 114 241 56 207 119 168 50 148 114 241 56 207 151 251 196 241 58 207 151 251 196 241 58 207 151 121 226 18 117 158 47 243 196 37 234 60 95 166 137 27 210 60 223 90 62 230 249 50 59 199 13 121 158 239 97 62 230 249 50 49 238 82 152 231 203 196 184 75 97 158 47 211 38 63 145 231 249 50 237 85 19 121 158 47 243 38 63 81 231 249 114 115 59 146 104 243 124 185 186 86 18 191 51 213 65 226 119 166 255 67 130 123 10 9 253 95 253 14 239 236 13 245 151 124 232 161 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

!DLFileLibrary methodsFor: 'uploaded' stamp: 'PL 6/27/2011 22:33:10.836'!
pagePng
	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 4 115 66 73 84 8 8 8 8 124 8 100 136 0 0 0 9 112 72 89 115 0 0 13 215 0 0 13 215 1 66 40 155 120 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 119 119 119 46 105 110 107 115 99 97 112 101 46 111 114 103 155 238 60 26 0 0 1 148 73 68 65 84 56 141 157 145 77 79 19 81 20 134 223 59 176 180 36 221 117 139 133 180 174 73 37 72 116 129 110 144 133 108 220 187 246 231 52 224 210 31 80 2 209 6 221 64 100 237 194 96 98 76 23 82 33 77 211 81 62 218 210 216 64 211 206 251 186 184 51 195 109 103 96 193 73 206 204 185 115 115 159 121 206 61 70 18 118 63 108 8 119 71 205 27 122 43 47 95 191 253 147 216 145 132 234 78 89 183 197 199 237 178 206 79 27 170 238 148 107 159 42 155 57 73 112 211 3 0 82 232 118 90 184 140 211 71 175 227 163 215 245 33 9 15 50 89 44 45 191 42 14 189 209 193 231 173 119 57 87 32 6 136 188 73 17 20 65 10 164 112 125 213 67 102 38 139 39 79 215 139 3 12 15 182 28 136 103 219 96 152 161 26 233 124 179 208 171 126 15 153 76 22 203 207 214 139 83 26 124 137 0 211 99 6 198 196 106 6 6 12 70 32 133 253 189 202 228 213 61 74 2 36 252 252 241 213 94 44 9 50 192 195 124 1 171 107 111 0 19 65 237 115 183 250 30 99 0 171 78 44 60 126 142 209 112 0 201 78 181 115 209 196 169 255 11 8 205 76 248 142 246 29 3 98 112 221 71 183 237 3 198 234 135 39 108 21 1 236 38 72 38 13 250 255 218 248 125 82 119 84 199 171 168 156 203 23 210 12 4 50 64 169 180 18 255 57 1 10 23 23 103 13 144 105 128 32 192 95 255 200 81 158 208 143 39 100 146 0 137 32 137 227 198 113 186 190 179 204 207 206 67 154 184 131 168 133 197 197 23 206 1 51 129 176 109 156 249 245 91 90 96 128 86 179 22 138 155 155 105 164 76 37 165 5 225 219 225 119 220 39 254 3 241 229 44 244 224 245 152 113 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

!DLFileLibrary methodsFor: 'uploaded' stamp: 'CO 5/26/2011 16:02:41.34'!
PlotKitPackedJs
	^ '/***

    PlotKit.PlotKit 0.9.1 : PACKED VERSION

    THIS FILE IS AUTOMATICALLY GENERATED.  If creating patches, please
    diff against the source tree, not this file.

    For more information, <http://www.liquidx.net/plotkit/>.
    
    Copyright (c) 2006. Alastair Tse.

***/

try{
if(typeof (MochiKit.Base)=="undefined"||typeof (MochiKit.DOM)=="undefined"||typeof (MochiKit.Color)=="undefined"||typeof (MochiKit.Format)=="undefined"){
throw "";
}
}
catch(e){
throw "PlotKit depends on MochiKit.{Base,Color,DOM,Format}";
}
MochiKit.Base.update(MochiKit.Color.Color.prototype,{asFillColor:function(){
return this.lighterColorWithLevel(0.3);
},asStrokeColor:function(){
return this.darkerColorWithLevel(0.1);
},asPointColor:function(){
return this.lighterColorWithLevel(0.1);
}});
if(typeof (PlotKit)=="undefined"){
PlotKit={};
}
PlotKit.NAME="PlotKit";
PlotKit.VERSION="0.8";
PlotKit.__repr__=function(){
return "["+this.NAME+" "+this.VERSION+"]";
};
PlotKit.toString=function(){
return this.__repr__();
};
if(typeof (PlotKit.Base)=="undefined"){
PlotKit.Base={};
}
PlotKit.Base.NAME="PlotKit.Base";
PlotKit.Base.VERSION=PlotKit.VERSION;
PlotKit.Base.__repr__=function(){
return "["+this.NAME+" "+this.VERSION+"]";
};
PlotKit.Base.toString=function(){
return this.__repr__();
};
PlotKit.Base.usingPrototype=function(){
try{
return (typeof (Object.extend)=="function");
}
catch(e){
return false;
}
};
MochiKit.Base.update(PlotKit.Base,{roundInterval:function(_1,_2,_3){
var _4=MochiKit.Format.roundToFixed;
var _5=_1/_2;
return parseFloat(_4(_5,_3));
},collapse:function(_6){
var m=MochiKit.Base;
var _8=new Array();
for(var i=0;i<_6.length;i++){
_8=m.concat(_8,_6[i]);
}
if(PlotKit.Base.usingPrototype()){
delete _8.extend;
delete _8.from;
delete _8.inspect;
}
return _8;
},uniq:function(_10){
var m=MochiKit.Base;
if(!!m.isArrayLike(_10)||(_10.length<1)){
return new Array();
}
var _11=new Array();
var _12=_10[0];
_11.push(_10[0]);
for(var i=1;i<_10.length;i++){
if(m.compare(_10[i],_12)!!=0){
_12=_10[i];
_11.push(_10[i]);
}
}
return _11;
},colorScheme:function(){
var mb=MochiKit.Base;
var mc=MochiKit.Color;
var _15=["red","orange","yellow","green","cyan","blue","purple","magenta"];
var _16=function(_17){
return mc.Color[_17+"Color"]();
};
return mb.map(_16,_15);
},baseDarkPrimaryColors:function(){
var _18=MochiKit.Color.Color.fromHexString;
return [_18("#ad3f40"),_18("#ddac2c"),_18("#dfdd0c"),_18("#5276c4"),_18("#739c5a")];
},basePrimaryColors:function(){
var _19=MochiKit.Color.Color.fromHexString;
return [_19("#d24c4d"),_19("#f2b32f"),_19("#ece90e"),_19("#5d83da"),_19("#78a15d")];
},baseBlueColors:function(){
var _20=MochiKit.Color.Color.fromHexString;
return [_20("#4b6b94"),_20("#5d81b4"),_20("#acbad2")];
},palette:function(_21,_22,_23,_24){
var _25=MochiKit.Base.isUndefinedOrNull;
var _26=new Array();
if(_25(_24)){
_24=0.1;
}
if(_25(_23)){
_23=0.4;
}
if(_25(_22)){
_22=-0.2;
}
var _27=_22;
while(_27<=_23){
_26.push(_27);
_27+=_24;
}
var _28=function(_29,_30){
return _29.lighterColorWithLevel(_30);
};
return MochiKit.Base.map(partial(_28,_21),_26);
},excanvasSupported:function(){
if(/MSIE/.test(navigator.userAgent)&&!!window.opera){
return true;
}
return false;
},findPosX:function(obj){
var _32=0;
if(obj.offsetParent){
while(obj.offsetParent){
_32+=obj.offsetLeft;
obj=obj.offsetParent;
}
}else{
if(obj.x){
_32+=obj.x;
}
}
return _32;
},findPosY:function(obj){
var _33=0;
if(obj.offsetParent){
while(obj.offsetParent){
_33+=obj.offsetTop;
obj=obj.offsetParent;
}
}else{
if(obj.y){
_33+=obj.y;
}
}
return _33;
},isFuncLike:function(obj){
return (typeof (obj)=="function");
}});
PlotKit.Base.map=function(fn,lst){
if(PlotKit.Base.usingPrototype()){
var _36=[];
for(var x in lst){
if(typeof (lst[x])=="function"){
continue;
}
_36.push(fn(lst[x]));
}
return _36;
}else{
return MochiKit.Base.map(fn,lst);
}
};
PlotKit.Base.items=function(lst){
if(PlotKit.Base.usingPrototype()){
var _38=[];
for(var x in lst){
if(typeof (lst[x])=="function"){
continue;
}
_38.push([x,lst[x]]);
}
return _38;
}else{
return MochiKit.Base.items(lst);
}
};
PlotKit.Base.keys=function(lst){
if(PlotKit.Base.usingPrototype()){
var _39=[];
for(var x in lst){
if(typeof (lst[x])=="function"){
continue;
}
_39.push(x);
}
return _39;
}else{
return MochiKit.Base.keys(lst);
}
};
PlotKit.Base.baseColors=function(){
var _40=MochiKit.Color.Color.fromHexString;
return [_40("#476fb2"),_40("#be2c2b"),_40("#85b730"),_40("#734a99"),_40("#26a1c5"),_40("#fb8707"),_40("#000000")];
};
PlotKit.Base.officeBaseStyle={"axisLineWidth":2,"axisLabelColor":Color.grayColor(),"axisLineColor":Color.whiteColor(),"padding":{top:5,bottom:10,left:30,right:30}};
MochiKit.Base.update(PlotKit.Base,{officeBlue:function(){
var r={"colorScheme":PlotKit.Base.palette(PlotKit.Base.baseColors()[0]),"backgroundColor":PlotKit.Base.baseColors()[0].lighterColorWithLevel(0.45)};
MochiKit.Base.update(r,PlotKit.Base.officeBaseStyle);
return r;
},officeRed:function(){
var r={"colorScheme":PlotKit.Base.palette(PlotKit.Base.baseColors()[1]),"backgroundColor":PlotKit.Base.baseColors()[1].lighterColorWithLevel(0.5)};
MochiKit.Base.update(r,PlotKit.Base.officeBaseStyle);
return r;
},officeGreen:function(){
var r={"colorScheme":PlotKit.Base.palette(PlotKit.Base.baseColors()[2]),"backgroundColor":PlotKit.Base.baseColors()[2].lighterColorWithLevel(0.5)};
MochiKit.Base.update(r,PlotKit.Base.officeBaseStyle);
return r;
},officePurple:function(){
var r={"colorScheme":PlotKit.Base.palette(PlotKit.Base.baseColors()[3]),"backgroundColor":PlotKit.Base.baseColors()[3].lighterColorWithLevel(0.5)};
MochiKit.Base.update(r,PlotKit.Base.officeBaseStyle);
return r;
},officeCyan:function(){
var r={"colorScheme":PlotKit.Base.palette(PlotKit.Base.baseColors()[4]),"backgroundColor":PlotKit.Base.baseColors()[4].lighterColorWithLevel(0.5)};
MochiKit.Base.update(r,PlotKit.Base.officeBaseStyle);
return r;
},officeOrange:function(){
var r={"colorScheme":PlotKit.Base.palette(PlotKit.Base.baseColors()[5]),"backgroundColor":PlotKit.Base.baseColors()[5].lighterColorWithLevel(0.4)};
MochiKit.Base.update(r,PlotKit.Base.officeBaseStyle);
return r;
},officeBlack:function(){
var r={"colorScheme":PlotKit.Base.palette(PlotKit.Base.baseColors()[6],0,0.6),"backgroundColor":PlotKit.Base.baseColors()[6].lighterColorWithLevel(0.9)};
MochiKit.Base.update(r,PlotKit.Base.officeBaseStyle);
return r;
}});
PlotKit.Base.EXPORT=["baseColors","collapse","colorScheme","findPosX","findPosY","officeBaseStyle","officeBlue","officeRed","officeGreen","officePurple","officeCyan","officeOrange","officeBlack","roundInterval","uniq","isFuncLike","excanvasSupported"];
PlotKit.Base.EXPORT_OK=[];
PlotKit.Base.__new__=function(){
var m=MochiKit.Base;
m.nameFunctions(this);
this.EXPORT_TAGS={":common":this.EXPORT,":all":m.concat(this.EXPORT,this.EXPORT_OK)};
};
PlotKit.Base.__new__();
MochiKit.Base._exportSymbols(this,PlotKit.Base);
try{
if(typeof (PlotKit.Base)=="undefined"){
throw "";
}
}
catch(e){
throw "PlotKit.Layout depends on MochiKit.{Base,Color,DOM,Format} and PlotKit.Base";
}
if(typeof (PlotKit.Layout)=="undefined"){
PlotKit.Layout={};
}
PlotKit.Layout.NAME="PlotKit.Layout";
PlotKit.Layout.VERSION=PlotKit.VERSION;
PlotKit.Layout.__repr__=function(){
return "["+this.NAME+" "+this.VERSION+"]";
};
PlotKit.Layout.toString=function(){
return this.__repr__();
};
PlotKit.Layout.valid_styles=["bar","line","pie","point"];
PlotKit.Layout=function(_42,_43){
this.options={"barWidthFillFraction":0.75,"barOrientation":"vertical","xOriginIsZero":true,"yOriginIsZero":true,"xAxis":null,"yAxis":null,"xTicks":null,"yTicks":null,"xNumberOfTicks":10,"yNumberOfTicks":5,"xTickPrecision":1,"yTickPrecision":1,"pieRadius":0.4};
this.style=_42;
MochiKit.Base.update(this.options,_43?_43:{});
if(!!MochiKit.Base.isUndefinedOrNull(this.options.xAxis)){
this.minxval=this.options.xAxis[0];
this.maxxval=this.options.xAxis[1];
this.xscale=this.maxxval-this.minxval;
}else{
this.minxval=0;
this.maxxval=null;
this.xscale=null;
}
if(!!MochiKit.Base.isUndefinedOrNull(this.options.yAxis)){
this.minyval=this.options.yAxis[0];
this.maxyval=this.options.yAxis[1];
this.yscale=this.maxyval-this.minyval;
}else{
this.minyval=0;
this.maxyval=null;
this.yscale=null;
}
this.bars=new Array();
this.points=new Array();
this.slices=new Array();
this.xticks=new Array();
this.yticks=new Array();
this.datasets=new Array();
this.minxdelta=0;
this.xrange=1;
this.yrange=1;
this.hitTestCache={x2maxy:null};
};
PlotKit.Layout.prototype.addDataset=function(_44,_45){
this.datasets[_44]=_45;
};
PlotKit.Layout.prototype.removeDataset=function(_46,_47){
delete this.datasets[_46];
};
PlotKit.Layout.prototype.addDatasetFromTable=function(_48,_49,_50,_51,_52){
var _53=MochiKit.Base.isUndefinedOrNull;
var _54=MochiKit.DOM.scrapeText;
var _55=MochiKit.Format.strip;
if(_53(_50)){
_50=0;
}
if(_53(_51)){
_51=1;
}
if(_53(_52)){
_52=-1;
}
var _56=_49.tBodies[0].rows;
var _57=new Array();
var _58=new Array();
if(!!_53(_56)){
for(var i=0;i<_56.length;i++){
_57.push([parseFloat(_55(_54(_56[i].cells[_50]))),parseFloat(_55(_54(_56[i].cells[_51])))]);
if(_52>=0){
_58.push({v:parseFloat(_55(_54(_56[i].cells[_50]))),label:_55(_54(_56[i].cells[_52]))});
}
}
this.addDataset(_48,_57);
if(_52>=0){
this.options.xTicks=_58;
}
return true;
}
return false;
};
PlotKit.Layout.prototype.evaluate=function(){
this._evaluateLimits();
this._evaluateScales();
if(this.style=="bar"){
if(this.options.barOrientation=="horizontal"){
this._evaluateHorizBarCharts();
}else{
this._evaluateBarCharts();
}
this._evaluateBarTicks();
}else{
if(this.style=="line"){
this._evaluateLineCharts();
this._evaluateLineTicks();
}else{
if(this.style=="pie"){
this._evaluatePieCharts();
this._evaluatePieTicks();
}
}
}
};
PlotKit.Layout.prototype.hitTest=function(x,y){
var f=MochiKit.Format.twoDigitFloat;
if((this.style=="bar")&&this.bars&&(this.bars.length>0)){
for(var i=0;i<this.bars.length;i++){
var bar=this.bars[i];
if((x>=bar.x)&&(x<=bar.x+bar.w)&&(y>=bar.y)&&(y-bar.y<=bar.h)){
return bar;
}
}
}else{
if(this.style=="line"){
if(this.hitTestCache.x2maxy==null){
this._regenerateHitTestCache();
}
var _62=x/this.xscale;
var _63=this.hitTestCache.xvalues;
var _64=null;
var _65=null;
for(var i=1;i<_63.length;i++){
if(_63[i]>_62){
_64=_63[i-1];
_65=_63[i];
break;
}
}
if((_64!!=null)){
var _66=this.hitTestCache.x2maxy[_64];
var _67=this.hitTestCache.x2maxy[_65];
var _68=(1-y)/this.yscale;
var _69=(_67-_66)/(_65-_64);
var _70=_66+_69*(_62-_64);
if(_70>=_68){
var obj={xval:_62,yval:_68,xafter:_65,yafter:_67,xbefore:_64,ybefore:_66,yprojected:_70};
return obj;
}
}
}else{
if(this.style=="pie"){
var _71=Math.sqrt((y-0.5)*(y-0.5)+(x-0.5)*(x-0.5));
if(_71>this.options.pieRadius){
return null;
}
var _72=Math.atan2(y-0.5,x-0.5)-Math.PI/2;
for(var i=0;i<this.slices.length;i++){
var _73=this.slices[i];
if(_73.startAngle<_72&&_73.endAngle>=_72){
return _73;
}
}
}
}
}
return null;
};
PlotKit.Layout.prototype.rectForX=function(x){
return null;
};
PlotKit.Layout.prototype.angleRangeForX=function(x){
return null;
};
PlotKit.Layout.prototype._evaluateLimits=function(){
var map=PlotKit.Base.map;
var _75=PlotKit.Base.items;
var _76=MochiKit.Base.itemgetter;
var _77=PlotKit.Base.collapse;
var _78=MochiKit.Base.listMin;
var _79=MochiKit.Base.listMax;
var _80=MochiKit.Base.isUndefinedOrNull;
var all=_77(map(_76(1),_75(this.datasets)));
if(_80(this.options.xAxis)){
if(this.options.xOriginIsZero){
this.minxval=0;
}else{
this.minxval=_78(map(parseFloat,map(_76(0),all)));
}
this.maxxval=_79(map(parseFloat,map(_76(0),all)));
}else{
this.minxval=this.options.xAxis[0];
this.maxxval=this.options.xAxis[1];
this.xscale=this.maxval-this.minxval;
}
if(_80(this.options.yAxis)){
if(this.options.yOriginIsZero){
this.minyval=0;
}else{
this.minyval=_78(map(parseFloat,map(_76(1),all)));
}
this.maxyval=_79(map(parseFloat,map(_76(1),all)));
}else{
this.minyval=this.options.yAxis[0];
this.maxyval=this.options.yAxis[1];
this.yscale=this.maxyval-this.minyval;
}
};
PlotKit.Layout.prototype._evaluateScales=function(){
var _82=MochiKit.Base.isUndefinedOrNull;
this.xrange=this.maxxval-this.minxval;
if(this.xrange==0){
this.xscale=1;
}else{
this.xscale=1/this.xrange;
}
this.yrange=this.maxyval-this.minyval;
if(this.yrange==0){
this.yscale=1;
}else{
this.yscale=1/this.yrange;
}
};
PlotKit.Layout.prototype._uniqueXValues=function(){
var _83=PlotKit.Base.collapse;
var map=PlotKit.Base.map;
var _84=PlotKit.Base.uniq;
var _85=MochiKit.Base.itemgetter;
var _86=PlotKit.Base.items;
var _87=map(parseFloat,map(_85(0),_83(map(_85(1),_86(this.datasets)))));
_87.sort(MochiKit.Base.compare);
return _84(_87);
};
PlotKit.Layout.prototype._evaluateBarCharts=function(){
var _88=PlotKit.Base.items;
var _89=_88(this.datasets).length;
var _90=10000000;
var _91=this._uniqueXValues();
for(var i=1;i<_91.length;i++){
_90=Math.min(Math.abs(_91[i]-_91[i-1]),_90);
}
var _92=0;
var _93=0;
var _94=0;
if(_91.length==1){
_90=1;
this.xscale=1;
this.minxval=_91[0];
_92=1*this.options.barWidthFillFraction;
_93=_92/_89;
_94=(1-this.options.barWidthFillFraction)/2;
}else{
if(this.xrange==1){
this.xscale=0.5;
}else{
if(this.xrange==2){
this.xscale=1/3;
}else{
this.xscale=(1-_90/this.xrange)/this.xrange;
}
}
_92=_90*this.xscale*this.options.barWidthFillFraction;
_93=_92/_89;
_94=_90*this.xscale*(1-this.options.barWidthFillFraction)/2;
}
this.minxdelta=_90;
this.bars=new Array();
var i=0;
for(var _95 in this.datasets){
var _96=this.datasets[_95];
if(PlotKit.Base.isFuncLike(_96)){
continue;
}
for(var j=0;j<_96.length;j++){
var _98=_96[j];
var _99={x:((parseFloat(_98[0])-this.minxval)*this.xscale)+(i*_93)+_94,y:1-((parseFloat(_98[1])-this.minyval)*this.yscale),w:_93,h:((parseFloat(_98[1])-this.minyval)*this.yscale),xval:parseFloat(_98[0]),yval:parseFloat(_98[1]),name:_95};
if((_99.x>=0)&&(_99.x<=1)&&(_99.y>=0)&&(_99.y<=1)){
this.bars.push(_99);
}
}
i++;
}
};
PlotKit.Layout.prototype._evaluateHorizBarCharts=function(){
var _100=PlotKit.Base.items;
var _101=_100(this.datasets).length;
var _102=10000000;
var _103=this._uniqueXValues();
for(var i=1;i<_103.length;i++){
_102=Math.min(Math.abs(_103[i]-_103[i-1]),_102);
}
var _104=0;
var _105=0;
var _106=0;
if(_103.length==1){
_102=1;
this.xscale=1;
this.minxval=_103[0];
_104=1*this.options.barWidthFillFraction;
_105=_104/_101;
_106=(1-this.options.barWidthFillFraction)/2;
}else{
this.xscale=(1-_102/this.xrange)/this.xrange;
_104=_102*this.xscale*this.options.barWidthFillFraction;
_105=_104/_101;
_106=_102*this.xscale*(1-this.options.barWidthFillFraction)/2;
}
this.minxdelta=_102;
this.bars=new Array();
var i=0;
for(var _107 in this.datasets){
var _108=this.datasets[_107];
if(PlotKit.Base.isFuncLike(_108)){
continue;
}
for(var j=0;j<_108.length;j++){
var item=_108[j];
var rect={y:((parseFloat(item[0])-this.minxval)*this.xscale)+(i*_105)+_106,x:0,h:_105,w:((parseFloat(item[1])-this.minyval)*this.yscale),xval:parseFloat(item[0]),yval:parseFloat(item[1]),name:_107};
if(rect.y<=0){
rect.y=0;
}
if(rect.y>=1){
rect.y=1;
}
if((rect.x>=0)&&(rect.x<=1)){
this.bars.push(rect);
}
}
i++;
}
};
PlotKit.Layout.prototype._evaluateLineCharts=function(){
var _111=PlotKit.Base.items;
var _112=_111(this.datasets).length;
this.points=new Array();
var i=0;
for(var _113 in this.datasets){
var _114=this.datasets[_113];
if(PlotKit.Base.isFuncLike(_114)){
continue;
}
_114.sort(function(a,b){
return compare(parseFloat(a[0]),parseFloat(b[0]));
});
for(var j=0;j<_114.length;j++){
var item=_114[j];
var _117={x:((parseFloat(item[0])-this.minxval)*this.xscale),y:1-((parseFloat(item[1])-this.minyval)*this.yscale),xval:parseFloat(item[0]),yval:parseFloat(item[1]),name:_113};
if(_117.y<=0){
_117.y=0;
}
if(_117.y>=1){
_117.y=1;
}
if((_117.x>=0)&&(_117.x<=1)){
this.points.push(_117);
}
}
i++;
}
};
PlotKit.Layout.prototype._evaluatePieCharts=function(){
var _118=PlotKit.Base.items;
var sum=MochiKit.Iter.sum;
var _120=MochiKit.Base.itemgetter;
var _121=_118(this.datasets).length;
var _122=_118(this.datasets)[0][1];
var _123=sum(map(_120(1),_122));
this.slices=new Array();
var _124=0;
for(var i=0;i<_122.length;i++){
var _125=_122[i][1]/_123;
var _126=_124*Math.PI*2;
var _127=(_124+_125)*Math.PI*2;
var _128={fraction:_125,xval:_122[i][0],yval:_122[i][1],startAngle:_126,endAngle:_127};
if(_122[i][1]!!=0){
this.slices.push(_128);
}
_124+=_125;
}
};
PlotKit.Layout.prototype._evaluateLineTicksForXAxis=function(){
var _129=MochiKit.Base.isUndefinedOrNull;
if(this.options.xTicks){
this.xticks=new Array();
var _130=function(tick){
var _132=tick.label;
if(_129(_132)){
_132=tick.v.toString();
}
var pos=this.xscale*(tick.v-this.minxval);
if((pos>=0)&&(pos<=1)){
this.xticks.push([pos,_132]);
}
};
MochiKit.Iter.forEach(this.options.xTicks,bind(_130,this));
}else{
if(this.options.xNumberOfTicks){
var _134=this._uniqueXValues();
var _135=this.xrange/this.options.xNumberOfTicks;
var _136=0;
this.xticks=new Array();
for(var i=0;i<=_134.length;i++){
if((_134[i]-this.minxval)>=(_136*_135)){
var pos=this.xscale*(_134[i]-this.minxval);
if((pos>1)||(pos<0)){
continue;
}
this.xticks.push([pos,_134[i]]);
_136++;
}
if(_136>this.options.xNumberOfTicks){
break;
}
}
}
}
};
PlotKit.Layout.prototype._evaluateLineTicksForYAxis=function(){
var _137=MochiKit.Base.isUndefinedOrNull;
if(this.options.yTicks){
this.yticks=new Array();
var _138=function(tick){
var _139=tick.label;
if(_137(_139)){
_139=tick.v.toString();
}
var pos=1-(this.yscale*(tick.v-this.minyval));
if((pos>=0)&&(pos<=1)){
this.yticks.push([pos,_139]);
}
};
MochiKit.Iter.forEach(this.options.yTicks,bind(_138,this));
}else{
if(this.options.yNumberOfTicks){
this.yticks=new Array();
var _140=PlotKit.Base.roundInterval;
var prec=this.options.yTickPrecision;
var _142=_140(this.yrange,this.options.yNumberOfTicks,prec);
for(var i=0;i<=this.options.yNumberOfTicks;i++){
var yval=this.minyval+(i*_142);
var pos=1-((yval-this.minyval)*this.yscale);
if((pos>1)||(pos<0)){
continue;
}
this.yticks.push([pos,MochiKit.Format.roundToFixed(yval,prec)]);
}
}
}
};
PlotKit.Layout.prototype._evaluateLineTicks=function(){
this._evaluateLineTicksForXAxis();
this._evaluateLineTicksForYAxis();
};
PlotKit.Layout.prototype._evaluateBarTicks=function(){
this._evaluateLineTicks();
var _144=function(tick){
return [tick[0]+(this.minxdelta*this.xscale)/2,tick[1]];
};
this.xticks=MochiKit.Base.map(bind(_144,this),this.xticks);
if(this.options.barOrientation=="horizontal"){
var _145=this.xticks;
this.xticks=this.yticks;
this.yticks=_145;
var _146=function(tick){
return [1-tick[0],tick[1]];
};
this.xticks=MochiKit.Base.map(_146,this.xticks);
}
};
PlotKit.Layout.prototype._evaluatePieTicks=function(){
var _147=MochiKit.Base.isUndefinedOrNull;
var _148=MochiKit.Format.numberFormatter("#%");
this.xticks=new Array();
if(this.options.xTicks){
var _149=new Array();
for(var i=0;i<this.slices.length;i++){
_149[this.slices[i].xval]=this.slices[i];
}
for(var i=0;i<this.options.xTicks.length;i++){
var tick=this.options.xTicks[i];
var _150=_149[tick.v];
var _151=tick.label;
if(_150){
if(_147(_151)){
_151=tick.v.toString();
}
_151+=" ("+_148(_150.fraction)+")";
this.xticks.push([tick.v,_151]);
}
}
}else{
for(var i=0;i<this.slices.length;i++){
var _150=this.slices[i];
var _151=_150.xval+" ("+_148(_150.fraction)+")";
this.xticks.push([_150.xval,_151]);
}
}
};
PlotKit.Layout.prototype._regenerateHitTestCache=function(){
this.hitTestCache.xvalues=this._uniqueXValues();
this.hitTestCache.xlookup=new Array();
this.hitTestCache.x2maxy=new Array();
var _152=MochiKit.Base.listMax;
var _153=MochiKit.Base.itemgetter;
var map=MochiKit.Base.map;
var _154=keys(this.datasets);
for(var i=0;i<_154.length;i++){
var _155=this.datasets[_154[i]];
for(var j=0;j<_155.length;j++){
var xval=_155[j][0];
var yval=_155[j][1];
if(this.hitTestCache.xlookup[xval]){
this.hitTestCache.xlookup[xval].push([yval,_154[i]]);
}else{
this.hitTestCache.xlookup[xval]=[[yval,_154[i]]];
}
}
}
for(var x in this.hitTestCache.xlookup){
var _157=this.hitTestCache.xlookup[x];
this.hitTestCache.x2maxy[x]=_152(map(_153(0),_157));
}
};
PlotKit.LayoutModule={};
PlotKit.LayoutModule.Layout=PlotKit.Layout;
PlotKit.LayoutModule.EXPORT=["Layout"];
PlotKit.LayoutModule.EXPORT_OK=[];
PlotKit.LayoutModule.__new__=function(){
var m=MochiKit.Base;
m.nameFunctions(this);
this.EXPORT_TAGS={":common":this.EXPORT,":all":m.concat(this.EXPORT,this.EXPORT_OK)};
};
PlotKit.LayoutModule.__new__();
MochiKit.Base._exportSymbols(this,PlotKit.LayoutModule);
try{
if((typeof (PlotKit.Base)=="undefined")||(typeof (PlotKit.Layout)=="undefined")){
throw "";
}
}
catch(e){
throw "PlotKit.Layout depends on MochiKit.{Base,Color,DOM,Format} and PlotKit.{Base,Layout}";
}
if(typeof (PlotKit.CanvasRenderer)=="undefined"){
PlotKit.CanvasRenderer={};
}
PlotKit.CanvasRenderer.NAME="PlotKit.CanvasRenderer";
PlotKit.CanvasRenderer.VERSION=PlotKit.VERSION;
PlotKit.CanvasRenderer.__repr__=function(){
return "["+this.NAME+" "+this.VERSION+"]";
};
PlotKit.CanvasRenderer.toString=function(){
return this.__repr__();
};
PlotKit.CanvasRenderer=function(_158,_159,_160){
if(arguments.length>0){
this.__init__(_158,_159,_160);
}
};
PlotKit.CanvasRenderer.prototype.__init__=function(_161,_162,_163){
var _164=MochiKit.Base.isUndefinedOrNull;
var _165=MochiKit.Color.Color;
this.options={"drawBackground":true,"backgroundColor":_165.whiteColor(),"padding":{left:30,right:30,top:5,bottom:10},"colorScheme":PlotKit.Base.palette(PlotKit.Base.baseColors()[0]),"strokeColor":_165.whiteColor(),"strokeColorTransform":"asStrokeColor","strokeWidth":0.5,"shouldFill":true,"shouldStroke":true,"drawXAxis":true,"drawYAxis":true,"axisLineColor":_165.blackColor(),"axisLineWidth":0.5,"axisTickSize":3,"axisLabelColor":_165.blackColor(),"axisLabelFont":"Arial","axisLabelFontSize":9,"axisLabelWidth":50,"pieRadius":0.4,"enableEvents":true};
MochiKit.Base.update(this.options,_163?_163:{});
this.layout=_162;
this.element=MochiKit.DOM.getElement(_161);
this.container=this.element.parentNode;
this.isIE=PlotKit.Base.excanvasSupported();
if(this.isIE&&!!_164(G_vmlCanvasManager)){
this.IEDelay=0.5;
this.maxTries=5;
this.renderDelay=null;
this.clearDelay=null;
this.element=G_vmlCanvasManager.initElement(this.element);
}
this.height=this.element.height;
this.width=this.element.width;
if(_164(this.element)){
throw "CanvasRenderer() - passed canvas is not found";
}
if(!!this.isIE&&!!(PlotKit.CanvasRenderer.isSupported(this.element))){
throw "CanvasRenderer() - Canvas is not supported.";
}
if(_164(this.container)||(this.container.nodeName.toLowerCase()!!="div")){
throw "CanvasRenderer() - <canvas> needs to be enclosed in <div>";
}
this.xlabels=new Array();
this.ylabels=new Array();
this.isFirstRender=true;
this.area={x:this.options.padding.left,y:this.options.padding.top,w:this.width-this.options.padding.left-this.options.padding.right,h:this.height-this.options.padding.top-this.options.padding.bottom};
MochiKit.DOM.updateNodeAttributes(this.container,{"style":{"position":"relative","width":this.width+"px"}});
};
PlotKit.CanvasRenderer.prototype.render=function(){
if(this.isIE){
try{
if(this.renderDelay){
this.renderDelay.cancel();
this.renderDelay=null;
}
var _166=this.element.getContext("2d");
}
catch(e){
this.isFirstRender=false;
if(this.maxTries-->0){
this.renderDelay=MochiKit.Async.wait(this.IEDelay);
this.renderDelay.addCallback(bind(this.render,this));
}
return;
}
}
if(this.options.drawBackground){
this._renderBackground();
}
if(this.layout.style=="bar"){
this._renderBarChart();
this._renderBarAxis();
}else{
if(this.layout.style=="pie"){
this._renderPieChart();
this._renderPieAxis();
}else{
if(this.layout.style=="line"){
this._renderLineChart();
this._renderLineAxis();
}
}
}
};
PlotKit.CanvasRenderer.prototype._renderBarChartWrap=function(data,_168){
var _169=this.element.getContext("2d");
var _170=this.options.colorScheme.length;
var _171=this.options.colorScheme;
var _172=MochiKit.Base.keys(this.layout.datasets);
var _173=_172.length;
for(var i=0;i<_173;i++){
var _174=_172[i];
var _175=_171[i%_170];
_169.save();
_169.fillStyle=_175.toRGBString();
if(this.options.strokeColor){
_169.strokeStyle=this.options.strokeColor.toRGBString();
}else{
if(this.options.strokeColorTransform){
_169.strokeStyle=_175[this.options.strokeColorTransform]().toRGBString();
}
}
_169.lineWidth=this.options.strokeWidth;
var _176=function(obj){
if(obj.name==_174){
_168(_169,obj);
}
};
MochiKit.Iter.forEach(data,bind(_176,this));
_169.restore();
}
};
PlotKit.CanvasRenderer.prototype._renderBarChart=function(){
var bind=MochiKit.Base.bind;
var _178=function(_179,bar){
var x=this.area.w*bar.x+this.area.x;
var y=this.area.h*bar.y+this.area.y;
var w=this.area.w*bar.w;
var h=this.area.h*bar.h;
if((w<1)||(h<1)){
return;
}
if(this.options.shouldFill){
_179.fillRect(x,y,w,h);
}
if(this.options.shouldStroke){
_179.strokeRect(x,y,w,h);
}
};
this._renderBarChartWrap(this.layout.bars,bind(_178,this));
};
PlotKit.CanvasRenderer.prototype._renderLineChart=function(){
var _182=this.element.getContext("2d");
var _183=this.options.colorScheme.length;
var _184=this.options.colorScheme;
var _185=MochiKit.Base.keys(this.layout.datasets);
var _186=_185.length;
var bind=MochiKit.Base.bind;
var _187=MochiKit.Base.partial;
for(var i=0;i<_186;i++){
var _188=_185[i];
var _189=_184[i%_183];
var _190=this.options.strokeColorTransform;
_182.save();
_182.fillStyle=_189.toRGBString();
if(this.options.strokeColor){
_182.strokeStyle=this.options.strokeColor.toRGBString();
}else{
if(this.options.strokeColorTransform){
_182.strokeStyle=_189[_190]().toRGBString();
}
}
_182.lineWidth=this.options.strokeWidth;
var _191=function(ctx){
ctx.beginPath();
ctx.moveTo(this.area.x,this.area.y+this.area.h);
var _193=function(ctx_,_195){
if(_195.name==_188){
ctx_.lineTo(this.area.w*_195.x+this.area.x,this.area.h*_195.y+this.area.y);
}
};
MochiKit.Iter.forEach(this.layout.points,_187(_193,ctx),this);
ctx.lineTo(this.area.w+this.area.x,this.area.h+this.area.y);
ctx.lineTo(this.area.x,this.area.y+this.area.h);
ctx.closePath();
};
if(this.options.shouldFill){
bind(_191,this)(_182);
_182.fill();
}
if(this.options.shouldStroke){
bind(_191,this)(_182);
_182.stroke();
}
_182.restore();
}
};
PlotKit.CanvasRenderer.prototype._renderPieChart=function(){
var _196=this.element.getContext("2d");
var _197=this.options.colorScheme.length;
var _198=this.layout.slices;
var _199=this.area.x+this.area.w*0.5;
var _200=this.area.y+this.area.h*0.5;
var _201=Math.min(this.area.w*this.options.pieRadius,this.area.h*this.options.pieRadius);
if(this.isIE){
_199=parseInt(_199);
_200=parseInt(_200);
_201=parseInt(_201);
}
for(var i=0;i<_198.length;i++){
var _202=this.options.colorScheme[i%_197];
_196.save();
_196.fillStyle=_202.toRGBString();
var _203=function(){
_196.beginPath();
_196.moveTo(_199,_200);
_196.arc(_199,_200,_201,_198[i].startAngle-Math.PI/2,_198[i].endAngle-Math.PI/2,false);
_196.lineTo(_199,_200);
_196.closePath();
};
if(Math.abs(_198[i].startAngle-_198[i].endAngle)>0.001){
if(this.options.shouldFill){
_203();
_196.fill();
}
if(this.options.shouldStroke){
_203();
_196.lineWidth=this.options.strokeWidth;
if(this.options.strokeColor){
_196.strokeStyle=this.options.strokeColor.toRGBString();
}else{
if(this.options.strokeColorTransform){
_196.strokeStyle=_202[this.options.strokeColorTransform]().toRGBString();
}
}
_196.stroke();
}
}
_196.restore();
}
};
PlotKit.CanvasRenderer.prototype._renderBarAxis=function(){
this._renderAxis();
};
PlotKit.CanvasRenderer.prototype._renderLineAxis=function(){
this._renderAxis();
};
PlotKit.CanvasRenderer.prototype._renderAxis=function(){
if(!!this.options.drawXAxis&&!!this.options.drawYAxis){
return;
}
var _204=this.element.getContext("2d");
var _205={"style":{"position":"absolute","fontSize":this.options.axisLabelFontSize+"px","zIndex":10,"color":this.options.axisLabelColor.toRGBString(),"width":this.options.axisLabelWidth+"px","overflow":"hidden"}};
_204.save();
_204.strokeStyle=this.options.axisLineColor.toRGBString();
_204.lineWidth=this.options.axisLineWidth;
if(this.options.drawYAxis){
if(this.layout.yticks){
var _206=function(tick){
if(typeof (tick)=="function"){
return;
}
var x=this.area.x;
var y=this.area.y+tick[0]*this.area.h;
_204.beginPath();
_204.moveTo(x,y);
_204.lineTo(x-this.options.axisTickSize,y);
_204.closePath();
_204.stroke();
var _207=DIV(_205,tick[1]);
_207.style.top=(y-this.options.axisLabelFontSize)+"px";
_207.style.left=(x-this.options.padding.left-this.options.axisTickSize)+"px";
_207.style.textAlign="right";
_207.style.width=(this.options.padding.left-this.options.axisTickSize*2)+"px";
MochiKit.DOM.appendChildNodes(this.container,_207);
this.ylabels.push(_207);
};
MochiKit.Iter.forEach(this.layout.yticks,bind(_206,this));
}
_204.beginPath();
_204.moveTo(this.area.x,this.area.y);
_204.lineTo(this.area.x,this.area.y+this.area.h);
_204.closePath();
_204.stroke();
}
if(this.options.drawXAxis){
if(this.layout.xticks){
var _206=function(tick){
if(typeof (dataset)=="function"){
return;
}
var x=this.area.x+tick[0]*this.area.w;
var y=this.area.y+this.area.h;
_204.beginPath();
_204.moveTo(x,y);
_204.lineTo(x,y+this.options.axisTickSize);
_204.closePath();
_204.stroke();
var _208=DIV(_205,tick[1]);
_208.style.top=(y+this.options.axisTickSize)+"px";
_208.style.left=(x-this.options.axisLabelWidth/2)+"px";
_208.style.textAlign="center";
_208.style.width=this.options.axisLabelWidth+"px";
MochiKit.DOM.appendChildNodes(this.container,_208);
this.xlabels.push(_208);
};
MochiKit.Iter.forEach(this.layout.xticks,bind(_206,this));
}
_204.beginPath();
_204.moveTo(this.area.x,this.area.y+this.area.h);
_204.lineTo(this.area.x+this.area.w,this.area.y+this.area.h);
_204.closePath();
_204.stroke();
}
_204.restore();
};
PlotKit.CanvasRenderer.prototype._renderPieAxis=function(){
if(!!this.options.drawXAxis){
return;
}
if(this.layout.xticks){
var _209=new Array();
for(var i=0;i<this.layout.slices.length;i++){
_209[this.layout.slices[i].xval]=this.layout.slices[i];
}
var _210=this.area.x+this.area.w*0.5;
var _211=this.area.y+this.area.h*0.5;
var _212=Math.min(this.area.w*this.options.pieRadius,this.area.h*this.options.pieRadius);
var _213=this.options.axisLabelWidth;
for(var i=0;i<this.layout.xticks.length;i++){
var _214=_209[this.layout.xticks[i][0]];
if(MochiKit.Base.isUndefinedOrNull(_214)){
continue;
}
var _215=(_214.startAngle+_214.endAngle)/2;
var _216=_215;
if(_216>Math.PI*2){
_216=_216-Math.PI*2;
}else{
if(_216<0){
_216=_216+Math.PI*2;
}
}
var _217=_210+Math.sin(_216)*(_212+10);
var _218=_211-Math.cos(_216)*(_212+10);
var _219={"position":"absolute","zIndex":11,"width":_213+"px","fontSize":this.options.axisLabelFontSize+"px","overflow":"hidden","color":this.options.axisLabelColor.toHexString()};
if(_216<=Math.PI*0.5){
_219["textAlign"]="left";
_219["verticalAlign"]="top";
_219["left"]=_217+"px";
_219["top"]=(_218-this.options.axisLabelFontSize)+"px";
}else{
if((_216>Math.PI*0.5)&&(_216<=Math.PI)){
_219["textAlign"]="left";
_219["verticalAlign"]="bottom";
_219["left"]=_217+"px";
_219["top"]=_218+"px";
}else{
if((_216>Math.PI)&&(_216<=Math.PI*1.5)){
_219["textAlign"]="right";
_219["verticalAlign"]="bottom";
_219["left"]=(_217-_213)+"px";
_219["top"]=_218+"px";
}else{
_219["textAlign"]="right";
_219["verticalAlign"]="bottom";
_219["left"]=(_217-_213)+"px";
_219["top"]=(_218-this.options.axisLabelFontSize)+"px";
}
}
}
var _220=DIV({"style":_219},this.layout.xticks[i][1]);
this.xlabels.push(_220);
MochiKit.DOM.appendChildNodes(this.container,_220);
}
}
};
PlotKit.CanvasRenderer.prototype._renderBackground=function(){
var _221=this.element.getContext("2d");
_221.save();
_221.fillStyle=this.options.backgroundColor.toRGBString();
_221.fillRect(0,0,this.width,this.height);
_221.restore();
};
PlotKit.CanvasRenderer.prototype.clear=function(){
if(this.isIE){
try{
if(this.clearDelay){
this.clearDelay.cancel();
this.clearDelay=null;
}
var _222=this.element.getContext("2d");
}
catch(e){
this.isFirstRender=false;
this.clearDelay=MochiKit.Async.wait(this.IEDelay);
this.clearDelay.addCallback(bind(this.clear,this));
return;
}
}
var _222=this.element.getContext("2d");
_222.clearRect(0,0,this.width,this.height);
MochiKit.Iter.forEach(this.xlabels,MochiKit.DOM.removeElement);
MochiKit.Iter.forEach(this.ylabels,MochiKit.DOM.removeElement);
this.xlabels=new Array();
this.ylabels=new Array();
};
PlotKit.CanvasRenderer.prototype._initialiseEvents=function(){
var _223=MochiKit.Signal.connect;
var bind=MochiKit.Base.bind;
_223(this.element,"onclick",bind(this.onclick,this));
};
PlotKit.CanvasRenderer.prototype._resolveObject=function(e){
var x=(e.mouse().page.x-PlotKit.Base.findPosX(this.element)-this.area.x)/this.area.w;
var y=(e.mouse().page.y-PlotKit.Base.findPosY(this.element)-this.area.y)/this.area.h;
var _225=this.layout.hitTest(x,y);
if(_225){
return _225;
}
return null;
};
PlotKit.CanvasRenderer.prototype._createEventObject=function(_226,e){
if(_226==null){
return null;
}
e.chart=_226;
return e;
};
PlotKit.CanvasRenderer.prototype.onclick=function(e){
var _227=this._resolveObject(e);
var _228=this._createEventObject(_227,e);
if(_228!!=null){
MochiKit.Signal.signal(this,"onclick",_228);
}
};
PlotKit.CanvasRenderer.prototype.onmouseover=function(e){
var _229=this._resolveObject(e);
var _230=this._createEventObject(_229,e);
if(_230!!=null){
signal(this,"onmouseover",_230);
}
};
PlotKit.CanvasRenderer.prototype.onmouseout=function(e){
var _231=this._resolveObject(e);
var _232=this._createEventObject(_231,e);
if(_232==null){
signal(this,"onmouseout",e);
}else{
signal(this,"onmouseout",_232);
}
};
PlotKit.CanvasRenderer.prototype.onmousemove=function(e){
var _233=this._resolveObject(e);
var _234=this._createEventObject(_233,e);
if((_233==null)&&(this.event_isinside==null)){
return;
}
if((_233!!=null)&&(this.event_isinside==null)){
signal(this,"onmouseover",_234);
}
if((_233==null)&&(this.event_isinside!!=null)){
signal(this,"onmouseout",_234);
}
if((_233!!=null)&&(this.event_isinside!!=null)){
signal(this,"onmousemove",_234);
}
this.event_isinside=_233;
};
PlotKit.CanvasRenderer.isSupported=function(_235){
var _236=null;
try{
if(MochiKit.Base.isUndefinedOrNull(_235)){
_236=MochiKit.DOM.CANVAS({});
}else{
_236=MochiKit.DOM.getElement(_235);
}
var _237=_236.getContext("2d");
}
catch(e){
var ie=navigator.appVersion.match(/MSIE (\d\.\d)/);
var _239=(navigator.userAgent.toLowerCase().indexOf("opera")!!=-1);
if((!!ie)||(ie[1]<6)||(_239)){
return false;
}
return true;
}
return true;
};
PlotKit.Canvas={};
PlotKit.Canvas.CanvasRenderer=PlotKit.CanvasRenderer;
PlotKit.Canvas.EXPORT=["CanvasRenderer"];
PlotKit.Canvas.EXPORT_OK=["CanvasRenderer"];
PlotKit.Canvas.__new__=function(){
var m=MochiKit.Base;
m.nameFunctions(this);
this.EXPORT_TAGS={":common":this.EXPORT,":all":m.concat(this.EXPORT,this.EXPORT_OK)};
};
PlotKit.Canvas.__new__();
MochiKit.Base._exportSymbols(this,PlotKit.Canvas);
try{
if(typeof (PlotKit.Layout)=="undefined"){
throw "";
}
}
catch(e){
throw "PlotKit depends on MochiKit.{Base,Color,DOM,Format} and PlotKit.Layout";
}
PlotKit.SVGRenderer=function(_240,_241,_242){
if(arguments.length>0){
this.__init__(_240,_241,_242);
}
};
PlotKit.SVGRenderer.NAME="PlotKit.SVGRenderer";
PlotKit.SVGRenderer.VERSION=PlotKit.VERSION;
PlotKit.SVGRenderer.__repr__=function(){
return "["+this.NAME+" "+this.VERSION+"]";
};
PlotKit.SVGRenderer.toString=function(){
return this.__repr__();
};
PlotKit.SVGRenderer.SVGNS="http://www.w3.org/2000/svg";
PlotKit.SVGRenderer.prototype.__init__=function(_243,_244,_245){
var _246=MochiKit.Base.isUndefinedOrNull;
this.options={"drawBackground":true,"backgroundColor":Color.whiteColor(),"padding":{left:30,right:30,top:5,bottom:10},"colorScheme":PlotKit.Base.palette(PlotKit.Base.baseColors()[1]),"strokeColor":Color.whiteColor(),"strokeColorTransform":"asStrokeColor","strokeWidth":0.5,"shouldFill":true,"shouldStroke":true,"drawXAxis":true,"drawYAxis":true,"axisLineColor":Color.blackColor(),"axisLineWidth":0.5,"axisTickSize":3,"axisLabelColor":Color.blackColor(),"axisLabelFont":"Arial","axisLabelFontSize":9,"axisLabelWidth":50,"axisLabelUseDiv":true,"pieRadius":0.4,"enableEvents":true};
MochiKit.Base.update(this.options,_245?_245:{});
this.layout=_244;
this.element=MochiKit.DOM.getElement(_243);
this.container=this.element.parentNode;
this.height=parseInt(this.element.getAttribute("height"));
this.width=parseInt(this.element.getAttribute("width"));
this.document=document;
this.root=this.element;
try{
this.document=this.element.getSVGDocument();
this.root=_246(this.document.documentElement)?this.element:this.document.documentElement;
}
catch(e){
}
this.element.style.zIndex=1;
if(_246(this.element)){
throw "SVGRenderer() - passed SVG object is not found";
}
if(_246(this.container)||this.container.nodeName.toLowerCase()!!="div"){
throw "SVGRenderer() - No DIV''s around the SVG.";
}
this.xlabels=new Array();
this.ylabels=new Array();
this.defs=this.createSVGElement("defs");
this.area={x:this.options.padding.left,y:this.options.padding.top,w:this.width-this.options.padding.left-this.options.padding.right,h:this.height-this.options.padding.top-this.options.padding.bottom};
MochiKit.DOM.updateNodeAttributes(this.container,{"style":{"position":"relative","width":this.width+"px"}});
};
PlotKit.SVGRenderer.prototype.render=function(){
if(this.options.drawBackground){
this._renderBackground();
}
if(this.layout.style=="bar"){
this._renderBarChart();
this._renderBarAxis();
}else{
if(this.layout.style=="pie"){
this._renderPieChart();
this._renderPieAxis();
}else{
if(this.layout.style=="line"){
this._renderLineChart();
this._renderLineAxis();
}
}
}
};
PlotKit.SVGRenderer.prototype._renderBarOrLine=function(data,_247,_248,_249){
var _250=this.options.colorScheme.length;
var _251=this.options.colorScheme;
var _252=MochiKit.Base.keys(this.layout.datasets);
var _253=_252.length;
for(var i=0;i<_253;i++){
var _254=_252[i];
var _255=new Array();
var _256=_251[i%_250];
if(this.options.shouldFill){
_255["fill"]=_256.toRGBString();
}else{
_255["fill"]="none";
}
if(this.options.shouldStroke&&(this.options.strokeColor||this.options.strokeColorTransform)){
if(this.options.strokeColor){
_255["stroke"]=this.options.strokeColor.toRGBString();
}else{
if(this.options.strokeColorTransform){
_255["stroke"]=_256[this.options.strokeColorTransform]().toRGBString();
}
}
_255["strokeWidth"]=this.options.strokeWidth;
}
if(_248){
_248(_255);
}
var _257=function(obj){
if(obj.name==_254){
_247(_255,obj);
}
};
MochiKit.Iter.forEach(data,bind(_257,this));
if(_249){
_249(_255);
}
}
};
PlotKit.SVGRenderer.prototype._renderBarChart=function(){
var bind=MochiKit.Base.bind;
var _258=function(_259,bar){
var x=this.area.w*bar.x+this.area.x;
var y=this.area.h*bar.y+this.area.y;
var w=this.area.w*bar.w;
var h=this.area.h*bar.h;
this._drawRect(x,y,w,h,_259);
};
this._renderBarOrLine(this.layout.bars,bind(_258,this));
};
PlotKit.SVGRenderer.prototype._renderLineChart=function(){
var bind=MochiKit.Base.bind;
var _260=function(_261,_262){
this._tempPointsBuffer+=(this.area.w*_262.x+this.area.x)+","+(this.area.h*_262.y+this.area.y)+" ";
};
var _263=function(_264){
this._tempPointsBuffer="";
this._tempPointsBuffer+=(this.area.x)+","+(this.area.y+this.area.h)+" ";
};
var _265=function(_266){
this._tempPointsBuffer+=(this.area.w+this.area.x)+","+(this.area.h+this.area.y);
_266["points"]=this._tempPointsBuffer;
var elem=this.createSVGElement("polygon",_266);
this.root.appendChild(elem);
};
this._renderBarOrLine(this.layout.points,bind(_260,this),bind(_263,this),bind(_265,this));
};
PlotKit.SVGRenderer.prototype._renderPieChart=function(){
var _268=this.options.colorScheme.length;
var _269=this.layout.slices;
var _270=this.area.x+this.area.w*0.5;
var _271=this.area.y+this.area.h*0.5;
var _272=Math.min(this.area.w*this.options.pieRadius,this.area.h*this.options.pieRadius);
if(_269.length==1&&(Math.abs(_269[0].startAngle)-Math.abs(_269[0].endAngle)<0.1)){
var _273={"cx":_270,"cy":_271,"r":_272};
var _274=this.options.colorScheme[0];
if(this.options.shouldFill){
_273["fill"]=_274.toRGBString();
}else{
_273["fill"]="none";
}
if(this.options.shouldStroke&&(this.options.strokeColor||this.options.strokeColorTransform)){
if(this.options.strokeColor){
_273["stroke"]=this.options.strokeColor.toRGBString();
}else{
if(this.options.strokeColorTransform){
_273["stroke"]=_274[this.options.strokeColorTransform]().toRGBString();
}
}
_273["style"]="stroke-width: "+this.options.strokeWidth;
}
this.root.appendChild(this.createSVGElement("circle",_273));
return;
}
for(var i=0;i<_269.length;i++){
var _273=new Array();
var _274=this.options.colorScheme[i%_268];
if(this.options.shouldFill){
_273["fill"]=_274.toRGBString();
}else{
_273["fill"]="none";
}
if(this.options.shouldStroke&&(this.options.strokeColor||this.options.strokeColorTransform)){
if(this.options.strokeColor){
_273["stroke"]=this.options.strokeColor.toRGBString();
}else{
if(this.options.strokeColorTransform){
_273["stroke"]=_274[this.options.strokeColorTransform]().toRGBString();
}
}
_273["style"]="stroke-width:"+this.options.strokeWidth;
}
var _275=0;
if(Math.abs(_269[i].endAngle-_269[i].startAngle)>Math.PI){
_275=1;
}
var x1=Math.cos(_269[i].startAngle-Math.PI/2)*_272;
var y1=Math.sin(_269[i].startAngle-Math.PI/2)*_272;
var x2=Math.cos(_269[i].endAngle-Math.PI/2)*_272;
var y2=Math.sin(_269[i].endAngle-Math.PI/2)*_272;
var rx=x2-x1;
var ry=y2-y1;
var _282="M"+_270+","+_271+" ";
_282+="l"+x1+","+y1+" ";
_282+="a"+_272+","+_272+" 0 "+_275+",1 "+rx+","+ry+" z";
_273["d"]=_282;
var elem=this.createSVGElement("path",_273);
this.root.appendChild(elem);
}
};
PlotKit.SVGRenderer.prototype._renderBarAxis=function(){
this._renderAxis();
};
PlotKit.SVGRenderer.prototype._renderLineAxis=function(){
this._renderAxis();
};
PlotKit.SVGRenderer.prototype._renderAxis=function(){
if(!!this.options.drawXAxis&&!!this.options.drawYAxis){
return;
}
var _283={"style":{"position":"absolute","textAlign":"center","fontSize":this.options.axisLabelFontSize+"px","zIndex":10,"color":this.options.axisLabelColor.toRGBString(),"width":this.options.axisLabelWidth+"px","overflow":"hidden"}};
var _284={"stroke":this.options.axisLineColor.toRGBString(),"strokeWidth":this.options.axisLineWidth};
if(this.options.drawYAxis){
if(this.layout.yticks){
var _285=function(tick){
var x=this.area.x;
var y=this.area.y+tick[0]*this.area.h;
this._drawLine(x,y,x-3,y,_284);
if(this.options.axisLabelUseDiv){
var _286=DIV(_283,tick[1]);
_286.style.top=(y-this.options.axisLabelFontSize)+"px";
_286.style.left=(x-this.options.padding.left+this.options.axisTickSize)+"px";
_286.style.textAlign="left";
_286.style.width=(this.options.padding.left-3)+"px";
MochiKit.DOM.appendChildNodes(this.container,_286);
this.ylabels.push(_286);
}else{
var _287={y:y+3,x:(x-this.options.padding.left+3),width:(this.options.padding.left-this.options.axisTickSize)+"px",height:(this.options.axisLabelFontSize+3)+"px",fontFamily:"Arial",fontSize:this.options.axisLabelFontSize+"px",fill:this.options.axisLabelColor.toRGBString()};
var _286=this.createSVGElement("text",_287);
_286.appendChild(this.document.createTextNode(tick[1]));
this.root.appendChild(_286);
}
};
MochiKit.Iter.forEach(this.layout.yticks,bind(_285,this));
}
this._drawLine(this.area.x,this.area.y,this.area.x,this.area.y+this.area.h,_284);
}
if(this.options.drawXAxis){
if(this.layout.xticks){
var _285=function(tick){
var x=this.area.x+tick[0]*this.area.w;
var y=this.area.y+this.area.h;
this._drawLine(x,y,x,y+this.options.axisTickSize,_284);
if(this.options.axisLabelUseDiv){
var _288=DIV(_283,tick[1]);
_288.style.top=(y+this.options.axisTickSize)+"px";
_288.style.left=(x-this.options.axisLabelWidth/2)+"px";
_288.style.textAlign="center";
_288.style.width=this.options.axisLabelWidth+"px";
MochiKit.DOM.appendChildNodes(this.container,_288);
this.xlabels.push(_288);
}else{
var _289={y:(y+this.options.axisTickSize+this.options.axisLabelFontSize),x:x-3,width:this.options.axisLabelWidth+"px",height:(this.options.axisLabelFontSize+3)+"px",fontFamily:"Arial",fontSize:this.options.axisLabelFontSize+"px",fill:this.options.axisLabelColor.toRGBString(),textAnchor:"middle"};
var _288=this.createSVGElement("text",_289);
_288.appendChild(this.document.createTextNode(tick[1]));
this.root.appendChild(_288);
}
};
MochiKit.Iter.forEach(this.layout.xticks,bind(_285,this));
}
this._drawLine(this.area.x,this.area.y+this.area.h,this.area.x+this.area.w,this.area.y+this.area.h,_284);
}
};
PlotKit.SVGRenderer.prototype._renderPieAxis=function(){
if(this.layout.xticks){
var _290=new Array();
for(var i=0;i<this.layout.slices.length;i++){
_290[this.layout.slices[i].xval]=this.layout.slices[i];
}
var _291=this.area.x+this.area.w*0.5;
var _292=this.area.y+this.area.h*0.5;
var _293=Math.min(this.area.w*this.options.pieRadius+10,this.area.h*this.options.pieRadius+10);
var _294=this.options.axisLabelWidth;
for(var i=0;i<this.layout.xticks.length;i++){
var _295=_290[this.layout.xticks[i][0]];
if(MochiKit.Base.isUndefinedOrNull(_295)){
continue;
}
var _296=(_295.startAngle+_295.endAngle)/2;
var _297=_296;
if(_297>Math.PI*2){
_297=_297-Math.PI*2;
}else{
if(_297<0){
_297=_297+Math.PI*2;
}
}
var _298=_291+Math.sin(_297)*(_293+10);
var _299=_292-Math.cos(_297)*(_293+10);
var _300={"position":"absolute","zIndex":11,"width":_294+"px","fontSize":this.options.axisLabelFontSize+"px","overflow":"hidden","color":this.options.axisLabelColor.toHexString()};
var _301={"width":_294+"px","fontSize":this.options.axisLabelFontSize+"px","height":(this.options.axisLabelFontSize+3)+"px","fill":this.options.axisLabelColor.toRGBString()};
if(_297<=Math.PI*0.5){
MochiKit.Base.update(_300,{"textAlign":"left","verticalAlign":"top","left":_298+"px","top":(_299-this.options.axisLabelFontSize)+"px"});
MochiKit.Base.update(_301,{"x":_298,"y":(_299-this.options.axisLabelFontSize),"textAnchor":"left"});
}else{
if((_297>Math.PI*0.5)&&(_297<=Math.PI)){
MochiKit.Base.update(_300,{"textAlign":"left","verticalAlign":"bottom","left":_298+"px","top":_299+"px"});
MochiKit.Base.update(_301,{"textAnchor":"left","x":_298,"y":_299});
}else{
if((_297>Math.PI)&&(_297<=Math.PI*1.5)){
MochiKit.Base.update(_300,{"textAlign":"right","verticalAlign":"bottom","left":_298+"px","top":_299+"px"});
MochiKit.Base.update(_301,{"textAnchor":"right","x":_298-_294,"y":_299});
}else{
MochiKit.Base.update(_300,{"textAlign":"left","verticalAlign":"bottom","left":_298+"px","top":_299+"px"});
MochiKit.Base.update(_301,{"textAnchor":"left","x":_298-_294,"y":_299-this.options.axisLabelFontSize});
}
}
}
if(this.options.axisLabelUseDiv){
var _302=DIV({"style":_300},this.layout.xticks[i][1]);
this.xlabels.push(_302);
MochiKit.DOM.appendChildNodes(this.container,_302);
}else{
var _302=this.createSVGElement("text",_301);
_302.appendChild(this.document.createTextNode(this.layout.xticks[i][1]));
this.root.appendChild(_302);
}
}
}
};
PlotKit.SVGRenderer.prototype._renderBackground=function(){
var opts={"stroke":"none","fill":this.options.backgroundColor.toRGBString()};
this._drawRect(0,0,this.width,this.height,opts);
};
PlotKit.SVGRenderer.prototype._drawRect=function(x,y,w,h,_304){
var _305={x:x+"px",y:y+"px",width:w+"px",height:h+"px"};
if(_304){
MochiKit.Base.update(_305,_304);
}
var elem=this.createSVGElement("rect",_305);
this.root.appendChild(elem);
};
PlotKit.SVGRenderer.prototype._drawLine=function(x1,y1,x2,y2,_306){
var _307={x1:x1+"px",y1:y1+"px",x2:x2+"px",y2:y2+"px"};
if(_306){
MochiKit.Base.update(_307,_306);
}
var elem=this.createSVGElement("line",_307);
this.root.appendChild(elem);
};
PlotKit.SVGRenderer.prototype.clear=function(){
while(this.element.firstChild){
this.element.removeChild(this.element.firstChild);
}
if(this.options.axisLabelUseDiv){
for(var i=0;i<this.xlabels.length;i++){
MochiKit.DOM.removeElement(this.xlabels[i]);
}
for(var i=0;i<this.ylabels.length;i++){
MochiKit.DOM.removeElement(this.ylabels[i]);
}
}
this.xlabels=new Array();
this.ylabels=new Array();
};
PlotKit.SVGRenderer.prototype.createSVGElement=function(name,_309){
var _310=MochiKit.Base.isUndefinedOrNull;
var elem;
var doc=_310(this.document)?document:this.document;
try{
elem=doc.createElementNS(PlotKit.SVGRenderer.SVGNS,name);
}
catch(e){
elem=doc.createElement(name);
elem.setAttribute("xmlns",PlotKit.SVGRenderer.SVGNS);
}
if(_309){
MochiKit.DOM.updateNodeAttributes(elem,_309);
}
return elem;
};
PlotKit.SVGRenderer.SVG=function(_312){
var ie=navigator.appVersion.match(/MSIE (\d\.\d)/);
var _313=(navigator.userAgent.toLowerCase().indexOf("opera")!!=-1);
if(ie&&(ie[1]>=6)&&(!!_313)){
var _314=_312["width"]?_312["width"]:"100";
var _315=_312["height"]?_312["height"]:"100";
var eid=_312["id"]?_312["id"]:"notunique";
var html="<svg:svg width=\""+_314+"\" height=\""+_315+"\" ";
html+="id=\""+eid+"\" version=\"1.1\" baseProfile=\"full\" />";
var _318=document.createElement(html);
var _319=_318.getSVGDocument().createElementNS(PlotKit.SVGRenderer.SVGNS,"svg");
_319.setAttribute("width",_314);
_319.setAttribute("height",_315);
_318.getSVGDocument().appendChild(_319);
return _318;
}else{
return PlotKit.SVGRenderer.prototype.createSVGElement("svg",_312);
}
};
PlotKit.SVGRenderer.isSupported=function(){
var _320=(navigator.userAgent.toLowerCase().indexOf("opera")!!=-1);
var _321=navigator.appVersion.match(/MSIE (\d\.\d)/);
var _322=navigator.userAgent.match(/AppleWebKit\/(\d+)/);
var _323=navigator.userAgent.match(/Opera\/(\d*\.\d*)/);
var _324=navigator.userAgent.match(/rv:(\d*\.\d*).*Gecko/);
var _325="http://www.w3.org/TR/SVG11/feature#SVG";
if(_321&&(_321[1]>=6)&&!!_320){
return document.implementation.hasFeature(_325,"1.1");
}
if(_323&&(_323[1]>8.9)){
return true;
}
if(_324&&(_324>1.7)){
return true;
}
return false;
};
PlotKit.SVG={};
PlotKit.SVG.SVGRenderer=PlotKit.SVGRenderer;
PlotKit.SVG.EXPORT=["SVGRenderer"];
PlotKit.SVG.EXPORT_OK=["SVGRenderer"];
PlotKit.SVG.__new__=function(){
var m=MochiKit.Base;
m.nameFunctions(this);
this.EXPORT_TAGS={":common":this.EXPORT,":all":m.concat(this.EXPORT,this.EXPORT_OK)};
};
PlotKit.SVG.__new__();
MochiKit.Base._exportSymbols(this,PlotKit.SVG);
try{
if(typeof (PlotKit.CanvasRenderer)=="undefined"){
throw "";
}
}
catch(e){
throw "SweetCanvas depends on MochiKit.{Base,Color,DOM,Format} and PlotKit.{Layout, Canvas}";
}
if(typeof (PlotKit.SweetCanvasRenderer)=="undefined"){
PlotKit.SweetCanvasRenderer={};
}
PlotKit.SweetCanvasRenderer=function(_326,_327,_328){
if(arguments.length>0){
this.__init__(_326,_327,_328);
}
};
PlotKit.SweetCanvasRenderer.NAME="PlotKit.SweetCanvasRenderer";
PlotKit.SweetCanvasRenderer.VERSION=PlotKit.VERSION;
PlotKit.SweetCanvasRenderer.__repr__=function(){
return "["+this.NAME+" "+this.VERSION+"]";
};
PlotKit.SweetCanvasRenderer.toString=function(){
return this.__repr__();
};
PlotKit.SweetCanvasRenderer.prototype=new PlotKit.CanvasRenderer();
PlotKit.SweetCanvasRenderer.prototype.constructor=PlotKit.SweetCanvasRenderer;
PlotKit.SweetCanvasRenderer.__super__=PlotKit.CanvasRenderer.prototype;
PlotKit.SweetCanvasRenderer.prototype.__init__=function(el,_330,opts){
var _331=PlotKit.Base.officeBlue();
MochiKit.Base.update(_331,opts);
PlotKit.SweetCanvasRenderer.__super__.__init__.call(this,el,_330,_331);
};
PlotKit.SweetCanvasRenderer.prototype._renderBarChart=function(){
var bind=MochiKit.Base.bind;
var _332=Color.blackColor().colorWithAlpha(0.1).toRGBString();
var _333=function(_334,x,y,w,h){
_334.fillStyle=_332;
_334.fillRect(x-2,y-2,w+4,h+2);
_334.fillStyle=_332;
_334.fillRect(x-1,y-1,w+2,h+1);
};
var _335=this.options.colorScheme.length;
var _336=this.options.colorScheme;
var _337=PlotKit.Base.keys(this.layout.datasets);
var _338=_337.length;
var _339=function(name){
for(var i=0;i<_338;i++){
if(name==_337[i]){
return _336[i%_335];
}
}
return _336[0];
};
var _340=function(_341,bar){
var x=this.area.w*bar.x+this.area.x;
var y=this.area.h*bar.y+this.area.y;
var w=this.area.w*bar.w;
var h=this.area.h*bar.h;
if((w<1)||(h<1)){
return;
}
_341.save();
_341.shadowBlur=5;
_341.shadowColor=Color.fromHexString("#888888").toRGBString();
if(this.isIE){
_341.save();
_341.fillStyle="#cccccc";
_341.fillRect(x-2,y-2,w+4,h+2);
_341.restore();
}else{
_333(_341,x,y,w,h);
}
if(this.options.shouldFill){
_341.fillStyle=_339(bar.name).toRGBString();
_341.fillRect(x,y,w,h);
}
_341.shadowBlur=0;
_341.strokeStyle=Color.whiteColor().toRGBString();
_341.lineWidth=2;
if(this.options.shouldStroke){
_341.strokeRect(x,y,w,h);
}
_341.restore();
};
this._renderBarChartWrap(this.layout.bars,bind(_340,this));
};
PlotKit.SweetCanvasRenderer.prototype._renderLineChart=function(){
var _342=this.element.getContext("2d");
var _343=this.options.colorScheme.length;
var _344=this.options.colorScheme;
var _345=PlotKit.Base.keys(this.layout.datasets);
var _346=_345.length;
var bind=MochiKit.Base.bind;
for(var i=0;i<_346;i++){
var _347=_345[i];
var _348=_344[i%_343];
var _349=this.options.strokeColorTransform;
_342.save();
var _350=function(ctx){
ctx.beginPath();
ctx.moveTo(this.area.x,this.area.y+this.area.h);
var _351=function(ctx_,_352){
if(_352.name==_347){
ctx_.lineTo(this.area.w*_352.x+this.area.x,this.area.h*_352.y+this.area.y);
}
};
MochiKit.Iter.forEach(this.layout.points,partial(_351,ctx),this);
ctx.lineTo(this.area.w+this.area.x,this.area.h+this.area.y);
ctx.lineTo(this.area.x,this.area.y+this.area.h);
ctx.closePath();
};
if(this.options.shouldFill){
_342.save();
if(this.isIE){
_342.fillStyle="#cccccc";
}else{
_342.fillStyle=Color.blackColor().colorWithAlpha(0.2).toRGBString();
}
_342.translate(-1,-2);
bind(_350,this)(_342);
if(this.options.shouldFill){
_342.fill();
}
_342.restore();
}
_342.shadowBlur=5;
_342.shadowColor=Color.fromHexString("#888888").toRGBString();
_342.fillStyle=_348.toRGBString();
_342.lineWidth=2;
_342.strokeStyle=Color.whiteColor().toRGBString();
if(this.options.shouldFill){
bind(_350,this)(_342);
_342.fill();
}
if(this.options.shouldStroke){
bind(_350,this)(_342);
_342.stroke();
}
_342.restore();
}
};
PlotKit.SweetCanvasRenderer.prototype._renderPieChart=function(){
var _353=this.element.getContext("2d");
var _354=this.options.colorScheme.length;
var _355=this.layout.slices;
var _356=this.area.x+this.area.w*0.5;
var _357=this.area.y+this.area.h*0.5;
var _358=Math.min(this.area.w*this.options.pieRadius,this.area.h*this.options.pieRadius);
if(this.isIE){
_356=parseInt(_356);
_357=parseInt(_357);
_358=parseInt(_358);
}
if(!!this.isIE){
_353.save();
var _359=Color.blackColor().colorWithAlpha(0.2);
_353.fillStyle=_359.toRGBString();
_353.shadowBlur=5;
_353.shadowColor=Color.fromHexString("#888888").toRGBString();
_353.translate(1,1);
_353.beginPath();
_353.moveTo(_356,_357);
_353.arc(_356,_357,_358+2,0,Math.PI*2,false);
_353.closePath();
_353.fill();
_353.restore();
}
_353.save();
_353.strokeStyle=Color.whiteColor().toRGBString();
_353.lineWidth=2;
for(var i=0;i<_355.length;i++){
var _360=this.options.colorScheme[i%_354];
_353.fillStyle=_360.toRGBString();
var _361=function(){
_353.beginPath();
_353.moveTo(_356,_357);
_353.arc(_356,_357,_358,_355[i].startAngle-Math.PI/2,_355[i].endAngle-Math.PI/2,false);
_353.lineTo(_356,_357);
_353.closePath();
};
if(Math.abs(_355[i].startAngle-_355[i].endAngle)>0.0001){
if(this.options.shouldFill){
_361();
_353.fill();
}
if(this.options.shouldStroke){
_361();
_353.stroke();
}
}
}
_353.restore();
};
PlotKit.SweetCanvasRenderer.prototype._renderBackground=function(){
var _362=this.element.getContext("2d");
if(this.layout.style=="bar"||this.layout.style=="line"){
_362.save();
_362.fillStyle=this.options.backgroundColor.toRGBString();
_362.fillRect(this.area.x,this.area.y,this.area.w,this.area.h);
_362.strokeStyle=this.options.axisLineColor.toRGBString();
_362.lineWidth=1;
var _363=this.layout.yticks;
var _364=false;
if(this.layout.style=="bar"&&this.layout.options.barOrientation=="horizontal"){
_363=this.layout.xticks;
_364=true;
}
for(var i=0;i<_363.length;i++){
var x1=0;
var y1=0;
var x2=0;
var y2=0;
if(_364){
x1=_363[i][0]*this.area.w+this.area.x;
y1=this.area.y;
x2=x1;
y2=y1+this.area.h;
}else{
x1=this.area.x;
y1=_363[i][0]*this.area.h+this.area.y;
x2=x1+this.area.w;
y2=y1;
}
_362.beginPath();
_362.moveTo(x1,y1);
_362.lineTo(x2,y2);
_362.closePath();
_362.stroke();
}
_362.restore();
}else{
PlotKit.SweetCanvasRenderer.__super__._renderBackground.call(this);
}
};
PlotKit.SweetCanvas={};
PlotKit.SweetCanvas.SweetCanvasRenderer=PlotKit.SweetCanvasRenderer;
PlotKit.SweetCanvas.EXPORT=["SweetCanvasRenderer"];
PlotKit.SweetCanvas.EXPORT_OK=["SweetCanvasRenderer"];
PlotKit.SweetCanvas.__new__=function(){
var m=MochiKit.Base;
m.nameFunctions(this);
this.EXPORT_TAGS={":common":this.EXPORT,":all":m.concat(this.EXPORT,this.EXPORT_OK)};
};
PlotKit.SweetCanvas.__new__();
MochiKit.Base._exportSymbols(this,PlotKit.SweetCanvas);
try{
if(typeof (PlotKit.SVGRenderer)=="undefined"){
throw "";
}
}
catch(e){
throw "SweetSVG depends on MochiKit.{Base,Color,DOM,Format} and PlotKit.{Layout, SVG}";
}
if(typeof (PlotKit.SweetSVGRenderer)=="undefined"){
PlotKit.SweetSVGRenderer={};
}
PlotKit.SweetSVGRenderer=function(_365,_366,_367){
if(arguments.length>0){
this.__init__(_365,_366,_367);
}
};
PlotKit.SweetSVGRenderer.NAME="PlotKit.SweetSVGRenderer";
PlotKit.SweetSVGRenderer.VERSION=PlotKit.VERSION;
PlotKit.SweetSVGRenderer.__repr__=function(){
return "["+this.NAME+" "+this.VERSION+"]";
};
PlotKit.SweetSVGRenderer.toString=function(){
return this.__repr__();
};
PlotKit.SweetSVGRenderer.prototype=new PlotKit.SVGRenderer();
PlotKit.SweetSVGRenderer.prototype.constructor=PlotKit.SweetSVGRenderer;
PlotKit.SweetSVGRenderer.__super__=PlotKit.SVGRenderer.prototype;
PlotKit.SweetSVGRenderer.prototype.__init__=function(_368,_369,_370){
var _371=PlotKit.Base.officeBlue();
MochiKit.Base.update(_371,_370);
PlotKit.SweetSVGRenderer.__super__.__init__.call(this,_368,_369,_371);
};
PlotKit.SweetSVGRenderer.prototype._addDropShadowFilter=function(){
var _372=this.createSVGElement("filter",{x:0,y:0,"id":"dropShadow"});
var _373=this.createSVGElement("feOffset",{"in":"SourceGraphic","dx":0,"dy":0,"result":"topCopy"});
var blur=this.createSVGElement("feGaussianBlur",{"in":"SourceAlpha","StdDeviation":2,"result":"shadow"});
var _375=this.createSVGElement("feOffset",{"in":"shadow","dx":-1,"dy":-2,"result":"movedShadow"});
var _376=this.createSVGElement("feMerge");
var _377=this.createSVGElement("feMergeNode",{"in":"topCopy"});
var _378=this.createSVGElement("feMergeNode",{"in":"movedShadow"});
_376.appendChild(_377);
_376.appendChild(_378);
_372.appendChild(_373);
_372.appendChild(blur);
_372.appendChild(_375);
_372.appendChild(_376);
this.defs.appendChild(_372);
};
PlotKit.SweetSVGRenderer.prototype._renderBarChart=function(){
var bind=MochiKit.Base.bind;
var _379=Color.blackColor().toRGBString();
var _380="fill:"+_379+";fill-opacity:0.15";
var _381="stroke-width: 2.0; stroke:"+Color.whiteColor().toRGBString();
var _382=function(_383,bar){
var x=this.area.w*bar.x+this.area.x;
var y=this.area.h*bar.y+this.area.y;
var w=this.area.w*bar.w;
var h=this.area.h*bar.h;
if((w<1)||(h<1)){
return;
}
_383["style"]=_381;
this._drawRect(x-2,y-1,w+4,h+2,{"style":_380});
this._drawRect(x,y,w,h,_383);
};
this._renderBarOrLine(this.layout.bars,bind(_382,this));
};
PlotKit.SweetSVGRenderer.prototype._renderLineChart=function(){
var bind=MochiKit.Base.bind;
var _384=Color.blackColor().toRGBString();
var _385="fill:"+_384+";fill-opacity:0.15";
var _386="stroke-width: 2.0; stroke:"+Color.whiteColor().toRGBString();
var _387=function(_388,_389){
this._tempPointsBuffer+=(this.area.w*_389.x+this.area.x)+","+(this.area.h*_389.y+this.area.y)+" ";
};
var _390=function(_391){
this._tempPointsBuffer="";
this._tempPointsBuffer+=(this.area.x)+","+(this.area.y+this.area.h)+" ";
};
var _392=function(_393){
this._tempPointsBuffer+=(this.area.w+this.area.x)+","+(this.area.h+this.area.y);
_393["points"]=this._tempPointsBuffer;
_393["stroke"]="none";
_393["transform"]="translate(-2, -1)";
_393["style"]=_385;
var _394=this.createSVGElement("polygon",_393);
this.root.appendChild(_394);
_393["transform"]="";
_393["style"]=_386;
var elem=this.createSVGElement("polygon",_393);
this.root.appendChild(elem);
};
this._renderBarOrLine(this.layout.points,bind(_387,this),bind(_390,this),bind(_392,this));
};
PlotKit.SweetSVGRenderer.prototype._renderPieChart=function(){
var _395=this.area.x+this.area.w*0.5;
var _396=this.area.y+this.area.h*0.5;
var _397=Color.blackColor().toRGBString();
var _398=Math.min(this.area.w*this.options.pieRadius,this.area.h*this.options.pieRadius);
var _399="fill:"+_397+";fill-opacity:0.15";
var _400=this.createSVGElement("circle",{"style":_399,"cx":_395+1,"cy":_396+1,"r":_398+1});
this.root.appendChild(_400);
PlotKit.SweetSVGRenderer.__super__._renderPieChart.call(this);
};
PlotKit.SweetSVGRenderer.prototype._renderBackground=function(){
var _401={"fill":this.options.backgroundColor.toRGBString(),"stroke":"none"};
if(this.layout.style=="bar"||this.layout.style=="line"){
this._drawRect(this.area.x,this.area.y,this.area.w,this.area.h,_401);
var _402=this.layout.yticks;
var _403=false;
if(this.layout.style=="bar"&&this.layout.options.barOrientation=="horizontal"){
_402=this.layout.xticks;
_403=true;
}
for(var i=0;i<_402.length;i++){
var x=0;
var y=0;
var w=0;
var h=0;
if(_403){
x=_402[i][0]*this.area.w+this.area.x;
y=this.area.y;
w=1;
h=this.area.w;
}else{
x=this.area.x;
y=_402[i][0]*this.area.h+this.area.y;
w=this.area.w;
h=1;
}
this._drawRect(x,y,w,h,{"fill":this.options.axisLineColor.toRGBString()});
}
}else{
PlotKit.SweetSVGRenderer.__super__._renderBackground.call(this);
}
};
PlotKit.SweetSVG={};
PlotKit.SweetSVG.SweetSVGRenderer=PlotKit.SweetSVGRenderer;
PlotKit.SweetSVG.EXPORT=["SweetSVGRenderer"];
PlotKit.SweetSVG.EXPORT_OK=["SweetSVGRenderer"];
PlotKit.SweetSVG.__new__=function(){
var m=MochiKit.Base;
m.nameFunctions(this);
this.EXPORT_TAGS={":common":this.EXPORT,":all":m.concat(this.EXPORT,this.EXPORT_OK)};
};
PlotKit.SweetSVG.__new__();
MochiKit.Base._exportSymbols(this,PlotKit.SweetSVG);
try{
if(typeof (PlotKit.CanvasRenderer)=="undefined"){
throw "";
}
}
catch(e){
throw "PlotKit.EasyPlot depends on all of PlotKit''s components";
}
if(typeof (PlotKit.EasyPlot)=="undefined"){
PlotKit.EasyPlot={};
}
PlotKit.EasyPlot.NAME="PlotKit.EasyPlot";
PlotKit.EasyPlot.VERSION=PlotKit.VERSION;
PlotKit.EasyPlot.__repr__=function(){
return "["+this.NAME+" "+this.VERSION+"]";
};
PlotKit.EasyPlot.toString=function(){
return this.__repr__();
};
PlotKit.EasyPlot=function(_404,_405,_406,_407){
this.layout=new Layout(_404,_405);
this.divElem=_406;
this.width=parseInt(_406.getAttribute("width"));
this.height=parseInt(_406.getAttribute("height"));
this.deferredCount=0;
if(this.width<1){
this.width=this.divElem.width?this.divElem.width:300;
}
if(this.height<1){
this.height=this.divElem.height?this.divElem.height:300;
}
if(isArrayLike(_407)){
for(var i=0;i<_407.length;i++){
if(typeof (_407[i])=="string"){
this.deferredCount++;
var d=MochiKit.Async.doSimpleXMLHttpRequest(_407[i]);
d.addCallback(MochiKit.Base.bind(PlotKit.EasyPlot.onDataLoaded,this));
}else{
if(isArrayLike(_407[i])){
this.layout.addDataset("data-"+i,_407[i]);
}
}
}
}else{
if(!!isUndefinedOrNull(_407)){
throw "Passed datasources are not Array like";
}
}
if(CanvasRenderer.isSupported()){
this.element=CANVAS({"id":this.divElem.getAttribute("id")+"-canvas","width":this.width,"height":this.height},"");
this.divElem.appendChild(this.element);
this.renderer=new SweetCanvasRenderer(this.element,this.layout,_405);
}else{
if(SVGRenderer.isSupported()){
this.element=SVGRenderer.SVG({"id":this.divElem.getAttribute("id")+"-svg","width":this.width,"height":this.height,"version":"1.1","baseProfile":"full"},"");
this.divElem.appendChild(this.element);
this.renderer=new SweetSVGRenderer(this.element,this.layout,_405);
}
}
if((this.deferredCount==0)&&(PlotKit.Base.keys(this.layout.datasets).length>0)){
this.layout.evaluate();
this.renderer.clear();
this.renderer.render();
}
};
PlotKit.EasyPlot.onDataLoaded=function(_409){
var _410=new Array();
var _411=_409.responseText.split("\n");
for(var i=0;i<_411.length;i++){
var _412=MochiKit.Format.strip(_411[i]);
if((_412.length>1)&&(_412.charAt(0)!!="#")){
_410.push(_412.split(","));
}
}
this.layout.addDataset("data-ajax-"+this.deferredCount,_410);
this.deferredCount--;
if((this.deferredCount==0)&&(PlotKit.Base.keys(this.layout.datasets).length>0)){
this.layout.evaluate();
this.renderer.clear();
this.renderer.render();
}
};
PlotKit.EasyPlot.prototype.reload=function(){
this.layout.evaluate();
this.renderer.clear();
this.renderer.render();
};
PlotKit.EasyPlotModule={};
PlotKit.EasyPlotModule.EasyPlot=PlotKit.EasyPlot;
PlotKit.EasyPlotModule.EXPORT=["EasyPlot"];
PlotKit.EasyPlotModule.EXPORT_OK=[];
PlotKit.EasyPlotModule.__new__=function(){
var m=MochiKit.Base;
m.nameFunctions(this);
this.EXPORT_TAGS={":common":this.EXPORT,":all":m.concat(this.EXPORT,this.EXPORT_OK)};
};
PlotKit.EasyPlotModule.__new__();
MochiKit.Base._exportSymbols(this,PlotKit.EasyPlotModule);


'! !

!DLFileLibrary methodsFor: 'uploaded' stamp: 'PL 6/23/2011 17:39:40.981'!
plusPng
	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 4 115 66 73 84 8 8 8 8 124 8 100 136 0 0 0 9 112 72 89 115 0 0 13 215 0 0 13 215 1 66 40 155 120 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 119 119 119 46 105 110 107 115 99 97 112 101 46 111 114 103 155 238 60 26 0 0 0 156 73 68 65 84 56 141 189 146 177 9 132 33 20 131 35 56 142 224 54 150 174 224 44 174 96 233 46 22 130 181 149 96 229 6 138 87 92 229 175 143 243 56 56 187 188 132 15 9 97 115 78 60 159 181 118 63 2 48 198 176 231 141 159 130 0 160 181 94 180 115 238 152 35 1 173 53 202 186 3 244 222 127 3 140 49 238 0 84 97 39 192 41 203 1 64 41 181 133 107 173 139 62 101 188 247 111 64 41 229 227 87 169 12 7 238 11 35 1 183 133 145 128 16 194 102 72 41 23 29 99 60 2 24 53 101 33 196 114 75 41 125 55 229 235 29 80 198 255 150 72 25 57 231 43 192 11 89 208 72 31 12 85 5 158 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

!DLFileLibrary methodsFor: 'uploaded' stamp: 'PL 6/28/2011 03:12:03.578'!
questionnaireJs

	^ 'function getEditorInfo(inputID)
{
	var input = document.getElementById(inputID);
	var rawInfo = input.value.split(''\n'');
	var editorInfo = new Array(parseInt(rawInfo.length / 2));
	
	for (i = 0; i < editorInfo.length; i++)
	{
		editorInfo[i] = new Array(2);
		editorInfo[i][0] = rawInfo[i * 2];
		editorInfo[i][1] = rawInfo[i * 2 + 1];
	}
	
	return editorInfo;
}

function setEditorInfo(inputID, editorInfo)
{
	var input = document.getElementById(inputID);
	var rawInfo = "";
	
	for (i = 0; i < editorInfo.length; i++)
	{
		rawInfo += editorInfo[i][0] + "\n";
		rawInfo += editorInfo[i][1] + "\n";
	}
	
	input.value = rawInfo;
}

function renderQuestionnaireEditor(editorID)
{
	renderIncludedTable(editorID);
	renderExcludedTable(editorID);
	
	updateLightbox();
}

function renderIncludedTable(editorID)
{
	// Retrieve arrays containing survey data
	var includedInfo = getEditorInfo("includedInfo_" + editorID);
	var headingsInfo = getEditorInfo("headingsInfo_" + editorID);
	
	// Retrieve html divs displaying survey data
	var includedDivs = document.getElementById("includedTable_" + editorID);
	
	var includedDivsContent = "";
	var entryCounter = 1;
	
	for (i = 0; i < headingsInfo.length; i++)
	{
		includedDivsContent += renderPage(i + 1, headingsInfo[i], i, editorID);
		
		var nextHeadingIndex = includedInfo.length;
		if (i < headingsInfo.length - 1)
			nextHeadingIndex = parseInt(headingsInfo[i + 1][0]);
		
		for (j = parseInt(headingsInfo[i][0]); j < nextHeadingIndex; j++)
		{
			var upEnabled = (j > 0);
			var downEnabled = (j < includedInfo.length - 1);
		
			includedDivsContent += renderIncludedEntry(entryCounter, includedInfo[j], j - parseInt(headingsInfo[i][0]) + 1, editorID, upEnabled, downEnabled);
			entryCounter++;
		}
		
		if (parseInt(headingsInfo[i][0]) == nextHeadingIndex
			|| headingsInfo[i][0] == includedInfo.length)
			includedDivsContent += renderEmptyEntry(1, "(Seite leer)");
	}
	
	includedDivs.innerHTML = includedDivsContent;
}

function renderExcludedTable(editorID)
{
	// Retrieve arrays containing survey data
	var excludedInfo = getEditorInfo("excludedInfo_" + editorID);
	
	// Retrieve html divs displaying survey data
	var excludedDivs = document.getElementById("excludedTable_" + editorID);
	
	var excludedDivsContent = "<div class=\"divider\"></div>";
	
	excludedDivsContent += renderReadOnlyPage("Verfgbare Fragen");
	
	for (j = 0; j < excludedInfo.length; j++)
		excludedDivsContent += renderExcludedEntry(j + 1, excludedInfo[j], editorID);
		
	if (excludedInfo.length == 0)
		excludedDivsContent += renderEmptyEntry(1, "(keine)");
	
	excludedDivs.innerHTML = excludedDivsContent;
}

function renderPage(pageNumber, heading, pageIndex, editorID)
{
	return "<div class=\"page\">Seite " + pageNumber + ": <input type=\"text\" onchange=\"renamePage(" + pageIndex + ", this.value, ''" + editorID + "'')\" value=\"" + heading[1] + "\"></div>";
}

function renderReadOnlyPage(heading)
{
	return "<div class=\"page\">" + heading + "</div>";
}

function renamePage(pageIndex, value, editorID)
{
	var headingsInfo = getEditorInfo("headingsInfo_" + editorID);
	
	headingsInfo[pageIndex][1] = value;
	
	setEditorInfo("headingsInfo_" + editorID, headingsInfo);
}

function renderIncludedEntry(listNumber, survey, colorID, editorID, upEnabled, downEnabled)
{
	var color = "even";
	
	if (colorID % 2 == 1)
		color = "odd";
	
	return "<div class=\"entry " + color + "\" id=\"" + survey[0] + "\">"
		+ "<div class=\"number\">" + listNumber + ".</div>"
		+ "<div class=\"question\">" + survey[1] + "</div>"
		+ "<div class=\"actions\">"
		+ renderUpButton(survey, editorID, upEnabled)
		+ renderDownButton(survey, editorID, downEnabled)
		+ renderMinusButton(survey, editorID)
		+ "</div></div>";
}

function renderEmptyEntry(listNumber, text)
{
	var color = "even";
	
	if (listNumber % 2 == 1)
		color = "odd";
	
	return "<div class=\"entry " + color + "\">"
		+ "<div class=\"question comment\"><i>" + text + "</i></div><div class=\"number\"></div></div>";
}

function renderExcludedEntry(listNumber, survey, editorID)
{
	var color = "even";
	
	if (listNumber % 2 == 1)
		color = "odd";
	
	return "<div class=\"entry " + color + "\" id=\"" + survey[0] + "\">"
		+ "<div class=\"number\"></div>"
		+ "<div class=\"question\">" + survey[1] + "</div>"
		+ "<div class=\"actions\">"
		+ renderPlusButton(survey, editorID)
		+ "</div></div>";
}

function renderUpButton(survey, editorID, enabled)
{
	if (!!enabled)
		return "<span class=\"iconpic iconSpacer\"></span>";
	
	return "<a onclick=\"moveEntry(''" + survey[0] + "'', ''" + editorID + "'', ''up'')\" class=\"iconpic upButton\" href=\"#\"><img alt=\"\" src=\"/files/DLFileLibrary/up.png\" title=\"nach oben verschieben\"/></a>";
}

function renderDownButton(survey, editorID, enabled)
{
	if (!!enabled)
		return "<span class=\"iconpic iconSpacer\"></span>";
	
	return "<a onclick=\"moveEntry(''" + survey[0] + "'', ''" + editorID + "'', ''down'')\" class=\"iconpic downButton\" href=\"#\"><img alt=\"\" src=\"/files/DLFileLibrary/down.png\" title=\"nach unten verschieben\"/></a>";
}

function renderMinusButton(survey, editorID)
{
	return "<a onclick=\"removeEntry(''" + survey[0] + "'', ''" + editorID + "'')\" class=\"iconpic minusButton\" href=\"#\"><img alt=\"\" src=\"/files/DLFileLibrary/minus.png\" title=\"aus dem Fragebogen entfernen\"/></a>";
}

function renderPlusButton(survey, editorID)
{
	return "<a onclick=\"addEntry(''" + survey[0] + "'', ''" + editorID + "'')\" class=\"iconpic plusButton\" href=\"#\"><img alt=\"\" src=\"/files/DLFileLibrary/plus.png\" title=\"zum Fragebogen hinzufgen\"/></a>";
}

function addEntry(surveyID, editorID)
{
	// Retrieve arrays containing survey data
	var includedInfo = getEditorInfo("includedInfo_" + editorID);
	var excludedInfo = getEditorInfo("excludedInfo_" + editorID);
	
	// Get index of entry to add
	var newEntry = - 1;
	
	for (i = 0; i < excludedInfo.length; i++)
		if (excludedInfo[i][0] == surveyID)
			newEntry = i;
	
	// Add entry to included ones and remove it from excluded entries
	includedInfo.push(excludedInfo[newEntry]);
	excludedInfo.splice(newEntry, 1);
	
	// Update hidden inputs
	setEditorInfo("includedInfo_" + editorID, includedInfo);
	setEditorInfo("excludedInfo_" + editorID, excludedInfo);
	
	renderQuestionnaireEditor(editorID);
}

function removeEntry(surveyID, editorID)
{
	// Retrieve arrays containing survey data
	var includedInfo = getEditorInfo("includedInfo_" + editorID);
	var excludedInfo = getEditorInfo("excludedInfo_" + editorID);
	var headingsInfo = getEditorInfo("headingsInfo_" + editorID);
	
	// Get index of entry to add
	var newEntry = - 1;
	
	for (i = 0; i < includedInfo.length; i++)
		if (includedInfo[i][0] == surveyID)
			newEntry = i;
	
	// Add entry to included ones and remove it from excluded entries
	excludedInfo.unshift(includedInfo[newEntry]);
	includedInfo.splice(newEntry, 1);
	
	// Move all pages back by one
	for (i = 0; i < headingsInfo.length; i++)
		if (headingsInfo[i][0] > newEntry)
			headingsInfo[i][0] = parseInt(headingsInfo[i][0]) - 1;
	
	// Update hidden inputs
	setEditorInfo("includedInfo_" + editorID, includedInfo);
	setEditorInfo("excludedInfo_" + editorID, excludedInfo);
	setEditorInfo("headingsInfo_" + editorID, headingsInfo);
	
	renderQuestionnaireEditor(editorID);
}

function moveEntry(surveyID, editorID, direction)
{
	// Retrieve arrays containing survey data
	var includedInfo = getEditorInfo("includedInfo_" + editorID);
	
	// Get index of entry to add
	var newEntry = - 1;
	
	for (i = 0; i < includedInfo.length; i++)
		if (includedInfo[i][0] == surveyID)
			entryIndex = i;
	
	if (direction == "up")
	{
		// Don''t move highest element upwards
		if (entryIndex == 0)
			return;
		
		var tmp = includedInfo[entryIndex];
		includedInfo[entryIndex] = includedInfo[entryIndex - 1];
		includedInfo[entryIndex - 1] = tmp;
	}
	else if (direction == "down")
	{
		// Don''t move lowest element downwards
		if (entryIndex == includedInfo.length - 1)
			return;
			
		var tmp = includedInfo[entryIndex];
		includedInfo[entryIndex] = includedInfo[entryIndex + 1];
		includedInfo[entryIndex + 1] = tmp;
	}
	
	// Update hidden inputs
	setEditorInfo("includedInfo_" + editorID, includedInfo);
	
	renderQuestionnaireEditor(editorID);
}
'! !

!DLFileLibrary methodsFor: 'requestHandling' stamp: 'topa 01/02/2012 12:01'!
resetMinCss
 ^ '/*
Copyright (c) 2009, Yahoo!! Inc. All rights reserved.
Code licensed under the BSD License:
http://developer.yahoo.net/yui/license.txt
version: 2.7.0
*/
html{color:#000;background:#FFF;}body,div,dl,dt,dd,ul,ol,li,h1,h2,h3,h4,h5,h6,pre,code,form,fieldset,legend,input,button,textarea,p,blockquote,th,td{margin:0;padding:0;}table{border-collapse:collapse;border-spacing:0;}fieldset,img{border:0;}address,caption,cite,code,dfn,em,strong,th,var,optgroup{font-style:inherit;font-weight:inherit;}del,ins{text-decoration:none;}li{list-style:none;}caption,th{text-align:left;}h1,h2,h3,h4,h5,h6{font-size:100%;font-weight:normal;}q:before,q:after{content:'';}abbr,acronym{border:0;font-variant:normal;}sup{vertical-align:baseline;}sub{vertical-align:baseline;}legend{color:#000;}input,button,textarea,select,optgroup,option{font-family:inherit;font-size:inherit;font-style:inherit;font-weight:inherit;}input,button,textarea,select{*font-size:100%;}'! !

!DLFileLibrary methodsFor: 'rendering' stamp: 'topa 2/6/2012 17:02'!
selectorsToInclude

	^ #(styleCss resetMinCss formUtilitiesJs multiCheckBoxJs questionnaireJs MochiKitJs PlotKitPackedJs)! !

!DLFileLibrary methodsFor: 'uploaded' stamp: 'PL 8/4/2011 19:02:19.654'!
styleCss
	^'
body {
	font-family: "Trebuchet MS",sans-serif;
	font-size: 0.85em;
	padding: 0 0 0 0;
	margin: 0 0 0 0;
}

a {
	color:#A62940;
	text-decoration:none;
}

#lightbox {
	background-color: #fff;
	padding: 10px;
	-moz-border-radius: 5px;
	-webkit-border-radius: 5px;
	overflow:auto;
	max-height:92%;
	min-width:40%;
	max-width:92%;
}

#lightbox form dl {
	margin-bottom: 5px;
	padding-bottom:5px;
}

.errors {
	border: 1px solid #F00;
}

.error {
	color: #F00;
}

.header {
	width: 100%;
	background-color: #df6824;
	height:100px;
	border-bottom: 5px solid #dfa27f;
}

.header img {
	padding:5px;
	float:left;
}

.footer {
	width:100%;
	height:20px;
	position:fixed;
	bottom:0px;
}

li.active a {
	background-color: #000 !!important;
}

.menu {
	float:left;
	margin-top: 5px;
}

.menu ul {
	clear: both;
}

.menu li {
	float: left;
	list-style:none;
	padding: 0 2px 0 2px;
}

.menu a {
	background-color: #fff;
	text-decoration: none;
	font-weight: bold;
	line-height: 30px;
	padding: 3px;
	color: #df6824;
}

.component {
	margin-bottom: 10px;
	border-bottom: 2px dotted #eee;
}


table caption, h2, h3 {
	font-size: 18pt;
}

.odd { background-color: #fadbab; }
.even{ background-color: #fff }

dl{
	margin:15px 0px 0px 0px;
	padding:0px;
	width:auto;
	clear:both;
}
	
dt{
	float:left;
	width:190px;
	margin:0px 0px 5px 0px;
}
	
dd {
	margin:0px 0px 10px 190px;
	color:#666666;
}

dd:empty:after {
	content:".";
	color:#fff;
}

dd label{
	vertical-align:top;
	margin:0px 8px 0px 0px;
	line-height:1.6em;
	}
	
caption {
	width: 600px;
}

.helptext:before {
	content:".";
	color:#fff;
}

.buttons {
	float:left;
}

.warning, 
.over {
}

.warning {
	background-color: #fc0;
}

.over { background-color: #df2424; }
.over a { color: #fff; padding:3px; }

.content {
	margin-top: 25px;
	margin-bottom: 50px;
	margin-left: 90px;
}

.content td, .content th {
	padding: 3px;
}

.content dt.required {
	font-weight: bold;
}

.helptext {
	font-size: 10px;
	color: #777;
}
.graph { 
        position: relative;
        width: 275px; 
        border: 1px solid #B1D632; 
        padding: 2px; 
    }
.graph .bar { 
        display: block;
        position: relative;
        background: #B1D632; 
        text-align: center; 
        color: #333; 
        height: 2em; 
        line-height: 2em;            
    }
.graph .bar span { position: absolute; left: 1em; }

.Admin a {
	background-color: FireBrick;
	color: white;
}

.iconstring {
	display: inline;
	margin: 0 0 0 5px;
	color: #F29B30;
	vertical-align: middle;
}

.iconpic {
	display: inline;
	margin: 0 0 0 2px;
	vertical-align: middle;
	position: relative;
	top: 2px;
}

tr {
	vertical-align: middle;
}

.deletionDescription {
	float: left;
	min-width: 130px;
}

.deletionItem {
	float: left;
	margin: 0 0 0 5px;
}

.clearFloat {
	clear: both;
}

.magritte textarea {
	width: 100%;
	height: 128px;
}

.multiCheckBox .voteButton {
	float: left;
}

.multiCheckBox .checkMarks {
	position: relative;
	top: -4px;
	width: 78px;
	height: 24px;
	background-image: url("multiCheckBox.png");
	float: left;
	vertical-align: middle;
}

.multiCheckBox .checkMarks div {
	position: relative;
	top: 3px;
	left: 40px;
	width: 38px;
	color: #345300;
	font-weight: bold;
}

.multiCheckBox .choiceLabel {
	color: #000000;
}

dl dl {
	display: inline;
	margin-top: 0px;
}

dl dl dt {
	margin-bottom: 16px;
}

dl dl dd {
	display: inline;
}

.questionnaire {
	width: 100%;
}

.questionnaire .label {
	display: table-cell;
	width: 96px;
}

.questionnaire .table .entry {
	height: 28px;
}

.questionnaire .table .entry div, .questionnaire .table .page div {
	display: table-cell;
	padding: 4px;
	color: #000000;
}

.questionnaire .table .entry .number {
	width: 20px;
}

.questionnaire .table .entry .question {
	width: 480px;
}

.questionnaire .table .entry .actions {
	text-align: right;
	width: 72px;
	padding-right: 12px;
}

.questionnaire .minusButton {
	margin-left: 16px;
}

.questionnaire .divider {
	width: 604px;
	background-color: #DFA27F;
	height: 5px;
}

.questionnaire .table .entry .actions .iconSpacer {
	display: inline-block;
	width: 18px;
	height: 16px;
}

.questionnaire .table .page {
	padding: 4px;
	color: #000000;
	font-weight: bold;
	padding-top: 20px;
}

.questionnaire .comment {
	color: #777 !!important;
	font-size: 10pt !!important;
}

.barChart div:nth-child(1) {
	float: left;
	margin-right: 8px;
	background-image: url("barchart.png");
	width: 64px;
	height: 16px;
	background-position: right;
}

.barChart div:nth-child(2) {
	width: 144px;
}

.barChart div:nth-child(1) div {
	background-image: url("barchart.png");
	height: 16px;
	background-position: left;
	text-align: right;
}

.barChart div:nth-child(1) div div {
	width: 100%;
	background-image: url("barchart_separator.png");
	height: 16px;
	background-position: right;
	background-repeat: no-repeat;
}
'! !

!DLFileLibrary methodsFor: 'uploaded' stamp: 'tfel 1/11/2011 18:16'!
togglePng
	| cache |
	cache := #(nil) asOrderedCollection.
	(cache first) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 1 115 82 71 66 0 174 206 28 233 0 0 0 6 98 75 71 68 0 255 0 255 0 255 160 189 167 147 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 0 7 116 73 77 69 7 217 7 23 18 23 1 235 45 151 111 0 0 4 27 73 68 65 84 56 17 1 16 4 239 251 1 255 255 255 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 129 172 233 0 127 170 233 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2 0 254 0 0 0 117 163 227 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 249 252 252 0 49 31 7 0 19 14 6 0 97 150 222 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 255 255 255 0 0 0 0 0 127 71 16 255 18 10 2 0 12 7 2 0 18 10 2 0 21 12 3 0 22 12 2 0 11 10 9 0 2 10 18 0 2 10 18 0 2 7 12 0 1 5 9 0 0 0 0 245 20 92 163 12 0 0 0 0 4 0 0 0 0 0 0 0 0 240 247 254 156 61 34 7 100 46 50 54 0 1 6 11 0 2 7 12 0 1 6 11 0 1 6 11 0 2 8 14 0 1 5 9 0 0 2 4 0 249 222 195 255 0 0 0 147 0 0 0 0 0 0 0 0 1 255 255 255 0 0 0 0 0 0 0 0 0 116 65 15 160 75 42 9 95 43 51 59 0 255 252 249 0 1 1 1 0 1 8 15 0 3 13 23 0 3 12 21 0 252 236 220 0 252 242 232 136 23 102 180 121 0 0 0 0 0 0 0 0 1 255 255 255 0 0 0 0 0 0 0 0 0 0 0 0 0 122 68 15 162 76 43 10 93 37 50 63 0 255 252 249 0 2 7 12 0 3 16 29 0 251 232 213 0 252 240 228 143 26 116 205 114 0 0 0 0 0 0 0 0 0 0 0 0 2 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 188 52 196 94 189 218 247 170 225 209 193 0 2 7 12 0 1 6 11 0 248 217 186 0 242 223 204 159 26 116 205 114 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 238 247 251 0 252 96 210 87 188 163 47 3 75 4 189 83 14 8 2 0 215 233 251 165 72 153 233 98 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 247 244 252 0 247 251 254 0 245 245 254 88 190 219 248 175 12 7 2 47 99 168 236 92 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 255 255 255 0 0 0 0 0 0 0 0 0 0 0 0 0 25 90 197 0 35 24 8 0 218 212 237 0 234 186 70 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 254 245 252 0 217 208 235 0 235 190 72 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 255 255 255 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 135 106 130 208 82 213 176 98 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache first! !

!DLFileLibrary methodsFor: 'requestHandling' stamp: 'topa 2/6/2012 17:02'!
updateRoot:	anHtmlRoot
		
	anHtmlRoot link
		relationship: 'icon';
		url: (DLFileLibrary / #faviconPng);
		type: 'image/x-icon'.
	
	super updateRoot: anHtmlRoot.! !

!DLFileLibrary methodsFor: 'uploaded' stamp: 'PL 6/23/2011 17:41:05.643'!
upPng
	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 18 0 0 0 16 8 6 0 0 0 27 6 47 92 0 0 0 4 115 66 73 84 8 8 8 8 124 8 100 136 0 0 0 9 112 72 89 115 0 0 13 215 0 0 13 215 1 66 40 155 120 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 119 119 119 46 105 110 107 115 99 97 112 101 46 111 114 103 155 238 60 26 0 0 2 142 73 68 65 84 56 141 173 83 77 79 19 81 20 61 111 58 45 165 32 17 168 29 2 211 6 81 41 165 20 68 33 13 44 8 150 46 45 11 8 31 177 145 106 19 2 132 31 226 47 32 221 169 193 104 96 227 162 16 93 64 107 100 33 162 141 9 84 145 138 198 242 209 166 95 2 66 129 50 157 190 113 161 52 16 9 72 226 77 238 230 190 147 115 207 59 39 151 72 146 132 255 81 204 89 128 10 107 63 87 97 237 231 206 194 145 211 20 93 107 113 94 74 19 234 5 0 185 196 88 150 103 30 198 207 173 136 55 59 138 5 41 227 25 112 116 213 12 56 186 106 4 41 227 225 205 142 226 115 17 105 155 187 139 8 75 167 156 246 14 147 161 82 15 67 165 30 78 123 135 137 176 116 74 219 220 93 244 79 68 188 217 81 12 202 120 156 246 206 122 147 209 136 96 116 7 193 232 14 76 70 35 156 246 206 122 80 230 68 101 199 60 226 205 29 197 0 235 185 127 183 183 206 100 50 33 24 221 62 6 46 231 10 224 247 251 241 232 201 216 60 32 182 173 207 61 255 241 23 81 89 67 187 26 144 79 223 235 235 173 171 174 169 197 210 234 38 82 130 136 125 65 4 0 228 42 88 40 21 44 170 116 133 88 252 184 128 199 163 99 243 64 218 26 242 185 19 89 162 178 134 118 53 5 227 233 179 223 169 45 45 215 99 118 49 130 195 5 153 180 0 0 144 201 21 191 55 19 130 166 234 18 132 131 1 140 62 125 182 192 128 182 133 124 238 4 41 189 105 83 83 10 111 79 79 143 73 163 173 194 251 47 209 236 87 68 81 192 210 155 73 0 64 85 243 109 176 172 34 251 214 88 201 33 182 182 132 241 241 113 63 195 192 34 83 105 174 62 208 234 202 219 13 13 173 120 23 136 33 67 37 100 168 4 65 72 33 48 59 137 221 173 168 75 72 37 125 91 241 245 198 11 37 151 65 33 67 134 74 88 141 39 161 211 241 136 135 87 184 173 205 13 165 172 176 226 250 235 205 88 164 233 251 74 248 178 74 83 14 74 1 65 56 192 183 183 19 216 223 136 184 34 11 47 135 147 145 229 23 57 249 156 230 103 34 212 152 207 93 129 4 6 34 165 152 155 118 35 182 246 213 43 207 203 119 30 122 164 18 83 123 19 5 165 122 11 87 213 130 181 15 19 72 109 69 93 177 79 211 195 210 31 179 8 33 68 99 180 142 40 47 114 67 218 27 54 68 151 102 176 29 14 120 89 165 202 22 242 185 247 142 166 166 18 119 147 19 68 158 99 201 136 7 174 196 231 87 89 146 108 196 132 16 181 225 214 136 140 205 25 146 210 7 94 54 47 223 22 242 185 247 0 0 146 36 101 155 231 155 114 213 250 214 193 195 52 79 106 0 68 173 111 29 228 249 166 220 163 243 83 143 246 60 245 11 111 234 61 115 239 138 207 230 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

!DLFileLibrary methodsFor: 'uploaded' stamp: 'tfel 1/11/2011 18:16'!
zipPng
	| cache |
	cache := #(nil) asOrderedCollection.
	(cache first) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 6 98 75 71 68 0 255 0 255 0 255 160 189 167 147 0 0 0 9 112 72 89 115 0 0 13 215 0 0 13 215 1 66 40 155 120 0 0 0 7 116 73 77 69 7 214 1 17 21 23 15 82 167 180 68 0 0 1 177 73 68 65 84 56 203 157 146 191 75 28 65 20 199 63 179 59 179 123 123 123 9 7 158 4 188 32 198 64 18 82 137 10 66 184 86 11 147 38 85 72 32 150 150 166 176 21 228 72 27 16 66 16 44 98 113 127 130 246 98 167 160 141 4 11 11 15 17 210 28 154 112 201 253 242 246 214 177 216 189 189 189 95 68 242 45 222 204 188 121 239 195 123 111 70 240 15 125 93 114 117 236 152 7 246 87 10 213 253 182 67 108 188 55 62 3 107 195 0 166 114 120 183 242 13 128 163 157 47 20 47 46 162 59 223 171 215 37 176 182 188 121 57 180 130 239 159 158 3 208 186 169 50 254 98 142 39 211 111 72 36 28 210 147 57 10 235 11 142 108 7 214 174 138 125 201 210 73 71 251 74 113 143 116 118 22 175 217 68 186 25 48 19 65 12 247 144 97 63 32 57 254 10 195 74 1 191 48 165 196 144 86 7 80 187 42 146 204 76 14 76 158 154 201 177 187 157 231 248 228 140 215 111 63 144 205 142 49 98 90 157 42 1 74 63 118 56 63 61 64 224 163 181 143 155 112 0 112 221 36 207 230 87 121 106 216 44 180 60 0 234 127 74 92 151 127 98 55 170 221 45 76 60 126 4 90 131 32 88 67 149 14 55 251 91 2 202 82 119 3 252 250 111 64 19 18 194 71 142 94 187 115 167 53 8 65 243 111 169 27 96 42 21 197 235 182 17 97 98 155 27 7 197 103 96 24 128 180 98 238 14 72 12 56 199 191 166 4 176 236 36 158 178 16 189 25 4 243 208 66 128 6 17 34 26 141 6 142 101 199 1 14 90 170 144 222 111 131 222 137 60 166 106 161 236 216 71 82 142 75 197 243 123 199 21 149 218 235 147 166 133 84 241 10 30 142 49 250 114 145 251 41 64 53 181 121 11 24 98 227 99 106 139 86 109 153 255 80 237 70 23 238 0 54 16 132 87 8 24 8 195 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache first! !

MAComponentRenderer subclass: #DLCssRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-configuration'!

!DLCssRenderer methodsFor: 'rendering' stamp: 'tfel 1/11/2011 21:59'!
collectErrors
	| errorList |
	errorList := Set new.
	[component validate]
		on: MAError
		do: [:error | errorList add: error messageText. ].
	^ errorList.! !

!DLCssRenderer methodsFor: 'rendering' stamp: 'sebh 7/19/2009 20:21'!
collectErrors: aDescription
	| current |
	errors ifNotNil: [ ^ errors includes: aDescription ].
	errors := IdentitySet new.
	current := component.
	[ current notNil ] whileTrue: [
		current isMagritteContainer ifTrue: [
			current errors do: [ :each |
				errors add: (each tag isDescription
					ifTrue: [ each tag ]
					ifFalse: [ current description ]) ] ].
		current := current parent ].
	^ self hasError: aDescription! !

!DLCssRenderer methodsFor: 'rendering' stamp: 'sebh 6/8/2009 00:21'!
renderContainer: aDescription 
	html definitionList
		class: (self classFor: aDescription);
		with: [ super renderContainer: aDescription ]! !

!DLCssRenderer methodsFor: 'rendering' stamp: 'sebh 7/19/2009 20:41'!
renderControl: aDescription
	html definitionData
		class: (self classFor: aDescription);
		with: [ 
				  super renderControl: aDescription.
				  html div class:'helptext'; with: aDescription comment.
				  (self hasError: aDescription) ifTrue: 
						[
							html unorderedList
								class: 'errors';
								list: self collectErrors;
								with: nil.
						].
			]! !

!DLCssRenderer methodsFor: 'rendering' stamp: 'sebh 6/8/2009 00:21'!
renderGroup: aDescription
	super renderGroup: aDescription.
	group isNil ifTrue: [ ^ self ].
	html definitionTerm
		class: 'group';
		with: group! !

!DLCssRenderer methodsFor: 'rendering' stamp: 'sebh 6/8/2009 00:21'!
renderLabel: aDescription
	html definitionTerm
		title: aDescription comment;
		class: (self classFor: aDescription);
		with: [ super renderLabel: aDescription ]! !

MAReport subclass: #DLMAGroupedReport
	instanceVariableNames: 'groupField'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMAGroupedReport methodsFor: 'accessing' stamp: 'sebh 6/21/2009 00:26'!
groupField

	^ groupField! !

!DLMAGroupedReport methodsFor: 'accessing' stamp: 'sebh 6/21/2009 00:26'!
groupField: anObject

	groupField := anObject.! !

!DLMAGroupedReport methodsFor: 'rendering' stamp: 'Marik 7/24/2009 12:55'!
renderTableBodyOn: html 
	self visible isEmpty 
		ifTrue: [ 
			html tableRow
				class: 'empty';
				with: [ 
					html tableData
						colSpan: self visibleColumns size;
						with: self tableEmpty ] ]
		ifFalse: [
			| grouping |
			grouping := Dictionary new.
			self visible keysAndValuesDo: [ :index :row |
				| groupstring |
				groupstring := (row perform: self groupField) asString.
				grouping at: groupstring ifAbsentPut: OrderedCollection new.
				(grouping at: groupstring) add: row.
				].
			
			grouping keysAndValuesDo: [ :head :groupedrows |
				html tableRow class:'grouping'; with: [ html tableData: head].
				groupedrows keysAndValuesDo: [ :index :row | 
				html tableRow
					class: (self rowStyleForNumber: index);
					with: [ 
						self visibleColumns do: [ :col | 
							col 
								renderCell: row
								index: index
								on: html ] ] ] ] ]! !

MAReport subclass: #DLMAReport
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMAReport methodsFor: 'style' stamp: 'sebh 7/23/2009 20:06'!
cssStyle: aString
	properties at: #cssStyle put: aString! !

!DLMAReport methodsFor: 'rendering' stamp: 'sebh 7/23/2009 20:11'!
renderContentOn: html
	html table
		id: self ajaxId; 
		class: 'report';
		style: (properties at: #cssStyle ifAbsent: ['']);
		with: [ self renderTableOn: html ]! !

MASelectListComponent subclass: #DLMASelectListComponent
	instanceVariableNames: ''
	classVariableNames: 'NewElementClass'
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMASelectListComponent class methodsFor: 'accessing' stamp: 'Marik 7/17/2009 10:47'!
newElementClass

	^ NewElementClass! !

!DLMASelectListComponent class methodsFor: 'accessing' stamp: 'Marik 7/17/2009 10:47'!
newElementClass: anObject

	NewElementClass := anObject.! !

!DLMASelectListComponent methodsFor: 'saving' stamp: 'sebh 7/19/2009 23:45'!
addNewElement

	| answer |
	answer := self root call: ((self class newElementClass new descriptionCreate asComponentOn: self class newElementClass new) addForm).
	answer ifNotNil: [
		answer save. 
		self value: answer.
		self description options add: answer.
		]! !

!DLMASelectListComponent methodsFor: 'rendering' stamp: 'Marik 7/16/2009 13:54'!
renderEditorOn: html
	self description isGrouped
		ifTrue: [ self renderEditorForGroupedOn: html ]
		ifFalse: [ self renderEditorForUngroupedOn: html ].
	html break.
	html submitButton on: #addNewElement of: self.! !

MASelectListComponent subclass: #DLMAUpdatableSelectListComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMAUpdatableSelectListComponent methodsFor: 'rendering' stamp: 'PL 5/25/2011 13:44:38.056'!
renderEditorForUngroupedOn: html
	
	| script |
	
	script := DLPureJSScript new jsScript: self description jsScript.
	
	html select
		onChange: script;
		id: self labelId;
		list: self options;
		selected: self value;
		callback: [:value | self value: value];
		labels: [:value | self labelForOption: value]! !

WARenderLoopMain subclass: #DLAuthMain
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-configuration'!

!DLAuthMain methodsFor: 'requestHandling' stamp: 'topa 4/28/2010 12:26'!
createRoot

	^ super createRoot
		addDecoration: DLPreAuthentication new;
		yourself! !

MARadioGroupComponent subclass: #DLMAUpdatableRadioGroupComponent
	instanceVariableNames: 'updater'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMAUpdatableRadioGroupComponent methodsFor: 'rendering' stamp: 'PL 5/25/2011 14:46:34.639'!
renderEditorOn: html
	
	super renderEditorOn: html.
	
	html script
		with: ('window.addEventListener(''load'', function() {', self description jsScript , '}, true)')! !

!DLMAUpdatableRadioGroupComponent methodsFor: 'rendering' stamp: 'PL 5/25/2011 14:42:43.143'!
renderOption: anObject index: anInteger in: aRadioGroup on: html

	| optionId script |
	
	script := DLPureJSScript new jsScript: self description jsScript.
	
	optionId := self optionId: anInteger.
	html radioButton
		id: optionId;
		group: aRadioGroup;
		selected: self value = anObject;
		onChange: script;
		callback: [ self value: anObject ].
	html space.
	html label
		for: optionId;
		with: (self labelForOption: anObject)! !

WAApplication subclass: #DLApplication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-configuration'!

DLApplication class
	instanceVariableNames: 'scheduler'!

!DLApplication class methodsFor: 'description' stamp: 'test 6/14/2009 15:22'!
description
	^ 'DLApplication'! !

!DLApplication class methodsFor: 'cronjob' stamp: 'topa 4/28/2010 15:57'!
startNotificationSchedule
	"to be done."
"	scheduler := TaskScheduler new.
	scheduler start.
	scheduler do: [
		Transcript show: DateAndTime now asString; cr;
					  show: 'Running notification process'; cr.
		DLNotification releaseMails.
		Transcript show: 'Finished';cr.
		] every: 1200 seconds."! !

!DLApplication class methodsFor: 'cronjob' stamp: 'topa 4/28/2010 15:57'!
stopNotificationSchedule
"	scheduler stop."! !

!DLApplication class methodsFor: 'description' stamp: 'MG 7/23/2009 19:33'!
translations
	^ Dictionary new
		at: #save put: 'Speichern';
		at: #cancel put: 'Abbrechen';
		at: #choose put: 'Auswhlen';
		at: #add put: 'Hinzufgen';
		at: #remove put: 'Entfernen';
		at: #change put: 'Verndern';
		at: #edit put: 'ndern';
		at: #now put: 'Jetzt';
		at: #leave put: 'Verlassen';
		yourself.! !

!DLApplication methodsFor: 'initialize' stamp: 'tfel 11/30/2010 18:16'!
basePath
	"Override this to work nicely behind an apache path"
	^ super basePath! !

!DLApplication methodsFor: 'initialize' stamp: 'tfel 1/11/2011 21:58'!
initializeWith: aRootComponent

	self
		addLibrary: DLFileLibrary;
		addLibrary: SUDeploymentLibrary;
		addLibrary: SUComponentLibrary;
		addLibrary: PTDeploymentLibrary;
		preferenceAt: #mainClass			put: DLAuthMain;
		preferenceAt: #sessionClass		put: DLSession;
		preferenceAt: #useCookies		put: true;
		preferenceAt: #resourceBaseUrl	put: (WAFileHandler default baseUrl asString, '/');
		preferenceAt: #rootClass			put: aRootComponent! !

Object subclass: #DeliSetup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-setup'!

!DeliSetup methodsFor: 'setup' stamp: 'PL 8/5/2011 22:02:23.554'!
InstallDatabase

	| lec lec2 sem sur sur2 user1 user2 user3 admin group1 group2 |
	
	"stop making snapshots while initializing"
	DLModel isTestRunning: true.  

	DLModel removeAllInstances.
	{2010. 2011} do: [:year | 
		DLSemester new semesterName: 'Sommer'; year: year;	 save.
		DLSemester new semesterName: 'Winter'; year: year;  save].
	DLUser createFrom: {#userName -> 'michael.haupt'. #realName -> 'Michael Haupt'. #email -> 'michael.haupt@hpi.uni-potsdam.de'. #isAdmin -> true}.
	DLUser createFrom: {#userName -> 'michael.perscheid'. #realName -> 'Michael Perscheid'. #email -> 'michael.perscheid@hpi.uni-potsdam.de'. #isAdmin -> true}.
	DLUser createFrom: {#userName -> 'tobias.pape'. #realName -> 'Tobias Pape'. #email -> 'tobias.pape@student.hpi.uni-potsdam.de'. #isAdmin -> true}.
	DLUser createFrom: {#userName -> 'tim.felgentreff'. #realName -> 'Tim Felgentreff'. #email -> 'tim.felgentreff@hpi.uni-potsdam.de'. #isAdmin -> true}.
	
	"group 15 test data"
	admin := DLUser createFrom: {#userName -> 'admin'. #realName -> 'Deli Administrator'. #email -> 'admin@deli'. #isAdmin -> true}.

	sem := DLSemester createFrom: {#semesterName -> 'SS'. #year ->  Date today year}.
	
	user1 := DLUser createFrom: {#userName -> 'mandy'. #realName -> 'Mandy Roick'. #email -> 'student@deli'. #isAdmin -> false}.
	user2 := DLUser createFrom: {#userName -> 'fabian'. #realName -> 'Fabian Eckert'. #email -> 'student@deli'. #isAdmin -> false}.
	user3 := DLUser createFrom: {#userName -> 'martin'. #realName -> 'Martin Schnberg'. #email -> 'student@deli'. #isAdmin -> false}.

	lec := DLLecture createFrom: {#lectureName -> 'SWT'. #semester -> sem. #students -> (OrderedCollection with: user1 with: user2 with: user3 with: admin)}.  	
	
	sur := DLSurvey createFrom: {#question -> 'Was bedeutet TDD?'. #lecture ->  lec. #status -> #closed}.
		
	DLAnswer createFrom: {#survey -> sur. #author -> user1. #answer -> 'Test-driven development'}.

	DLAnswer createFrom: {#survey -> sur. #author -> user2. #answer -> 'Time-driven design'}.
	
	group1 := DLGroup createFrom: {#groupName -> 'Gruppe 1'. #groupDescription -> 'Erste Gruppe'. #lecture -> lec. #students -> (OrderedCollection with: user1 )}.
	
	group2 := DLGroup createFrom: {#groupName -> 'Gruppe 2'. #groupDescription -> 'Zweite Gruppe'. #lecture -> lec. #students -> (OrderedCollection with: user2 with: user3 with: admin)}.
	
	sur2 := DLSurvey createFrom: {#question -> 'Was sind eure Lieblingsprozesse?'. #lecture ->  lec. #status -> #open. #maxAnswers -> 5.
		#maxAnswersPerChoice -> 3. #surveyType -> #multipleChoice. #choices -> (OrderedCollection with: 'RUP' with: 'Scrum' with: 'LSD' with: 'XP')}.
		
	DLAnswer createFrom: {#survey -> sur2. #author -> user1. #answer -> (Dictionary new at: 'RUP' put: 2; at: 'Scrum' put: 0; at: 'XP' put: 3; yourself)}.
	DLAnswer createFrom: {#survey -> sur2. #author -> user2. #answer -> (Dictionary new at: 'RUP' put: 0; at: 'Scrum' put: 4; at: 'XP' put: 1; yourself)}.
	DLAnswer createFrom: {#survey -> sur2. #author -> user3. #answer -> (Dictionary new at: 'RUP' put: 0; at: 'Scrum' put: 0; at: 'XP' put: 5; yourself)}.
	
	DLSurvey createFrom: {#question -> 'Wie viele Mitglieder sollte ein Scrum-Team haben?'. #lecture ->  lec. #status -> #open. #maxAnswers -> 1.
		#maxAnswersPerChoice -> 1. #surveyType -> #multipleChoice. #choices -> (OrderedCollection with: '1 bis 4' with: '5 bis 9' with: '10 bis 15' with: 'mehr als 15')}.
		
	DLSurvey createFrom: {#question -> 'Welche dieser Entwicklungsprozesse sind iterativ?'. #lecture ->  lec. #status -> #open. #maxAnswers -> 4.
		#maxAnswersPerChoice -> 1. #surveyType -> #multipleChoice. #choices -> (OrderedCollection with: 'Wasserfall-Modell' with: 'V-Modell XT' with: 'Scrum'
			with: 'LSD')}.
	
	DLSurvey createFrom: {#question -> 'Welches Thema in SWT fandet ihr am interessantesten?'. #lecture ->  lec. #status -> #open}.
	
	DLQuestionnaire createFrom: {#surveys -> DLSurvey instances copy. #headings -> (OrderedCollection with: 0 -> 'Inhaltliches' with: 4 -> 'Zur Vorlesung').
		#title -> 'Feedback zur Vorlesung'}.
	
	DLSurvey createFrom: {#question -> 'Welche Fachbcher fandet ihr ntzlich?'. #lecture ->  lec. #status -> #hidden}.

	"start making snapshots again"
	DLModel isTestRunning: false.! !

Object subclass: #DLModel
	instanceVariableNames: 'oid fieldChanges'
	classVariableNames: 'WriteMutex'
	poolDictionaries: ''
	category: 'Deli-models'!

DLModel class
	instanceVariableNames: 'instances isTestRunning'!

DLModel subclass: #DLAnswer
	instanceVariableNames: 'survey author answer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLAnswer class methodsFor: 'persistence-description' stamp: 'PL 5/25/2011 18:00:01.066'!
descriptionAnswerAsString

	^ MAStringDescription new
		accessor: #answerAsString;
		label: 'Antwort';
		priority: 20;
		beRequired;
		yourself! !

!DLAnswer class methodsFor: 'persistence-description' stamp: 'PL 5/11/2011 14:45:12.515'!
descriptionAuthor

	^ MAStringDescription new
		accessor: #author;
		label: 'Autor';
		priority: 10;
		beReadonly;
		beRequired;
		yourself! !

!DLAnswer class methodsFor: 'accessing' stamp: 'PL 5/11/2011 14:38:05.854'!
metaName

	^ 'Antwort'! !

!DLAnswer class methodsFor: 'accessing' stamp: 'PL 5/11/2011 14:38:09.452'!
metaNamePlural

	^ 'Antworten'! !

!DLAnswer methodsFor: 'accessing' stamp: 'PL 5/28/2011 01:34:16.888'!
answer

	^ answer! !

!DLAnswer methodsFor: 'accessing' stamp: 'PL 5/28/2011 14:28:53.236'!
answer: anObject

	answer := anObject! !

!DLAnswer methodsFor: 'accessing' stamp: 'PL 8/5/2011 17:53:40.225'!
answerAsString

	"If this is an answer to a multiple choice question, print the choices formatted as a string."
	| string |
	
	self survey ifNil: [^ ''].
	self survey surveyType = #text ifTrue: [^ self answer].
	
	string := ''.
	self sortedListOfAnswers do:
		[:each |
			string ~= '' ifTrue: [string := string , ', '].
			string := string , (each value asString , '  ', each key asString)].
	^ string! !

!DLAnswer methodsFor: 'accessing' stamp: 'PL 5/25/2011 18:06:15.029'!
answerAsString: aString

	self answer: aString! !

!DLAnswer methodsFor: 'accessing' stamp: 'PL 8/5/2011 17:50:12.171'!
at: anObject

	^ self answer at: anObject ifAbsent: nil! !

!DLAnswer methodsFor: 'accessing' stamp: 'PL 5/28/2011 01:34:09.834'!
author

	^ author! !

!DLAnswer methodsFor: 'accessing' stamp: 'PL 5/28/2011 01:34:13.027'!
author: anObject

	author := anObject! !

!DLAnswer methodsFor: 'printing' stamp: 'PL 5/28/2011 14:29:37.567'!
canonicalName

	self survey surveyType = #multipleChoice
		ifTrue: [^ self answerAsString].
		
	^ self answer! !

!DLAnswer methodsFor: 'description' stamp: 'PL 6/14/2011 08:06:21.621'!
descriptionList

	^ self description select: [:each | #(author answer) includes: each accessor selector]! !

!DLAnswer methodsFor: 'accessing' stamp: 'PL 8/5/2011 17:54:30.13'!
sortedListOfAnswers

	"Return a list of the given votes per choice sorted by the amount of votes."
	| sortedList |
	
	sortedList := SortedCollection new.
	(self answer select: [:each | each value ~= 0])
		keysAndValuesDo: [:key :value | sortedList add: (key -> value)].
	
	sortedList := sortedList sortBy: [:a :b | a value > b value].
	
	^ sortedList! !

!DLAnswer methodsFor: 'accessing' stamp: 'PL 5/28/2011 01:34:03.94'!
survey

	^ survey! !

!DLAnswer methodsFor: 'accessing' stamp: 'PL 5/28/2011 01:34:00.164'!
survey: anObject
	
	survey := anObject! !

DLModel subclass: #DLDeadline
	instanceVariableNames: 'deadlineName deadlineDescription group lecture date time requirements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLDeadline class methodsFor: 'description' stamp: 'sebh 7/19/2009 19:13'!
descriptionDeadlineDescription
	^ MAMemoDescription new
		accessor: #deadlineDescription; 
		label: 'Beschreibung'; 
		priority: 30;
		beRequired;
		yourself.! !

!DLDeadline class methodsFor: 'description' stamp: 'sebh 7/19/2009 19:13'!
descriptionDeadlineName
	^ MAStringDescription new
		accessor: #deadlineName;
	 	label: 'Titel';
		priority: 20;
		beRequired;
		yourself.! !

!DLDeadline class methodsFor: 'description' stamp: 'sebh 7/17/2009 20:35'!
descriptionTime
	^ MATimeDescription new
		accessor: #time; 
		label: 'Uhrzeit'; 
		priority: 50;
		default: '23:59:59';
		beRequired;
		yourself.! !

!DLDeadline class methodsFor: 'persistence-description' stamp: 'sebh 6/6/2009 23:33'!
metaName
	^ 'Abgabetermin'! !

!DLDeadline class methodsFor: 'persistence-description' stamp: 'sebh 7/3/2009 00:01'!
metaNamePlural
	^ 'Abgabetermine'! !

!DLDeadline methodsFor: 'comparing' stamp: 'tfel 1/9/2011 20:03'!
< anotherModel

	^ self lecture < anotherModel lecture or: [
		self lecture = anotherModel lecture and: [
			self dateAndTime < anotherModel dateAndTime]]! !

!DLDeadline methodsFor: 'description' stamp: 'tfel 3/10/2010 14:58'!
additionalDescriptions

	^ {self descriptionGroup. self descriptionLecture. self descriptionRequirements. self descriptionDate}! !

!DLDeadline methodsFor: 'accessing' stamp: 'Marik 6/9/2009 17:48'!
canonicalName
	^ self deadlineName! !

!DLDeadline methodsFor: 'description' stamp: 'tfel 12/5/2009 13:46'!
collectDependentObjects
	| dependentDeliveries dependentRequirement dependentParent |
	dependentParent := super collectDependentObjects.
	dependentDeliveries := DLDelivery instances select: [:aDelivery   | aDelivery    deadline = self].
	dependentRequirement:= self requirements.
	^ dependentParent, dependentDeliveries, dependentDeliveries! !

!DLDeadline methodsFor: 'description' stamp: 'tfel 6/22/2010 10:35'!
copyWithDependentObjects
	| newDeadline |
	newDeadline := self copy oid: nil; yourself. 
	self deliveries do: [:aDelivery | aDelivery copyWithDependentObjects deadline: newDeadline].
	^ newDeadline! !

!DLDeadline methodsFor: 'accessing' stamp: 'MH 8/5/2011 15:04:51.648'!
countDeliveriesComplete

	| completedDeliveries |
	completedDeliveries := 0.
	self deliveries do: [:aDelivery | (aDelivery isComplete) ifTrue: [completedDeliveries := completedDeliveries + 1]].
	^ completedDeliveries! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 5/20/2009 20:55'!
date

	^ date! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 5/20/2009 20:55'!
date: anObject

	date := anObject.! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 7/14/2009 23:57'!
dateAndTime
	
	^ DateAndTime date: self date time: self time! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 6/3/2009 20:57'!
deadlineDescription

	^ deadlineDescription! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 6/3/2009 20:57'!
deadlineDescription: anObject

	deadlineDescription := anObject.! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 5/20/2009 20:55'!
deadlineName

	^ deadlineName! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 5/20/2009 20:55'!
deadlineName: anObject

	deadlineName := anObject.! !

!DLDeadline methodsFor: 'accessing' stamp: 'MH 8/5/2011 15:05:08.462'!
deliveries

	^ DLDelivery instances select: [:aDelivery | (aDelivery deadline = self) and: [aDelivery group = self group]]! !

!DLDeadline methodsFor: 'description' stamp: 'Marik 7/24/2009 10:40'!
descriptionCreateForLecture
 ^ super description select: [:each | #(lecture deadlineName deadlineDescription date time requirements) includes: each accessor selector]! !

!DLDeadline methodsFor: 'description' stamp: 'MH 8/5/2011 15:05:35.087'!
descriptionDate
	^ MADateDescription new
		accessor: #date;
		label: 'Datum'; 
		priority: 40;
		default: (Date today);
		beRequired;
		yourself! !

!DLDeadline methodsFor: 'description' stamp: 'MH 8/5/2011 15:05:39.877'!
descriptionGroup
	^ MASingleOptionDescription new
		accessor: #group; 
		label: 'Gruppe';
		priority: 25;
		optionsAndLabels: (DLGroup getKeyValueSelect: [:aGroup | aGroup lecture = self lecture]);
		comment: 'Gruppenspezifischen Termin festlegen durch Auswahl.'
		yourself! !

!DLDeadline methodsFor: 'description' stamp: 'tfel 12/5/2009 15:28'!
descriptionLecture
	| description |
	description :=  MASingleOptionDescription new
		accessor: #lecture; 
		label: 'Vorlesung';
		priority: 10;
		optionsAndLabels: (DLLecture getKeyValueSelect: [:aLecture | true]);
		beRequired;
		yourself.
	self lecture ifNotNil: [description beReadonly].
	^ description! !

!DLDeadline methodsFor: 'description' stamp: 'tfel 1/9/2011 19:52'!
descriptionList
 ^ super description select: [:each | #(deadlineName date time lecture group) includes: each accessor selector]! !

!DLDeadline methodsFor: 'description' stamp: 'MH 8/5/2011 15:05:46.167'!
descriptionRequirements
	^ MAToManyRelationDescription new
		accessor: #requirements; 
		label:'Abgaben'; 
		priority:60;
		classes: (Array with: DLRequirement);
		default: Array new;
		yourself! !

!DLDeadline methodsFor: 'description' stamp: 'sebh 7/2/2009 22:45'!
descriptionUpdate
 ^ super description select: [:each | #(lecture group deadlineName deadlineDescription date time requirements) includes: each accessor selector]! !

!DLDeadline methodsFor: 'accessing' stamp: 'tfel 2/13/2010 17:08'!
gracePeriod
	"Give a half hour grace period for uploading"

	^ Duration minutes: -30! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 6/16/2009 00:54'!
group

	^ group! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 6/16/2009 00:54'!
group: anObject

	group := anObject.! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 6/8/2009 23:14'!
initialize
	super initialize.
	self requirements: OrderedCollection new.! !

!DLDeadline methodsFor: 'accessing' stamp: 'tfel 1/12/2011 20:22'!
isCritical
	
	| timeDifference panicTime |
	panicTime := (Duration days: 0.5).
	timeDifference := self dateAndTime - (DateAndTime date: (Date today) time: (Time now addTime: self gracePeriod)).
		((Duration zero < timeDifference) & (timeDifference < panicTime))
		ifTrue: [^ true].
	^false! !

!DLDeadline methodsFor: 'accessing' stamp: 'MH 8/5/2011 15:05:58.765'!
isExpired
	"This adds a grace period, so people can upload a little after the time"
	^ self dateAndTime < (DateAndTime date: (Date today) time: (Time now addTime: self gracePeriod))! !

!DLDeadline methodsFor: 'accessing' stamp: 'Marik 7/9/2009 13:44'!
isNotCritical

	^ ((self isExpired not) & (self isCritical not))! !

!DLDeadline methodsFor: 'accessing' stamp: 'MH 8/5/2011 15:06:04.081'!
isNotExpired

	^ self isExpired not! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 6/3/2009 22:03'!
lecture

	^ lecture! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 6/3/2009 22:03'!
lecture: anObject

	lecture := anObject.! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 6/18/2009 15:56'!
requirements

	^ requirements! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 7/14/2009 23:56'!
requirements: anObject
	self genericCollectionAccessor: 'requirements' withArgument: anObject! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:32'!
time

	^ time! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:32'!
time: anObject

	time := anObject.! !

!DLDeadline methodsFor: 'saving' stamp: 'sebh 7/15/2009 16:41'!
trackChangeVariables
	^ {'deadlineName'.'deadlineDescription'.'group'.'lecture'.'requirements'. 'date'. 'time'.}! !

DLModel subclass: #DLDeliverable
	instanceVariableNames: 'delivery deliverableRequirement filePath fileSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLDeliverable class methodsFor: 'description' stamp: 'sebh 7/17/2009 20:35'!
descriptionDeliverableRequirement
	^ MAStringDescription new
		accessor: #deliverableRequirement;
		label: 'Requirement';
		priority: 20;
		beReadonly;
		yourself.! !

!DLDeliverable class methodsFor: 'description' stamp: 'Marik 7/23/2009 16:16'!
descriptionDelivery
	^ MAStringDescription new 
		accessor: #delivery;
		label: 'Delivery';
		priority: 10;
		beHidden;
		beRequired;
		yourself.! !

!DLDeliverable class methodsFor: 'accessing' stamp: 'Marik 6/24/2009 15:22'!
metaName
	^ 'Abgabedatei'! !

!DLDeliverable class methodsFor: 'accessing' stamp: 'sebh 7/3/2009 00:02'!
metaNamePlural
	^ 'Abgabedateien'! !

!DLDeliverable class methodsFor: 'permission' stamp: 'sebh 7/14/2009 00:16'!
rightCreate: aUser
	^ false.! !

!DLDeliverable class methodsFor: 'permission' stamp: 'sebh 7/14/2009 00:16'!
rightDelete: aUser
	^ false.! !

!DLDeliverable class methodsFor: 'permission' stamp: 'sebh 7/14/2009 00:17'!
rightUpdate: aUser
	^ false.! !

!DLDeliverable methodsFor: 'description' stamp: 'Marik 7/1/2009 10:33'!
additionalDescriptions
	^ {self descriptionFileModel}.! !

!DLDeliverable methodsFor: 'accessing' stamp: 'Marik 7/23/2009 18:12'!
canonicalName
	^ self delivery canonicalName! !

!DLDeliverable methodsFor: 'accessing' stamp: 'sebh 6/9/2009 13:48'!
deliverableRequirement

	^ deliverableRequirement! !

!DLDeliverable methodsFor: 'accessing' stamp: 'sebh 6/9/2009 13:48'!
deliverableRequirement: anObject

	deliverableRequirement := anObject.! !

!DLDeliverable methodsFor: 'accessing' stamp: 'sebh 6/18/2009 15:58'!
delivery

	^ delivery! !

!DLDeliverable methodsFor: 'accessing' stamp: 'sebh 6/18/2009 15:58'!
delivery: anObject

	delivery := anObject.! !

!DLDeliverable methodsFor: 'description' stamp: 'tfel 2/8/2010 10:40'!
descriptionFileModel
	| extensionsText extensions |
	self deliverableRequirement ifNotNilDo: [:aRequirement |
		extensions := aRequirement filetype extensions.
		extensionsText := aRequirement filetype extensionsText.
		] ifNil:	[
		extensions := {}.
		extensionsText := ''.
		].
	^ MAFileDescription new
		accessor: #fileModel;
		label: 'Datei';
		priority: 80;
		beRequired;
		componentClass: DLMADeliverableFileUploadComponent;
		kind: DLMAExternalFileModel;
		reportColumnClass: DLMAFileColumn;
	   addCondition: [:anUploadedFile | extensions includes: '.' , anUploadedFile extension asLowercase]
		labelled: 'Dateityp muss einer der folgenden Endungen entsprechen: ' , extensionsText;
		"the following cond is not needed (i think) see the check in DLUserDeliveryDetailComp>>#renderContent:"
			"addCondition: [:anUploadedFile | self delivery ifNotNilDo: [:aDelivery | aDelivery deadline isNotExpired]]
			labelled: 'Die Abgabefrist ist leider bereits ausgelaufen.';"
		comment: 'Nur Dateien mit Endung(en) ', extensionsText ,' erlaubt.';
		yourself.! !

!DLDeliverable methodsFor: 'accessing' stamp: 'tfel 1/12/2011 12:13'!
fileModel

	| separatedPath filename delimiter path |
	self filePath isEmpty ifTrue: [^ nil].
	delimiter := (FileDirectory default pathNameDelimiter).
	separatedPath := self filePath findTokens: delimiter.
	path := separatedPath allButLast.
	filename := separatedPath last.
	^ DLMAExternalFileModel new 
				location: path;
				filename: filename;
				filesize: self fileSize;
				yourself.! !

!DLDeliverable methodsFor: 'accessing' stamp: 'topa 4/28/2010 15:48'!
fileModel: aFileModel

	self 
		filePath: 
			((aFileModel location copyWith: aFileModel filename) 
			asStringSeparatedBy: FileDirectory default pathNameDelimiter asString);
		fileSize: aFileModel filesize;
		save;
		sendNotification: aFileModel filename.! !

!DLDeliverable methodsFor: 'accessing' stamp: 'sebh 6/14/2009 00:21'!
filePath

	^ filePath! !

!DLDeliverable methodsFor: 'accessing' stamp: 'sebh 6/14/2009 00:24'!
filePath: anObject

	filePath := anObject.! !

!DLDeliverable methodsFor: 'accessing' stamp: 'sebh 6/14/2009 01:36'!
fileSize

	^ fileSize! !

!DLDeliverable methodsFor: 'accessing' stamp: 'sebh 6/14/2009 01:37'!
fileSize: anObject

	fileSize := anObject.! !

!DLDeliverable methodsFor: 'accessing' stamp: 'Marik 6/10/2009 17:22'!
initialize 

	super initialize.
	self filePath: ''.! !

!DLDeliverable methodsFor: 'deprecated' stamp: 'topa 01/02/2012 14:18'!
sendNotification: aFilename
	| receivers mailNotification deadlineCompleted |
	(self delivery isComplete)
		ifTrue: [deadlineCompleted := 'Damit sind alle erforderlichen Dateien zu dieser Deadline eingereicht worden.']
		ifFalse: [deadlineCompleted := 'Ihnen fehlen noch einige Dateien, um diese Deadline zu vervollstndigen.'].
	receivers := OrderedCollection new.
	self delivery group students do: [:aStudent | receivers add: aStudent email].
	mailNotification := DLMail new.
	mailNotification
		receivers: receivers;
		subject: self delivery group groupName, ' - Eine Datei wurde hochgeladen';
		text: 'Liebes Gruppenmitglied von "',self delivery group groupName,'",

es wurde gerade die Datei ', aFilename,' hochgeladen.

Betreffende Deadline: ',self delivery deadline deadlineName,'
',deadlineCompleted,'

Mit freundlichen Gren 
Deli - dein Abgabesystem';
		sendMail.! !

!DLDeliverable methodsFor: 'saving' stamp: 'sebh 7/15/2009 16:46'!
trackChangeVariables
	^ {'filePath'.'fileSize'}! !

DLModel subclass: #DLDelivery
	instanceVariableNames: 'group deadline'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLDelivery class methodsFor: 'persistence-description' stamp: 'tfel 6/22/2010 12:33'!
getOrCreateFrom: anArray
 	| result |
	result := super getOrCreateFrom: anArray.
	result deadline requirements do: [:aRequirement |
		DLDeliverable getOrCreateFrom: {#delivery->result. #deliverableRequirement->aRequirement}.
		].
	^ result.! !

!DLDelivery class methodsFor: 'accessing' stamp: 'sebh 6/13/2009 22:31'!
metaName
	^ 'Abgabe'! !

!DLDelivery class methodsFor: 'accessing' stamp: 'sebh 7/3/2009 00:02'!
metaNamePlural
	^ 'Abgaben'! !

!DLDelivery class methodsFor: 'persistence-description' stamp: 'sebh 7/14/2009 00:21'!
rightCreate: aUser
	^ false! !

!DLDelivery class methodsFor: 'persistence-description' stamp: 'sebh 7/14/2009 00:22'!
rightDelete: aUser
	^ false! !

!DLDelivery class methodsFor: 'persistence-description' stamp: 'sebh 7/14/2009 00:22'!
rightUpdate: aUser
	^ false! !

!DLDelivery methodsFor: 'description' stamp: 'tfel 3/10/2010 14:59'!
additionalDescriptions
	^ {self descriptionGroup. self descriptionDeadline}! !

!DLDelivery methodsFor: 'accessing' stamp: 'Marik 7/1/2009 15:32'!
canonicalName
	^ self deadline canonicalName, ' ', self group canonicalName! !

!DLDelivery methodsFor: 'description' stamp: 'tfel 12/5/2009 13:47'!
collectDependentObjects
	| dependentDeliverables dependentParent |
	dependentParent := super collectDependentObjects.
	dependentDeliverables := DLDeliverable instances select: [:aDeliverable | aDeliverable delivery = self].
	^ dependentParent, dependentDeliverables! !

!DLDelivery methodsFor: 'description' stamp: 'tfel 6/22/2010 09:56'!
copyWithDependentObjects
	| newDelivery |
	newDelivery := self copy oid: nil; yourself.
	DLDeliverable instances 
		select: [:aDeliverable | aDeliverable delivery = self]
		thenDo: [:aDeliverable | aDeliverable copy oid: nil; delivery: newDelivery].
	^ newDelivery! !

!DLDelivery methodsFor: 'accessing' stamp: 'cr 6/6/2009 17:52'!
deadline

	^ deadline! !

!DLDelivery methodsFor: 'accessing' stamp: 'cr 6/6/2009 17:52'!
deadline: anObject

	deadline := anObject.! !

!DLDelivery methodsFor: 'description' stamp: 'tfel 12/5/2009 13:47'!
deliverables
	^ DLDeliverable instances select: [:aDeliverable | aDeliverable delivery = self]! !

!DLDelivery methodsFor: 'description' stamp: 'tfel 12/5/2009 15:28'!
descriptionDeadline
	^ MASingleOptionDescription new 
		accessor: #deadline;
		label: 'Deadline';
	   priority: 10;
		optionsAndLabels: (DLDeadline getKeyValueSelect: [:aDeadline | true]);
		beRequired;
		yourself.! !

!DLDelivery methodsFor: 'description' stamp: 'tfel 12/5/2009 15:29'!
descriptionGroup
	^ MASingleOptionDescription new
		accessor: #group;
		label: 'Gruppe';
		priority: 20;
		optionsAndLabels: (DLGroup getKeyValueSelect: [:aGroup | true]);
		beRequired;
		yourself.! !

!DLDelivery methodsFor: 'accessing' stamp: 'cr 6/6/2009 17:52'!
group

	^ group! !

!DLDelivery methodsFor: 'accessing' stamp: 'cr 6/6/2009 17:52'!
group: anObject

	group := anObject.! !

!DLDelivery methodsFor: 'accessing' stamp: 'sebh 7/14/2009 23:54'!
isComplete
	^ self deliverables allSatisfy: [:aDelivery | aDelivery filePath ~= ''].! !

DLModel subclass: #DLFileType
	instanceVariableNames: 'filetypeName extensions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLFileType class methodsFor: 'description' stamp: 'sebh 7/17/2009 20:39'!
descriptionExtensions
	^ MAMemoDescription new 
		accessor: #extensionsText; 
		label: 'Dateiendungen'; 
		priority: 20;
		comment: 'Eine komma-separierte Liste der Dateiendungen z.B. ".pdf,.ppt"';
		yourself.! !

!DLFileType class methodsFor: 'description' stamp: 'sebh 7/17/2009 20:40'!
descriptionFiletypeName
	^ MAStringDescription new 
		accessor: #filetypeName;
		label: 'Name'; 
		priority: 10;
		beRequired;
		yourself.! !

!DLFileType class methodsFor: 'persistence-description' stamp: 'sebh 7/3/2009 00:02'!
metaName
	^ 'Abgabetyp'! !

!DLFileType class methodsFor: 'persistence-description' stamp: 'sebh 7/3/2009 00:02'!
metaNamePlural
	^ 'Abgabetypen'! !

!DLFileType methodsFor: 'as yet unclassified' stamp: 'tfel 2/13/2010 17:16'!
<= anotherModel

	^ self filetypeName <= anotherModel filetypeName! !

!DLFileType methodsFor: 'accessing' stamp: 'Marik 7/12/2009 14:43'!
canonicalName
	^ self filetypeName,' <',self extensionsText,'>'! !

!DLFileType methodsFor: 'accessing' stamp: 'sebh 6/8/2009 00:44'!
extensions

	^ extensions! !

!DLFileType methodsFor: 'accessing' stamp: 'sebh 6/8/2009 00:44'!
extensions: anObject

	extensions := anObject.! !

!DLFileType methodsFor: 'accessing' stamp: 'topa 4/28/2010 15:36'!
extensionsText

	^ self extensions asStringSeparatedBy: ', '! !

!DLFileType methodsFor: 'accessing' stamp: 'TimFelgentreff 01/12/2011 03:18'!
extensionsText: aText
	"Converts the comma-separated string into an OrderedCollection and checks whether the extension starts with a dot."
	aText = nil ifFalse: [
		^ self extensions: (((aText 
			reject: [:char | char = $ .]) 
				findTokens: ',') 
					select: [:each | each first = $.]) asOrderedCollection ].
	aText = nil ifTrue: [
		^ self extensions: OrderedCollection new
	]! !

!DLFileType methodsFor: 'accessing' stamp: 'topa 12/22/2009 19:50'!
filetypeName

	"filetypeName ifNil: [filetypeName := '']."
	^ filetypeName! !

!DLFileType methodsFor: 'accessing' stamp: 'sebh 6/8/2009 00:43'!
filetypeName: anObject

	filetypeName := anObject.! !

!DLFileType methodsFor: 'accessing' stamp: 'sebh 6/8/2009 00:45'!
initialize

	super initialize.
	self extensions: OrderedCollection new.! !

DLModel subclass: #DLGroup
	instanceVariableNames: 'groupName groupDescription lecture students groupNumber'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLGroup class methodsFor: 'persistence-description' stamp: 'sebh 7/17/2009 20:43'!
descriptionGroupDescription
	^ MAStringDescription new
		accessor: #groupDescription; 
		label: 'Beschreibung';
		priority: 20;
		beRequired;
		yourself.! !

!DLGroup class methodsFor: 'persistence-description' stamp: 'tfel 10/18/2010 17:23'!
descriptionGroupName
	^ MAStringDescription new
		accessor: #groupName; 
		label: 'Gruppenname';
		priority: 10;
		beReadonly;
		yourself.! !

!DLGroup class methodsFor: 'persistence-description' stamp: 'sebh 7/17/2009 20:43'!
descriptionGroupNumber
	^ MAStringDescription new
		accessor: #groupNumber; 
		label: 'Gruppennummer';
		priority: 15;
		beReadonly;
		yourself.! !

!DLGroup class methodsFor: 'persistence-description' stamp: 'MG 7/24/2009 17:36'!
descriptionMail
	^ DLMAMailDescription new
		accessor: #mail;
		label: '';
		priority: 100;
		reportColumnClass: DLMAMailLinkColumn;
		componentClass: DLMALinkComponent;
		yourself! !

!DLGroup class methodsFor: 'persistence-description' stamp: 'sebh 6/6/2009 23:34'!
metaName
	^ 'Gruppe'! !

!DLGroup class methodsFor: 'persistence-description' stamp: 'sebh 7/3/2009 00:02'!
metaNamePlural
	^ 'Gruppen'! !

!DLGroup methodsFor: 'as yet unclassified' stamp: 'tfel 1/9/2011 20:05'!
< anotherGroup

	^ self lecture < anotherGroup lecture or: [
		self lecture = anotherGroup lecture and: [
			self asNumber < anotherGroup asNumber]]! !

!DLGroup methodsFor: 'description' stamp: 'tfel 3/10/2010 14:59'!
additionalDescriptions
	^ {self descriptionStudents. self descriptionLecture}! !

!DLGroup methodsFor: 'saving' stamp: 'sebh 7/14/2009 23:47'!
addStudent: aUser
	self students addIfNotPresent: aUser.
	self save.! !

!DLGroup methodsFor: 'accessing' stamp: 'tfel 10/26/2010 09:40'!
asNumber

	^ (self groupNumber copyReplaceAll: 'group' with: '') asNumber! !

!DLGroup methodsFor: 'accessing' stamp: 'topa 4/30/2010 14:02'!
canonicalName
	^ self groupNumber! !

!DLGroup methodsFor: 'description' stamp: 'tfel 12/5/2009 13:49'!
collectDependentObjects
	| dependentDeadlines dependentDeliveries dependentParent |
	dependentParent := super collectDependentObjects.
	dependentDeadlines := DLDeadline instances select: [:aDeadline | aDeadline group = self].
	dependentDeliveries:= DLDelivery instances select: [:aDelivery | aDelivery group = self].
	^ dependentParent, dependentDeadlines, dependentDeliveries! !

!DLGroup methodsFor: 'saving' stamp: 'tfel 10/18/2010 17:22'!
createGroupName

	self groupNumber ifNil: [self createGroupNumber].
	self groupName: self groupNumber.! !

!DLGroup methodsFor: 'saving' stamp: 'tfel 10/26/2010 09:41'!
createGroupNumber

	(self groupNumber isNil) 
		ifTrue: [| groups number result | 
			groups := DLGroup instances select: [:aGroup | aGroup lecture = self lecture].
			number := groups size + 1.					
			self setGroupByNumber: number ]! !

!DLGroup methodsFor: 'saving' stamp: 'tfel 10/26/2010 09:49'!
delete

	super delete.
	self lecture groups
		select: [:g | g asNumber > self asNumber]
		thenDo: [:g | g setGroupByNumber: g asNumber - 1].
	self smalltalkDependentSaveStrategy.! !

!DLGroup methodsFor: 'description' stamp: 'tfel 10/18/2010 17:23'!
description
 ^ super description select: [:each | #(students lecture mail) includes: each accessor selector]! !

!DLGroup methodsFor: 'description' stamp: 'tfel 10/18/2010 17:22'!
descriptionCreate
 ^ super description select: [:each | #(lecture groupDescription) includes: each accessor selector]! !

!DLGroup methodsFor: 'description' stamp: 'tfel 10/18/2010 17:23'!
descriptionDetail
 ^ super description select: [:each | #(students lecture groupNumber) includes: each accessor selector]! !

!DLGroup methodsFor: 'description' stamp: 'tfel 12/5/2009 15:29'!
descriptionLecture
	^ MASingleOptionDescription new
		accessor: #lecture;
		label: 'Vorlesung';
		priority: 15;
		optionsAndLabels: (DLLecture getKeyValueSelect: [:aLecture | true]);
		beRequired;
		yourself.! !

!DLGroup methodsFor: 'description' stamp: 'tfel 10/18/2010 17:27'!
descriptionList
 ^ super description select: [:each | #(students lecture mail groupNumber) includes: each accessor selector]! !

!DLGroup methodsFor: 'description' stamp: 'tfel 10/18/2010 17:30'!
descriptionStudents
	^ MAMultipleOptionDescription new
		accessor: #students;
		label: 'Studenten';
		priority: 30;
		optionsAndLabels: (DLUser getKeyValueSelect: [:aUser | true]);
		componentClass: MACheckboxGroupComponent;
		yourself.! !

!DLGroup methodsFor: 'description' stamp: 'tfel 10/18/2010 17:22'!
descriptionUpdate
 ^ super description select: [:each | #(students lecture groupDescription) includes: each accessor selector]! !

!DLGroup methodsFor: 'accessing' stamp: 'sebh 5/27/2009 16:27'!
groupDescription

	^ groupDescription! !

!DLGroup methodsFor: 'accessing' stamp: 'sebh 5/27/2009 16:27'!
groupDescription: anObject

	groupDescription := anObject.! !

!DLGroup methodsFor: 'accessing' stamp: 'sebh 5/20/2009 20:54'!
groupName

	^ groupName! !

!DLGroup methodsFor: 'accessing' stamp: 'Marik 7/14/2009 15:53'!
groupName: anObject

	groupName := anObject.! !

!DLGroup methodsFor: 'accessing' stamp: 'Marik 7/14/2009 15:10'!
groupNumber

	^ groupNumber! !

!DLGroup methodsFor: 'accessing' stamp: 'topa 10/28/2009 22:14'!
groupNumber: anObject

	groupNumber := anObject! !

!DLGroup methodsFor: 'accessing' stamp: 'cr 6/6/2009 17:32'!
initialize
	super initialize.
	self students: OrderedCollection new.! !

!DLGroup methodsFor: 'accessing' stamp: 'sebh 5/26/2009 11:19'!
lecture

	^ lecture! !

!DLGroup methodsFor: 'accessing' stamp: 'tfel 10/18/2010 17:20'!
lecture: anObject

	lecture := anObject.
	self createGroupNumber.
	self createGroupName.! !

!DLGroup methodsFor: 'accessing' stamp: 'topa 4/28/2010 15:36'!
mail

	| linkCollection |
	linkCollection := OrderedCollection new.
	self students do:[:each| linkCollection add: (each email)].
	linkCollection isEmpty
		ifTrue: [^nil]
		ifFalse:[^ 'mailto:',(linkCollection asStringSeparatedBy: ',').].! !

!DLGroup methodsFor: 'saving' stamp: 'sebh 7/14/2009 23:51'!
removeStudent: aUser
	self students remove: aUser ifAbsent: ["User is not present anymore, let's not bother with details"].
	self save.! !

!DLGroup methodsFor: 'accessing' stamp: 'TimFelgentreff 01/12/2011 03:15'!
setGroupByNumber: number
	| num |
	num := number printString.
	[num size < 3] whileTrue: [ num := '0', num ].
	groupNumber := 'group', num.! !

!DLGroup methodsFor: 'accessing' stamp: 'cr 6/6/2009 17:23'!
students
	^ students! !

!DLGroup methodsFor: 'accessing' stamp: 'cr 6/6/2009 17:31'!
students: anObject

	students := anObject.! !

!DLGroup methodsFor: 'saving' stamp: 'sebh 7/15/2009 16:44'!
trackChangeVariables
	^ {'groupName'.'groupDescription'.'lecture'.'students'.'groupNumber'}! !

DLModel subclass: #DLLecture
	instanceVariableNames: 'lectureName lectureHomepage mailingList semester teacher assistants studentAssistants students visible groupSize groupingPhase topicPhase'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLLecture class methodsFor: 'as yet unclassified' stamp: 'martin 7/15/2009 22:46'!
createLectureName: aLectureName semester: aSemester
		^ self new
		lectureName: aLectureName;
		semester: aSemester;
		save;
		yourself.! !

!DLLecture class methodsFor: 'description' stamp: 'sebh 7/17/2009 20:26'!
descriptionGroupSize
	^ MANumberDescription new
		accessor: #groupSize; 
		label: 'Gruppengre'; 
		priority: 70;
		comment: 'Maximale Gruppengre';
		yourself.! !

!DLLecture class methodsFor: 'description' stamp: 'MG 7/18/2009 17:50'!
descriptionLectureHomepage
	^ MAStringDescription new
		accessor: #prepareLectureHomepage; 
		label: 'Webseite'; 
		priority: 25;
		reportColumnClass: DLMALinkColumn;
		componentClass: DLMALinkComponent;
		yourself.! !

!DLLecture class methodsFor: 'description' stamp: 'sebh 7/17/2009 20:26'!
descriptionLectureName
	^ MAStringDescription new
		accessor: #lectureName; 
		label: 'Lehrveranstaltung'; 
		priority: 10;
		beRequired;
		yourself.! !

!DLLecture class methodsFor: 'description' stamp: 'MG 7/24/2009 17:34'!
descriptionMailingList
	^ MAStringDescription new 
		accessor: #mailingList; 
		label: 'E-Mail Verteiler';
		priority: 27;
		reportColumnClass: DLMALinkColumn;
		componentClass: DLMAMailLinkComponent;
		yourself.! !

!DLLecture class methodsFor: 'description' stamp: 'sebh 7/17/2009 20:28'!
descriptionVisible
	^ MABooleanDescription new 
		accessor: #visible; 
		label: 'Sichtbar'; 
		priority: 70;
		checkboxLabel: '';
		default: true;
		trueString: 'Sichtbar';
		falseString:'Nicht sichtbar';
		yourself.! !

!DLLecture class methodsFor: 'as yet unclassified' stamp: 'tfel 11/3/2010 11:49'!
getOrCreateLectureName: aLectureName semester: aSemester

	| lecture |
	lecture := self instances detect: [:aLecture | 
		(aLecture lectureName = aLectureName) & (aLecture semester = aSemester)]
	                                 ifNone: [nil].
	lecture ifNotNil: [ ^ lecture ].
	^ self createLectureName: aLectureName semester: aSemester.! !

!DLLecture class methodsFor: 'as yet unclassified' stamp: 'tfel 12/5/2009 13:50'!
getOrCreateUserName: aLectureName semester: aSemester

	| lecture |
	lecture := self instances detect: [:aLecture | 
		(aLecture lectureName = aLectureName) & (aLecture semester = aSemester)]
	                                 ifNone: [nil].
	lecture ifNotNil: [ ^ lecture ].
	^ self createLectureName: aLectureName semester: aSemester.! !

!DLLecture class methodsFor: 'accessing' stamp: 'sebh 7/3/2009 00:03'!
metaName
	^ 'Lehrveranstaltung'! !

!DLLecture class methodsFor: 'accessing' stamp: 'sebh 7/3/2009 00:03'!
metaNamePlural
	^ 'Lehrveranstaltungen'! !

!DLLecture methodsFor: 'as yet unclassified' stamp: 'tfel 1/9/2011 20:06'!
< anotherLecture
	"Sort lectures with a higher semester first"
	^ (anotherLecture semester < self semester) or: [
		self semester = anotherLecture semester and: [
			self canonicalName < anotherLecture canonicalName]]! !

!DLLecture methodsFor: 'description' stamp: 'MG 7/18/2009 11:53'!
additionalDescriptions
	^ {
		self descriptionAssistants.
		self descriptionSemester.
		self descriptionStudents.
		self descriptionStudentAssistants.
		self descriptionTeacher.
		self descriptionGroupingPhase.
		self descriptionTopicPhase.
		self descriptionMail.
	}! !

!DLLecture methodsFor: 'saving' stamp: 'sebh 6/20/2009 23:04'!
addStudent: aUser
	self students addIfNotPresent: aUser.
	self save.! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/3/2009 18:08'!
assistants

	^ assistants! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 7/15/2009 16:48'!
assistants: anObject
	self genericCollectionAccessor: 'assistants' withArgument: anObject! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/3/2009 19:13'!
canonicalName
	^ self lectureName, ' ', self semester canonicalName! !

!DLLecture methodsFor: 'description' stamp: 'tfel 12/5/2009 13:51'!
collectDependentObjects
	| dependentDeadlines dependentGroups dependentTopics dependentParent |
	dependentParent    := super collectDependentObjects.
	dependentDeadlines := DLDeadline instances select: [:aDeadline | aDeadline lecture = self].
	dependentGroups 	 := DLGroup instances select: [:aGroup 	 | aGroup 	 lecture = self].
	dependentTopics 	 := DLTopic instances select: [:aTopic 	 | aTopic 	 lecture = self].
	^ dependentParent, dependentDeadlines, dependentGroups, dependentTopics.! !

!DLLecture methodsFor: 'description' stamp: 'sebh 7/17/2009 20:31'!
descriptionAssistants
	^ MAMultipleOptionDescription new
		accessor: #assistants;
		label: 'Assistent'; 
		priority: 35;
		optionsAndLabels: (DLUser getKeyValueSelect: [:aUser | aUser isAssistant]);
		componentClass: MACheckboxGroupComponent;
		yourself.! !

!DLLecture methodsFor: 'description' stamp: 'MG 7/17/2009 19:18'!
descriptionCreate
 ^ self description select: [:each | #(lectureName semester prepareLectureHomepage mailingList teacher assistants studentAssistants visible groupingPhase topicPhase groupSize) includes: each accessor selector]! !

!DLLecture methodsFor: 'description' stamp: 'MG 7/18/2009 17:43'!
descriptionDetail

 ^ self description select: [:each | #(lectureName semester prepareLectureHomepage mailingList teacher assistants studentAssistants visible groupingPhase topicPhase groupSize) includes: each accessor selector]! !

!DLLecture methodsFor: 'description' stamp: 'sebh 7/17/2009 20:29'!
descriptionGroupingPhase
	^ MADateDescription new 
		accessor: #groupingPhase; 
		label: 'Gruppenwahl bis';
		priority: 80;
		default: (Date today);
		beRequired;
		comment: 'Ist dieses Datum noch nicht erreicht, knnen Studenten neue Gruppen erstellen, beitreten oder verlassen.';
		yourself.! !

!DLLecture methodsFor: 'description' stamp: 'MG 7/18/2009 17:43'!
descriptionList
 ^ self description select: [:each | #(lectureName prepareLectureHomepage mail teacher semester) includes: each accessor selector]! !

!DLLecture methodsFor: 'description' stamp: 'MG 7/24/2009 17:36'!
descriptionMail
	^ DLMAMailDescription new
		accessor: #mail;
		label: '';
		priority: 140;
		reportColumnClass: DLMAMailLinkColumn;
		componentClass: DLMALinkComponent;
		yourself! !

!DLLecture methodsFor: 'description' stamp: 'sebh 7/17/2009 20:30'!
descriptionSemester
	^ MASingleOptionDescription new
		accessor: #semester; 
		label: 'Semester'; 
		priority: 50;
		optionsAndLabels: (DLSemester getKeyValueSelect: [:aSemester | aSemester year >= Date today year]);
		beRequired;
		reference: MAStringDescription new;
		yourself.! !

!DLLecture methodsFor: 'description' stamp: 'sebh 7/17/2009 20:30'!
descriptionStudentAssistants
	^ MAMultipleOptionDescription new
		accessor: #studentAssistants;
	 	label: 'Studentische Assistenten';
		priority: 40;
		componentClass: MACheckboxGroupComponent;
		optionsAndLabels: (DLUser getKeyValueSelect: [:aUser | aUser isStudentAssistant ]);
		yourself.! !

!DLLecture methodsFor: 'description' stamp: 'tfel 12/5/2009 15:29'!
descriptionStudents
	^ MAMultipleOptionDescription new
		accessor: #students;
		label: 'Studenten';
		priority: 60;
		optionsAndLabels: (DLUser getKeyValueSelect: [:aUser | true]);
		yourself.! !

!DLLecture methodsFor: 'description' stamp: 'sebh 7/17/2009 20:30'!
descriptionTeacher
	^ MASingleOptionDescription new
		accessor: #teacher; 
		label: 'Dozent'; 
		priority: 30;
		optionsAndLabels: (DLUser getKeyValueSelect: [:aUser | aUser isTeacher]);
		beRequired;
		yourself.! !

!DLLecture methodsFor: 'description' stamp: 'sebh 7/17/2009 20:32'!
descriptionTopicPhase
	^ MADateDescription new
		accessor: #topicPhase; 
		label: 'Themenwahl bis'; 
		priority: 90;
		default: (Date today);
		beRequired;
		comment: 'Ist dieses Datum noch nicht erreicht, knnen Studenten Themen whlen und auch abwhlen.';
		yourself.! !

!DLLecture methodsFor: 'description' stamp: 'Marik 7/13/2009 16:23'!
descriptionUpdate
 ^ self descriptionCreate! !

!DLLecture methodsFor: 'accessing' stamp: 'cr 7/8/2009 15:37'!
groupingPhase

	^groupingPhase! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/20/2009 22:26'!
groupingPhase: anObject

	groupingPhase := anObject.! !

!DLLecture methodsFor: 'accessing' stamp: 'caro 7/24/2009 17:17'!
groupingPhaseActive
"returns true if groupingPhase is active"
	self groupingPhase ifNotNilDo: [:aGroupingPhase | ^ (aGroupingPhase  > (DateAndTime now))] ifNil: [^ true]! !

!DLLecture methodsFor: 'as yet unclassified' stamp: 'topa 4/27/2010 13:38'!
groups

	^ DLGroup instances select: [:group | group lecture == self]! !

!DLLecture methodsFor: 'accessing' stamp: 'cr 5/31/2009 16:02'!
groupSize

	^ groupSize! !

!DLLecture methodsFor: 'accessing' stamp: 'cr 5/31/2009 16:02'!
groupSize: anObject

	groupSize := anObject.! !

!DLLecture methodsFor: 'accessing' stamp: 'Marik 7/14/2009 17:09'!
initialize
	super initialize.
	self assistants: OrderedCollection new;
		  students: OrderedCollection new;
		  studentAssistants: OrderedCollection new.
	self visible: true.! !

!DLLecture methodsFor: 'accessing' stamp: 'Marik 7/9/2009 13:59'!
lectureHomepage

	^ lectureHomepage! !

!DLLecture methodsFor: 'accessing' stamp: 'Marik 7/9/2009 13:59'!
lectureHomepage: anObject

	lectureHomepage := anObject.! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 5/20/2009 16:23'!
lectureName

	^ lectureName! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 5/20/2009 16:23'!
lectureName: anObject

	lectureName := anObject.! !

!DLLecture methodsFor: 'accessing' stamp: 'MG 7/18/2009 11:30'!
mail

	self mailingList isNil
		ifTrue: [^ nil]
		ifFalse: [^'mailto:', self mailingList].! !

!DLLecture methodsFor: 'accessing' stamp: 'Marik 7/13/2009 16:13'!
mailingList

	^ mailingList! !

!DLLecture methodsFor: 'accessing' stamp: 'Marik 7/13/2009 16:13'!
mailingList: anObject

	mailingList := anObject.! !

!DLLecture methodsFor: 'accessing' stamp: 'MG 7/17/2009 19:24'!
prepareLectureHomepage
	^ self lectureHomepage! !

!DLLecture methodsFor: 'accessing' stamp: 'topa 2/6/2012 17:34'!
prepareLectureHomepage: aString

	aString ifNotNil:[
		(aString beginsWith: 'http://')
			ifTrue: [self lectureHomepage: aString]
			ifFalse: [self lectureHomepage: 'http://',aString]]! !

!DLLecture methodsFor: 'saving' stamp: 'sebh 6/20/2009 23:08'!
removeStudent: aUser
	self students remove: aUser ifAbsent: ["Somehow the user was removed. Result is the same."].
	self save.! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 5/20/2009 16:23'!
semester

	^ semester! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 5/20/2009 16:23'!
semester: anObject

	semester := anObject.! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/9/2009 14:00'!
studentAssistants

	^ studentAssistants! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 7/15/2009 16:47'!
studentAssistants: anObject
	self genericCollectionAccessor: 'studentAssistants' withArgument: anObject! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:18'!
students

	^ students! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:18'!
students: anObject

	students := anObject.! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/3/2009 18:08'!
teacher

	^ teacher! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/3/2009 18:08'!
teacher: anObject

	teacher := anObject.! !

!DLLecture methodsFor: 'accessing' stamp: 'cr 7/8/2009 15:47'!
topicPhase

	^ topicPhase! !

!DLLecture methodsFor: 'accessing' stamp: 'caro 6/28/2009 16:39'!
topicPhase: anObject

	topicPhase := anObject.! !

!DLLecture methodsFor: 'accessing' stamp: 'topa 4/20/2010 10:01'!
topicPhaseActive
"returns true if topicPhase is active"
	^ self topicPhase ifNotNilDo: [:aTopicPhase | ^ aTopicPhase > (DateAndTime now)] ifNil: [^ true].! !

!DLLecture methodsFor: 'as yet unclassified' stamp: 'topa 4/26/2010 20:13'!
topics

	^ DLTopic instances select: [:topic | topic lecture == self]! !

!DLLecture methodsFor: 'saving' stamp: 'martin 7/15/2009 23:18'!
trackChangeVariables
	^ {'lectureName'.
	'lectureHomepage'.
	'mailingList'.
	'semester'.
	'teacher'.
	'assistants'.
	'studentAssistants'.
	'visible'.
	'groupSize'.
	'groupingPhase'.
	'topicPhase'}! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:18'!
visible

	^ visible! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:18'!
visible: anObject

	visible := anObject.! !

DLModel subclass: #DLLogEntry
	instanceVariableNames: 'klassName objectId objectCanonicalName activity changes user created'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLLogEntry class methodsFor: 'persistence-description' stamp: 'sebh 7/17/2009 20:46'!
descriptionChanges
	^ MAStringDescription new
		accessor: #changes;
		label: 'Vernderungen';
		priority: 10;
		reportColumnClass: DLMAChangesColumn;
		yourself.! !

!DLLogEntry class methodsFor: 'persistence-description' stamp: 'sebh 7/17/2009 20:46'!
descriptionCreated
	^ MATimeStampDescription new 
		accessor: #created;
		label: 'Erzeugt';
		priority: 10.! !

!DLLogEntry class methodsFor: 'persistence-description' stamp: 'sebh 7/17/2009 20:47'!
descriptionUser
	^ MAToOneRelationDescription new 
		accessor: #user; 
		label: 'Benutzer'; 
		priority: 20;
		classes: {DLUser};
		undefined: 'System';
		yourself.! !

!DLLogEntry class methodsFor: 'persistence-description' stamp: 'sebh 7/12/2009 03:16'!
metaName
	^ 'Logbucheintrag'! !

!DLLogEntry class methodsFor: 'persistence-description' stamp: 'sebh 7/12/2009 03:17'!
metaNamePlural
	^ 'Logbucheintrge'! !

!DLLogEntry class methodsFor: 'persistence-description' stamp: 'sebh 6/30/2009 22:15'!
rightCreate: aUser
	^ false! !

!DLLogEntry class methodsFor: 'persistence-description' stamp: 'sebh 6/30/2009 22:16'!
rightDelete: aUser
	^ false! !

!DLLogEntry class methodsFor: 'persistence-description' stamp: 'sebh 6/30/2009 22:16'!
rightDetail: aUser
	^ false! !

!DLLogEntry class methodsFor: 'persistence-description' stamp: 'sebh 6/30/2009 22:20'!
rightUpdate: aUser
	^ false.! !

!DLLogEntry methodsFor: 'accessing' stamp: 'sebh 7/24/2009 15:22'!
activity

	^ activity! !

!DLLogEntry methodsFor: 'accessing' stamp: 'sebh 7/24/2009 15:22'!
activity: anObject

	activity := anObject.! !

!DLLogEntry methodsFor: 'accessing' stamp: 'sebh 7/19/2009 23:20'!
canonicalName
	^ self klassName,' ',self objectId asString.! !

!DLLogEntry methodsFor: 'accessing' stamp: 'sebh 7/11/2009 13:29'!
changes

	^ changes! !

!DLLogEntry methodsFor: 'accessing' stamp: 'sebh 7/11/2009 13:29'!
changes: anObject

	changes := anObject.! !

!DLLogEntry methodsFor: 'description' stamp: 'tfel 12/5/2009 13:52'!
collectDependentObjects
	| dependentLogEntryChanges dependentNotifications dependentParent |
	dependentParent    := super collectDependentObjects.
	dependentLogEntryChanges := self changes.
	dependentNotifications := DLNotification instances select: [:aNotification | aNotification logEntry = self].
	^ dependentParent, dependentLogEntryChanges, dependentNotifications.! !

!DLLogEntry methodsFor: 'accessing' stamp: 'sebh 6/30/2009 22:21'!
created

	^ created! !

!DLLogEntry methodsFor: 'accessing' stamp: 'sebh 6/30/2009 22:21'!
created: anObject

	created := anObject.! !

!DLLogEntry methodsFor: 'accessing' stamp: 'sebh 7/11/2009 13:27'!
initialize
	super initialize.
	self created: DateAndTime now.
	self changes: OrderedCollection new.! !

!DLLogEntry methodsFor: 'accessing' stamp: 'sebh 7/12/2009 02:49'!
klass
	^ Smalltalk classNamed: self klassName.! !

!DLLogEntry methodsFor: 'accessing' stamp: 'sebh 7/12/2009 02:48'!
klassName

	^ klassName! !

!DLLogEntry methodsFor: 'accessing' stamp: 'sebh 7/12/2009 02:48'!
klassName: anObject

	klassName := anObject.! !

!DLLogEntry methodsFor: 'accessing' stamp: 'tfel 12/5/2009 13:52'!
object
	^ ((Smalltalk classNamed: self klassName) instances) detect: [:anObject | anObject oid = self objectId].! !

!DLLogEntry methodsFor: 'accessing' stamp: 'sebh 7/24/2009 15:51'!
objectCanonicalName

	^ objectCanonicalName! !

!DLLogEntry methodsFor: 'accessing' stamp: 'sebh 7/24/2009 15:51'!
objectCanonicalName: anObject

	objectCanonicalName := anObject.! !

!DLLogEntry methodsFor: 'accessing' stamp: 'sebh 6/30/2009 14:13'!
objectId

	^ objectId! !

!DLLogEntry methodsFor: 'accessing' stamp: 'sebh 6/30/2009 14:13'!
objectId: anObject

	objectId := anObject.! !

!DLLogEntry methodsFor: 'permission' stamp: 'sebh 6/30/2009 22:17'!
rightUpdate: aUser
	^ false.! !

!DLLogEntry methodsFor: 'saving' stamp: 'sebh 7/1/2009 00:44'!
trackChangeVariables
	"DON'T even think about it"
	^ {}! !

!DLLogEntry methodsFor: 'accessing' stamp: 'sebh 6/30/2009 22:43'!
user

	^ user! !

!DLLogEntry methodsFor: 'accessing' stamp: 'sebh 6/30/2009 22:43'!
user: anObject

	user := anObject.! !

DLModel subclass: #DLLogEntryChange
	instanceVariableNames: 'attributeName activity attributeValue objectCanonicalName klassName objectId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLLogEntryChange class methodsFor: 'persistence-description' stamp: 'sebh 7/12/2009 03:16'!
metaName
	^ 'nderung'! !

!DLLogEntryChange class methodsFor: 'persistence-description' stamp: 'sebh 7/12/2009 03:16'!
metaNamePlural
	^ 'nderungen'! !

!DLLogEntryChange class methodsFor: 'persistence-description' stamp: 'sebh 7/14/2009 00:30'!
rightCreate: aUser
	^ false! !

!DLLogEntryChange class methodsFor: 'persistence-description' stamp: 'sebh 7/14/2009 00:30'!
rightDelete: aUser
	^ false! !

!DLLogEntryChange class methodsFor: 'persistence-description' stamp: 'sebh 7/14/2009 00:30'!
rightUpdate: aUser
	^ false! !

!DLLogEntryChange methodsFor: 'accessing' stamp: 'sebh 7/12/2009 01:35'!
activity

	^ activity! !

!DLLogEntryChange methodsFor: 'accessing' stamp: 'sebh 7/12/2009 01:35'!
activity: anObject

	activity := anObject.! !

!DLLogEntryChange methodsFor: 'accessing' stamp: 'sebh 7/11/2009 14:30'!
attributeName

	^ attributeName! !

!DLLogEntryChange methodsFor: 'accessing' stamp: 'sebh 7/11/2009 14:30'!
attributeName: anObject

	attributeName := anObject.! !

!DLLogEntryChange methodsFor: 'accessing' stamp: 'sebh 7/11/2009 14:30'!
attributeValue

	^ attributeValue! !

!DLLogEntryChange methodsFor: 'accessing' stamp: 'sebh 7/11/2009 14:30'!
attributeValue: anObject

	attributeValue := anObject.! !

!DLLogEntryChange methodsFor: 'accessing' stamp: 'sebh 7/19/2009 23:20'!
canonicalName
	^ self attributeName,' ',self activity asString,' ',self attributeValue.! !

!DLLogEntryChange methodsFor: 'accessing' stamp: 'sebh 7/19/2009 16:41'!
klass
	^ Smalltalk classNamed: self klassName.! !

!DLLogEntryChange methodsFor: 'accessing' stamp: 'sebh 7/12/2009 02:48'!
klassName

	^ klassName! !

!DLLogEntryChange methodsFor: 'accessing' stamp: 'sebh 7/12/2009 02:48'!
klassName: anObject

	klassName := anObject.! !

!DLLogEntryChange methodsFor: 'accessing' stamp: 'tfel 12/5/2009 13:53'!
object
 ^ (Smalltalk classNamed: self klassName) instances detect: [:anObject | anObject oid = self objectId].! !

!DLLogEntryChange methodsFor: 'accessing' stamp: 'sebh 7/24/2009 16:03'!
objectCanonicalName

	^ objectCanonicalName! !

!DLLogEntryChange methodsFor: 'accessing' stamp: 'sebh 7/24/2009 16:03'!
objectCanonicalName: anObject

	objectCanonicalName := anObject.! !

!DLLogEntryChange methodsFor: 'accessing' stamp: 'sebh 7/11/2009 13:29'!
objectId

	^ objectId! !

!DLLogEntryChange methodsFor: 'accessing' stamp: 'sebh 7/11/2009 13:30'!
objectId: anObject

	objectId := anObject.! !

DLModel subclass: #DLMail
	instanceVariableNames: 'subject text sender receivers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLMail class methodsFor: 'default' stamp: 'topa 01/02/2012 14:17'!
defaultSender
	
	^ WAEmailAddress 
		address: 'tim.felgentreff@student.hpi.uni-potsdam.de'
		username: 'Deli Abgabesystem'! !

!DLMail class methodsFor: 'description' stamp: 'sebh 7/17/2009 20:50'!
descriptionReceivers
	^ MAStringDescription new accessor: #receivers;
		label: 'Empfnger';
		priority: 10;
		beRequired;
		yourself.! !

!DLMail class methodsFor: 'description' stamp: 'sebh 7/17/2009 20:51'!
descriptionSender
	^ MAStringDescription new 
		accessor: #sender;
		label: 'Absender';
		priority: 20;
		beRequired;
		yourself.! !

!DLMail class methodsFor: 'description' stamp: 'sebh 7/17/2009 20:52'!
descriptionSubject
	^ MAStringDescription new 
		accessor: #subject;
		label: 'Betreff';
		priority: 30;
		beRequired;
		yourself.! !

!DLMail class methodsFor: 'description' stamp: 'sebh 7/17/2009 20:52'!
descriptionText
	^ MAStringDescription new 
		accessor: #text;
		label: 'Text';
		priority: 40;
		beRequired;
		yourself.! !

!DLMail class methodsFor: 'accessing' stamp: 'sebh 7/11/2009 10:35'!
metaName
	^ 'Mail'! !

!DLMail class methodsFor: 'accessing' stamp: 'sebh 7/11/2009 10:35'!
metaNamePlural
	^ 'Mails'! !

!DLMail methodsFor: 'accessing' stamp: 'topa 01/02/2012 14:13'!
initialize
	super initialize.
	
	self sender: self class defaultSender.! !

!DLMail methodsFor: 'accessing' stamp: 'topa 4/28/2010 15:37'!
receivers

	^ receivers! !

!DLMail methodsFor: 'accessing' stamp: 'topa 01/02/2012 14:16'!
receivers: someReceivers
	
	(someReceivers anySatisfy: [:r | (r isKindOf: WAEmailAddress) not])
		ifTrue: [receivers := someReceivers collect: [:recv | WAEmailAddress address: recv]]
		ifFalse: [receivers := someReceivers]! !

!DLMail methodsFor: 'accessing' stamp: 'topa 4/28/2010 15:44'!
receiversFromString: someReceivers
	
	self receivers: (someReceivers tokensBasedOn: $,) asOrderedCollection.! !

!DLMail methodsFor: 'accessing' stamp: 'topa 4/28/2010 15:37'!
receiversString

	^ self receivers asStringSeparatedBy: $, asString! !

!DLMail methodsFor: 'accessing' stamp: 'Marik 6/29/2009 14:18'!
sender

	^ sender! !

!DLMail methodsFor: 'accessing' stamp: 'topa 01/02/2012 14:18'!
sender: anObject

	(anObject isKindOf: WAEmailAddress)
		ifTrue: [sender := anObject]
		ifFalse: [sender := (WAEmailAddress address: anObject)]! !

!DLMail methodsFor: 'mailing' stamp: 'esec 1/9/2012 10:28'!
sendMail
	
	"self receivers ifNotNilDo: [:recvs | | message |
		message := WAEmailMessage 
			from: self sender
			toAll: recvs
			subject: self subject.
		message headerAt: 'Content-Type' put: 'text/html;charset=UTF-8'.
		message body: self text.
		message send]."! !

!DLMail methodsFor: 'accessing' stamp: 'Marik 6/29/2009 14:18'!
subject

	^ subject! !

!DLMail methodsFor: 'accessing' stamp: 'Marik 6/29/2009 14:18'!
subject: anObject

	subject := anObject.! !

!DLMail methodsFor: 'accessing' stamp: 'Marik 6/29/2009 14:19'!
text

	^ text! !

!DLMail methodsFor: 'accessing' stamp: 'Marik 6/29/2009 14:19'!
text: anObject

	text := anObject.! !

!DLModel class methodsFor: 'save' stamp: 'tfel 12/22/2009 17:47'!
createFrom: anArray
	"Create an object with the values given in anArray and use the standard getters/setters so nondefault get/set behaviour works"
	^ (self newFrom: anArray) 
			save;
			yourself! !

!DLModel class methodsFor: 'magritte' stamp: 'sebh 6/8/2009 00:22'!
descriptionContainer
	^ super descriptionContainer
		componentRenderer: DLCssRenderer;
		yourself! !

!DLModel class methodsFor: 'save' stamp: 'tfel 12/5/2009 15:08'!
getFrom: anAttributeArray 
	| keys values objects |
	keys := anAttributeArray collect: [ :anAttribute | anAttribute key ].
	values := anAttributeArray collect: [ :anAttribute | anAttribute value ].
	"We only contain objects that defined all their values"
	(values includes: nil) ifTrue: 
		[ DLNilValueException new
			messageText: 'A given value was nil';
			signal ].
	objects := self 
				searchBy: keys
				withValues: values
				limit: 2.
	objects isEmptyOrNil ifTrue: [
		DLNoResultException new
			messageText: 'No object was returned';
			signal.
		].
	objects size > 1 ifTrue: [ 
		DLMultipleResultsException new
			messageText: 'More than one element with similar default fields';
			signal.
		].
	"If there is really only one object, return it!!"
	^ objects first.! !

!DLModel class methodsFor: 'save' stamp: 'tfel 12/5/2009 15:13'!
getKeyValueSelect: aBlock
	| objects kv |
	objects := self instances select: aBlock.
	kv := OrderedCollection new.
	objects do: [:object | kv add: (object -> object canonicalName)].
	^ kv! !

!DLModel class methodsFor: 'save' stamp: 'sebh 7/19/2009 22:52'!
getOrCreateFrom: anAttributeArray 
	"Get an object from a given attribute array, create one if it doesn't exist yet.'"
	^ self getOrCreateFrom: anAttributeArray withDefaultValues: {}.! !

!DLModel class methodsFor: 'save' stamp: 'sebh 7/19/2009 22:51'!
getOrCreateFrom: anAttributeArray withDefaultValues: aDefaultValueList
	"Get an object from a given attribute array, create one if it doesn't exist yet.'"
	| object |
	[object := self getFrom: anAttributeArray.]
 	on: DLNoResultException 
 	do: [:exc | ^ self createFrom: anAttributeArray].
	object ifNil: [^ self createFrom: (anAttributeArray, aDefaultValueList)].
	^ object.! !

!DLModel class methodsFor: 'accessing' stamp: 'tfel 12/5/2009 14:02'!
instances

	instances ifNil: [instances := OrderedCollection new].
	^ instances! !

!DLModel class methodsFor: 'accessing' stamp: 'topa 04/28/2010 17:03'!
instances: anObject

	instances := anObject.! !

!DLModel class methodsFor: 'accessing' stamp: 'PL 5/25/2011 18:24:41.536'!
isTestRunning

	isTestRunning ifNil: [self isTestRunning: false].
	
	^ isTestRunning! !

!DLModel class methodsFor: 'accessing' stamp: 'CM 5/12/2011 16:53:22.026'!
isTestRunning: aBoolean

	isTestRunning := aBoolean! !

!DLModel class methodsFor: 'accessing' stamp: 'sebh 7/9/2009 15:27'!
metaName
	^ ''! !

!DLModel class methodsFor: 'accessing' stamp: 'sebh 7/9/2009 15:34'!
metaNamePlural
	^ ''! !

!DLModel class methodsFor: 'save' stamp: 'sebh 6/13/2009 21:09'!
newFrom: anArray
	"Create an object with the values given in anArray and use the standard getters/setters so nondefault get/set behaviour works"
	| newobject |
	newobject := self new.
	anArray do: [:element | newobject perform: ((element key, ':') asSymbol) with: element value ].
	^ newobject! !

!DLModel class methodsFor: 'squeaksave' stamp: 'topa 04/28/2010 17:04'!
removeAllInstances
	self instances: nil.
	self
		allSubclassesDo: [:klass | klass removeAllInstances]! !

!DLModel class methodsFor: 'permission' stamp: 'sebh 6/13/2009 14:08'!
rightCreate: aUser
	^ aUser isAdmin! !

!DLModel class methodsFor: 'permission' stamp: 'sebh 6/13/2009 14:09'!
rightDelete: aUser
	^ aUser isAdmin! !

!DLModel class methodsFor: 'permission' stamp: 'sebh 6/13/2009 19:28'!
rightDetail: aUser
	^ aUser notNil.! !

!DLModel class methodsFor: 'permission' stamp: 'PL 5/16/2011 16:37:26.856'!
rightUpdate: aUser

	^ aUser isAdmin! !

!DLModel class methodsFor: 'accessing' stamp: 'tfel 12/5/2009 15:11'!
searchBy: keys withValues: values limit: limit

	| selection resultLimit |
	selection := (self instances select: [:instance |
		keys allSatisfy: [:key |
			(instance perform: key) = (values at: (keys indexOf: key))]]).
	limit ifNil: [resultLimit := selection size] ifNotNil: [resultLimit := limit].
	^ selection isEmpty 
		ifTrue: [selection]
		ifFalse: [selection copyFrom: 1 to: (resultLimit min: selection size)]! !

!DLModel class methodsFor: 'accessing' stamp: 'tfel 12/23/2009 12:16'!
writeMutex
	
	^ WriteMutex ifNil: [WriteMutex := Monitor new]! !

!DLModel methodsFor: 'comparing' stamp: 'topa 02/06/2012 16:56'!
< anotherModel

	^ self oid < anotherModel oid! !

!DLModel methodsFor: 'comparing' stamp: 'tfel 1/9/2011 20:04'!
<= anotherModel

	^ self < anotherModel or: [self = anotherModel]! !

!DLModel methodsFor: 'description' stamp: 'sebh 6/26/2009 23:00'!
additionalDescriptions
	^ {}.! !

!DLModel methodsFor: 'converting' stamp: 'tfel 1/12/2011 12:20'!
asString

	^ self printString! !

!DLModel methodsFor: 'printing' stamp: 'sebh 6/30/2009 12:05'!
canonicalName
	^ nil! !

!DLModel methodsFor: 'saving' stamp: 'tfel 12/5/2009 14:23'!
changesForField: aFieldName 
	| field changes change oldField |	
	changes := OrderedCollection new.
	oldField := self fieldChanges at: aFieldName asSymbol ifAbsent: [^ changes].
	field := self perform: aFieldName asSymbol.
	(field isKindOf: OrderedCollection) ifTrue: [
		"We have collection change. Log the differences"
		(oldField copyWithoutAll: field) do: [:removed |
			changes add: {
						#attributeName->aFieldName.
						#attributeValue->removed asString.
						#activity->#removed.
						#klassName->removed className.
						#objectId->removed oid.
						#objectCanonicalName->removed canonicalName.}].
		(field copyWithoutAll: oldField) do: [:added |
			changes add: {
						#attributeName->aFieldName.
						#attributeValue->added asString.
						#activity->#added.
						#klassName->added className.
						#objectId->added oid.
						#objectCanonicalName->added canonicalName.}].
		]
	ifFalse: [
		"A simple field. Just mark it as changed"
		change := {
				#attributeName->aFieldName.
				#attributeValue->field asString.
				#activity->#changed.
				#klassName->field className.
				} asOrderedCollection.
		(field class includesBehavior: DLModel) ifTrue: [
			change addAll: { "For Foreign keys make sure to capture the info"
				#objectId->field oid.
				#objectCanonicalName->field canonicalName}.
		].
		changes add: change.
	].
	
	^ changes.! !

!DLModel methodsFor: 'dependencyTracking' stamp: 'sebh 6/16/2009 08:53'!
collectDependencies
	"Recursively collect all objects that depend on me or are transitively connected to this object"
	| dependencies |
	dependencies := Set with: self.
	self collectDependentObjects do: [:each | dependencies addAll: each collectDependencies].
	^ dependencies! !

!DLModel methodsFor: 'dependencyTracking' stamp: 'sebh 7/24/2009 15:15'!
collectDependentObjects
	"Return an iterable list that contains all objects that depend on this object, extend!! this method!!"
	| dependentLogEntries |
	dependentLogEntries := Set new.
	"dependentLogEntries := (SqsSearch for: DLLogEntry) select: [:aLogEntry | (aLogEntry klassName = self className) & (aLogEntry objectId = self oid)]."
	
	^ dependentLogEntries.! !

!DLModel methodsFor: 'permission' stamp: 'CM 5/10/2011 17:57:50.658'!
currentUser
	WACurrentRequestContext value session ifNil: [^ nil] ifNotNil: [^ WACurrentRequestContext value session user].! !

!DLModel methodsFor: 'saving' stamp: 'tfel 7/1/2010 10:14'!
delete
	
	self class instances remove: self ifAbsent: [].
	"self collectDependentObjects do: [:each | each delete]."
	self smalltalkDependentSaveStrategy.
	^ true! !

!DLModel methodsFor: 'description' stamp: 'PL 5/25/2011 17:23:17.216'!
description
	| tempDescription |
	tempDescription := super description copy.
	self additionalDescriptions do: [:aDescription | aDescription ifNotNil: [tempDescription add: aDescription]].
	^ tempDescription! !

!DLModel methodsFor: 'description' stamp: 'sebh 6/13/2009 19:42'!
descriptionAdminCreate
	^ self descriptionCreate! !

!DLModel methodsFor: 'description' stamp: 'sebh 6/13/2009 19:42'!
descriptionAdminDetail
	^ self descriptionDetail! !

!DLModel methodsFor: 'description' stamp: 'sebh 6/13/2009 19:42'!
descriptionAdminList
	^ self descriptionList! !

!DLModel methodsFor: 'description' stamp: 'sebh 6/13/2009 19:42'!
descriptionAdminUpdate
	^ self descriptionUpdate! !

!DLModel methodsFor: 'description' stamp: 'sebh 6/8/2009 17:32'!
descriptionCreate
	^ self description! !

!DLModel methodsFor: 'description' stamp: 'sebh 6/13/2009 15:48'!
descriptionDetail
	^ self description! !

!DLModel methodsFor: 'description' stamp: 'sebh 6/3/2009 19:44'!
descriptionList
	^ self description! !

!DLModel methodsFor: 'description' stamp: 'sebh 6/4/2009 22:47'!
descriptionUpdate
	^ self description! !

!DLModel methodsFor: 'description' stamp: 'sebh 6/13/2009 19:42'!
descriptionUserCreate
	^ self descriptionCreate! !

!DLModel methodsFor: 'description' stamp: 'sebh 6/13/2009 19:42'!
descriptionUserDetail
	^ self descriptionDetail! !

!DLModel methodsFor: 'description' stamp: 'sebh 6/13/2009 19:42'!
descriptionUserList
	^ self descriptionList! !

!DLModel methodsFor: 'description' stamp: 'sebh 6/13/2009 19:42'!
descriptionUserUpdate
	^ self descriptionUpdate! !

!DLModel methodsFor: 'saving' stamp: 'tfel 10/26/2010 09:48'!
destroy
	| logEntry block notification|
	logEntry := DLLogEntry createFrom: {
			#klassName->self className. 
			#objectId->self oid. 
			#changes->nil.
			#user->self currentUser.
			#activity->#deleted.
			#objectCanonicalName-> self canonicalName.
		}.
		
	self trackMailChangeVariables do: [:aMailChange | 
		block := aMailChange key.
		(DLUser instances select: block) do: [:aUser |
			notification := DLNotification getOrCreateFrom: {#user->aUser. #logEntry->logEntry}.
			notification save.
		].
	].
	
	self delete.
	^ true! !

!DLModel methodsFor: 'accessing' stamp: 'tfel 12/5/2009 14:24'!
fieldChanges

	^ fieldChanges! !

!DLModel methodsFor: 'description' stamp: 'tfel 12/5/2009 14:29'!
genericCollectionAccessor: varName withArgument: anObject
	
	^ self instVarNamed: varName put: anObject! !

!DLModel methodsFor: 'initialize-release' stamp: 'tfel 12/5/2009 14:24'!
initialize

	super initialize.
	fieldChanges := Dictionary new.! !

!DLModel methodsFor: 'comparing' stamp: 'topa 3/17/2010 19:47'!
isA: aDlModel

	^ aDlModel == self class! !

!DLModel methodsFor: 'saving' stamp: 'sebh 7/14/2009 14:46'!
logChangesForField: aFieldName 
	^ (self changesForField: aFieldName) collect: [:aChange | DLLogEntryChange newFrom: aChange].! !

!DLModel methodsFor: 'saving' stamp: 'sebh 7/15/2009 14:53'!
mailChangesForField: aFieldName 
	
	^ (self changesForField: aFieldName) collect: [:aChangeset | |changeDict| 
		changeDict := Dictionary newFrom: aChangeset.
		DLNotification newFrom: {
			#attributeName->changeDict at: #attributeName.
			#activity->changeDict at: #activity.
			#attributeValue->changeDict at: #attributeValue.
		}].! !

!DLModel methodsFor: 'accessing' stamp: 'tfel 1/6/2010 11:25'!
oid
	"Always increment oid from last oid. Only allow setting the oid on objects 
	which have been saved already, to avoid duplicate oids"

	((oid isNil or: [oid asInteger = 0]) and: [self class instances includes: self])
		ifTrue: [
			(self class instances first == self)
				ifTrue: [oid := 1]
				ifFalse: 	[oid := (self class instances before: self) oid + 1]].
	^ oid! !

!DLModel methodsFor: 'accessing' stamp: 'tfel 1/5/2010 17:19'!
oid: anInteger

	oid := anInteger! !

!DLModel methodsFor: 'printing' stamp: 'sebh 6/8/2009 18:02'!
printString
	^ self canonicalName ifNil: [^ super printString]! !

!DLModel methodsFor: 'permission' stamp: 'sebh 6/13/2009 14:26'!
rightUpdate: aUser
	^ self class rightUpdate: aUser.! !

!DLModel methodsFor: 'saving' stamp: 'CM 5/12/2011 18:26:39.891'!
save
	| t1 |
	t1 := oid
				ifNil: [#created]
				ifNotNil: [#changed].
	self smalltalkDependentSaveStrategy.
	"self collectDependentObjects do: [:each | each save]."
	self class instances addIfNotPresent: self.
	self oid.
	^ true! !

!DLModel methodsFor: 'saving' stamp: 'Marik 7/1/2009 10:03'!
trackChangeVariables
	^ {}.! !

!DLModel methodsFor: 'saving' stamp: 'sebh 7/14/2009 14:34'!
trackMailChangeVariables
	^ {}.! !

DLModel subclass: #DLNotification
	instanceVariableNames: 'user logEntry fields'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLNotification class methodsFor: 'persistence-description' stamp: 'sebh 7/18/2009 12:07'!
metaName
	^ 'Benachrichtigung'! !

!DLNotification class methodsFor: 'persistence-description' stamp: 'sebh 7/18/2009 12:07'!
metaNamePlural
	^ 'Benachrichtigungen'! !

!DLNotification class methodsFor: 'persistence-description' stamp: 'esec 1/8/2012 14:48'!
releaseMails
	| allNotifications usersNotifications |
	allNotifications := DLNotification instances.
	usersNotifications := allNotifications 
		groupBy: [:aNotification | aNotification user] 
		having:  [:aNotification | true].
	usersNotifications keysAndValuesDo: [:user :notifications |
		| mailContent |
		mailContent := self renderMailForUser: user notifications: notifications.
		(DLMail newFrom: {
			#receivers -> user email.
			#text -> mailContent.
			#subject -> 'Neuigkeiten im Abgabesystem'
		}) sendMail.
	].
	allNotifications do: [:aNotification |
		aNotification destroy.
		]! !

!DLNotification class methodsFor: 'persistence-description' stamp: 'sebh 7/24/2009 15:30'!
renderAliveObject: html with: notification 
	html tableData: 
		[ html text: notification logEntry object class metaName , ' ' , notification logEntry object canonicalName ].
	html tableData: 
		[ notification logEntry changes 
			select: [ :aChange | notification fields includes: aChange attributeName ]
			thenDo: 
				[ :aChange | 
				html definitionList: 
					[ | description |
					description := notification logEntry object description 
						detect: [ :a | a accessor readSelector asString = aChange attributeName ]
						ifNone: [ aChange attributeName ].
					html definitionTerm: [ html text: description label , ' ' , aChange activity ].
					html definitionData: [ html text: aChange attributeValue ] ] ] ].
	html tableData: notification logEntry created.
	^ html tableData: notification logEntry user! !

!DLNotification class methodsFor: 'persistence-description' stamp: 'sebh 7/24/2009 16:32'!
renderDeadObject: html with: notification 
	notification logEntry activity = #deleted
		ifTrue: [
			html tableData: notification logEntry objectCanonicalName;
				  tableData: 'Gelscht';
			 	  tableData: notification logEntry created;
			     tableData: notification logEntry user
			]! !

!DLNotification class methodsFor: 'persistence-description' stamp: 'sebh 7/24/2009 16:33'!
renderDeletion: html with: notification 
	html tableData: notification logEntry objectCanonicalName;
	     tableData: 'Gelscht';
	     tableData: notification logEntry created;
	     tableData: notification logEntry user.! !

!DLNotification class methodsFor: 'persistence-description' stamp: 'sebh 7/24/2009 16:33'!
renderMailForUser: user notifications: notifications 
	| result |
	result := WARenderCanvas builder
		callbackOwner: self;
		render: [ :html | 
			html paragraph: 'Hallo ' , user canonicalName , ',';
			     paragraph: 'Folgende dich betreffende nderungen wurden im Abgabensystem vorgenommen:';
			     table: [ 
						self 
							renderTableHead: html;
							renderTableBody: html with: notifications 
					];
					paragraph: 'Bis zum nchsten Mal,';
					paragraph: 'Deli'.
			].
	^ result! !

!DLNotification class methodsFor: 'persistence-description' stamp: 'sebh 7/24/2009 15:34'!
renderTableBody: html with: notifications 
	^ html tableBody: 
		[ notifications do: 
			[ :notification | 
			html tableRow: 
				[ notification logEntry object 
					ifNotNil: 
						[self 
							renderAliveObject: html
							with: notification] 
				  ifNil: [
						self 
							renderDeadObject: html
							with: notification.
							]
				] ] ]! !

!DLNotification class methodsFor: 'persistence-description' stamp: 'sebh 7/24/2009 15:26'!
renderTableHead: html 
	html tableHead: 
		[ html
			tableData: [ html text: 'Objekt' ];
			tableData: [ html text: 'Vernderungen' ];
			tableData: [ html text: 'Wann' ];
			tableData: [ html text: 'Ausfhrender Benutzer' ] ]! !

!DLNotification methodsFor: 'accessing' stamp: 'sebh 7/15/2009 15:16'!
fields

	^ fields! !

!DLNotification methodsFor: 'accessing' stamp: 'sebh 7/15/2009 15:16'!
fields: anObject

	fields := anObject.! !

!DLNotification methodsFor: 'accessing' stamp: 'sebh 7/15/2009 15:57'!
initialize
	super initialize.
	self fields: OrderedCollection new.! !

!DLNotification methodsFor: 'accessing' stamp: 'sebh 7/15/2009 15:17'!
logEntry

	^ logEntry! !

!DLNotification methodsFor: 'accessing' stamp: 'sebh 7/15/2009 15:16'!
logEntry: anObject

	logEntry := anObject.! !

!DLNotification methodsFor: 'accessing' stamp: 'sebh 7/15/2009 15:52'!
user

	^ user! !

!DLNotification methodsFor: 'accessing' stamp: 'sebh 7/15/2009 15:52'!
user: anObject

	user := anObject.! !

DLModel subclass: #DLQuestionnaire
	instanceVariableNames: 'surveys headings title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLQuestionnaire class methodsFor: 'persistence-description' stamp: 'PL 6/22/2011 14:26:03.82'!
descriptionAdminTitle

	^ MAStringDescription new
		accessor: #title;
		label: (self labelTranslations at: #title);
		priority: (self priorities at: #title);
		beRequired;
		yourself! !

!DLQuestionnaire class methodsFor: 'persistence-description' stamp: 'PL 8/5/2011 20:47:08.266'!
descriptionEditor

	^ DLMAQuestionnaireDescription new
		accessor: #editorInfo;
		label: (self labelTranslations at: #editor);
		priority: (self priorities at: #editor);
		yourself! !

!DLQuestionnaire class methodsFor: 'persistence-description' stamp: 'PL 6/22/2011 14:32:02.535'!
descriptionLecture

	^ MASingleOptionDescription new
		accessor: #lecture;
		label: (self labelTranslations at: #lecture);
		priority: (self priorities at: #lecture);
		beRequired;
		beReadonly;
		optionsAndLabels: (DLLecture getKeyValueSelect: [:lecture | true]);
		yourself! !

!DLQuestionnaire class methodsFor: 'persistence-description' stamp: 'PL 6/22/2011 14:29:36.812'!
descriptionNumberOfSurveys

	^ MAStringDescription new
		accessor: #numberOfSurveys;
		label: (self labelTranslations at: #numberOfSurveys);
		priority: (self priorities at: #numberOfSurveys);
		beRequired;
		beReadonly;
		yourself! !

!DLQuestionnaire class methodsFor: 'translations' stamp: 'PL 6/23/2011 16:24:37.429'!
labelTranslations

	^ Dictionary new
		at: #title put: 'Titel';
		at: #numberOfSurveys put: 'Anzahl Fragen';
		at: #lecture put: 'Vorlesung';
		at: #editor put: 'Zusammensetzung';
		yourself! !

!DLQuestionnaire class methodsFor: 'accessing' stamp: 'PL 6/22/2011 14:21:42.176'!
metaName

	^ 'Fragebogen'! !

!DLQuestionnaire class methodsFor: 'accessing' stamp: 'PL 6/22/2011 14:21:47.746'!
metaNamePlural

	^ 'Fragebgen'! !

!DLQuestionnaire class methodsFor: 'user interface' stamp: 'PL 6/23/2011 16:24:49.835'!
priorities

	^ Dictionary new
		at: #title put: 5;
		at: #lecture put: 10;
		at: #numberOfSurveys put: 15;
		at: #editor put: 20;
		yourself! !

!DLQuestionnaire methodsFor: 'printing' stamp: 'PL 6/23/2011 16:33:19.245'!
canonicalName

	^ self title! !

!DLQuestionnaire methodsFor: 'description' stamp: 'PL 8/5/2011 21:22:05.517'!
descriptionCreate

	^ self description select: [:each | #(title lecture editorInfo) includes: each accessor selector]! !

!DLQuestionnaire methodsFor: 'description' stamp: 'PL 8/5/2011 21:21:43.974'!
descriptionDetail

	^ self description select: [:each | #(title lecture numberOfSurveys) includes: each accessor selector]! !

!DLQuestionnaire methodsFor: 'description' stamp: 'PL 8/5/2011 21:21:36.879'!
descriptionList

	^ self description select: [:each | #(title lecture numberOfSurveys) includes: each accessor selector]! !

!DLQuestionnaire methodsFor: 'description' stamp: 'PL 8/5/2011 21:22:08.681'!
descriptionUpdate

	^ self description select: [:each | #(title lecture editorInfo) includes: each accessor selector]! !

!DLQuestionnaire methodsFor: 'accessing' stamp: 'PL 6/23/2011 16:42:59.753'!
editorInfo

	^ Dictionary new
		add: #surveys -> self surveys;
		add: #headings -> self headings;
		yourself! !

!DLQuestionnaire methodsFor: 'accessing' stamp: 'PL 6/27/2011 21:38:30.963'!
editorInfo: aDictionary

	self
		surveys: (aDictionary at: #surveys);
		headings: (aDictionary at: #headings)! !

!DLQuestionnaire methodsFor: 'accessing' stamp: 'PL 6/22/2011 14:10:10.748'!
headings

	^ headings! !

!DLQuestionnaire methodsFor: 'accessing' stamp: 'PL 6/22/2011 14:10:21.342'!
headings: anOrderedCollection

	headings := anOrderedCollection! !

!DLQuestionnaire methodsFor: 'initialize-release' stamp: 'PL 6/27/2011 23:27:38.801'!
initialize
	
	super initialize.
	
	self
		headings: OrderedCollection new;
		surveys: OrderedCollection new.
	
	self headings add: (0 -> 'Seite 1')! !

!DLQuestionnaire methodsFor: 'accessing' stamp: 'PL 8/5/2011 20:33:43.183'!
lecture

	(self surveys isNil or: (self surveys isEmpty))
			ifTrue: [^ nil].

	^ self surveys first lecture! !

!DLQuestionnaire methodsFor: 'accessing' stamp: 'MH 6/27/2011 23:07:13.921'!
numberOfSurveys
	
	^ self surveys size! !

!DLQuestionnaire methodsFor: 'accessing' stamp: 'PL 6/22/2011 14:10:25.599'!
surveys

	^ surveys! !

!DLQuestionnaire methodsFor: 'accessing' stamp: 'PL 6/22/2011 14:10:33.069'!
surveys: anOrderedCollection

	surveys := anOrderedCollection! !

!DLQuestionnaire methodsFor: 'accessing' stamp: 'PL 6/22/2011 14:24:10.727'!
title

	^ title! !

!DLQuestionnaire methodsFor: 'accessing' stamp: 'PL 6/22/2011 14:24:17.299'!
title: aString

	title := aString! !

DLModel subclass: #DLRequirement
	instanceVariableNames: 'requirementName requirementDescription filetype'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLRequirement class methodsFor: 'description' stamp: 'sebh 7/17/2009 20:54'!
descriptionRequirementDescription
	^ MAMemoDescription new 
		accessor: #requirementDescription;
		label:'Beschreibung';
		priority:20;
		beRequired;
		yourself.! !

!DLRequirement class methodsFor: 'description' stamp: 'sebh 7/17/2009 20:54'!
descriptionRequirementName
	^ MAStringDescription new
		accessor: #requirementName; 
		label:'Title';
		priority:10;
		beRequired;
		yourself.! !

!DLRequirement class methodsFor: 'accessing' stamp: 'sebh 7/3/2009 00:03'!
metaName
	^ 'Anforderung'! !

!DLRequirement class methodsFor: 'accessing' stamp: 'sebh 7/3/2009 00:04'!
metaNamePlural
	^ 'Anforderungen'! !

!DLRequirement methodsFor: 'description' stamp: 'Marik 7/12/2009 14:22'!
additionalDescriptions
	^ {self descriptionFiletype}! !

!DLRequirement methodsFor: 'accessing' stamp: 'sebh 6/8/2009 01:00'!
canonicalName
	^ self requirementName! !

!DLRequirement methodsFor: 'description' stamp: 'tfel 12/5/2009 15:29'!
descriptionFiletype
	^ MASingleOptionDescription new 
		accessor: #filetype; 
		label:'Dateityp';
		priority:30;
		optionsAndLabels: (DLFileType getKeyValueSelect: [:aFile | true]);
		componentClass: (DLMASelectListComponent newElementClass: DLFileType);
		beRequired;
		yourself.! !

!DLRequirement methodsFor: 'accessing' stamp: 'sebh 6/8/2009 00:13'!
filetype

	^ filetype! !

!DLRequirement methodsFor: 'accessing' stamp: 'sebh 6/8/2009 00:13'!
filetype: anObject

	filetype := anObject.! !

!DLRequirement methodsFor: 'accessing' stamp: 'sebh 6/8/2009 00:13'!
requirementDescription

	^ requirementDescription! !

!DLRequirement methodsFor: 'accessing' stamp: 'sebh 6/8/2009 00:13'!
requirementDescription: anObject

	requirementDescription := anObject.! !

!DLRequirement methodsFor: 'accessing' stamp: 'sebh 6/8/2009 00:13'!
requirementName

	^ requirementName! !

!DLRequirement methodsFor: 'accessing' stamp: 'sebh 6/8/2009 00:13'!
requirementName: anObject

	requirementName := anObject.! !

!DLRequirement methodsFor: 'saving' stamp: 'sebh 7/15/2009 16:43'!
trackChangeVariables
	^ {'filetype'.'requirementName'.'requirementDescription'}! !

DLModel subclass: #DLSemester
	instanceVariableNames: 'semesterName year'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLSemester class methodsFor: 'persistence-description' stamp: 'topa 04/28/2010 17:22'!
getForDate: aDate

	| summerStart winterStart lastWinterEnd |
	summerStart := Date newDay: 1 month: 'April' year: aDate year.
	winterStart := Date newDay: 1 month: 'October' year: aDate year.
	lastWinterEnd :=  Date newDay: 31 month: 'March' year: aDate year.

	(lastWinterEnd >= aDate) ifTrue: [
		^DLSemester getOrCreateFrom: { #year -> (aDate year - 1). #semesterName -> 'Winter' }.
		].

	((aDate >= summerStart) and: [aDate < winterStart]) ifTrue: [
		^DLSemester getOrCreateFrom: { #year -> aDate year. #semesterName -> 'Sommer' }.
		].

	(aDate > winterStart) ifTrue: [
		^DLSemester getOrCreateFrom: { #year -> aDate year. #semesterName -> 'Winter' }.
		].! !

!DLSemester class methodsFor: 'persistence-description' stamp: 'sebh 6/6/2009 23:35'!
metaName
	^ 'Semester'! !

!DLSemester class methodsFor: 'persistence-description' stamp: 'sebh 7/3/2009 00:04'!
metaNamePlural
	^ 'Semester'! !

!DLSemester methodsFor: 'as yet unclassified' stamp: 'tfel 1/9/2011 20:04'!
< anotherSemester

	^ self asNumber < anotherSemester asNumber! !

!DLSemester methodsFor: 'as yet unclassified' stamp: 'tfel 1/9/2011 19:19'!
asNumber

	^ semesterName = 'Sommer' 
		ifTrue: [self year]
		ifFalse: [self year + 0.5]! !

!DLSemester methodsFor: 'accessing' stamp: 'sebh 6/19/2009 00:10'!
canonicalName
	^ self year asString, ' ', self semesterName.! !

!DLSemester methodsFor: 'description' stamp: 'tfel 12/5/2009 13:55'!
collectDependentObjects
	| dependentLectures |
	dependentLectures := DLLecture instances select: [:aLecture | aLecture semester = self].
	^ dependentLectures! !

!DLSemester methodsFor: 'accessing' stamp: 'cr 7/20/2009 17:27'!
nextSemester

	(semesterName = 'Sommer') ifTrue: [
		^DLSemester getOrCreateFrom: { #year -> self year. #semesterName -> 'Winter'}.
		]
	ifFalse: [
		^DLSemester getOrCreateFrom: { #year -> (self year + 1). #semesterName -> 'Sommer'}.
		].! !

!DLSemester methodsFor: 'accessing' stamp: 'sebh 5/20/2009 15:46'!
semesterName

	^ semesterName! !

!DLSemester methodsFor: 'accessing' stamp: 'sebh 5/20/2009 15:46'!
semesterName: anObject

	semesterName := anObject.! !

!DLSemester methodsFor: 'accessing' stamp: 'sebh 5/20/2009 15:46'!
year

	^ year! !

!DLSemester methodsFor: 'accessing' stamp: 'sebh 5/20/2009 15:46'!
year: anObject

	year := anObject.! !

DLModel subclass: #DLSurvey
	instanceVariableNames: 'lecture question status maxAnswers maxAnswersPerChoice choices surveyType statisticsVisibility answersVisibility'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLSurvey class methodsFor: 'translations' stamp: 'MH 5/19/2011 16:32:30.793'!
answersVisibilityMetaNames

	^ OrderedCollection new
		add: #own -> 'Einzelperson';
		add: #group -> 'Gruppe';
		add: #full -> 'Alle';
		yourself! !

!DLSurvey class methodsFor: 'persistence-description' stamp: 'PL 5/25/2011 16:48:15.91'!
descriptionAdminAnswersVisibility
	
	^ MASingleOptionDescription new
		accessor: #answersVisibility;
		label: (self labelTranslations at: #answersVisibility);
		priority: (self priorities at: #answersVisibility);
		optionsAndLabels: self answersVisibilityMetaNames;
		beRequired;
		componentClass: MARadioGroupComponent;  
		yourself! !

!DLSurvey class methodsFor: 'persistence-description' stamp: 'PL 5/25/2011 16:48:53.96'!
descriptionAdminQuestion

	^ MAStringDescription new
		accessor: #question; 
		label: (self labelTranslations at: #question);
		priority: (self priorities at: #question);
		beRequired;
		yourself! !

!DLSurvey class methodsFor: 'persistence-description' stamp: 'PL 5/25/2011 16:49:02.204'!
descriptionAdminStatisticsVisibility
	
	^ MASingleOptionDescription new
		accessor: #statisticsVisibility;
		label: (self labelTranslations at: #statisticsVisibility);
		priority: (self priorities at: #statisticsVisibility);
		optionsAndLabels: self statisticsVisibilityMetaNames;
		beRequired;
		componentClass: MARadioGroupComponent;  
		yourself! !

!DLSurvey class methodsFor: 'persistence-description' stamp: 'PL 5/25/2011 16:49:10.618'!
descriptionAdminStatus
	
	^ MASingleOptionDescription new
		accessor: #status;
		label: (self labelTranslations at: #status);
		priority: (self priorities at: #status);
		optionsAndLabels: self statusMetaNames;
		beRequired;
		reportColumnClass: DLMAToggleColumn;
		yourself! !

!DLSurvey class methodsFor: 'persistence-description' stamp: 'PL 5/25/2011 16:49:17.115'!
descriptionAdminType

	^ DLMAUpdatableSingleOptionDescription new
		accessor: #surveyType;
		label: (self labelTranslations at: #surveyType);
		priority: (self priorities at: #surveyType);
		optionsAndLabels: self typeMetaNames;
		beRequired;
		componentClass: DLMAUpdatableRadioGroupComponent;
		jsScript: self typeChangeScript;  
		yourself! !

!DLSurvey class methodsFor: 'persistence-description' stamp: 'CO 7/26/2011 12:40:29.013'!
descriptionAnswers

	^ MAToManyRelationDescription new
		accessor: #answers;
		label: (self labelTranslations at: #answers);
		priority: (self priorities at: #answers);
		classes: (Array with: DLAnswer);
		default: Array new;
		beReadonly;
		yourself! !

!DLSurvey class methodsFor: 'persistence-description' stamp: 'PL 5/25/2011 16:50:00.167'!
descriptionLecture

	^ MASingleOptionDescription new
		accessor: #lecture;
		label: (self labelTranslations at: #lecture);
		priority: (self priorities at: #lecture);
		beRequired;
		optionsAndLabels: (DLLecture getKeyValueSelect: [:lecture | true]);
		yourself! !

!DLSurvey class methodsFor: 'persistence-description' stamp: 'PL 5/25/2011 16:50:05.414'!
descriptionLectureReadonly

	^ MASingleOptionDescription new
		accessor: #lectureReadonly; 
		label: (self labelTranslations at: #lecture);
		priority: (self priorities at: #lecture);
		beRequired;
		beReadonly;
		optionsAndLabels: (DLLecture getKeyValueSelect: [:lecture | true]);
		yourself! !

!DLSurvey class methodsFor: 'persistence-description' stamp: 'PL 5/25/2011 16:50:30.852'!
descriptionMyAnswerWrittenOut

	^ MAStringDescription new
		accessor: #myAnswerWrittenOut; 
		label: (self labelTranslations at: #myAnswer);
		priority: (self priorities at: #myAnswer);
		beReadonly;
		yourself! !

!DLSurvey class methodsFor: 'persistence-description' stamp: 'PL 8/4/2011 18:24:29.659'!
descriptionParticipation

	^ MAStringDescription new
		accessor: #participation; 
		label: (self labelTranslations at: #participation);
		priority: (self priorities at: #participation);
		beReadonly;
		componentClass: DLMABarChartComponent;
		reportColumnClass: DLMABarChartColumn;
		yourself! !

!DLSurvey class methodsFor: 'persistence-description' stamp: 'PL 8/5/2011 19:54:21.345'!
descriptionUserAnswers

	^ MAToManyRelationDescription new
		accessor: #answersUser;
		label: (self labelTranslations at: #answers);
		priority: (self priorities at: #answers);
		classes: (Array with: DLAnswer);
		default: Array new;
		yourself! !

!DLSurvey class methodsFor: 'persistence-description' stamp: 'PL 5/25/2011 16:51:30.044'!
descriptionUserQuestion

	^ MAStringDescription new
		accessor: #questionReadonly; 
		label: (self labelTranslations at: #question);
		priority: (self priorities at: #question);
		beRequired;
		beReadonly;
		yourself! !

!DLSurvey class methodsFor: 'persistence-description' stamp: 'PL 8/5/2011 19:44:00.973'!
descriptionUserStatus
	
	^ MASingleOptionDescription new
		accessor: #statusUser;
		label: (self labelTranslations at: #status);
		priority: (self priorities at: #status);
		optionsAndLabels: self statusMetaNames;
		beRequired;
		beReadonly;
		yourself! !

!DLSurvey class methodsFor: 'persistence-description' stamp: 'PL 8/5/2011 19:49:05.688'!
descriptionUserType

	^ MASingleOptionDescription new
		accessor: #surveyTypeUser; 
		label: (self labelTranslations at: #surveyType);
		priority: (self priorities at: #surveyType);
		beReadonly;
		optionsAndLabels: self typeMetaNames;
		beRequired;  
		yourself! !

!DLSurvey class methodsFor: 'translations' stamp: 'PL 5/24/2011 18:41:50.538'!
invisibleText

	^ Unicode value: 16r2014! !

!DLSurvey class methodsFor: 'translations' stamp: 'MH 6/8/2011 12:09:03.295'!
labelTranslations

	^ Dictionary new
		at: #surveyType put: 'Typ';
		at: #question put: 'Frage';
		at: #answers put: 'Antworten';
		at: #status put: 'Status';
		at: #maxAnswers put: 'Max. Stimmen';
		at: #maxAnswersPerChoice put: 'Max. Stimmen/Antwort';
		at: #choices put: 'Antwortmglichkeiten';
		at: #lecture put: 'Vorlesung';
		at: #statisticsVisibility put: 'Statistiksichtbarkeit';
		at: #answersVisibility put: 'Antwortensichtbarkeit';
		at: #myAnswer put: 'Meine Antwort';
		at: #participation put: 'Beteiligung';
		at: #statistics put: 'Statistik';
		yourself! !

!DLSurvey class methodsFor: 'accessing' stamp: 'PL 6/22/2011 14:21:28.79'!
metaName

	^ 'Umfrage'! !

!DLSurvey class methodsFor: 'accessing' stamp: 'PL 6/22/2011 14:21:31.663'!
metaNamePlural

	^ 'Umfragen'! !

!DLSurvey class methodsFor: 'translations' stamp: 'CO 5/12/2011 19:18:20.954'!
noAnswerText

	^ '(nicht beantwortet)'! !

!DLSurvey class methodsFor: 'translations' stamp: 'PL 5/25/2011 14:18:10.131'!
noChoiceText

	^ '(keine Antwortmglichkeit)'! !

!DLSurvey class methodsFor: 'user interface' stamp: 'MH 6/8/2011 12:09:27.431'!
priorities

	^ Dictionary new
		at: #status put: 5;
		at: #lecture put: 10;
		at: #question put: 15;
		at: #surveyType put: 20;
		at: #choices put: 25;
		at: #maxAnswersPerChoice put: 30;
		at: #maxAnswers put: 35;
		at: #participation put: 40;
		at: #statisticsVisibility put: 45;
		at: #answersVisibility put: 50;
		at: #answers put: 55;
		at: #myAnswer put: 60;
		at: #statistics put: 65;
		yourself! !

!DLSurvey class methodsFor: 'translations' stamp: 'CO 5/18/2011 12:32:59.474'!
statisticsVisibilityMetaNames

	^ OrderedCollection new
		add: #nothing -> 'nichts';
		add: #full -> 'alles';
		yourself! !

!DLSurvey class methodsFor: 'user interface' stamp: 'PL 5/24/2011 18:16:05.483'!
statusImages

	^ OrderedCollection new
		add: #hidden -> (DLFileLibrary / #bubbleTransparentPng);
		add: #open -> (DLFileLibrary / #bubbleGreenPng);
		add: #closed -> (DLFileLibrary / #bubbleRedPng);
		yourself! !

!DLSurvey class methodsFor: 'translations' stamp: 'CO 5/5/2011 16:14:26.528'!
statusMetaNames

	^ OrderedCollection new
		add: #hidden -> 'unsichtbar';
		add: #open -> 'freigegeben';
		add: #closed -> 'geschlossen';
		yourself! !

!DLSurvey class methodsFor: 'user interface' stamp: 'PL 8/5/2011 19:33:02.261'!
typeChangeScript

	"This script is invoked every time the survey time is toggled via JavaScript in the creation menu.
	It fades multiple choice fields in and out according to the type."
	| association typeName typeLabel choicesLabel maxAnswersLabel maxAnswersPerChoiceLabel statisticsVisibilityLabel |
	
	association := self typeMetaNames detect: [:each | each key = #text].
	typeName := association ifNotNil: [association value] ifNil: [''].
	
	typeLabel := (self labelTranslations at: #surveyType) , ':'.
	choicesLabel := (self labelTranslations at: #choices) , ':'.
	maxAnswersLabel := (self labelTranslations at: #maxAnswers) , ':'.
	maxAnswersPerChoiceLabel := (self labelTranslations at: #maxAnswersPerChoice) , ':'.
	statisticsVisibilityLabel := (self labelTranslations at: #statisticsVisibility) , ':'.

	^ 'if (getValueOfRadioGroupByLabel("' , typeLabel , '") == "' , (typeName asString) , '")
		hideMagritteRows(["' , choicesLabel , '", "' , maxAnswersLabel , '", "' , maxAnswersPerChoiceLabel , '", "' , statisticsVisibilityLabel , '"], true)
		else hideMagritteRows(["' , choicesLabel , '", "' , maxAnswersLabel , '", "' , maxAnswersPerChoiceLabel , '", "' , statisticsVisibilityLabel , '"], false)'! !

!DLSurvey class methodsFor: 'translations' stamp: 'PL 5/25/2011 21:32:25.439'!
typeMetaNames

	^ OrderedCollection new
		add: #multipleChoice -> 'Multiple Choice';
		add: #text -> 'Volltext';
		yourself! !

!DLSurvey methodsFor: 'accessing' stamp: 'PL 8/5/2011 17:57:15.82'!
addAnswerFrom: sourceDictionary to: targetDictionary

	"Sum up the votes of two different answers."
	
	sourceDictionary keysAndValuesDo: [:key :value | targetDictionary at: key
		ifPresent: [:v | targetDictionary at: key put: ((targetDictionary at: key) + value)]
		ifAbsent: [targetDictionary at: key put: value]]! !

!DLSurvey methodsFor: 'description' stamp: 'PL 8/5/2011 22:11:58.972'!
additionalDescriptions

	^ {self descriptionAdminMaxAnswersPerChoice.
		self descriptionAdminMaxAnswers.
		self descriptionMaxAnswersPerChoiceReadonly.
		self descriptionMaxAnswersReadonly.
		self descriptionChoicesAsString.
		self descriptionChoicesAsStringReadonly.
		self descriptionMyAnswer.
		self descriptionAdminStatistics.
		self descriptionUserStatistics}! !

!DLSurvey methodsFor: 'accessing' stamp: 'PL 8/4/2011 19:47:46.269'!
answers

	^ DLAnswer instances select: [:each | each survey = self]! !

!DLSurvey methodsFor: 'accessing' stamp: 'CO 5/12/2011 19:02:17.532'!
answers: anOrderedCollection

	DLAnswer instances
		removeAll: (DLAnswer instances select: [:each | each survey = self]);    
		addAll: anOrderedCollection.! !

!DLSurvey methodsFor: 'accessing' stamp: 'PL 8/5/2011 18:00:55.737'!
answersUser
	
	"Show the users the subset of answers they should see (everyone, group or voter)."
	
	self answersVisibility = #full ifTrue: [^ self answers].
	
	self answersVisibility = #group
		ifTrue: [| groups students answers |
			groups := DLGroup allInstances 
				select: [:each | (each students includes: self currentUser) 
					and: (each lecture = self lecture)].		
			students := OrderedCollection new.
			groups do: [:each | students addAll: each students].
			^ self answers select: [:each | students includes: each author]].
		
	^ self answers select: [:each | each author = self currentUser]! !

!DLSurvey methodsFor: 'accessing' stamp: 'PL 8/5/2011 18:01:06.261'!
answersVisibility

	^ answersVisibility! !

!DLSurvey methodsFor: 'accessing' stamp: 'PL 8/5/2011 18:01:15.796'!
answersVisibility: aSymbol

	answersVisibility := aSymbol! !

!DLSurvey methodsFor: 'testing' stamp: 'PL 8/5/2011 19:15:26.007'!
areMultipleChoiceFieldsInvisible

	^ self surveyType ~= #multipleChoice
		and: (DLSurvey instances includes: self)! !

!DLSurvey methodsFor: 'printing' stamp: 'CM 5/10/2011 16:40:35.025'!
canonicalName

	^ self question! !

!DLSurvey methodsFor: 'accessing' stamp: 'PL 5/16/2011 17:02:27.488'!
choices
	
	choices ifNil: [choices := OrderedCollection new].
	
	^ choices! !

!DLSurvey methodsFor: 'accessing' stamp: 'PL 8/5/2011 18:01:34.364'!
choices: anOrderedCollection

	choices := anOrderedCollection! !

!DLSurvey methodsFor: 'accessing' stamp: 'PL 8/5/2011 18:02:16.467'!
choicesAsString

	| result |
	
	result := ''.
	self choices do:
		[:each |
			result ifNotEmpty: [result := result , String crlf].
			result := result , each].
	^ result! !

!DLSurvey methodsFor: 'accessing' stamp: 'PL 8/5/2011 18:02:55.679'!
choicesAsString: aString

	| string |
	
	self choices: OrderedCollection new.

	string := aString ifNil: self class noChoiceText.
	(string subStrings: String crlf) do:
		[:each |
			(each notEmpty and: (self choices includes: each) not)
				ifTrue: [self choices add: each]]! !

!DLSurvey methodsFor: 'accessing' stamp: 'PL 8/5/2011 22:10:24.784'!
choicesAsStringReadonly

	^ self choicesAsString! !

!DLSurvey methodsFor: 'description' stamp: 'PL 8/5/2011 22:10:47.259'!
descriptionAdminDetail

	^ self description select: [:each |
		#(lectureReadonly status question answers participation #maxAnswersReadonly #maxAnswersPerChoiceReadonly
			surveyType #choicesAsStringReadonly statisticsVisibility answersVisibility statistics) 
			includes: each accessor selector]! !

!DLSurvey methodsFor: 'description' stamp: 'MH 5/25/2011 09:47:18.161'!
descriptionAdminList

	^ self description select: [:each |
		#(lecture status question participation surveyType) 
			includes: each accessor selector]! !

!DLSurvey methodsFor: 'persistence-description' stamp: 'PL 8/5/2011 19:15:26.12'!
descriptionAdminMaxAnswers

	self areMultipleChoiceFieldsInvisible ifTrue: [^ nil].
	
	^ MANumberDescription new
		accessor: #maxAnswers; 
		label: (self class labelTranslations at: #maxAnswers);
		priority: (self class priorities at: #maxAnswers);
		bePositive;
		beInteger;
		comment: 'Positive ganze Zahl.';
		yourself! !

!DLSurvey methodsFor: 'persistence-description' stamp: 'PL 8/5/2011 19:15:26.066'!
descriptionAdminMaxAnswersPerChoice

	self areMultipleChoiceFieldsInvisible ifTrue: [^ nil].

	^ MANumberDescription new
		accessor: #maxAnswersPerChoice; 
		label: (self class labelTranslations at: #maxAnswersPerChoice);
		priority: (self class priorities at: #maxAnswersPerChoice);
		bePositive;
		beInteger;
		comment: 'Positive ganze Zahl.';
		yourself! !

!DLSurvey methodsFor: 'persistence-description' stamp: 'MH 6/8/2011 13:56:42.094'!
descriptionAdminStatistics
	
	self surveyType = #multipleChoice ifFalse: [^ nil].
	
	^ DLMAMultiCheckboxGroupDescription new
			accessor: #statistics;
			label: (self class labelTranslations at: #statistics);
			labels: self choices;
			priority: (self class priorities at: #statistics);
			beReadonly;
			componentClass: DLMAChartComponent;  
			yourself! !

!DLSurvey methodsFor: 'description' stamp: 'MH 5/25/2011 09:55:11.299'!
descriptionAdminUpdate

	^ self description select: [:each |
		#(lectureReadonly questionReadonly status answers statisticsVisibility answersVisibility)
			includes: each accessor selector]! !

!DLSurvey methodsFor: 'persistence-description' stamp: 'PL 8/5/2011 19:15:26.092'!
descriptionChoicesAsString

	self areMultipleChoiceFieldsInvisible ifTrue: [^ nil].

	^ MAMemoDescription new 
		accessor: #choicesAsString;
		label: (self class labelTranslations at: #choices);
		priority: (self class priorities at: #choices);
		comment: 'Jede Antwortmglichkeit in eine neue Zeile.';
		yourself! !

!DLSurvey methodsFor: 'persistence-description' stamp: 'PL 8/5/2011 22:11:58.936'!
descriptionChoicesAsStringReadonly

	self areMultipleChoiceFieldsInvisible ifTrue: [^ nil].

	^ MAMemoDescription new 
		accessor: #choicesAsStringReadonly;
		label: (self class labelTranslations at: #choices);
		priority: (self class priorities at: #choices);
		yourself! !

!DLSurvey methodsFor: 'description' stamp: 'PL 8/5/2011 19:07:58.422'!
descriptionCreate

	^ self description select: [:each |
		#(lecture status question maxAnswers maxAnswersPerChoice
			surveyType choicesAsString answersVisibility statisticsVisibility) includes: each accessor selector]! !

!DLSurvey methodsFor: 'persistence-description' stamp: 'PL 8/5/2011 22:11:26.158'!
descriptionMaxAnswersPerChoiceReadonly

	self areMultipleChoiceFieldsInvisible ifTrue: [^ nil].

	^ MANumberDescription new
		accessor: #maxAnswersPerChoiceReadonly; 
		label: (self class labelTranslations at: #maxAnswersPerChoice);
		priority: (self class priorities at: #maxAnswersPerChoice);
		beReadonly;
		bePositive;
		beInteger;
		yourself! !

!DLSurvey methodsFor: 'persistence-description' stamp: 'PL 8/5/2011 22:11:41.27'!
descriptionMaxAnswersReadonly

	self areMultipleChoiceFieldsInvisible ifTrue: [^ nil].

	^ MANumberDescription new
		accessor: #maxAnswersReadonly; 
		label: (self class labelTranslations at: #maxAnswers);
		priority: (self class priorities at: #maxAnswers);
		beReadonly;
		bePositive;
		beInteger;
		yourself! !

!DLSurvey methodsFor: 'persistence-description' stamp: 'PL 8/5/2011 19:07:29.081'!
descriptionMyAnswer

	self surveyType = #text
		ifTrue: [^ MAStringDescription new
			accessor: #myAnswer;
			label: (self class labelTranslations at: #myAnswer);
			priority: (self class priorities at: #myAnswer);
			comment: 'Feld leeren, um Antwort zurckzuziehen.';
			yourself]
		ifFalse: [^ DLMAMultiCheckboxGroupDescription new
			accessor: #myAnswer;
			label: (self class labelTranslations at: #myAnswer);
			labels: self choices;
			maxAnswers: self maxAnswers;
			maxAnswersPerChoice: self maxAnswersPerChoice;  
			priority: (self class priorities at: #myAnswer);
			comment: self voteComment;
			yourself]! !

!DLSurvey methodsFor: 'description' stamp: 'PL 8/5/2011 22:10:47.311'!
descriptionUserDetail

	^ self description select: [:each |
		#(lecture question status myAnswerWrittenOut #choicesAsStringReadonly #maxAnswersReadonly
			#maxAnswersPerChoiceReadonly participation answersUser statisticsUser)
			includes: each accessor selector]! !

!DLSurvey methodsFor: 'description' stamp: 'PL 8/5/2011 19:44:00.947'!
descriptionUserList

	^ self description select: [:each |
		#(lecture question myAnswerWrittenOut #statusUser) includes: each accessor selector]! !

!DLSurvey methodsFor: 'persistence-description' stamp: 'MH 6/8/2011 14:06:31.128'!
descriptionUserStatistics
	
	self surveyType = #multipleChoice ifFalse: [^ nil].
	self statisticsVisibility = #nothing ifTrue: [^ nil].  
	
	^ DLMAMultiCheckboxGroupDescription new
			accessor: #statisticsUser;
			label: (self class labelTranslations at: #statistics);
			labels: self choices;
			priority: (self class priorities at: #statistics);
			beReadonly;
			componentClass: DLMAChartComponent;  
			yourself! !

!DLSurvey methodsFor: 'description' stamp: 'PL 5/24/2011 18:37:29.9'!
descriptionUserUpdate

	^ self description select: [:each |
		#(lectureReadonly questionReadonly myAnswer) includes: each accessor selector]! !

!DLSurvey methodsFor: 'initialize-release' stamp: 'PL 8/5/2011 19:08:26.155'!
initialize
	
	super initialize.
	
	self
		statisticsVisibility: #nothing;
		answersVisibility: #own;
		status: #hidden;
		surveyType: #text;
		maxAnswersPerChoice: 1;
		maxAnswers: 1! !

!DLSurvey methodsFor: 'accessing' stamp: 'CO 5/11/2011 11:56:26.374'!
lecture

	^ lecture! !

!DLSurvey methodsFor: 'accessing' stamp: 'PL 5/11/2011 14:12:18.963'!
lecture: aDLLecture

	lecture := aDLLecture! !

!DLSurvey methodsFor: 'accessing' stamp: 'CO 5/12/2011 18:40:52.841'!
lectureReadonly

	^ self lecture! !

!DLSurvey methodsFor: 'accessing' stamp: 'PL 8/5/2011 19:09:19.295'!
maxAnswers

	^ maxAnswers! !

!DLSurvey methodsFor: 'accessing' stamp: 'PL 8/5/2011 19:09:30.615'!
maxAnswers: anInteger

	maxAnswers := anInteger ifNil: 1! !

!DLSurvey methodsFor: 'accessing' stamp: 'PL 8/5/2011 19:09:34.799'!
maxAnswersPerChoice

	^ maxAnswersPerChoice! !

!DLSurvey methodsFor: 'accessing' stamp: 'PL 8/5/2011 19:09:43.17'!
maxAnswersPerChoice: anInteger
	
	maxAnswersPerChoice := anInteger ifNil: 1! !

!DLSurvey methodsFor: 'accessing' stamp: 'PL 8/5/2011 22:10:37.578'!
maxAnswersPerChoiceReadonly

	^ self maxAnswersPerChoice! !

!DLSurvey methodsFor: 'accessing' stamp: 'PL 8/5/2011 22:10:47.23'!
maxAnswersReadonly

	^ self maxAnswers! !

!DLSurvey methodsFor: 'accessing' stamp: 'PL 8/5/2011 19:10:54.469'!
myAnswer

	| answer |
	
	answer := DLAnswer instances select: [:each | each survey = self and: (each author = self currentUser)].
	
	^ answer
		ifEmpty: ['']
		ifNotEmpty: [answer first]! !

!DLSurvey methodsFor: 'accessing' stamp: 'PL 8/5/2011 19:10:23.274'!
myAnswer: anObject

	| answer |
	
	answer := DLAnswer instances select: [:each | each survey = self and: (each author = self currentUser)].

	(anObject isNil or: (anObject = self class noAnswerText))
		ifTrue: [answer do: [:each | each delete].
			^ self].

	answer := answer
		ifEmpty: [DLAnswer createFrom:
			{#author -> self currentUser.
			#survey -> self.
			#answer -> anObject}]
		ifNotEmpty: [answer first
			answer: anObject;
			yourself]! !

!DLSurvey methodsFor: 'accessing' stamp: 'PL 8/5/2011 19:10:46.637'!
myAnswerWrittenOut

	| answer |
	
	answer := DLAnswer instances select: [:each | each survey = self and: (each author = self currentUser)].
	
	^ answer
		ifEmpty: [self class noAnswerText]
		ifNotEmpty: [answer first]! !

!DLSurvey methodsFor: 'accessing' stamp: 'PL 5/11/2011 14:58:50.893'!
numberOfAnswers

	^ self answers size! !

!DLSurvey methodsFor: 'accessing' stamp: 'PL 5/11/2011 14:12:26.917'!
numberOfParticipants

	^ lecture students size! !

!DLSurvey methodsFor: 'accessing' stamp: 'PL 8/5/2011 19:16:59.157'!
participation

	^ Array with: self numberOfAnswers with: self numberOfParticipants! !

!DLSurvey methodsFor: 'accessing' stamp: 'CM 5/10/2011 15:29:26.834'!
question

	^ question! !

!DLSurvey methodsFor: 'accessing' stamp: 'PL 5/11/2011 14:13:09.188'!
question: aString

	question := aString! !

!DLSurvey methodsFor: 'accessing' stamp: 'CO 5/12/2011 18:08:07.599'!
questionReadonly

	^ self question! !

!DLSurvey methodsFor: 'permission' stamp: 'PL 8/5/2011 19:12:09.985'!
rightUpdate: aUser

	"Give the user the rights to edit his survey answer only if the survey is still open."
	^ aUser isAdmin or: (self status = #open)! !

!DLSurvey methodsFor: 'accessing' stamp: 'MH 6/8/2011 12:51:05.094'!
statistics

	| votes answers |
	
	votes := Dictionary new.
	answers := DLAnswer instances select: [:each | each survey = self].
	answers do: [:each | self addAnswerFrom: each answer to: votes].
	
	^ votes! !

!DLSurvey methodsFor: 'accessing' stamp: 'MH 6/8/2011 14:06:22.422'!
statisticsUser

	^ self statistics! !

!DLSurvey methodsFor: 'accessing' stamp: 'PL 8/5/2011 19:12:26.02'!
statisticsVisibility

	^ statisticsVisibility! !

!DLSurvey methodsFor: 'accessing' stamp: 'PL 8/5/2011 19:12:33.575'!
statisticsVisibility: aSymbol

	statisticsVisibility := aSymbol! !

!DLSurvey methodsFor: 'accessing' stamp: 'CM 5/10/2011 15:29:34.193'!
status

	^ status! !

!DLSurvey methodsFor: 'accessing' stamp: 'CM 5/10/2011 15:29:37.66'!
status: aSymbol

	status := aSymbol! !

!DLSurvey methodsFor: 'accessing' stamp: 'PL 8/5/2011 19:44:00.913'!
statusUser

	^ self status! !

!DLSurvey methodsFor: 'accessing' stamp: 'PL 8/5/2011 19:12:41.91'!
surveyType

	^ surveyType! !

!DLSurvey methodsFor: 'accessing' stamp: 'PL 8/5/2011 19:12:49.059'!
surveyType: aSymbol

	surveyType := aSymbol! !

!DLSurvey methodsFor: 'accessing' stamp: 'PL 8/5/2011 19:49:05.649'!
surveyTypeUser

	^ self surveyType! !

!DLSurvey methodsFor: 'description' stamp: 'PL 8/5/2011 19:07:11.834'!
voteComment

	| comment |
	
	self maxAnswers ~= 1
		ifTrue: [comment := 'Ihnen stehen insgesamt ' , self maxAnswers asString, ' Stimmen']
		ifFalse: [comment := 'Ihnen steht insgesamt eine Stimme'].
	
	comment := comment , ' zur Verfgung. Pro Antwort drfen Sie dabei maximal '.
	
	self maxAnswersPerChoice ~= 1
		ifTrue: [comment := comment , self maxAnswersPerChoice asString, ' Stimmen']
		ifFalse: [comment := comment , ' eine Stimme'].
	
	comment := comment , ' vergeben.'.
	
	^ comment! !

DLModel subclass: #DLTestItemModel
	instanceVariableNames: 'title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-tests'!

!DLTestItemModel class methodsFor: 'persistence-description' stamp: 'sebh 7/11/2009 10:37'!
metaName
	^ 'testItem'! !

!DLTestItemModel class methodsFor: 'persistence-description' stamp: 'sebh 7/11/2009 10:37'!
metaNamePlural
	^ 'testItems'! !

!DLTestItemModel class methodsFor: 'persistence-description' stamp: ''!
sqsDescrTitle
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'title';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_test_item_models';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'title';
		 yourself! !

!DLTestItemModel methodsFor: 'accessing' stamp: 'sebh 7/9/2009 11:30'!
canonicalName
	^ self title.! !

!DLTestItemModel methodsFor: 'accessing' stamp: 'sebh 7/7/2009 22:53'!
title

	^ title! !

!DLTestItemModel methodsFor: 'accessing' stamp: 'sebh 7/7/2009 22:53'!
title: anObject

	title := anObject.! !

DLModel subclass: #DLTestModel
	instanceVariableNames: 'title body items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-tests'!

!DLTestModel class methodsFor: 'persistence-description' stamp: 'sebh 7/11/2009 10:36'!
metaName
	^ 'Testmodel'! !

!DLTestModel class methodsFor: 'persistence-description' stamp: 'sebh 7/11/2009 10:36'!
metaNamePlural
	^ 'Testmodels'! !

!DLTestModel class methodsFor: 'persistence-description' stamp: ''!
sqsDescrBody
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'body';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_test_models';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'body';
		 yourself! !

!DLTestModel class methodsFor: 'persistence-description' stamp: ''!
sqsDescrItems
	^ SqsCollectionDescription new manuallyMaintained: false;
		 collectionClass: #OrderedCollection;
		 tableName: 'dl_test_models_items';
		 ownerColumn: (SqsColumn new manuallyMaintained: false;
			 columnName: 'dl_test_model_id';
			 sqlType: #integer;
			 foreignKey: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_test_models';
				 updateActions: #();
				 deleteActions: (OrderedCollection new add: #CASCADE;
					 yourself);
				 referencingColumns: (Set new add: 'dl_test_model_id';
					 yourself);
				 yourself);
			 canBeNull: false;
			 isPrimaryKey: false;
			 autoIncrement: false;
			 linkedVariable: #SQSOWNER;
			 yourself);
		 referenceColumn: (SqsColumn new manuallyMaintained: false;
			 columnName: 'items_id';
			 sqlType: #integer;
			 foreignKey: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_test_item_models';
				 updateActions: #();
				 deleteActions: #(#CASCADE );
				 referencingColumns: (Set new add: 'items_id';
					 yourself);
				 yourself);
			 canBeNull: false;
			 isPrimaryKey: false;
			 autoIncrement: false;
			 linkedVariable: #SQSREF;
			 yourself);
		 maintainOrder: true;
		 simpleValues: false;
		 indexType: #integer;
		 referencedClass: #DLTestItemModel;
		 linkedVariable: 'items';
		 orderField: 'sqs_order_number';
		 yourself! !

!DLTestModel class methodsFor: 'persistence-description' stamp: ''!
sqsDescrTitle
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'title';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_test_models';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'title';
		 yourself! !

!DLTestModel methodsFor: 'accessing' stamp: 'sebh 6/27/2009 19:11'!
body

	^ body! !

!DLTestModel methodsFor: 'accessing' stamp: 'sebh 6/27/2009 19:11'!
body: anObject

	body := anObject.! !

!DLTestModel methodsFor: 'accessing' stamp: 'sebh 7/9/2009 11:30'!
canonicalName
	^ self title! !

!DLTestModel methodsFor: 'accessing' stamp: 'sebh 6/27/2009 18:37'!
initialize
	super initialize.
	self items: OrderedCollection new.! !

!DLTestModel methodsFor: 'accessing' stamp: 'sebh 6/27/2009 18:36'!
items

	^ items! !

!DLTestModel methodsFor: 'accessing' stamp: 'sebh 7/10/2009 16:13'!
items: anObject
	^ self genericCollectionAccessor: 'items' withArgument: anObject.! !

!DLTestModel methodsFor: 'accessing' stamp: 'sebh 6/27/2009 18:36'!
title

	^ title! !

!DLTestModel methodsFor: 'accessing' stamp: 'sebh 6/27/2009 18:36'!
title: anObject

	title := anObject.! !

!DLTestModel methodsFor: 'accessing' stamp: 'sebh 7/7/2009 23:01'!
trackChangeVariables
	^ {'title'. 'items'}.! !

DLModel subclass: #DLTopic
	instanceVariableNames: 'topicName topicDescription lecture students'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLTopic class methodsFor: 'persistence-description' stamp: 'mg 7/24/2009 18:20'!
descriptionMail
	^ DLMAMailDescription new
		accessor: #mail;
		label: '';
		priority: 140;
		reportColumnClass: DLMAMailLinkColumn;
		componentClass: DLMAMailLinkComponent;
		yourself! !

!DLTopic class methodsFor: 'description' stamp: 'sebh 7/17/2009 20:56'!
descriptionTopicDescription
	^ MAMemoDescription new
		accessor: #topicDescription; 
		label: 'Beschreibung';
		priority: 20;
		yourself.! !

!DLTopic class methodsFor: 'description' stamp: 'sebh 7/17/2009 20:57'!
descriptionTopicName
	^ MAStringDescription new
		accessor: #topicName;
		label: 'Thema';
		priority: 10;
		beRequired;
		yourself.! !

!DLTopic class methodsFor: 'accessing' stamp: 'caro 6/25/2009 17:02'!
metaName
	^ 'Thema'! !

!DLTopic class methodsFor: 'accessing' stamp: 'sebh 7/3/2009 00:04'!
metaNamePlural
	^ 'Themen'! !

!DLTopic methodsFor: 'as yet unclassified' stamp: 'tfel 1/9/2011 20:07'!
< anotherTopic

	^ self lecture < anotherTopic lecture or: [
		(self lecture = anotherTopic lecture) and: [self oid < anotherTopic oid]]! !

!DLTopic methodsFor: 'description' stamp: 'tfel 3/10/2010 14:59'!
additionalDescriptions
	^ {self descriptionStudents. self descriptionLecture}! !

!DLTopic methodsFor: 'saving' stamp: 'caro 6/25/2009 16:51'!
addStudent: aUser
	self students addIfNotPresent: aUser.
	self save.! !

!DLTopic methodsFor: 'accessing' stamp: 'caro 6/26/2009 01:20'!
canonicalName
	^ self topicName! !

!DLTopic methodsFor: 'description' stamp: 'MG 7/13/2009 17:13'!
descriptionCreate
 ^ self description select: [:each | #(topicName topicDescription students lecture) includes: each accessor selector]! !

!DLTopic methodsFor: 'description' stamp: 'MG 7/13/2009 17:14'!
descriptionDetail
 ^ self descriptionCreate! !

!DLTopic methodsFor: 'description' stamp: 'tfel 12/5/2009 15:30'!
descriptionLecture
	^ MASingleOptionDescription new
		accessor: #lecture;
		label: 'Vorlesung';
		priority: 10;
		optionsAndLabels: (DLLecture getKeyValueSelect: [:aLecture | true]);
		beRequired;
		yourself.! !

!DLTopic methodsFor: 'description' stamp: 'MG 7/13/2009 16:59'!
descriptionList
 ^ self description select: [:each | #(topicName topicDescription students lecture mail) includes: each accessor selector]! !

!DLTopic methodsFor: 'description' stamp: 'tfel 12/5/2009 15:30'!
descriptionStudents
	^ MAMultipleOptionDescription new
		accessor: #students;
		label: 'Studenten';
		priority: 30;
		optionsAndLabels: (DLUser getKeyValueSelect: [:aUser | true]);
		yourself.! !

!DLTopic methodsFor: 'description' stamp: 'MG 7/13/2009 17:13'!
descriptionUpdate
 ^ self descriptionCreate! !

!DLTopic methodsFor: 'accessing' stamp: 'caro 6/28/2009 16:40'!
initialize
	super initialize.
	self students: OrderedCollection new.! !

!DLTopic methodsFor: 'accessing' stamp: 'sebh 7/14/2009 22:39'!
lecture 

	^ lecture! !

!DLTopic methodsFor: 'accessing' stamp: 'caro 6/25/2009 16:59'!
lecture: anObject

	lecture := anObject.! !

!DLTopic methodsFor: 'accessing' stamp: 'topa 4/28/2010 15:46'!
mail

	self students isEmpty
		ifTrue: [^nil]
		ifFalse: [^ 'mailto:',((self students collect:[:each|each email]) asStringSeparatedBy: ',')].! !

!DLTopic methodsFor: 'saving' stamp: 'caro 6/25/2009 16:59'!
removeStudent: aUser
	self students remove: aUser ifAbsent: ["Somehow the user was removed. Result is the same."].
	self save.! !

!DLTopic methodsFor: 'accessing' stamp: 'caro 6/25/2009 16:59'!
students

	^ students! !

!DLTopic methodsFor: 'accessing' stamp: 'caro 6/25/2009 16:59'!
students: anObject

	students := anObject.! !

!DLTopic methodsFor: 'accessing' stamp: 'caro 6/25/2009 16:59'!
topicDescription

	^ topicDescription! !

!DLTopic methodsFor: 'accessing' stamp: 'caro 6/25/2009 16:59'!
topicDescription: anObject

	topicDescription := anObject.! !

!DLTopic methodsFor: 'accessing' stamp: 'caro 6/25/2009 16:59'!
topicName

	^ topicName! !

!DLTopic methodsFor: 'accessing' stamp: 'caro 6/25/2009 16:59'!
topicName: anObject

	topicName := anObject.! !

DLModel subclass: #DLUser
	instanceVariableNames: 'userName realName email isAdmin isTeacher isAssistant isStudentAssistant'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLUser class methodsFor: 'persistence-description' stamp: 'topa 12/22/2009 19:54'!
defaultMailSuffix

	^ '@student.hpi.uni-potsdam.de'! !

!DLUser class methodsFor: 'persistence-description' stamp: 'martin 7/18/2009 14:05'!
descriptionIsAdmin
	^ MABooleanDescription new
		accessor: #isAdmin;
		label: 'Administrator';
		priority: 30;
		checkboxLabel: '';
		default: false;
		trueString: 'Ja';
		falseString: 'Nein';
		yourself.! !

!DLUser class methodsFor: 'persistence-description' stamp: 'martin 7/18/2009 14:06'!
descriptionIsAssistant
	^ MABooleanDescription new
		accessor: #isAssistant;
		label: 'Assistent';
		priority: 40;
		checkboxLabel: '';
		default: false;
		trueString: 'Ja';
		falseString: 'Nein';
		yourself.! !

!DLUser class methodsFor: 'persistence-description' stamp: 'martin 7/18/2009 14:06'!
descriptionIsStudentAssistant
	^ MABooleanDescription new
		accessor: #isStudentAssistant;
		label: 'Studentischer Assistent';
		priority: 40;
		checkboxLabel: '';
		default: false;
		trueString: 'Ja';
		falseString: 'Nein';
		yourself.! !

!DLUser class methodsFor: 'persistence-description' stamp: 'martin 7/18/2009 14:06'!
descriptionIsTeacher
	^ MABooleanDescription new
		accessor: #isTeacher;
		label: 'Dozent';
		priority: 40;
		checkboxLabel: '';
		default: false;
		trueString: 'Ja';
		falseString: 'Nein';
		yourself.! !

!DLUser class methodsFor: 'persistence-description' stamp: 'sebh 7/17/2009 21:04'!
descriptionRealName
	^ MAStringDescription new
		accessor: #realName;
		label: 'Name';
		priority: 20;
		beRequired;
		yourself.! !

!DLUser class methodsFor: 'persistence-description' stamp: 'sebh 7/17/2009 21:04'!
descriptionUserName
	^ MAStringDescription new
		accessor: #userName;
		label: 'Benutzername';
		priority: 10;
		beRequired;
		yourself.! !

!DLUser class methodsFor: 'persistence-description' stamp: 'sebh 6/6/2009 23:35'!
metaName
	^ 'Benutzer'! !

!DLUser class methodsFor: 'persistence-description' stamp: 'sebh 7/3/2009 00:04'!
metaNamePlural
	^ 'Benutzer'! !

!DLUser class methodsFor: 'save' stamp: 'topa 5/3/2010 10:12'!
save
	"If new users were added during the save, re-sort for better retrieval"
	| retVal preSaveInstancesCount |
	preSaveInstancesCount := self instances size.
	retVal := super save.
	self instances size > preSaveInstancesCount
		ifTrue: [self instances: (self instances copy sortBy: [:a :b | 
					(a realName findTokens: ' ') last < (b realName findTokens: ' ') last])].
	^ retVal! !

!DLUser methodsFor: 'comparing' stamp: 'topa 04/28/2010 17:25'!
<= anotherUser

	^ (self userName asLowercase findTokens: '.') last <= (anotherUser userName asLowercase findTokens: '.') last! !

!DLUser methodsFor: 'description' stamp: 'Marik 7/24/2009 19:08'!
additionalDescriptions
	^ {self descriptionEmail}! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 6/8/2009 18:06'!
canonicalName
	^ self realName ifNil: [^ self userName]! !

!DLUser methodsFor: 'description' stamp: 'sebh 7/2/2009 23:07'!
descriptionCreate
 ^ self description select: [:each | #(userName realName email isAdmin isAssistant isStudentAssistant isTeacher) includes: each accessor selector]! !

!DLUser methodsFor: 'as yet unclassified' stamp: 'Marik 7/24/2009 19:14'!
descriptionEmail

	^ MAStringDescription new
		accessor: #email;
		label: '';
		priority: 100;
		addCondition: 
				[ :anEmail | 
				anEmail matchesRegexIgnoringCase: 				'[A-Za-z0-9._-]+@([A-Za-z0-9._-]+\.)?hpi.uni-potsdam.de' ]
		labelled: 'Muss eine gltige HPI-E-Mail-Adresse sein.';
		comment: 'HPI E-Mail-Adressen Schema';
		reportColumnClass: DLMAMailLinkColumn;
		componentClass: DLMAMailLinkComponent;
		beRequired;
		yourself! !

!DLUser methodsFor: 'description' stamp: 'martin 7/18/2009 13:53'!
descriptionList
 ^ self description select: [:each | #(userName realName email isAdmin isTeacher isAssistant isStudentAssistant) includes: each accessor selector]! !

!DLUser methodsFor: 'description' stamp: 'topa 10/26/2009 15:15'!
descriptionUserUpdate
"topa: userName should be read only

 ^ self description select: [:each | #(userName realName email) includes: each accessor selector]"

	^ self description select: [:each|
		#(realName email) includes: each accessor selector]! !

!DLUser methodsFor: 'accessing' stamp: 'tfel 7/12/2011 08:51:30.128'!
destroy
	| userId |
	userId := self oid.
	super destroy.
	(DLNotification searchBy: #(user)
		withValues: #(userId)
		limit: nil) do: [:aNotification | aNotification destroy].! !

!DLUser methodsFor: 'accessing' stamp: 'topa 12/22/2009 19:53'!
email

	email ifNil: ["Sanely guess for default students"
		email := self userName, self class defaultMailSuffix].
	^ email! !

!DLUser methodsFor: 'accessing' stamp: 'Marik 5/27/2009 10:17'!
email: anObject

	email := anObject.! !

!DLUser methodsFor: 'accessing' stamp: 'topa 4/27/2010 13:40'!
groupForLecture: aLecture
	^ aLecture groups
		detect: [:aGroup | aGroup students includes: self] 
		ifNone: [nil].! !

!DLUser methodsFor: 'accessing' stamp: 'topa 4/27/2010 14:10'!
groups
	^ DLGroup instances select: [:aGroup | aGroup students includes: self]! !

!DLUser methodsFor: 'accessing' stamp: 'CM 5/6/2011 11:49:35.882'!
initialize
	super initialize.
	self isAdmin: false.
	self isAssistant: false.
	self isStudentAssistant: false.
	self isTeacher: false.
	self userName:''.! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 6/3/2009 17:34'!
isAdmin
	^ isAdmin! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 5/27/2009 23:08'!
isAdmin: anObject

	isAdmin := anObject.! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:36'!
isAssistant

	^ isAssistant! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:36'!
isAssistant: anObject

	isAssistant := anObject.! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 6/9/2009 13:58'!
isStudentAssistant

	^ isStudentAssistant! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 6/9/2009 13:58'!
isStudentAssistant: anObject

	isStudentAssistant := anObject.! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:35'!
isTeacher

	^ isTeacher! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:35'!
isTeacher: anObject

	isTeacher := anObject.! !

!DLUser methodsFor: 'accessing' stamp: 'tfel 12/5/2009 13:57'!
lectures
	^ DLLecture instances select: [:aLecture | aLecture students includes: self]! !

!DLUser methodsFor: 'accessing' stamp: 'Marik 7/14/2009 14:35'!
lectures: aCollection
	| lecturesBefore lecturesRemove lecturesAdd |
	lecturesBefore := self lectures.
	lecturesRemove := lecturesBefore difference: aCollection.
	lecturesAdd    := aCollection difference: lecturesBefore.
	lecturesRemove do: [:aLecture | aLecture students remove: self. aLecture save.].
	lecturesAdd    do: [:aLecture | aLecture students add: self.    aLecture save.].! !

!DLUser methodsFor: 'accessing' stamp: 'mg 7/24/2009 18:18'!
mail

	self email isNil
		ifTrue: [^nil]
		ifFalse: [^ 'mailto:',self email].! !

!DLUser methodsFor: 'accessing' stamp: 'topa 04/28/2010 16:48'!
realName

	realName ifNil: ["Try to guess real name from HPI standard username"
		realName := ((userName findTokens: '.') 
			collect: [:subStr | subStr capitalized])
				asStringSeparatedBy: ' '].
	^ realName! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:37'!
realName: anObject

	realName := anObject.! !

!DLUser methodsFor: 'permission' stamp: 'sebh 6/13/2009 14:30'!
rightUpdate: aUser
	^ (aUser = self) | (super rightUpdate: aUser)! !

!DLUser methodsFor: 'accessing' stamp: 'cr 7/8/2009 16:40'!
topicForLecture
 ^'foo'! !

!DLUser methodsFor: 'accessing' stamp: 'cr 7/8/2009 16:43'!
topicForLecture: aLoo
 ^nil! !

!DLUser methodsFor: 'saving' stamp: 'sebh 7/15/2009 15:49'!
trackChangeVariables
	^ {'isAdmin'.'isStudentAssistant'.'isTeacher'.'isAssistant'.'realName'.'email'}! !

!DLUser methodsFor: 'saving' stamp: 'sebh 7/15/2009 15:47'!
trackMailChangeVariables
	^ {[:aUser | aUser isAdmin] -> {'isAdmin'}.
		[:aUser | aUser = self ] -> {'isAdmin'. 'isAssistant'. 'isStudentAssistant'. 'isTeacher'. 'realName'. 'email'}}! !

!DLUser methodsFor: 'accessing' stamp: 'Marik 5/26/2009 13:25'!
userName

	^ userName! !

!DLUser methodsFor: 'accessing' stamp: 'Marik 5/26/2009 13:25'!
userName: anObject

	userName := anObject.! !

!Object methodsFor: '*deli-translation-override' stamp: 'topa 4/28/2010 15:10'!
labelForSelector: aSymbol

	DLApplication translations at: aSymbol ifPresent: [:translation | ^ translation].
	^ aSymbol asCapitalizedPhrase! !

WADecoration subclass: #DLPreAuthentication
	instanceVariableNames: ''
	classVariableNames: 'AllowExistingUsersViaBasicAuth'
	poolDictionaries: ''
	category: 'Deli-configuration'!

!DLPreAuthentication class methodsFor: 'preferences' stamp: 'tfel 1/11/2011 21:39'!
allowExistingUsersViaBasicAuth

	<preference: 'Allow existing users to logon via basic auth'
		category: 'Deli'
		description: 'If true, exisiting users (created in-image) may login via BasicAuth with any password. This should usually be deactivated as authentication should be done securely via something like Apache''s krb5_mod over an https stream. The option is useful for testing the system locally without having to setup an Apache server.'
		type: #Boolean>
	^ AllowExistingUsersViaBasicAuth ifNil: [false].! !

!DLPreAuthentication class methodsFor: 'preferences' stamp: 'tfel 1/11/2011 20:44'!
allowExistingUsersViaBasicAuth: aBoolean

	^ AllowExistingUsersViaBasicAuth := aBoolean! !

!DLPreAuthentication methodsFor: 'as yet unclassified' stamp: 'tfel 1/11/2011 21:04'!
denyAccess

	self requestContext respond: [:response | 
		response
			status: 401
			message: 'You are not authorized to access Deli' ].! !

!DLPreAuthentication methodsFor: 'as yet unclassified' stamp: 'tfel 1/11/2011 21:36'!
ensureLogin

	(self isAuthorized and: [ self session isLoggedIn not ]) 
		ifTrue: [ self session login: self kerberosUserName ].
	^ self session isLoggedIn! !

!DLPreAuthentication methodsFor: 'as yet unclassified' stamp: 'TimFelgentreff 01/13/2011 04:56'!
isAuthorized

	^ (self session requestContext request headers 
		at: 'authorization' 
		ifAbsent: [ '' ]) isEmpty not! !

!DLPreAuthentication methodsFor: 'as yet unclassified' stamp: 'topa 4/28/2010 12:11'!
isGlobal

	^ true! !

!DLPreAuthentication methodsFor: 'as yet unclassified' stamp: 'TimFelgentreff 01/13/2011 04:56'!
kerberosUserName

	| currentRequest authorizationHeader |
	currentRequest := self session requestContext request.
	authorizationHeader := currentRequest headers at: 'authorization' ifAbsent: [^ false].
	^ ((Base64MimeConverter 
		mimeDecodeToChars: (ReadStream on: (authorizationHeader 
			findTokens: {Character space}) last)) contents
		findTokens: {$:}) first.! !

!DLPreAuthentication methodsFor: 'as yet unclassified' stamp: 'tfel 11/2/2011 11:59'!
processChildCallbacks: aStream

	self ensureLogin
		ifTrue: [ super processChildCallbacks: aStream ]
		ifFalse: [ self session requestContext response forbidden ].! !

!DLPreAuthentication methodsFor: 'as yet unclassified' stamp: 'tfel 1/11/2011 21:35'!
requestBasicAuth

	self requestContext respond: [:response | 
		response basicAuthenticationRealm: 'Deli' ].! !

!DLPreAuthentication methodsFor: 'as yet unclassified' stamp: 'tfel 1/11/2011 21:36'!
updateRoot: aStream

	self ensureLogin
		ifTrue: [ super updateRoot: aStream ]
		ifFalse: [ self class allowExistingUsersViaBasicAuth
			ifTrue: [ self requestBasicAuth ]
			ifFalse: [ self denyAccess ] ].! !

MAMultipleOptionDescription subclass: #DLMAMultiCheckboxGroupDescription
	instanceVariableNames: 'labels maxAnswers maxAnswersPerChoice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMAMultiCheckboxGroupDescription class methodsFor: 'magritte-seaside-defaults' stamp: 'PL 5/27/2011 00:40:13.467'!
defaultComponentClasses

	^ Array with: DLMAMultiCheckboxGroupComponent! !

!DLMAMultiCheckboxGroupDescription class methodsFor: 'accessing-defaults' stamp: 'PL 5/28/2011 14:32:09.778'!
defaultKind

	^ Dictionary! !

!DLMAMultiCheckboxGroupDescription class methodsFor: 'accessing' stamp: 'PL 5/27/2011 00:33:15.972'!
label
	
	^ 'Multi-Checkbox'! !

!DLMAMultiCheckboxGroupDescription methodsFor: 'initialization' stamp: 'PL 7/12/2011 11:22:10.755'!
initialize

	super initialize.

	self
		maxAnswers: 1;
		maxAnswersPerChoice: 1! !

!DLMAMultiCheckboxGroupDescription methodsFor: 'validating' stamp: 'PL 7/12/2011 11:36:50.826'!
isValid: anObject

	| numberOfVotes |
	
	numberOfVotes := 0.
	
	anObject do: [:each | each value > self maxAnswersPerChoice ifTrue: [^ false].
		numberOfVotes := numberOfVotes + each value].
	
	numberOfVotes > self maxAnswers ifTrue: [^ false].
	
	^ true! !

!DLMAMultiCheckboxGroupDescription methodsFor: 'accessing' stamp: 'PL 5/28/2011 03:38:26.888'!
labels

	^ labels! !

!DLMAMultiCheckboxGroupDescription methodsFor: 'accessing' stamp: 'PL 5/28/2011 03:38:31.375'!
labels: anObject

	labels := anObject! !

!DLMAMultiCheckboxGroupDescription methodsFor: 'accessing' stamp: 'PL 7/12/2011 11:20:27.793'!
maxAnswers

	^ maxAnswers! !

!DLMAMultiCheckboxGroupDescription methodsFor: 'accessing' stamp: 'PL 7/12/2011 11:20:44.051'!
maxAnswers: aNumber

	maxAnswers := aNumber! !

!DLMAMultiCheckboxGroupDescription methodsFor: 'accessing' stamp: 'PL 7/12/2011 11:20:52.599'!
maxAnswersPerChoice

	^ maxAnswersPerChoice! !

!DLMAMultiCheckboxGroupDescription methodsFor: 'accessing' stamp: 'PL 7/12/2011 11:21:03.458'!
maxAnswersPerChoice: aNumber

	maxAnswersPerChoice := aNumber! !

!DLMAMultiCheckboxGroupDescription methodsFor: 'validating' stamp: 'PL 7/12/2011 11:16:15.551'!
validateKind: anObject

	"Validate ==anObject== to be of the right kind."

	(anObject isKindOf: self kind)
		ifFalse: [ MAKindError description: self signal: self kindErrorMessage ]! !

!DLMAMultiCheckboxGroupDescription methodsFor: 'validating' stamp: 'PL 7/12/2011 11:17:10.923'!
validateRequired: anObject

	"Validate ==anObject== not to be ==nil== if it is required."

	(self isRequired and: [ anObject isNil ])
		ifTrue: [ MARequiredError description: self signal: self requiredErrorMessage ]! !

!DLMAMultiCheckboxGroupDescription methodsFor: 'validation-private' stamp: 'PL 7/12/2011 11:35:15.987'!
validateSpecific: anObject

	(self isValid: anObject)
		ifFalse: [MAConditionError description: self signal: 'Zu viele Stimmen abgegeben.']! !

MAMultipleOptionDescription subclass: #DLMAQuestionnaireDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMAQuestionnaireDescription class methodsFor: 'magritte-seaside-defaults' stamp: 'PL 6/23/2011 16:35:34.908'!
defaultComponentClasses

	^ Array with: DLMAQuestionnaireComponent! !

!DLMAQuestionnaireDescription class methodsFor: 'accessing-defaults' stamp: 'PL 6/23/2011 16:30:26.007'!
defaultKind

	^ Dictionary! !

!DLMAQuestionnaireDescription class methodsFor: 'accessing' stamp: 'PL 6/23/2011 16:09:15.953'!
label
	
	^ 'Questionnaire Editor'! !

!DLMAQuestionnaireDescription methodsFor: 'validating' stamp: 'PL 8/6/2011 00:55:18.159'!
validateKind: anObject

	anObject isDictionary
		ifFalse: [MAKindError description: self signal: self kindErrorMessage]! !

!DLMAQuestionnaireDescription methodsFor: 'validating' stamp: 'PL 8/6/2011 00:56:17.163'!
validateRequired: anObject

	"No fields are required for questionnaire editors"! !

MAStringDescription subclass: #DLMAMailDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMAMailDescription methodsFor: 'accessing' stamp: 'Marik 7/13/2009 16:05'!
isSortable

	^ false! !

!Collection methodsFor: '*deli' stamp: 'topa 4/28/2010 15:31'!
asStringSeparatedBy: delimiter
	"the infamous join"

	^ String streamContents: [:stream |
		self asStringOn: stream delimiter: delimiter]! !

MATextInputComponent subclass: #DLMABarChartComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMABarChartComponent class methodsFor: 'testing' stamp: 'PL 8/4/2011 18:04:40.259'!
isAbstract

	^ false! !

!DLMABarChartComponent methodsFor: 'rendering' stamp: 'CO 08/07/2011 07:31'!
renderContentOn: html
	
	| progress level maximum percentage |
	
	progress := self value.
	level := progress first.
	maximum := progress second.
	maximum = 0
		ifTrue: [percentage := '0%']
		ifFalse: [percentage := ((level / maximum * 1000) rounded / 10) asFloat rounded asString , '%'].
	
	html div
		class: 'barChart';
		with:
			[html div
				with: [html div
				style: ('width: ' , percentage);
				with: [html div]].
	
			html div
				with: level asString , '/' , maximum asString , ' (' , percentage , ')']! !

MATextInputComponent subclass: #DLMALinkComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMALinkComponent class methodsFor: 'accessing' stamp: 'cr 7/13/2009 14:41'!
isAbstract
	^false! !

!DLMALinkComponent methodsFor: 'rendering' stamp: 'PL 5/14/2011 21:58:44.916'!
renderViewerOn: html
	html anchor url: self value; with: '[Beschreibung]'.! !

DLMALinkComponent subclass: #DLMAMailLinkComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMAMailLinkComponent methodsFor: 'as yet unclassified' stamp: 'PL 5/25/2011 21:28:48.602'!
renderViewerOn: html
	self value
		ifNotNil:
			[html anchor
				url: 'mailto:', self value;
				class: 'iconpic';
				with: [html image url: DLFileLibrary/#emailPng].]
		ifNil: [html text: 'Keine E-Mail Adresse angegeben'].! !
DLRootComponent initialize!
